#include <iostream>
#include <vector>

#ifndef LOCAL_D
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif


using namespace std;

const int MOD = 1e9 + 7;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
    vector<int> sum(n + 1);
    dp[k][k] = 1;
    sum[k] = 1;
    for (int i = k + 1; i <= n; i++) {
        for (int j = 1; j <= i; j++) {
            dp[i][j] = sum[i - j] % MOD - dp[i - j][j] % MOD;
            sum[i] += dp[i][j];
            sum[i] %= MOD;
        }
    }
    cout << sum[n];
    return 0;
}