#pragma GCC optimize("Ofast")
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr);

#include <bits/stdc++.h>

#define int long long
#define double long double
#define endl "\n"

#define MOD 1000000007

using namespace std;

//int32_t main() {
//    ON_START
//
//    int n, k;
//    cin >> n >> k;
//
//    int res = 1;
//
//    int sum = 0;
//    vector<int> d;
//    while(sum != n) {
//        if(d.empty()) {
//            d.push_back(k);
//            sum += k;
//        } else {
//            if(d.back() == 1) {
//                d.push_back(2);
//                sum += 2;
//
//                if(sum > n) {
//                    d.pop_back();
//                    sum = n;
//                    for (int i = 1; i < d.size(); ++i) {
//                        if(d[i] == 2) {
//                            d[i]++;
//                            break;
//                        }
//                    }
//                }
//            } else {
//                d.push_back(1);
//                sum += 1;
//            }
//        }
//    }
//
//    while(d.size() != 1) {
//        int b = d.back();
//        d.pop_back();
//    }
//
////    cout << d.size() << endl;
////    for (int i = 0; i < d.size(); ++i) {
////        cout << i + 1 << ": " << d[i] << endl;
////    }
//
//    cout << res << endl;
//
//    return 0;
//}

int32_t main() {
    ON_START

    int n, k;
    cin >> n >> k;

    if(n == k) {
        cout << "1\n";
        return 0;
    }

    int res = 0;

    int dp[n + 1][n + 1][n + 1];
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            for (int l = 0; l < n + 1; ++l) {
                dp[i][j][l] = 0;
            }
        }
    }
    dp[1][k][n - k] = 1;
    for (int i = 2; i < n + 1; ++i) {
        if(i % 2 == 0) { //Down
            for (int j = 0; j < n + 1; ++j) {
                for (int l = 0; l < n + 1; ++l) {
                    for (int m = 1; m < j && l - m >= 0; ++m) {
                        dp[i][m][l - m] += dp[i - 1][j][l];
                        dp[i][m][l - m] %= MOD;
                    }
                }
            }
        } else { //Up
            for (int j = 0; j < n + 1; ++j) {
                for (int l = 0; l < n + 1; ++l) {
                    for (int m = j + 1; l - m >= 0; ++m) {
                        dp[i][m][l - m] += dp[i - 1][j][l];
                        dp[i][m][l - m] %= MOD;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            res += dp[i][j][0];
            res %= MOD;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            for (int l = 0; l < n + 1; ++l) {
                dp[i][j][l] = 0;
            }
        }
    }
    dp[1][k][n - k] = 1;
    for (int i = 2; i < n + 1; ++i) {
        if(i % 2 == 1) { //Down
            for (int j = 0; j < n + 1; ++j) {
                for (int l = 0; l < n + 1; ++l) {
                    for (int m = 1; m < j && l - m >= 0; ++m) {
                        dp[i][m][l - m] += dp[i - 1][j][l];
                        dp[i][m][l - m] %= MOD;
                    }
                }
            }
        } else { //Up
            for (int j = 0; j < n + 1; ++j) {
                for (int l = 0; l < n + 1; ++l) {
                    for (int m = j + 1; l - m >= 0; ++m) {
                        dp[i][m][l - m] += dp[i - 1][j][l];
                        dp[i][m][l - m] %= MOD;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            res += dp[i][j][0];
            res %= MOD;
        }
    }
    cout << res << endl;

    return 0;
}