#include <bits/stdc++.h>

using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define BALL(x) (x).rbegin(), (x).rend()
#define LAST(x) (x)[(x).size() - 1]

//#define DEBUG
#ifdef DEBUG
ifstream _in("debug.in");
#define cin _in
#endif

#define int long long
//#define endl '\n'
#define INF 1e15+7
const int MOD = 1e9+7;

signed main() {
	ios_base::sync_with_stdio(false);
	int n, k;
	cin >> n >> k;
	int m = (n - k) * 2 + 1;
	vector<vector<vector<vector<int>>>> dp(m + 1, vector<vector<vector<int>>>(n + 1,
											vector<vector<int>>(n + 1, vector<int>(2))));
	dp[1][k][k][0] = 1;
	dp[1][k][k][1] = 1;
	for (int im = 2; im <= m; ++im) {
		for (int in = 0; in <= n; ++in) {
			for (int ik = 1; ik <= in; ++ik) {
				for (int x = 1; x < ik; ++x) {
					dp[im][in][ik][0] += dp[im - 1][in - ik][x][1];
				}
				dp[im][in][ik][0] %= MOD;
				for (int x = ik + 1; x <= in; ++x) {
					dp[im][in][ik][1] += dp[im - 1][in - ik][x][0];
				}
				dp[im][in][ik][1] %= MOD;
			}
		}
	}

	int ans = 0;
	for (int i = 0; i <= m; ++i) {
		for (int j = 0; j <= n; ++j) {
			ans += dp[i][n][j][0];
			if (i != 1)
				ans += dp[i][n][j][1];
			ans %= MOD;
		}
	}
	cout << ans << endl;
}