#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(c) c.begin(), c.end()
#define sz(c) (int)c.size()
#define int long long
const int MOD = (int)1e9 + 7;
const int MAXN = (int)3e5 + 7;
int fact[MAXN];
int n, m, k;
int pw(int x, int a)
{
    int res = 1;
    int cur = x;
    for (int i = 0; (1LL << i) <= a; ++i)
    {
        if (a & (1LL << i)) res = (res * cur) % MOD;
        cur = (cur * cur) % MOD;
    }
    return res;
}
int C(int N, int K)
{
    if (N < 0 || K < 0 || K > N) return 0;
    return ((fact[N] * pw(fact[K], MOD - 2) % MOD) * pw(fact[N - K], MOD - 2) % MOD);
}
int func(int n, int k)
{
    int lg = 0;
    while ((1LL << lg) <= k) lg++;
    int ind = lg - 1;
    while (ind >= 0 && k & (1LL << ind)) ind--;
    int ans = 0;
    for (int i = 0; i <= lg; ++i)
    {
        int A = 0;
        int q = 0;
        for (int j = lg - 1; j >= 0; --j)
        {
            if (k & (1LL << j)) ++q;
            else
            {
                A += C(j, i - q - 1);
            }
        }
        ans += pw(n, i) * (C(lg, i) - A);
        ans %= MOD;
    }
    return ans;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i)
    {
        fact[i] = (fact[i - 1] * i) % MOD;
    }
    cin >> n >> m >> k;
    if (m == 0)
    {
        cout << func(n, k) << endl;
        return 0;
    }
    int pr[n];
    for (int i = 0; i < n; ++i) pr[i] = -1;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        pr[b] = max(pr[b], a + 1);
    }
    int dp[n][k + 1][n];
    for (int i = 0; i < k + 1; ++i)
    {
        dp[0][i][0] = 1;
    }
    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j <= k; ++j)
        {
            for (int z = 0; z < i; ++z)
            {
                dp[i][j][z] = dp[i - 1][j][z];
                if (z < pr[i]) dp[i][j][z] = 0;
            }
            dp[i][j][i] = 0;
            for (int w = 0; w < j; ++w)
            {
                if ((w & j) != w) continue;
                for (int h = 0; h <= i - 1; ++h)
                {
                    dp[i][j][i] += dp[i - 1][w][h];
                    dp[i][j][i] %= MOD;
                }
            }
        }
    }
    int ans = 0;
    for (int j = 0; j <= k; ++j)
    {
        for (int z = 0; z < n; ++z)
        {
            ans += dp[n - 1][j][z];
            ans %= MOD;
        }
    }
    cout << ans << endl;
}
