#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(c) c.begin(), c.end()
#define sz(c) (int)c.size()
#define x first
#define y second
const int MAXN = (int)3e5 + 7;
int n;
vector<int> G[MAXN];
int a[MAXN];
vector<pair<int, int>> edg;
vector<pair<int, int>> edges[MAXN];
int used[MAXN];
int pr[MAXN];
bool taken[MAXN], used1[MAXN], used2[MAXN];
int col = 0;
vector<int> comp[MAXN];
void dfs(int v)
{
    used[v] = col;
    comp[col].pb(v);
    for (auto u : G[v])
    {
        if (used[u] != -1) continue;
        dfs(u);
    }
}
int ans = 0;
int dfs1(int v)
{
    used1[v] = true;
    int cnt = 0;
    bool flag = true;
    int res = 0;
    for (int u : G[v])
    {
        if (used1[u]) continue;
        cnt++;
        res += dfs1(u);
        if (taken[u]) flag = false;
    }
    if (cnt == 0 || flag == true)
    {
        taken[v] = true;
        res++;
    }
    return res;
}
void dfs2(int v)
{
    used2[v] = true;
    for (auto u : G[v])
    {
        if (used2[u]) continue;
        pr[u] = v;
        dfs2(u);
    }
}
void f1(int id)
{
    ans += dfs1(comp[id][0]);
}
void f2(int id)
{
    int st = comp[id][0];
    pr[st] = -1;
    dfs2(st);
    int a = -1, b = -1;
    for (auto p : edges[id])
    {
        if (pr[p.x] != p.y && pr[p.y] != p.x)
        {
            a = p.x;
            b = p.y;
            break;
        }
    }
    used1[a] = true;
    int cur1 = 0, cur2 = 0;
    for (int v : comp[id])
    {
        if (used1[v]) continue;
        cur1 += dfs1(v);
    }
    for (int v : comp[id])
    {
        used1[v] = false;
        taken[v] = false;
    }
    used1[b] = true;
    for (int v : comp[id])
    {
        if (used1[v]) continue;
        cur2 += dfs1(v);
    }
    ans += max(cur1, cur2);
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; ++i)
    {
        if (i >= a[i]) continue;
        if (a[a[i]] == i) a[i] = -2;
    }
    for (int i = 0; i < n; ++i)
    {
        if (a[i] < 0) continue;
        G[i].pb(a[i]);
        G[a[i]].pb(i);
        edg.pb({i, a[i]});
    }
    for (int i = 0; i < n; ++i) used[i] = -1;
    for (int i = 0; i < n; ++i)
    {
        if (used[i] == -1)
        {
            dfs(i);
            col++;
        }
    }
    for (auto p : edg)
    {
        edges[used[p.x]].pb(p);
    }
    for (int i = 0; i < col; ++i)
    {
        if (sz(comp[i]) == sz(edges[i]) + 1)
        {
            f1(i);
        }
        else
        {
            f2(i);
        }
    }
    cout << ans << endl;
}
