#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 15;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 5002;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
int n, k;
int dp[MAXN][MAXN][2];
int pref[2][MAXN][MAXN];
int mod = (1e9 + 7);

void init() {
}

void solve() {
	init();
	if (n == k) {
		cout << 1 << '\n';
		return;
	}
  	for (int i = 0; i < MAXN; i++) {
  		dp[i][i][0] = dp[i][i][1] = 1;
  	}
	for (int sum = 1; sum + 1 < MAXN; sum++) {
		for (int last = 1; last + 1 < MAXN; last++) {
			if (last > sum) {
				continue;
			}
			if (last == sum) {
				continue;
			}
			dp[sum][last][0] = pref[1][sum - last][last - 1];
			dp[sum][last][1] = pref[0][sum - last][last + 1] - pref[0][sum - last][sum + 1];
			if (dp[sum][last][1] < mod) {
				dp[sum][last][1] += mod;
			}
		}
		for (int i = 1; i < MAXN; i++) {
			pref[1][sum][i] = pref[1][sum][i - 1] + dp[sum][i][1];
			if (pref[1][sum][i] > mod) {
				pref[1][sum][i] -= mod;
			}
		}
		for (int i = MAXN - 2; i > 0; i--) {
			pref[0][sum][i] = pref[0][sum][i + 1] + dp[sum][i][0]; 
			if (pref[0][sum][i] > mod) {
				pref[0][sum][i] -= mod;
			}
		}
	}		
	cout << (dp[n][k][0] + dp[n][k][1]) % mod << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}