#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/STACK:256000000")
#define int long long
vector<vector<int>>g;
vector<int>par;
vector<int>used;
vector<int>dist;
vector<int>in;
int z = 0;
int c = -1;
vector<int>nex;
void find(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u] == 0) {
			par[u] = v;
			used[u] = 1;
			find(u);
		}
		else {
			if (z == 0 && par[v] != u) {
				par[u] = v;
				z = 1;
				c = u;
			}
		}
	}
}
vector<int>no;
vector<pair<int, int>>dp;
void dfs(int v) {
	dp[v].first = 1;
	for (auto u : g[v]) {
		if (in[u] == 0 && dist[u] == -1) {
			dist[u] = dist[v] + 1;
			dfs(u);
			dp[v].first += dp[u].second;
			dp[v].second += max(dp[u].second, dp[u].first);
		}
	}
}
void dfs2(int v) {
	dp[v].first = 1;
	for (auto u : g[v]) {
		if (in[u] == 0 && dist[u] == -1) {
			dist[u] = dist[v] + 1;
			dfs2(u);
			dp[v].first += dp[u].second;
			dp[v].second += max(dp[u].second, dp[u].first);
		}
	}
	
}
signed main() {
	int n;
	cin >> n;
	g.resize(n);
	nex.resize(n, -1);
	par.resize(n, -1);
	used.resize(n);
	no.resize(n);
	dp.resize(n, { 0, 0 });
	dist.resize(n, -1);
	in.resize(n);
	map<pair<int, int>, int>mp;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		if (x == -1) {
			continue;
		}
		x--;
		if (mp[{ min(x, i), max(x, i) }] == 0) {
			g[x].push_back(i);
			g[i].push_back(x);
		}
		mp[{ min(x, i), max(x, i) }] = 1;
	}
	int ans = 0;
	vector<int>d(n, -1);
	
	for (int q = 0; q < n; q++) {
		if (!used[q]) {
			c = -1;
			z = 0;
			used[q] = 1;
			find(q);
			if (c == -1) {
				dist[q] = 0;
				dfs2(q);
				ans += max(dp[q].first, dp[q].second);
				c = -1;
				z = 0;
				continue;
			}
			int colvo = 0;
			int u = par[c];
			while (u != c) {
				nex[par[u]] = u;
				in[u] = 1;
				u = par[u];
				colvo++;
			}
			nex[par[u]] = u;
			in[c] = 1;
			u = par[c];
			colvo++;
			int cnt1 = 0;
			int cnt2 = 0;
			while (u != c) {
				dist[u] = 0;
				dfs(u);
				cnt1 = 0;
				cnt2 = 0;
				for (auto x : g[u]) {
					if (in[x] == 0) {
						cnt1 += max(dp[x].first, dp[x].second);
						cnt2 += dp[x].second;
					}
				}
				if (cnt1 > cnt2) {
					no[u] = 1;
					ans += cnt1;
				}
				else {
					ans += cnt2;
					no[u] = 0;
				}
				u = par[u];
			}
			dist[u] = 0;
			cnt1 = 0;
			cnt2 = 0;
			dfs(u);
			for (auto x : g[u]) {
				if (in[x] == 0) {
					cnt1 += max(dp[x].first, dp[x].second);
					cnt2 += dp[x].second;
				}
			}
			if (cnt1 > cnt2) {
				no[u] = 1;
				ans += cnt1;
			}
			else {
				ans += cnt2;
			}
			u = nex[c];
			int ch = 0;
			while (no[u] == 0) {
				if (u == c) {
					ch = 1;
					break;
				}
				u = nex[u];
			}
			
			if (ch == 1 && n >= 21) {
				ans += colvo / 2;
			}
			else {
				int c2 = u;
				u = nex[u];
				while (u != c2) {
					if (no[u] == 0) {
						d[u] = d[par[u]] + 1;
						if (d[u] % 2 == 0) {
							ans++;
						}
					}
					u = nex[u];
				}
			}
			
			c = -1;
			z = 0;
		}
		c = -1;
		z = 0;
	}

	if (ans > n) {
		ans = n;
	}
	cout << ans;
	return 0;
}