#include <iostream>
#include <vector>
#include <string>
#include <math.h>

#define int long long

using namespace std;

const int mod = 1e9 + 7;

int c(int n, int k) {
    int ans = 1;
    k = max(k, n - k);
    int m = 1;
    for(int i = n; i > k; i --) {
        ans *= i;
        while(m <= n - k && ans % m == 0) {
            ans = ans / m;
            m ++;
        }
    }
    return ans % mod;
}

int qpow(int a, int b) {
    if(b == 0) {
        return 1;
    }
    else {
        if(b % 2 == 1) {
            int ans = qpow(a, b - 1);
            return (ans * a) % mod;
        }
        else {
            int ans = qpow(a, b / 2);
            return (ans * ans) % mod;
        }
    }
}

int32_t main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> in(0);
    int s = 0;
    while(k > 0) {
        in.emplace_back(k % 2);
        s += k % 2;
        k /= 2;
    }
    int ans = qpow(n, s);
    s = 0;
    for(int i = in.size() - 1; i >= 0; i --) {
        if(in[i] == 1) {
            for(int j = 0; j <= i; j ++) {
                ans += (qpow(n, s + j) * c(i, j)) % mod;
                ans %= mod;
            }
            s ++;
        }
    }
    cout << ans;
    return 0;
}