#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()

const ll INF = 1e18;
const ll MOD = 1'000'000'007;

void entry(int test_id) {
    (void) test_id;
    int n, m;
    scanf("%d %d", &n, &m);
    vector<int> requests(m);
    for (int i = 0; i < m; ++i) {
        int x;
        scanf("%d", &x);
        requests[i] = x - 1;
    }
    vector<int> order_pos(n);
    for (int i = 0; i < n; ++i) {
        int p;
        scanf("%d", &p);
        //order[i] = p - 1;
        order_pos[p - 1] = i;
    }
    vector<vector<int>> req_ids(n);
    for (int i = 0; i < m; ++i) {
        int j = order_pos[requests[i]];
        req_ids[j].push_back(i);
    }
    vector<int> ans;
    vector<int> next_same(m, m);
    {
        map<int, int> mp;
        for (int i = 0; i < m; ++i) {
            int x = requests[i];
            if (mp.count(x)) {
                int j = mp[x];
                next_same[j] = i;
            }
            mp[x] = i;
        }
    }
    vector<int> next_req(n, m);
    for (int i = 0; i < m; ++i) {
        int x = requests[i];
        if (next_req[x] == m) next_req[x] = i;
    }
    for (int j = 0; j < m; ++j) {
        while (true) {
            int cur;
            for (int h = 0; h < n; ++h) {
                if (order_pos[h] == 0) cur = h;
            }
            if (cur == requests[j]) {
                next_req[cur] = next_same[j];
            }

            int npos = 0;
            int L = j;
            int R = next_req[cur];
            //for (int k = j; k < next_req[cur]; ++k) {
            //    int ps = order_pos[requests[k]];
            //    npos = max(npos, ps);
            //}
            int rem = R - L;
            while (npos < n) {
                int cnt1 = lower_bound(all( req_ids[npos]), L) - req_ids[npos].begin();
                int cnt2 = lower_bound(all(req_ids[npos]), R) - req_ids[npos].begin();
                rem -= cnt2 - cnt1;
                if (rem == 0) break;
                ++npos;
            }
            for (int i = 0; i < n; ++i) {
                if (order_pos[i] <= npos) --order_pos[i];
            }
            order_pos[cur] = npos;
            ans.push_back(npos);
            auto t = req_ids[0];
            req_ids.erase(req_ids.begin());
            req_ids.insert(req_ids.begin() + npos, t);
            if (cur == requests[j]) {
                break;
            }
        }
    }
    printf("%lld\n", ans.size());
    for (int npos : ans) {
        printf("%d ", npos + 1);
    }
    printf("\n");
}