#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define forn(i, n) for (int i = 0; i < n; ++i)
#define MAX_LL numeric_limits<long long>::max()
#define MIN_LL numeric_limits<long long>::min()
#define MAX_INT numeric_limits<int>::max()
#define MIN_INT numeric_limits<int>::min()
#define all(x) (x).begin(), (x).end()
#define int long long
#define vi vector<int>

int n, m;
vi A, B, C;
vi E;

bool read() {
    cin >> n >> m;
    A.resize(m);
    B.resize(n);
    E.resize(n + 1);
    for (int &x : A) cin >> x;
    for (int &x : B) cin >> x;
    return 1;
}

void solve() {
    if (n == m) {
        forn(i, n) if (A[i] != B[n - 1 - i]) goto next;

        cout << 2*n - 1 << endl;
        forn(i, n - 1) cout << n-i << " ";
        forn(i, n) cout << n << " ";

        return;
    }

    next:
    for (int i = 0, j = 0; i < m; ++i) {
        if (E[A[i]] != 0) {
            for (; B[j] != A[i]; ++j) {
                C.push_back(B[j]);
                E[B[j]] = -1;
            }
            ++j;
            E[A[i]] = -1;
        }
        C.push_back(A[i]);
    }

    m=C.size();
    vector<int> Ans(m, n);
    for (int i = 0; i < m; ++i) {
        if (E[C[i]] != -1) {
            set<int> S;
            for (int j = E[C[i]]; j < i; --j) {
                S.insert(C[j]);
            }
            Ans[E[C[i]]] = S.size();
        }
        E[C[i]] = i;
    }

    cout << m << '\n';
    for (int i = 0; i < m; ++i) {
        cout << Ans[i] << " ";
    }
}

void init() {
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    init();
    read();
    solve();
    cout.flush();
}
