#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <math.h>

using namespace std;

int main() {
	queue<long long> start;
	queue<long long> work;

	long long n, m, a;

	cin >> n >> m;

	vector<long long> way;
	vector<long long> numb(n + 1);

	vector<pair<long long, long long>> add;
	vector<long long> ans;

	for (long long i = 0; i < m; i++) {
		cin >> a;
		way.push_back(a);
	}

	for (long long i = 1; i < n + 1; i++) {
		cin >> a;
		numb[a] = i;
		start.push(i);
	}

	for (long long i = 0; i < way.size(); i++) {
		work.push(numb[way[i]]);
	}

	long long count = 0;
	
	while (work.size() > 0) {

		while (work.size() > 0 && start.size() > 0 && work.front() == start.front()) {
			work.pop();
			add.push_back({ start.front(), count });
			start.pop();
			ans.push_back(-1);

			count++;
		}
		if (work.size() > 0){

			while (start.size() > 0 && work.front() != start.front()) {
				add.push_back({ start.front(), count });
				start.pop();
				ans.push_back(-1);

				count++;
			}
			if (start.size() == 0) {
				long long i = count - 1;

				while (add[i].first != work.front()) {
					add[i].second += 1;
					i--;
				}

				start.push(add[i].first);

				ans[i] = count - add[i].second + 1;
			}
		}
	}

	cout << ans.size() << "\n";

	for (long long i = 0; i < count; i++) {
		if (ans[i] == -1) {
			cout << n << " ";
		}
		else {
			cout << ans[i] << " ";
		}
	}
	
	system("pause");
}