#include <iostream>
#include <vector>

using namespace std;

int main() {
	int n, k;

	cin >> n >> k;

	if (k == n) {
		cout << 1;
	}
	else {
		vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1, { 0, 0 }));

		dp[k][k].first = 1;
		dp[k][k].second = 1;

		for (int i = k + 1; i <= n; i++) {
			for (int j = 1; j <= i; j++) {

				for (int z = j + 1; z <= i - j; z++) {
					dp[i][j].second += dp[i - j][z].first;
				}

				for (int z = 1; z < j; z++) {
					dp[i][j].first += dp[ i - j][z].second;
				}
			}
		}

		long long ans = 0;

		for (int j = 1; j <= n; j++) {
			ans += dp[n][j].first + dp[n][j].second;

			ans %= ((long long)1e9 + 7);
		}

		cout << ans;

	}


	system("pause");
}