#include <iostream>
#include <vector>
using namespace std;
#define ll long long
const int64_t MOD = 1e9 + 7;


int main()
{
    ios_base:: sync_with_stdio(false);
    cin.tie(NULL);
    ll total, start;
    cin >> total >> start;
    if (start == total)
    {
        cout << 1;
    }else
    {
        int dp[total + 1][total + 1][2];
        for (int i = 0;  i <= total; i++)
        {
            for (int j = 0; j <= total; j++)
            {
                dp[i][j][0] = 0;
                dp[i][j][1] = 0;
            }
        }
        for (int i = 0; i <= total; i++)
        {
            dp[i][i][0] = 1;
            dp[i][i][1] = 1;
        }
        dp[1][1][0] = 1;
        dp[1][1][1] = 1;
        for (int i = 2; i <= total; i++)
        {
            for (int j = 1; j <= i; j++)
            {
                for (int u = j + 1; u <= i - j; u++)
                {
                    dp[i][j][0] += dp[i - j][u][1];
                    dp[i][j][0] %= MOD;
                }
                for (int u = j - 1; u >= 1; u--)
                {
                    dp[i][j][1] += dp[i - j][u][0];
                    dp[i][j][1] %= MOD;
                }
            }
        }
       /* for (int i = 0; i <= total; i++)
        {
            for (int j = 0; j <= total; j++)
            {
                cout << i << ' ' << j << ' ' << dp[i][j][0] << ' ' << dp[i][j][1] << endl;
            }
        }*/
        cout << (dp[total][start][0] + dp[total][start][1]) % MOD;
    }
    return 0;
}
