#include <iostream>
#include <vector>
using namespace std;
#define ll long long
vector<vector<ll>> g;
vector<ll> used;
vector<ll> dist;


void dfs(ll current, ll current_dist)
{
    used[current] = 1;
    for (ll i = 0; i < g[current].size(); i++)
    {
        if (g[current][i] == 1 && used[i] == 0)
        {
            dist[i] = max(dist[i], current_dist);
            dfs(i, current_dist + 1);
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll amount, current, start, best = 0, ans = 0;
    bool isit;
    cin >> amount;
    vector<ll> accept;
    vector<ll> add;
    for (ll i = 0; i < amount; i++)
    {
        used.push_back(0);
        dist.push_back(0);
        for (ll j = 0; j < amount; j++)
        {
            add.push_back(0);
        }
        g.push_back(add);
        add.clear();
    }
    for (ll i = 0; i < amount; i++)
    {
        g[i][i] = 0;
        cin >> current;
        if (current == -1)
        {
            accept.push_back(i);
        }else
        {
            start = i;
            g[i][current - 1] = 1;
            g[current - 1][i] = 1;
        }
    }
    dfs(start, 1);
    for (int i = 0; i < amount; i++)
    {
        if (dist[i] > best)
        {
            best = dist[i];
            start = i;
        }
    }
    for (int i = 0; i < amount; i++)
    {
        dist[i] = 0;
        used[i] = 0;
    }
    dfs(start, 1);
    best = 0;
    for (int i = 0; i < amount; i++)
    {
        best = max(best, dist[i]);
    }
    ans = best / 2 + 1;
    for (int i = 0; i < accept.size(); i++)
    {
        isit = true;
        for (int j = 0; j < amount; j++)
        {
            if (g[accept[i]][j] == 1)
            {
                isit = false;
                break;
            }
        }
        if (isit)
        {
            ans++;
        }
    }
    cout << ans;
    return 0;
}
