#include<iostream>
#include<vector>
#include<algorithm>

#define int long long 

using namespace std;

const int MAXN = 3e5;
int n, m, a[MAXN + 1], b[MAXN + 1];

void solve1()
{
    cout << n << "\n";
    for (int i = 0; i < n; ++i) {
        cout << n << " ";
    }
}

void solve2()
{
    cout << 2 * n - 1 << "\n";
    for (int i = 0; i < n - 1; ++i) {
        cout << n - i << " ";
    }
    for (int i = 0; i < n; ++i) {
        cout << n << " ";
    }
}

void build(vector<int> & L)
{
    vector<bool> used(n + 1);
    int j = 1;
    for (int i = 1; i <= m; ++i) {
        while (!used[a[i]]) {
            used[b[j]] = 1;
            ++j;
        }
        L.push_back(a[i]);
    }
}

void solve3()
{
    vector<int> L;
    build(L);
    cout << L.size() << "\n";
    vector<int> ans(L.size(), n);
    vector<int> prev(n + 1, -1);
    for (int i = 0; i < L.size(); ++i) {
        if (prev[L[i]] != -1) {
            vector<bool> used(n + 1);
            for (int j = prev[L[i]]; j <= i; ++j) {
                used[L[j]] = 1;
            }
            int cur = 0;
            for (int i = 1; i <= n; ++i) {
                if (used[i]) {
                    ++cur;
                }
            }
            ans[prev[L[i]]] = cur;
        }
        prev[L[i]] = i;
    }
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] << " ";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> b[i];
    }
    bool t1 = 1;
    for (int i = 1; i <= n; ++i) {
        if (a[i] != b[i]) {
            t1 = 0;
        }
    }
    if (t1) {
        solve1();
        return 0;
    }
    bool t2 = 1;
    for (int i = 1; i <= n; ++i) {
        if (a[i] != b[n - i + 1]) {
            t2 = 0;
        }
    }
    if (t2) {
        solve2();
        return 0;
    }
    if (n <= 2000 && m <= 2000) {
        solve3();
        return 0;
    }
    return 0;
}