#include<iostream>
#include<vector>
#include<algorithm>

#define int long long 

using namespace std;

int n;
const int MAXN = 300000;
int a[MAXN + 1];

void solve1()
{
    int ans = 1;
    for (int mask = 1; mask < (1LL << n); ++mask) {
        bool ok = 1;
        for (int i = 1; i <= n; ++i) {
            if (a[i] != -1 && (mask & (1LL << (i - 1))) && (mask & (1LL << (a[i] - 1)))) {
                ok = 0;
            }
        }
        if (ok) {
            int cur = 0;
            for (int i = 0; i < n; ++i) {
                if (mask & (1LL << i)) {
                    ++cur;
                }
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    if (n <= 20) {
        solve1();
    }
    //system("pause");
    return 0;
}