#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>

typedef long long lol;

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector <int> cards(n), positions(n);
	vector <int> goods(m);
	for (int i = 0; i < m; i++)
	{
		cin >> goods[i];
		goods[i]--;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> cards[i];
		cards[i]--;
		positions[cards[i]] = i;
	}
	vector <int> answer;
	for (int i = 0; i < m; i++)
	{
		while (cards[0] != goods[i])
		{
			int next_position = 0;
			for (int j = i; (j < m) && (goods[j] != cards[0]); j++)
			{
				next_position = max(next_position, positions[goods[j]]);
			}
			answer.push_back(next_position + 1);
			int current_card = cards[0];
			for (int j = 1; j <= next_position; j++)
			{
				cards[j - 1] = cards[j];
			}
			cards[next_position] = current_card;
			for (int j = 0; j < n; j++)
			{
				positions[cards[j]] = j;
			}
		}
		int next_position = 0;
		for (int j = i + 1; (j < m) && (goods[j] != cards[0]); j++)
		{
			next_position = max(next_position, positions[goods[j]]);
		}
		answer.push_back(next_position + 1);
		int current_card = cards[0];
		for (int j = 1; j <= next_position; j++)
		{
			cards[j - 1] = cards[j];
		}
		cards[next_position] = current_card;
		for (int j = 0; j < n; j++)
		{
			positions[cards[j]] = j;
		}
	}
	cout << answer.size() << "\n";
	for (int i = 0; i < answer.size(); i++)
	{
		cout << answer[i] << " ";
	}
	return 0;
}