#include<bits/stdc++.h>

#pragma GCC optimize("unroll-loops", "Ofast", "fast-math", "O3")

#define endl '\n'

using namespace std;

const int inf = 1e9 + 228;


vector < vector < int > > a;

bool check(vector < pair < int, int > > &seg){
    int i, n = seg.size(), tec_l = -inf, tec_r = inf;
    for (i = 0; i < n; i++){
        tec_l = max(tec_l, seg[i].first);
        tec_r = min(tec_r, seg[i].second);
    }
    return tec_l <= tec_r;
}

bool checker(vector < int > &inds){
    int i, j, n = a.size(), k = a[0].size();
    vector < vector < pair < int, int  > > > x(k);
    bool f = true;
    for (i = 0; i < k; i++){
        for (j = 0; j < n; j += 2){
            pair < int, int > cur = {min(a[inds[j]][i], a[inds[j + 1]][i]), max(a[inds[j]][i], a[inds[j + 1]][i])};
            x[i].push_back(cur);
        }
        f = f & check(x[i]);
    }

    return f;

}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int i, j, l, n, k;
    cin >> n >> k;
    a.assign(n, vector < int > (k));
    for (i = 0; i < n; i++){
        for (j = 0; j < k; j++){
            cin >> a[i][j];
        }
    }
    if (k == 1){
        cout << "YES" << endl;
        vector < pair < int, int > > b(n);
        for (i = 0; i < n; i++){
            b[i].first = a[i][0]; b[i].second = i;
        }
        sort(b.begin(), b.end());
        for (i = 0; i < n / 2; i++){
            cout << b[i].second + 1 << " " << b[n - i - 1].second + 1 << endl;
        }
        return 0;
    }
    vector < int > inds(n);
    for (i = 0; i < n; i++){
        inds[i] = i;
    }
    if (checker(inds)){
        cout << "YES" << endl;
        for (i = 0; i < n; i += 2){
            cout << inds[i] + 1 << " " << inds[i + 1] + 1 << endl;
        }
        return 0;
    }
    while (next_permutation(inds.begin(), inds.end())){
        if (checker(inds)){
            cout << "YES" << endl;
            for (i = 0; i < n; i += 2){
                cout << inds[i] + 1 << " " << inds[i + 1] + 1 << endl;
            }
            return 0;
        }
    }
    if (checker(inds)){
        cout << "YES" << endl;
        for (i = 0; i < n; i += 2){
            cout << inds[i] + 1 << " " << inds[i + 1] + 1<< endl;
        }
        return 0;
    }
    cout << "NO" << endl;

    return 0;
}
/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
*/
