#include <iostream>
#include <vector>

using ll = int64_t;
const ll MOD = 1000000007;


int main(){
	ll n,k; std::cin>>n>>k;
	std::vector<std::vector<std::vector<ll>>> dp(n+1,std::vector<std::vector<ll>>(n+1,std::vector<ll>(2,0)));
	
	if(k == n){
		std::cout<<1<<std::endl;
		return 0;
	}

	dp[k][k][1] = 1;
	for(int s=k+1;s<=n;s++){
		dp[s][1][0] = 0;
		for(int a=2;a<=n;a++){
			if(s-a > 0)
				dp[s][a][0] = (dp[s-1][a-1][0] + dp[s-a][a-1][1])%MOD;
		}
		dp[s][n][1]= 0;
		for(int a=n-1;a>=1;a--){
			if(s-a > 0)
				dp[s][a][1] = (dp[s-1][a-1][1] - dp[s-a][a][0] + MOD)%MOD;
			dp[s][0][1] = (dp[s][0][1] + dp[s][a][0])%MOD;
		}
	}
	
	ll ans1 = 0;
	for(int a=1;a<=n;a++)
		ans1 = (ans1 + dp[n][a][0] + dp[n][a][1])%MOD;
		
	dp.assign(n+1,std::vector<std::vector<ll>>(n+1,std::vector<ll>(2,0)));
	dp[k][k][1] = 1;
	dp[k][0][0] = 1;
	for(int s=k+1;s<=n;s++){
		dp[s][n][0] = 0;
		for(int a=n-1;a>=1;a--){
			if(s-a > 0)
				dp[s][a][0] = (dp[s-1][a-1][0] - dp[s-a][a][1] + MOD)%MOD;
		}
		dp[s][1][1]= 0;
		for(int a=2;a<=n;a++){
			if(s-a > 0)
				dp[s][a][1] = (dp[s-1][a-1][1] + dp[s-a][a-1][0])%MOD;
			dp[s][0][0] = (dp[s][0][0] + dp[s][a][1])%MOD;
		}
	}
	
	ll ans2 = 0;
	for(int a=1;a<=n;a++)
		ans2 = (ans2 + dp[n][a][0] + dp[n][a][1])%MOD;
		
	std::cout<<(ans1+ans2)%MOD<<std::endl;
}
