#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define ll long long
#define ld long double
#define eb emplace_back
#define mp make_pair

using namespace std;

const int N = 3e5 + 5;
vector<int> g[N];
bool cycle[N];
int used[N];
int dp0[N], dp1[N];
int dp[N][2][2];  /// vertex, chosen, first vertex chosen

void cdfs(int v, int& bt) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            cdfs(u, bt);
        }
        else if (used[u] == 1) {
            bt = u;
            break;
        }
        if (bt != -1) {
            break;
        }
    }
    if (!sz(g[v])) {
        cycle[v] = 1;
    }
    if (bt != -1) {
        cycle[v] = 1;
    }
    if (bt == v) {
        bt = -1;
    }
    used[v] = 2;
}

void tdfs(int v) {
    used[v] = 1;
    dp0[v] = 0;
    dp1[v] = 1;
    for (int u : g[v]) {
        if (used[u] || cycle[u]) {
            continue;
        }
        tdfs(u);
        dp0[v] += dp1[u];
        dp1[v] += dp0[u];
    }
}

void xdfs(int v, vector<int>& path) {
    path.eb(v);
    used[v] = 1;
    for (int u : g[v]) {
        if (cycle[u] && !used[u]) {
            xdfs(u, path);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int v;
        cin >> v;
        g[v].eb(i);
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            int bt = -1;
            cdfs(i, bt);
        }
    }
    fill(used, used + N, 0);
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            tdfs(i);
        }
    }
    fill(used, used + N, 0);
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            vector<int> path;
            xdfs(i, path);
            dp[path[0]][1][1] = dp1[path[0]];
            dp[path[0]][0][0] = dp0[path[0]];
            for (int j = 1; j < sz(path); ++j) {
                dp[path[j]][1][1] = dp[path[j - 1]][0][1] + dp1[path[j]];
                dp[path[j]][0][1] = max(dp[path[j - 1]][0][1], dp[path[j - 1]][1][1]) + dp0[path[j]];
                if (j != sz(path) - 1) {
                    dp[path[j]][1][0] = dp[path[j - 1]][0][0] + dp1[path[j]];
                    dp[path[j]][0][0] = max(dp[path[j - 1]][0][0], dp[path[j - 1]][1][0]) + dp0[path[j]];
                }
            }
            int cur = 0;
            for (int j = 0; j < 2; ++j) {
                for (int k = 0; k < 2; ++k) {
                    cur = max(cur, dp[path.back()][j][k]);
                }
            }
            ans += cur;
        }
    }
    cout << ans;
    return 0;
}

