#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define ll long long
#define ld long double
#define eb emplace_back
#define mp make_pair

using namespace std;

const int N = 405;

int g[N][N], mt[N], used[N];

bool dfs(int v, int it) {
    if (used[v] == it) {
        return false;
    }
    used[v] = it;
    for (int u = 0; u < N; ++u) {
        if (g[v][u] && (mt[u] == -1 || dfs(mt[u], it))) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    vector<vector<pii>> a(n, vector<pii>(k));
    vector<pii> ms(n);
    for (int i = 0; i < n; ++i) {
        ms[i].s = i;
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j].f;
            a[i][j].s = i;
        }
    }
    if (n < 402) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i != j) {
                    g[i][j] = 1;
                }
            }
        }
        vector<bool> part(n);
        for (int p = 0; p < k; ++p) {
            sort(all(a), [&p](const vector<pii>& a, const vector<pii>& b) {
                return a[p].f < b[p].f;
            });
            if (p == 0) {
                for (int i = n / 2; i < n; ++i) {
                    part[a[i][p].s] = 1;
                }
            }
            int x = (a[n / 2][p].f == a[n / 2 - 1][p].f ? a[n / 2][p].f : -1);
            for (int i = 0; i < n / 2; ++i) {
                for (int j = 0; j < n / 2; ++j) {
                    if (a[i][p].f != x && a[j][p].f != x) {
                        g[a[i][p].s][a[j][p].s] = 0;
                        g[a[j][p].s][a[i][p].s] = 0;
                    }
                }
            }
            for (int i = n / 2; i < n; ++i) {
                for (int j = n / 2; j < n; ++j) {
                    if (a[i][p].f != x && a[j][p].f != x) {
                        g[a[i][p].s][a[j][p].s] = 0;
                        g[a[j][p].s][a[i][p].s] = 0;
                    }
                }
            }
        }
        fill(mt, mt + n, -1);
        for (int i = 0; i < n; ++i) {
            if (part[i] == 0) {
                dfs(i, i + 1);
            }
        }
        if (count(mt, mt + n, -1) == n / 2) {
            cout << "YES\n";
            for (int i = 0; i < n; ++i) {
                if (mt[i] != -1) {
                    cout << i + 1 << ' ' << mt[i] + 1 << '\n';
                }
            }
        }
        else {
            cout << "NO\n";
        }
        return 0;
    }
    for (int p = 0; p < k; ++p) {
        sort(all(a), [&p](const vector<pii>& a, const vector<pii>& b) {
            return a[p].f < b[p].f;
        });
        for (int i = n / 2; i < n; ++i) {
            ms[a[i][p].s].f |= (1 << p);
        }
    }
    sort(all(ms));
    for (int i = 0; i < n / 2; ++i) {
        if (ms[i].f + ms[n - i - 1].f != (1 << k) - 1) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES\n";
    for (int i = 0; i < n / 2; ++i) {
        cout << ms[i].s + 1 << ' ' << ms[n - i - 1].s + 1 << '\n';
    }
    return 0;
}

