#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].push_back(x - 1);
            g[x - 1].push_back(i);
        }
    }
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = {g[i].size(), i};
    }
    sort(v.begin(), v.end());
    vector<bool> used(n);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        auto cv = v[i];
        if (used[cv.second]) {
            continue;
        }
        used[cv.second] = true;
        ans++;
        for (int nv : g[cv.second]) {
            used[nv] = true;
        }
    }
    cout << ans << endl;
}