#include <bits/stdc++.h>
#include <stdint.h>

using namespace std;

vector<int>* factor(int n){
  vector<int>* res = new vector<int>();
  for(int i = 1; i*i <= n; i++){
    if(n%i==0){
      res->push_back(i);
      // res.push_back(n/i);
    }
  }
  return res;
}

int force(int k){
  for(int i = 0; i < 1000; i++){
    int t = i*i+k;
    float r = sqrt(t); 
    if(floor(r)==r){
      return r;
    }
  }
  return -1;
}

int smart(int k){
  if(k==0){
    return 0;
  }else{
    int res = 0x7fffffff;
    int ak = abs(k);
    auto factors = factor(ak);
    for(auto d : *factors){
      int t = -k/d - d;
      if(t%2==0){
        res = min(res,abs(t/2));
      }
    }
    delete factors;
    if(res == 0x7fffffff){
      res = -1;
    }
    return res;
  }
}

int main(){
  // for(int k = 0; k < 1000; k++){
  //   if(smart(k)!=force(k)){
  //     cout << "k = " << k << "; smart(k) = " << smart(k) << "; force(k) = " << force(k) << "\n";
  //   }
  // }

  // return 0;

  int k;
  cin >> k;

  int res = smart(k);
  if(res==-1){
    cout << "none";
  }else{
    cout << res;
  }

  cout << "\n";
  return 0;
}