#include <bits/stdc++.h>
#include <stdint.h>

using namespace std;

vector<int64_t>* factor(int64_t n){
  // cout << "factor start\n";
  vector<int64_t>* res = new vector<int64_t>();
  for(int64_t i = 1; i*i <= n; i++){
    if(n%i==0){
      res->push_back(i);
      // res.push_back(n/i);
    }
  }
  // cout << "factor end\n";
  return res;
}

int64_t force(int64_t k){
  for(int64_t i = 0; i < 1000; i++){
    int64_t t = i*i+k;
    float r = sqrt(t); 
    if(floor(r)==r){
      return r;
    }
  }
  return -1;
}

int64_t smart(int64_t k){
  if(k==0){
    return 0;
  }else{
    int64_t res = 0x7fffffffffffffff;
    int64_t ak = abs(k);
    auto factors = factor(ak);
    for(auto d : *factors){
      int64_t t = -k/d - d;
      if(t%2==0){
        res = min(res,abs(t/2));
      }
    }
    delete factors;
    if(res == 0x7fffffffffffffff){
      res = -1;
    }
    return res;
  }
}

int main(){
  // for(int64_t k = 0; k < 1000; k++){
  //   if(smart(k)!=force(k)){
  //     cout << "k = " << k << "; smart(k) = " << smart(k) << "; force(k) = " << force(k) << "\n";
  //   }
  // }

  // return 0;

  int64_t k;
  cin >> k;

  int64_t res = smart(k);
  if(res==-1){
    cout << "none";
  }else{
    cout << res;
  }

  cout << "\n";
  return 0;
}