#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

#define max(a,b) (a>b?a:b)
#define min(a,b) ((a)<(b)?(a):(b))

int n;

int* arr;
char* colors;
vector<int>* tree;

int pick(){
  for(int i = 0; i < n; i++){
    if(colors[i]==0)return i;
  }
  return -1;
}

int pick(vector<int> v,char plarity){
  for(auto i : v){
    if((colors[i]&plarity) == 0)return i;
  }
  return -1;
}

int rec(int i,bool color,char plarity){

  colors[i] = plarity;
  int p = pick(tree[i],plarity);
  if(p<0)return color;
  int res = color+rec(p,!color,plarity);

  // cout << "rec(" << i << ", " << color << ") = "<< res <<"\n";
  return res;
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }
  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0)continue;
    tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  while(1){
    int t = pick();
    if(t==-1)break;
    int a = rec(t,true,1);
    int b = rec(t,false,2);
    res += max(a,b);
  }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}