#include <iostream>
#include <cmath>

using namespace std;
//-9999999999999
int64_t sign(int64_t k)
{
    return k < 0 ? -1 : 1;
}

int64_t scnd(int64_t k)
{
    if(k == 0) {
        return 0;
    }
    int64_t a = round(sqrt(llabs(k)));
    int64_t b = k / a;
    while ((k > 0 && a > 1 || k < 0 && b < -1) && (a * b != k || a * (2 * ((b - a) / 2) + a) != k)) {
        if (sign(k) == 1) {
            a -= 1;
            b = k / a;
        } else {
            b += 1;
            a = k / b;
        }
    }
    if (a * b == k) {
        int64_t l = a;
        int64_t f = (b - a) / 2 * sign(k);
        if(l * (2 * f * sign(k) + l) == k)
            return llabs(f + l * sign(k));
        else
            return -1;
    } else {
        return -1;
    }
}

int64_t scnd_2(int64_t k)
{
    if(k >= 0) {
        return scnd(k);
    }
    int64_t a = -round(sqrt(llabs(k)));
    int64_t b = -k / a;
    while ((a < -1) && (a * b != k || a * (2 * ((b - a) / 2) + a) != k)) {
        a += 1;
        b = k / a;
    }
    if (a * b == k) {
        int64_t l = a;
        int64_t f = (b - a) / 2 * sign(k);
        if(l * (2 * f * sign(k) + l) == k)
            return llabs(f + l * sign(k));
        else
            return -1;
    } else {
        return -1;
    }
}

int main() {
    int64_t k;
    cin >> k;
    int64_t r1 = scnd(k);
    int64_t r2 = r1;
    if(k < 0)
    {
        r2 = scnd_2(k);
    }
    int64_t r;
    if(r1 == -1)
        r = r2;
    else if(r2 == -1)
        r = r1;
    else
        r = min(r1, r2);
    if(r == -1)
        cout << "none";
    else
        cout << r;
    return 0;
}
