#include <bits/stdc++.h>


#define int long long


const int MOD = 1e9 + 7;
using namespace std;


void warp()
{
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int solve(int n, int k)
{
    if (n == k) return 1;
    vector<vector<int> > downShift(n + 1, vector<int> (n + 1));
    vector<vector<int> > upShift(n + 1, vector<int> (n + 1));
    for (int i = 1; i <= n; i++)
    {
        downShift[i][i] = 1;
        upShift[i][i] = 1;
    }
    for (int i = 1; i < n; i++)
    {
        int tmp = 0;
        for (int k = 1; k < n && (i + k + 1 <= n); k++)
        {
            tmp += upShift[i][k];
            tmp %= MOD;
            downShift[i + k + 1][k + 1] = tmp;
        }
        tmp = 0;
        int j = n;
        while (i + j - 1 > n)
        {
            tmp += downShift[i][j];
            tmp %= MOD;
            j--;
        }
        while (j > 1)
        {
            tmp += downShift[i][j];
            tmp %= MOD;
            upShift[i + j - 1][j - 1] = tmp;
            j--;
        }
    }
    return downShift[n][k] + upShift[n][k];
}


signed main()
{
    //warp();
    int n, k;
    cin >> n >> k;
    cout << solve(n, k) << endl;
    return 0;
}
