#include <bits/stdc++.h>


#define int long long


using namespace std;


void warp()
{
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


bool in(int mask, int i)
{
    return ((mask & (1 << i)) > 0);
}


int dumbSolve(vector<int> a)
{
    int n = a.size();
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        int cnt = 0;
        bool flag = true;
        for (int i = 0; i < n; i++)
        {
            if (in(mask, i)) cnt++;
            if (a[i] != -1 && in(mask, i) && in(mask, a[i])) flag = false;
        }
        if (flag)
        {
            ans = max(ans, cnt);
        }
    }
    return ans;
}


pair<int, int> dfs(int v, vector<vector<int> > &g, vector<bool> &used)
{
    used[v] = true;
    pair<int, int> ans = make_pair(1, 0);
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (used[u]) continue;
        pair<int, int> res = dfs(u, g, used);
        ans.first += res.second;
        ans.second += res.first;
    }
    return ans;
}


int solve(vector<int> &a)
{
    int n = a.size();
    vector<vector<int> > g(n);
    for (int i = 0; i < n; i++)
    {
        if (a[i] == -1) continue;
        g[i].push_back(a[i]);
        g[a[i]].push_back(i);
    }
    vector<bool> used(n);
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (used[i]) continue;
        pair<int, int> res = dfs(i, g, used);
        ans += max(res.first, res.second);
    }
    return ans;
}


signed main()
{
    //warp();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (a[i] > 0) a[i]--;
    }
    if (n <= 20) cout << dumbSolve(a) << endl;
    else cout << solve(a) << endl;
    return 0;
}
