//#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long

const int MAXN = 5001;
const int mod = 1e9 + 7;
int dp[MAXN][MAXN][2];

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			int t0 = 0;
			int t1 = 0;
			for (int k = 0; k < j; k++)
			{
				t1 += dp[i - j][k][0];
			}
			for (int k = j + 1; k <= n; k++)
			{
				t0 += dp[i - j][k][1];
			}
			dp[i][j][0] = t0 % mod;
			dp[i][j][1] = t1 % mod;
		}
	}
	if (n == k)
	{
		cout << 1;
	}
	else
	{
		int ans = 0;
		for (int i = 0; i <= n; i++)
		{
			ans += dp[n][i][0] + dp[n][i][1];
			ans %= mod;
		}
		cout << ans;
	}
}


