#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cmath>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define popb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

signed main() {

	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n);
	for (auto &i : a)
		cin >> i;
	for (auto &i : b)
		cin >> i;

	vector<int> tmp = a;
	vector<int> c;
	int pn = 0, pm = 0;
	for ( ; pn < n && pm < m; ) {
		if (a[pm] != b[pn]) {
			while (pn < n && a[pm] != b[pn]) {
				c.pb(b[pn]);
				++pn;
			}
		}
		else {
			c.pb(a[pm]);
			++pn, ++pm;
		}
	}
	while (pm < m) {
		c.pb(a[pm]);
		++pm;
	}
	// for (int i = 0; i < n; ++i) {
	// 	c.pb(i + 1);
	// }

	// for (int i = 0; i < sz(c); ++i) {
	// 	cout << c[i] << " ";
	// }
	// cout << endl;

	vector<int> ans;
	int last = n;

	for (int i = 0; i < sz(c); ++i) {
		int p = -1;
		for (int j = i + 1; j < sz(c); ++j) {
			if (c[i] == c[j]) {
				p = j;
				break;
			}
		}
		if (p == -1) {
			ans.pb(n);
			--last;
		}
		else {
			ans.pb(min(p - i, last));
		}
	}

	cout << sz(ans) << endl;
	for (int i = 0; i < sz(ans); ++i) {
		cout << ans[i] << " ";
	}

	return 0;
}