#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

vector<int> g;
vector<vector<int>> ag;
vector<int> ts, cycle;
vector<bool> used, iscyc;

vector<vector<int>> dp;

void dfs(int v) {
	used[v] = true;
	int u = g[v];
	if (u != -1 && !used[u]) dfs(u);
	ts.pb(v);
}

void dfs2(int v) {
	cycle.pb(v);
	used[v] = true;
	int u = g[v];
	if (u == -1) return;
	if (used[u]) return;
	dfs2(u);
}

void dfs3(int v) {
	dp[v][0] = 0;
	dp[v][1] = 1;

	int a = 0, b = 0;

	for (auto &u : ag[v]) {
		if (iscyc[u]) continue;
		dfs3(u);
		a += dp[u][1];
		b += dp[u][0];
	}

	dp[v][0] += max(a, b);
	dp[v][1] += b;
}

signed main() {
	int n;
	cin >> n;
	g.resize(n);
	dp.resize(n, vector<int>(2));
	ag.resize(n);
	used.resize(n);
	iscyc.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> g[i];
		if (g[i] != -1)  {
			--g[i];
			ag[g[i]].pb(i);
		}
	}

	for (int i = 0; i < n; ++i) {
		if (used[i]) continue;
		dfs(i);
	}
	reverse(all(ts));

	// for (auto &i : ts) {
	// 	cout << i + 1 << " ";
	// }
	// cout << endl;

	fill(all(used), false);
	dfs2(ts.back());

	// for (auto &i : cycle) {
	// 	cout << i + 1 << " ";
	// }
	// cout << endl;

	for (auto &v : cycle) {
		iscyc[v] = 1;
	}

	for (auto &v : cycle) {
		dfs3(v);
	}

	// for (auto &v : cycle) {
	// 	cout << v + 1 << endl;
	// 	cout << dp[v][0] << " " << dp[v][1] << endl;
	// }

	int ans1 = 0, ans2 = 0, ans3 = 0;

	if (sz(cycle) == 1) {
		cout << max(dp[cycle[0]][0], dp[cycle[0]][1]) << endl;
	}
	else if (sz(cycle) % 2 == 0) {
		for (int i = 0; i < sz(cycle); ++i) {
			ans1 += dp[cycle[i]][1 - (i & 1)];
			ans2 += dp[cycle[i]][i & 1];
		}
		cout << max(ans1, ans2) << endl;
	}
	else {
		// fill(all(used), false);
		// int ind = 0;
		// for (int i = cycle[0]; !used[g[i]]; i = g[i]) {
		// 	ans1 += dp[i][1 - (ind & 1)];
		// 	ans2 += dp[i][ind & 1];
		// 	++ind;
		// 	used[i] = true;
		// }
		for (int i = 0; i < sz(cycle) - 1; ++i) {
			ans1 += dp[cycle[i]][1 - (i & 1)];
			ans2 += dp[cycle[i]][i & 1];
		}
		int kek = max(ans1, ans2) + dp[cycle.back()][0];
		ans1 -= dp[cycle[0]][1];
		ans1 += dp[cycle[0]][0];
		ans1 += dp[cycle.back()][1];
		kek = max(kek, ans1);
		cout << kek << endl;
	}

	return 0;
}