/*#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("Ofast")*/

#include <bits/stdc++.h>

#define endl "\n"
#define pii pair<int,int>
//#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const double EPS = 1e-10;
const int Q = 31;
const int P = 1e9 + 9;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}


void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector <int>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}
void show(vector<pii>& arr)
{
    for (auto i : arr)
        cout << i.first << " " << i.second << "    ";
    cout << endl;
}




vector <vector<int>> graph;
vector <int> used;
vector <int> usedt;
vector <int> st;
vector <int> cycle;

bool cdfs(int v, int prev)
{
    used[v] = 1;
    st.push_back(v);
    bool res = 0;
    int tmp = -1;
    for (auto to : graph[v])
    {

        if (to == prev)
        {
            prev = -1;
            continue;
        }
        if (used[to] == 1)
        {
            tmp = to;
            res = 1;
        }
        if (!used[to])

            res = cdfs(to, v) || res;
    }
    //cout << endl << endl;

    if (tmp != -1 && cycle.empty())
    {
        for (int i = st.size() - 1; st[i] != tmp; --i)
            cycle.push_back(st[i]);

        cycle.push_back(tmp);
    }

    used[v] = 2;
    //cout << v << " " << res << endl;
    st.pop_back();
    return res;
}

vector <pii> dp;


void dfsdp(int v, int prev, int l, int r)
{
    dp[v].first = 1;
    for (auto to : graph[v])
    {
        if (to == prev || to == l || to == r)
            continue;
        dfsdp(to, v, l, r);
        dp[v].first += dp[to].second;
        dp[v].second += max(dp[to].first, dp[to].second);
    }
}



int main()
{
    hello();

    int n;
    cin >> n;
    graph.resize(n);
    used.resize(n);
    usedt.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; ++i)
    {
        int v;
        cin >> v;
        if (v == -1)
            continue;
        graph[v - 1].push_back(i);
        graph[i].push_back(v - 1);
    }


    int res = 0;

    for (int i = 0; i < n; ++i)
    {
        if (used[i])
            continue;
        cycle.clear();
        int tmp = cdfs(i, -1);
        if (tmp)
        {
        //show(cycle);
        random_shuffle(cycle.begin(), cycle.end());
            for (int j = 0; j < cycle.size(); ++j)
            {
                int l, r;
                if (j == 0)
                    l = cycle.back();
                else
                    l = cycle[j - 1];
                r = cycle[(j + 1) % cycle.size()];
                dfsdp(cycle[j], -1, l, r);
               // cout << cycle[j] << " " << l << " " << r << endl;

            }


            //show(dp);
            for (int j1 = 1; j1 < cycle.size(); ++j1)
            {
                int j = cycle[j1];
                int jj = cycle[j1 - 1];
                dp[j].first += dp[jj].second;
                dp[j].second += max(dp[jj].first, dp[jj].second);
            }

            if (cycle.size() % 2)
                dp[cycle.back()].first--;


             //show(dp);


            res += max(dp[cycle.back()].second, dp[cycle.back()].first);
        }
        else
        {
            dfsdp(i, -1, -1, -1);
            res += max(dp[i].first, dp[i].second);
        }
    }

    cout << res << endl;
}
