#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#define lint long long
using namespace std;

bool veq(vector<int>& a, vector<int>& b)
{
    if(a.size() != b.size()) return false;
    for(int i = 0; i < a.size(); i++)
    {
        if(a[i] != b[i]) return false;
    }
    return true;
}
int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < m; i++) cin >> b[i];
    if(veq(a, b))
    {
        cout << n << '\n';
        for(int i = 0; i < n; i++) cout << n << ' ';
    }
    else
    {
        vector<int> ans(n);
        int dop = 0;
        int ind = 0, k = 0;
        while(k + dop < n)
        {
            if(b[k + dop] == a[ind])
            {
                ans[k + dop] = n;
                k++;
                ind++;
            }
            else
            {
                ans[k + dop] = n - k - dop;
                dop++;
            }
        }
        cout << n + dop << '\n';
        for(int i = 0; i < n; i++) cout << ans[i] << ' ';
        for(int i = 0; i < dop; i++) cout << n << ' ';
    }
}
