#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define f   first
#define s   second

typedef pair<int, int> pr;

set<long long> sq;

long long solve(long long k) {
    bool fl = false;
    if (!k) {
        return 0;
       // exit(0);
    }
    if (sq.find(k) != sq.end())
        return (long long)sqrt(k);
    if (k < 0) {
        fl = true;
        k = -k;
    }
    if (k % 4 == 2) {
        return -1;
        //cout << "none";
      //  exit(0);
    }
    if (k % 2) {
        if (!fl) {
            return (k + 1) / 2;
           // exit(0);
        }
        else {
            return k / 2;
         //   exit(0);
        }
    }
    long long m = k / 4;
    if (fl)
        --m;
    else
        ++m;
    return m;
}

long long solve1(long long k) {
    bool fl = false;
    if (k < 0) {
        fl = true;
        k = -k;
    }
    if (k == 0)
        return 0;
    if (k % 4 == 2) {
        return -1;
        //cout << "none";
      //  exit(0);
    }
    long long h = (long long)sqrt(k);
    while (true) {
        if (k % h == 0) {
            if ((k % 4) || ((h % 2 == 0) && ((k / h) % 2 == 0)))
                break;
        }
        --h;
    }
    long long a = h;
    long long b = k / h;
    long long l = (a + b) / 2;
    if (!fl) {
        return l;
        //exit(0);
    }
    l = l - min(a, b);
    return l;
}

//set <long long> sq;

long long naive(long long k) {
    for (long long l = 0; l < 1000; ++l) {
        if (sq.find(l * l - k) != sq.end())
            return l;
    }
    return -1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long k;
    cin >> k;
    /*for (int i = 0; i < 1001; ++i)
        sq.insert(i * i);
    for (int i = 0; i < 1000; ++i) {
        cout << i << '\n';
        if (naive(i) != solve1(i)) {
            cout << solve1(i) << ' ' << naive(i) << '\n';
            exit(0);
        }
    }*/
    long long res = solve1(k);
    if (res == -1) {
        cout << "none";
        exit(0);
    }
    cout << res;

    return 0;
}
