#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> ans;
vector<int> used;
pair<int, int> pp;

void dfs(int v, int last) {
	used[v] = 1;
	ans[v] = { 1,0 };
	for (auto i : g[v]) {
		if (used[i]==0) {
			dfs(i, v);
			ans[v].first += ans[i].second;
			ans[v].second += max(ans[i].first, ans[i].second);
		}
		else {
			if (i != last) {
				pp.first = i;
				pp.second = last;
			}
		}
	}
}

void dfs1(int v, int is,int x) {
	used[v] = x;
	ans[v] = { 1,0 };
	for (auto i : g[v]) {
		if (used[i]<x) {
			dfs1(i, is, x);
			if (i != is) {
				ans[v].first += ans[i].second;
				ans[v].second += max(ans[i].first, ans[i].second);
			}
			else {
				ans[v].first += ans[i].second;
				ans[v].second += ans[i].second;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	g.resize(n);
	used.resize(n, 0);
	ans.resize(n);
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		if (x != -1) {
			g[i].push_back(x - 1);
			g[x - 1].push_back(i);
		}
	}
	long long an = 0;
	for (int i = 0; i < n; i++) {
		if (used[i]==0) {
			pp = { -1,-1 };
			dfs(i, -1);
			if (pp.first == -1) {
				an += max(ans[i].first, ans[i].second);
			}
			else {
				int an1=0;
				dfs1(i, pp.first, 2);
				if (pp.first == i) {
					an1 = max(an1, ans[i].second);
				}
				else {
					an1 = max(an1, max(ans[i].first, ans[i].second));
				}
				dfs1(i, pp.first, 3);
				if (pp.second == i) {
					an1 = max(an1, ans[i].second);
				}
				else {
					an1 = max(an1, max(ans[i].first, ans[i].second));
				}
				an += an1;
			}
		}
	}
	cout << an;
	system("pause");
}
