#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <cassert>
#include <cmath>
#include <math.h>
#include <time.h>
#include <ctime>
#define int long long
#define double long double

using namespace std;

const int sz = 3e5, inf = 1e15;
pair<int, int> tree[4 * sz];
int mod[4 * sz];

void rc(int v)
{
	mod[2 * v] += mod[v], mod[2 * v + 1] += mod[v];
	mod[v] = 0;
	tree[v].first = min(tree[2 * v].first + mod[2 * v], tree[2 * v + 1].first + mod[2 * v + 1]);
	if (tree[v].first == tree[2 * v].first + mod[2 * v])
		tree[v].second = tree[2 * v].second;
	else
		tree[v].second = tree[2 * v + 1].second;
}

void push(int v, int l, int r, int x, int pl)
{
	if (l + 1 == r)
	{
		tree[v] = { x + mod[v], l };
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		push(2 * v, l, m, x, pl);
	else
		push(2 * v + 1, m, r, x, pl);
	rc(v);
}

void solve()
{
	return;
}

signed main()
{
	//freopen("input.txt", "r", stdin);
	for (int i = 0; i < 4 * sz; i++)
		tree[i] = { -inf, 0 }, mod[i] = 0;
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(m), st(m, 0);
	vector<vector<int>> num(m);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
		push(1, 0, sz, b[i], i);
	}
	for (int i = 0; i < m; i++)
	{
		num[a[i]].push_back(i);
	}
	vector<int> ans;
	int max_n = n, cnt = 0;
	if (a[0] == b[0])
	{
		cout << n << "\n";
		for (int i = 0; i < n; i++)
			cout << n << " ";
	}
	else if (a[0] == b[n - 1])
	{
		cout << 2 * n - 1 << "\n";
		for (int i = 0; i < n - 1; i++)
			cout << n - i << " ";
		for (int i = 0; i < n; i++)
			cout << n << " ";
	}
	else if ((n <= 2000) && (m <= 2000))
		solve();
	return 0;
}