#pragma gcc("OFast")

#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 1;
int cur_comp;
int a[MAXN], col[MAXN];
int dp[MAXN][2][2];
vector<int> topsort;
vector<int> gr[MAXN], comp[MAXN];
bool on_cycle[MAXN];
int cache[MAXN][2];

void top(int v) {
	col[v] = 1;
	if (a[v] != -1 && !col[a[v]])
		top(a[v]);
	topsort.pb(v);
}

void cond(int v) {
	col[v] = cur_comp;
	comp[cur_comp].pb(v);
	for (int u : gr[v])
		if (!col[u])
			cond(u);
}

int count(int v, int ccol) {
	if (cache[v][ccol] != -1) return cache[v][ccol];
	int res = ccol;
	if (!ccol) {
		for (int u : gr[v])
			if (!on_cycle[u])
				res += max(count(u, 0), count(u, 1));
	}
	else {
		for (int u : gr[v])
			if (!on_cycle[u])
				res += count(u, 0);
	}
	return cache[v][ccol] = res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i)
		cache[i][0] = cache[i][1] = -1;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		if (a[i] != -1)
			gr[a[i]].pb(i);
	}
	for (int i = 1; i <= n; ++i)
		if (!col[i])
			top(i);
	memset(col, 0, sizeof col);
	for (int i = n - 1; i >= 0; --i) {
		int v = topsort[i];
		if (!col[v]) {
			++cur_comp;
			cond(v);
		}
	}
	int ans = 0;
	for (int i = 1; i <= cur_comp; ++i) {
		int sz = comp[i].size();
		if (sz == 1) continue;
		for (int j : comp[i])
			on_cycle[j] = true;
		vector<pair<int, int>> vals;
		for (int j : comp[i])
			vals.pb({count(j, 0), count(j, 1)});
		dp[0][0][0] = vals[0].f;
		dp[0][1][1] = vals[0].s;
		for (int j = 1; j < sz; ++j) {
			for (int l = 0; l < 2; ++l) {
				dp[j][0][l] = max(dp[j - 1][0][l], dp[j - 1][1][l]) + vals[j].f;
				dp[j][1][l] = dp[j - 1][0][l] + vals[j].s;
			}
		}
		ans += max(dp[sz - 1][1][0], max(dp[sz - 1][0][0], dp[sz - 1][0][1]));
	}
	for (int i = 1; i <= n; ++i)
		if (a[i] == -1)
			ans += max(count(i, 0), count(i, 1));
	cout << ans;
    return 0;
}