#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

/*

void build(int v, int l, int r)
{
	if (l + 1 == r)
	{
		rmq[v] = a[v];
		return;
	}
	build(v + v, l, (l + r) / 2);
	build(v + v + 1, (l + r) / 2, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl) return 0;
	if (l <= tl && r >= tr)
	{
		return rmq[v];
	}
	return get(v + v, tl, (tl + tr) / 2, l, r) + get(v + v + 1, (tl + tr) / 2, tr, l, r);
}


int update(int v, int l, int r, int ind, int x)
{
	if (l + 1 == r)
	{
		rmq[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (ind < m) update(v + v, l, m, ind, x);
	else update(v + v + 1, m, r, ind, x);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

*/

#define int long long
int32_t main()
{
	int k;
	cin >> k;
	if (k == 0)
	{
		cout << 0;
		return 0;
	}
	if (k > 0)
	{
		vector<int> d;
		int ans = 1e18, f, s;
		bool flag = true;
		for (int i = 1; i * i <= k; i++)
		{
			if (k % i == 0)
			{
				f = i;
				s = k / i;
				if (!((s - f) & 1))
				{
					if (flag)
					{
						ans = f + (s - f) / 2;
						flag = false;
						continue;
					}
					ans = min(ans, f + (s - f) / 2);
				}
			}
		}
		if (flag) cout << "none";
		else cout << ans;
		return 0;
	}
	k = -k;
	int ans = 1e18, f, s;
	bool flag = true;
	for (int i = 1; i * i <= k; i++)
	{
		if (k % i == 0)
		{
			f = i;
			s = k / i;
			if (!((s - f) & 1))
			{
				if (flag)
				{
					ans = (s - f) / 2;
					flag = false;
					continue;
				}
				ans = min(ans, (s - f) / 2);
			}
		}
	}
	cout << ans;
	system("pause");
	return 0;
}