#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

/*

void build(int v, int l, int r)
{
	if (l + 1 == r)
	{
		rmq[v] = a[v];
		return;
	}
	build(v + v, l, (l + r) / 2);
	build(v + v + 1, (l + r) / 2, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl) return 0;
	if (l <= tl && r >= tr)
	{
		return rmq[v];
	}
	return get(v + v, tl, (tl + tr) / 2, l, r) + get(v + v + 1, (tl + tr) / 2, tr, l, r);
}


int update(int v, int l, int r, int ind, int x)
{
	if (l + 1 == r)
	{
		rmq[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (ind < m) update(v + v, l, m, ind, x);
	else update(v + v + 1, m, r, ind, x);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

*/

#define int long long
int32_t main()
{
	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n);
	vector<vector<int>> q(n, vector<int>(0));
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
		q[a[i]].push_back(i);
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
	}

	if (n == m)
	{
		bool flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[i]);
		if (flag)
		{
			cout << n << '\n';
			for (int i = 0; i < n; i++)
			{
				cout << b[i] + 1 << " ";
			}
			system("pause");
			return 0;
		}
		flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[n - i - 1]);
		if (flag)
		{
			cout << n + n - 1 << '\n';
			for (int i = 0; i < n - 1; i++)
			{
				cout << n - i << " ";
			}
			for (int i = 0; i < n; i++) cout << n << " ";
			system("pause");
			return 0;
		}
	}

	system("pause");
	return 0;
}