#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

/*

void build(int v, int l, int r)
{
	if (l + 1 == r)
	{
		rmq[v] = a[v];
		return;
	}
	build(v + v, l, (l + r) / 2);
	build(v + v + 1, (l + r) / 2, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl) return 0;
	if (l <= tl && r >= tr)
	{
		return rmq[v];
	}
	return get(v + v, tl, (tl + tr) / 2, l, r) + get(v + v + 1, (tl + tr) / 2, tr, l, r);
}


int update(int v, int l, int r, int ind, int x)
{
	if (l + 1 == r)
	{
		rmq[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (ind < m) update(v + v, l, m, ind, x);
	else update(v + v + 1, m, r, ind, x);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

*/

#define int long long
int32_t main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n);
	vector<vector<int>> q(n, vector<int>(0));
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
		q[a[i]].push_back(i);
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
	}

	if (n == m)
	{
		bool flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[i]);
		if (flag)
		{
			cout << n << '\n';
			for (int i = 0; i < n; i++)
			{
				cout << n << " ";
			}
			system("pause");
			return 0;
		}
		flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[n - i - 1]);
		if (flag)
		{
			cout << n + n - 1 << '\n';
			for (int i = 0; i < n - 1; i++)
			{
				cout << n - i << " ";
			}
			for (int i = 0; i < n; i++) cout << n << " ";
			system("pause");
			return 0;
		}
	}


	//if (n <= 2000 && m <= 2000)
	//{
		vector<int> ans;
		bool flag;
		int kolvo;
		int curr = 0;
		vector<bool> used(n, false);
		int where;
		auto it = b.begin();
		int j;
		for (int i = 0; i < m;)
		{
			flag = false;
			curr = b[0];
			kolvo = 0;
			j = i + 1;
			if (a[i] != b[0]) j--;
			for (j; j < m; j++)
			{
				if (a[j] == b[0])
				{
					flag = true;
					break;
				}
				if (!used[a[j]])
				{
					kolvo++;
					used[a[j]] = true;
				}
			}
			b.erase(b.begin());
			/*if (!flag)
			{
				used.assign(n, false);
				ans.push_back(n);
				b.push_back(curr);
				continue;
			}*/
			where = 1;
			for (it = b.begin(); it != b.end(); it++)
			{
				if (kolvo == 0)
				{
					//it++;
					break;
				}
				where++;
				if (used[*it])
				{
					used[*it] = false;
					kolvo--;
				}
			}
			ans.push_back(where);
			b.insert(it, curr);
			if (curr == a[i]) i++;
		}
		cout << ans.size() << '\n';
		for (auto i : ans) cout << i << " ";
		return 0;
	//}
	
	system("pause");
	return 0;
}