#include <bits/stdc++.h>
using namespace std;

#define sz(x) ((int)(x).size())

int b_sz = 1;
int cnt[300228];

struct qr {
    int l, r;
    bool operator<(qr x) {
        if(x.l/b_sz == l/b_sz) {
            return (x.r / b_sz < r / b_sz);
        }
        return x.l/b_sz < l/b_sz;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    int n, m;

    cin >> n >> m;

    vector<int> a(m), ans;
    set<int> super;
    queue<int> q;

    for(int i = 0; i < m; ++i) 
        cin >> a[i];
    
    for(int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        q.push(t);
    }
    
    for(int i = 0; i < m; ++i) {
        if(super.find(a[i]) != super.end())
            ans.push_back(a[i]);
        else {
            while(q.front() != a[i]) {
                super.insert(q.front());
                ans.push_back(q.front());
                q.pop();
            }
            super.insert(q.front());
            ans.push_back(q.front());
            q.pop();
        }
    }

    cout << sz(ans) << endl;

    vector<int> right(sz(ans)), slv(sz(ans));
    set< pair<int, int> > tmp;

    for(int i = sz(ans) - 1; i >= 0; --i) {
        auto p = tmp.lower_bound({ans[i], -1});
        if(p == tmp.end() || (*p).first != ans[i]) {
            slv[i] = n;
            right[i] = -1;
            tmp.insert({ans[i], i});
            continue;
        }
        right[i] = (*p).second;
        tmp.erase(p);
        tmp.insert({ans[i], i});
    }

    b_sz = sqrt(sz(ans));

    vector<qr> t;

    for(int i = 0; i < sz(right); ++i) {
        if(right[i] - i <= 2) {
            if(right[i] == -1)
                slv[i] = n;
            else
                slv[i] = right[i] - i;
        }
        else {
            qr temp;
            temp.l = i + 1;
            temp.r = right[i] - 1;
            t.push_back(temp);
        }
    }

    sort(t.begin(), t.end());

    int tl = 0, tr = 0;
    int all_cnt = 1;
    cnt[ans[0]]++;
    for(int i = 0; i < sz(t); ++i) {
        if(tr < t[i].l) {
            while(tr < t[i].r) {
                cnt[ans[tr + 1]]++;
                if(cnt[ans[tr + 1]] == 1)
                    all_cnt++;
                tr++;
            }
            while(tl < t[i].l) {
                cnt[ans[tl]]--;
                if(cnt[ans[tl]] == 0)
                    all_cnt--;
                tl++;
            }
        }
        else if(tl > t[i].r) {
            while(tl > t[i].l) {
                cnt[ans[tl - 1]]++;
                if(cnt[ans[tl - 1]] == 1)
                    all_cnt++;
                tl--;
            }
            while(tr > t[i].r) {
                cnt[ans[tr]]--;
                if(cnt[ans[tr]] == 0)
                    all_cnt--;
                tr--;
            }
        }
        else {
            while(tr < t[i].r) {
                cnt[ans[tr + 1]]++;
                if(cnt[ans[tr + 1]] == 1)
                    all_cnt++;
                tr++;
            }
            while(tr > t[i].r) {
                cnt[ans[tr]]--;
                if(cnt[ans[tr]] == 0)
                    all_cnt--;
                tr--;
            }
            while(tl > t[i].l) {
                cnt[ans[tl - 1]]++;
                if(cnt[ans[tl - 1]] == 1)
                    all_cnt++;
                tl--;
            }
            while(tl < t[i].l) {
                cnt[ans[tl]]--;
                if(cnt[ans[tl]] == 0)
                    all_cnt--;
                tl++;
            }
        }
        slv[t[i].l - 1] = all_cnt + 1;
    } 

    for(int i = 0; i < sz(slv); ++i)
        cout << slv[i] << " ";
    cout << endl;
    return 0;
}