#include <bits/stdc++.h>
using namespace std;

#define sz(x) ((int)(x).size())
#define INF 1234567890

bool comp(string &a, string &b) {
    for(int i = 0; i < sz(a); ++i)
        if(a[i] != '1' && b[i] != '1' && a[i] == b[i])
            return false;
    return true;
}

vector< vector<int> > g;

void solve(int n, int k) {
    vector<string> s(n);
    for(int i = 0; i < n; ++i)
        s[i] = "";
    vector< vector<int> > v(n, vector<int>(k));
    for(int i = 0; i < n; ++i) 
        for(int j = 0; j < k; ++j)
            cin >> v[i][j];
    
    for(int j = 0; j < k; ++j) {
        vector< pair<int, int> > t(n);
        for(int i = 0; i < n; ++i)
            t[i] = {v[i][j], i};
        sort(t.begin(), t.end());
        int sr = t[n / 2 - 1].first;
        for(int i = 0; i < n; ++i) {
            if(t[i].first == sr)
                s[t[i].second] += "1";
            else if(i < n/2)
                s[t[i].second] += "0";
            else
                s[t[i].second] += "2";
        }
    }

    g.resize(n);

    for(int i = 0; i < n; ++i) 
        for(int j = 0; j < i; ++j) 
            if(comp(s[i], s[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }

    for(int i = 0; i < n; ++i)
        sort(g[i].begin(), g[i].end());

/*
    for(int i = 0; i < n; ++i) {
        cout << i << ": ";
        for(int j = 0; j < sz(g[i]); ++j)
            cout << g[i][j] << " ";
        cout << endl;
    }

*/
    vector< pair<int, int> > ans;
    vector<char> used(n, false);

    for(int i = 0; i < n / 2; ++i) {
        int min_sz = INF;
        int idx = -1;
        for(int j = 0; j < n; ++j) 
            if(!used[j] && sz(g[j]) < min_sz) {
                min_sz = sz(g[j]);
                idx = j;
            }
        
        if(min_sz == 0) {
            cout << "NO" << endl;
            exit(0);
        }

        int to = g[idx][0];

        used[idx] = true;
        used[to] = true;

        for(int j = 0; j < sz(g[idx]); ++j) {
            int w = g[idx][j];
            auto p = lower_bound(g[w].begin(), g[w].end(), idx);
            if(p != g[w].end() && (*p) == idx)
                g[w].erase(p);
        }
        for(int j = 0; j < sz(g[to]); ++j) {
            int w = g[to][j];
            auto p = lower_bound(g[w].begin(), g[w].end(), to);
            if(p != g[w].end() && (*p) == to)
                g[w].erase(p);
        }
        ans.push_back({min(idx, to), max(idx, to)});
    }

    cout << "YES" << endl;
    for(int i = 0; i < sz(ans); ++i)
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
    exit(0);
}

int main() {
    int n, k;
    cin >> n >> k;

    if(n <= 400) 
        solve(n, k);

    vector< pair<string, int> > s(n);
    for(int i = 0; i < n; ++i)
        s[i] = {"", i};
    vector< vector<int> > v(n, vector<int>(k));
    for(int i = 0; i < n; ++i) 
        for(int j = 0; j < k; ++j)
            cin >> v[i][j];
    
    for(int j = 0; j < k; ++j) {
        vector< pair<int, int> > t(n);
        for(int i = 0; i < n; ++i)
            t[i] = {v[i][j], i};
        sort(t.begin(), t.end());
        for(int i = 0; i < n; ++i) {
            if(i < n/2)
                s[t[i].second].first += "0";
            else
                s[t[i].second].first += "1";
        }
    }

    sort(s.begin(), s.end());
    vector< pair<int, int> > ans;
    for(int i = 0; i < n/2; ++i) {
        int j = n - i - 1;
        for(int w = 0; w < k; ++w) {
            if(s[i].first[w] == s[j].first[w]) {
                cout << "NO" << endl;
                return 0;
            }
        }
        ans.push_back({min(s[i].second, s[j].second), max(s[i].second, s[j].second)});
    }

    cout << "YES" << endl;
    for(int i = 0; i < sz(ans); ++i)
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
    return 0;
}