// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MOD = 1'000'000'007;

ll power(ll a, ll n) {
	if (n == 0) {
		return a;
	}
	if (n % 2 == 0) {
		return power((a * a) % MOD, n / 2);
	}
	return (a * power((a * a) % MOD, n / 2)) % MOD;
}

inline void solve() {
	ll n;
	cin >> n;
	ll k;
	cin >> k;
	ll res = 0;
	for (ll i = 0; i < k; ++i) {
		ll m = 0;
		while (i) {
			m += (i & 1);
			i >>= 1;
		}
		res += power(m, n);
	}
	cout << res << endl;
}

int main() {
	start();
	solve();
	return 0;
}
