// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MOD = 1'000'000'007;

ll power(ll a, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		return power((a * a) % MOD, n / 2);
	}
	return (a * power((a * a) % MOD, n / 2)) % MOD;
}

ll f(ll a, ll b) {
	if (b == 0) {
		return b;
	}
	return a * f(a - 1, b - 1);
}

ll get(ll k, ll n) {
	ll res = 0;
	vector<ll> a;
	while (k) {
		a.emplace_back(k % 2);
		k /= 2;
	}
	vector<ll> d(64);
	ll cnt = 0;
	while (!a.empty()) {
		if (a.back() == 1) {
			for (ll i = 0; i < a.size(); ++i) {
				for (ll j = 0; j < a.size(); ++j) {
					d[i + cnt] = (d[i + cnt] + f(a.size(), j)) % MOD;
				}
			}
			++cnt;
		}
		a.pop_back();
	}
	for (ll i = 0; i < d.size(); ++i) {
		res += d[i] * power(n, i);
	}
	return res % MOD;
}

inline void solve() {
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	ll k;
	cin >> k;
	cout << get(k, n) << endl;
}

int main() {
	start();
	solve();
	return 0;
}
