#include <iostream>
#include <vector>

using namespace std;

vector<int> b;
vector<int> now;
vector<vector<int> > use;
vector<int> ans;

struct st{
    int n;
    vector<int> t;

    void init(int _n){
        n = _n;
        t.resize(4 * n);
    }

    void update(int v, int pos, int val, int dl, int dr){
        if (dl == dr - 1){
            t[v] = val;
            return;
        }
        int dm = (dl + dr) / 2;
        if (pos < dm){
            update(2 * v, pos, val, dl, dm);
        }else{
            update(2 * v + 1, pos, val, dm, dr);
        }
        t[v] = max(t[2 * v], t[2 *v + 1]);
    }

    void update(int pos, int val){
        update(1, pos, val, 0, n);
    }

    int get(int v, int l, int r, int dl ,int dr){
        if (l == dl && r == dr){
            return t[v];
        }
        if (l >= r){
            return 0;
        }
        int dm = (dl + dr) / 2;
        return max(get(2 * v, l, min(r, dm), dl, dm), get(2 * v + 1, max(l, dm), r, dm, dr));
    }

    int get(int l, int r){
        return get(1, l ,r, 0, n);
    }

};

st t;


int get(int pos){
    return use[b[pos]][now[b[pos]]];
}

void push(int pos){
    ans.push_back(pos + 1);
    int sup = b[0];
    for (int i = 1; i <= pos; i++){
        b[i - 1] = b[i];
    }
    for (int i = 0; i <= pos; i++){
        if (get(i) != -1){
            t.update(get(i), i);
        }
    }
    b[pos] = sup;
}


int main()
{
    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    b.resize(n);
    now.resize(n);
    t.init(n);
    use.resize(n);
    vector<int> a(m);
    for (int i = 0; i < m; i++){
        cin >> a[i];
        a[i]--;
        use[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++){
        use[i].push_back(-1);
    }
    for (int i = 0; i < n; i++){
        cin >> b[i];
        b[i]--;
        if (get(i) != -1){
            t.update(get(i), i);
        }
    }
    if (n == m){
        bool t = true;
        for (int i = 0; i < n; i++){
            if (a[i] != b[i]){
                t = false;
                break;
            }
        }
        if (t){
            cout << n << endl;
            for (int i = 0; i < n; i++){
                cout << n << ' ';
            }
            return 0;
        }
        t = true;
        for (int i = 0; i < n; i++){
            if (a[i] != b[n - i - 1]){
                t = false;
                break;
            }
        }
        if (t){
            cout << 2 * n - 1 << endl;
            for (int i = n; i >= 2; i--){
                cout << i << ' ';
            }
            for (int i = 0; i < n ;i++){
                cout << n << ' ';
            }
            cout << endl;
            return 0;
        }
    }
    //prt(a);
    //cout << endl;
    //prt(b);
    int cnt = 0;
    for (int i = 0; i < m; i++){
        int c = a[i];
        if (b[0] == a[i] && i > 0){
            push(0);
            cnt++;
            now[c]++;
            continue;
        }
        int pos = 0;
        for (pos = 0; b[pos] != c; pos++){}
        cnt += pos;
        for (int j = 0; pos > 0; j++, pos--){
            if (get(0) == -1){
                push(n - 1);
            }else{
                int wh = t.get(0, b[j]);
                push(wh);
            }
            //prt(b);
        }
        t.update(c, -1);
        now[c]++;
        if (get(c) != -1){
            t.update(get(c), 0);
        }
    }
    push(n - 1);
    if (ans.size() > n + m - 1){
        ans.resize(n + m - 1);
    }
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
