#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<vector<int> > a(n, vector<int>(k));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < k; j++){
            cin >> a[i][j];
        }
    }
    if (n <= 10){
        vector<int> x(n);
        for (int i = 0; i < n; i++){
            x[i] = n - i - 1;
        }
        bool sup = true;
        while (next_permutation(x.begin(), x.end()) || sup){
            sup = false;
            bool check = true;
            for (int j = 0; j < k; j++){
                int left = -1e9;
                int right = 1e0;
                for (int i = 0; i < n; i += 2){
                    left = max(a[x[i]][j], left);
                }
                for (int i = 1; i < n; i += 2){
                    right = min(a[x[i]][j], right);
                }
                if (left > right){
                    check = false;
                }
            }
            if (check){
                cout << "YES" << endl;
                for (int i = 0; i < n; i += 2){
                    cout << x[i] + 1 << ' ' << x[i + 1] + 1 << "\n";
                }
                cout << endl;
                return 0;
            }
        }
        cout << "NO" << endl;
    }
    return 0;
}
