#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    //freopen("input.txt", "r", stdin);
    int n, k;
    cin >> n >> k;
    vector<vector<int> > a(n, vector<int>(k));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < k; j++){
            cin >> a[i][j];
        }
    }
    if (n <= 10){
        vector<int> x(n);
        for (int i = 0; i < n; i++){
            x[i] = n - i - 1;
        }
        bool sup = true;
        vector<int> sup2 = {0, 3, 1, 5, 2, 4};
        while (next_permutation(x.begin(), x.end()) || sup){
            sup = false;
            bool check = true;
            for (int j = 0; j < k; j++){
                int left = -1e9;
                int right = 1e9;
                for (int i = 0; i < n; i += 2){
                    left = max(min(a[x[i]][j], a[x[i + 1]][j]), left);
                }
                for (int i = 1; i < n; i += 2){
                    right = min(max(a[x[i]][j], a[x[i - 1]][j]), right);
                }
                if (left > right){
                    check = false;
                }
            }
            if (check){
                cout << "YES" << endl;
                for (int i = 0; i < n; i += 2){
                    cout << x[i] + 1 << ' ' << x[i + 1] + 1 << "\n";
                }
                cout << endl;
                return 0;
            }
        }
        cout << "NO" << endl;
    }else{
        cout << "YES" << endl;
        vector<pair<int, int> > x(n);
        for (int i = 0; i < n; i++){
            x[i] = {a[i][0], i};
        }
        sort(x.begin(), x.end());
        for (int i = 0; i * 2 < n; i++){
            cout << x[i].second + 1 << ' ' << x[n - i - 1].second + 1 << "\n";
        }
    }
    return 0;
}
