#include <iostream>
#include <vector>

using namespace std;

void output(vector<long> arr) {
	for (long i = 0; i < arr.size(); i++) {
		cout << arr[i];
		if (i != arr.size() - 1) {
			cout << " ";
		}
	}
	cout << endl;
}

int main() {
	long n, i, current, node, sum1, sum2, pair1, pair2, counter, res1, res2;
	cin >> n;
	vector<bool> marked(n, false);
	vector<long> level(n, 0);
	vector<vector<long>> edges(n);
	vector<long> stackNodes;
	vector<long> tree;
	vector<long> results(n, 0);
	vector<long> pos(n);
	bool mustDiffer;
	long result = 0;

	for (i = 0; i < n; i++) {
		vector<long> temp;
		edges[i] = temp;
	}
	for (i = 0; i < n; i++) {
		cin >> current;
		if (current != -1) {
			edges[i].push_back(current - 1);
			edges[current - 1].push_back(i);
		}
	}

	for (current = 0; current < n; current++) {
		if (marked[current]) {
			continue;
		}
		if (edges[current].size() == 0) {
			result++;
			continue;
		}

		stackNodes.clear();
		stackNodes.push_back(current);
		mustDiffer = false;
		tree.clear();
		counter = 0;
		pair1 = -1;
		pair2 = -1;
		while (stackNodes.size() > 0) {
			node = stackNodes[stackNodes.size() - 1];
			stackNodes.pop_back();
			if (marked[node]) {
				continue;
			}
			
			
			for (i = 0; i < edges[node].size(); i++) {
				if (level[edges[node][i]] != 0) {
					if (!marked[edges[node][i]] && !mustDiffer) {
						mustDiffer = true;
						pair1 = node;
						pair2 = edges[node][i];
						//cout << "Add: " << pair1 << " " << pair2 << endl;
					} else {
						//cout << "Higher: " << node << "->" << edges[node][i] << endl;
					}
					continue;
				} else {
					level[edges[node][i]] = level[node] + 1;
					stackNodes.push_back(edges[node][i]);
				}
			}

			marked[node] = true;
			tree.push_back(node);
			pos[node] = counter;
			counter++;
			//cout << node << "-" << level[node] << "-" << pos[node] << endl;
			//output(stackNodes);
		}
		//cout << "T: ";
		//output(tree);
		//cout << mustDiffer << endl;
		if (!mustDiffer) {
			for (i = tree.size() - 1; i >= 0; i--) {
				sum1 = 0;
				sum2 = 1;
				//cout << "Sums" << tree[i] << endl;
				for (long j = 0; j < edges[tree[i]].size(); j++) {
					if (pos[edges[tree[i]][j]] < pos[tree[i]]) {
						continue;
					}
				
					if (((tree[i] == pair1 && edges[tree[i]][j] == pair2) || (tree[i] == pair2 && edges[tree[i]][j] == pair1))) {
						//cout << "Pass: " << tree[i] << " " << edges[tree[i]][j] << endl;
						continue;
					}

					sum1 += results[edges[tree[i]][j]];
					//cout << "J" << j << "-" << edges[tree[i]][j] << " " << sum1 << " " << sum2 << endl;
					for (long k = 0; k < edges[edges[tree[i]][j]].size(); k++) {
						if (pos[edges[edges[tree[i]][j]][k]] < pos[edges[tree[i]][j]]) {
							continue;
						}
						if (((edges[edges[tree[i]][j]][k] == pair1 && edges[tree[i]][j] == pair2) || (edges[edges[tree[i]][j]][k] == pair2 && edges[tree[i]][j] == pair1))) {
							//cout << "Pass: " << edges[edges[tree[i]][j]][k] << " " << edges[tree[i]][j] << endl;
							continue;
						}

							sum2 += results[edges[edges[tree[i]][j]][k]];
							//cout << "K" << k << "-" << edges[edges[tree[i]][j]][k] << " " << sum1 << " " << sum2 << endl;
						}
					}
				//cout << "r: " << tree[i] << " " << sum1 << " " << sum2 << endl;
				results[tree[i]] = max(sum1, sum2);
			}
			result += results[tree[0]];
		} else {
			// pair1 off
			//cout << "P1: *****" << endl;
			for (i = tree.size() - 1; i >= 0; i--) {
				sum1 = 0;
				sum2 = 1;
				//cout << "Sums" << tree[i] << endl;
				for (long j = 0; j < edges[tree[i]].size(); j++) {
					if (pos[edges[tree[i]][j]] < pos[tree[i]]) {
						continue;
					}
				
					if (((tree[i] == pair1 && edges[tree[i]][j] == pair2) || (tree[i] == pair2 && edges[tree[i]][j] == pair1))) {
						//cout << "Pass: " << tree[i] << " " << edges[tree[i]][j] << endl;
						continue;
					}

					sum1 += results[edges[tree[i]][j]];
					//cout << "J" << j << "-" << edges[tree[i]][j] << " " << sum1 << " " << sum2 << endl;
					for (long k = 0; k < edges[edges[tree[i]][j]].size(); k++) {
						if (pos[edges[edges[tree[i]][j]][k]] < pos[edges[tree[i]][j]]) {
							continue;
						}
						if (((edges[edges[tree[i]][j]][k] == pair1 && edges[tree[i]][j] == pair2) || (edges[edges[tree[i]][j]][k] == pair2 && edges[tree[i]][j] == pair1))) {
							//cout << "Pass: " << edges[edges[tree[i]][j]][k] << " " << edges[tree[i]][j] << endl;
							continue;
						}

							sum2 += results[edges[edges[tree[i]][j]][k]];
							//cout << "K" << k << "-" << edges[edges[tree[i]][j]][k] << " " << sum1 << " " << sum2 << endl;
						}
					}
				//cout << "r: " << tree[i] << " " << sum1 << " " << sum2 << endl;
				results[tree[i]] = (tree[i] != pair1) ? max(sum1, sum2) : max(sum1, sum2 - 1);
			}
			res1 = results[tree[0]];

			// pair2 off
			//cout << "P2: *****" << endl;
			for (i = tree.size() - 1; i >= 0; i--) {
				sum1 = 0;
				sum2 = 1;
				//cout << "Sums" << tree[i] << endl;
				for (long j = 0; j < edges[tree[i]].size(); j++) {
					if (pos[edges[tree[i]][j]] < pos[tree[i]]) {
						continue;
					}
				
					if (((tree[i] == pair1 && edges[tree[i]][j] == pair2) || (tree[i] == pair2 && edges[tree[i]][j] == pair1))) {
						//cout << "Pass: " << tree[i] << " " << edges[tree[i]][j] << endl;
						continue;
					}

					sum1 += results[edges[tree[i]][j]];
					//cout << "J" << j << "-" << edges[tree[i]][j] << " " << sum1 << " " << sum2 << endl;
					for (long k = 0; k < edges[edges[tree[i]][j]].size(); k++) {
						if (pos[edges[edges[tree[i]][j]][k]] < pos[edges[tree[i]][j]]) {
							continue;
						}
						if (((edges[edges[tree[i]][j]][k] == pair1 && edges[tree[i]][j] == pair2) || (edges[edges[tree[i]][j]][k] == pair2 && edges[tree[i]][j] == pair1))) {
							//cout << "Pass: " << edges[edges[tree[i]][j]][k] << " " << edges[tree[i]][j] << endl;
							continue;
						}

							sum2 += results[edges[edges[tree[i]][j]][k]];
							//cout << "K" << k << "-" << edges[edges[tree[i]][j]][k] << " " << sum1 << " " << sum2 << endl;
						}
					}
				//cout << "r: " << tree[i] << " " << sum1 << " " << sum2 << endl;
				results[tree[i]] = (tree[i] != pair2) ? max(sum1, sum2) : max(sum1, sum2 - 1);
			}
			res2 = results[tree[0]];

			result += max(res1, res2);
		}
		//cout << "S: ";
		//output(results);
		//cout << "R: " << result << endl;
	}

	cout << result << endl;
	return 0;
}