#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int l, r, a;
int x;

signed main() {
    cin >> l >> r >> a;
    if (r - l < a) {
        cout << 0;
        return 0;
    }
    x = (r - l) / a;
    int o = (r - x * a) - l + 1;
    int ans = o *    ((x + 1) * (x - 0) / 2);
    ans += (a - o) * ((x - 0) * (x - 1) / 2);
    cout << ans;

    return 0;
}