#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int MAXN = 1e6;

vector<int> sq(MAXN);

void gen() {
    for (int i = 0; i < MAXN; ++i) {
        sq[i] = i * i;
    }
}

signed main() {
    gen();
    int k;
    cin >> k;
    if (k == 0) {
        cout << 0;
        return 0;
    }
    for (int i = 0; i < MAXN - 1; ++i) {
        if (sq[i + 1] - sq[i] == abs(k)) {
            if (k > 0) {
                cout << i + 1;
            } else {
                cout << i;
            }
            return 0;
        }
    }
    cout << "none";

    return 0;
}