#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

struct DO {
    int n;
    vector<int> tree;

    DO(long long n) : n(n) {
        tree.resize(n * 2, 0);
    }

public:
    void add(int k, int x) {
        k += n;
        tree[k] += x;
        for (k /= 2; k >= 1; k /= 2) {
            tree[k] = f(tree[k * 2], tree[k * 2 + 1]);
        }
    }

    int sum(int a, int b) {
        a += n;
        b += n;
        int res = 0;
        while (b >= a) {
            if (a % 2 == 1) {
                res += tree[a++];
            }
            if (b % 2 == 0) {
                res += tree[b--];
            }
            a /= 2;
            b /= 2;
        }
        return res;
    }

private:
    int f(int a, int b) {
        int res = a + b;
        if (res >= MOD) {
            res -= MOD;
        }
        return res;
    }
};

int _sum(int a, int b) {
    int res = a + b;
    if (res >= MOD) {
        res -= MOD;
    }
    return res;
}

signed main() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        vector<pair<int, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first;
            a[i].second = i + 1;
        }
        sort(a.begin(), a.end());
        cout << "YES" << "\n";
        for (int i = 0; i < n / 2; ++i) {
            cout << a[i].second << " " << a[n - i - 1].second << "\n";
        }
    } else {
        cout << 1 / 0;
    }
    return 0;
}