#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

struct DO {
    int n;
    vector<int> tree;

    DO(long long n) : n(n) {
        tree.resize(n * 2, 0);
    }

public:
    void add(int k, int x) {
        k += n;
        tree[k] += x;
        for (k /= 2; k >= 1; k /= 2) {
            tree[k] = f(tree[k * 2], tree[k * 2 + 1]);
        }
    }

    int sum(int a, int b) {
        a += n;
        b += n;
        int res = 0;
        while (b >= a) {
            if (a % 2 == 1) {
                res += tree[a++];
            }
            if (b % 2 == 0) {
                res += tree[b--];
            }
            a /= 2;
            b /= 2;
        }
        return res;
    }

private:
    int f(int a, int b) {
        int res = a + b;
        if (res >= MOD) {
            res -= MOD;
        }
        return res;
    }
};

vector<vector<int>> g;

vector<bool> gen_tmp;
int ans = 0;

void all() {
    int s = 0;
    for (int v = 0; v < g.size(); ++v) {
        if (gen_tmp[v]) {
            s++;
        }
        for (int u:g[v]) {
            if (gen_tmp[v] && gen_tmp[u]) {
                return;
            }
        }
    }
    ans = max(ans, s);
}

void gen(int x) {
    if (x == g.size()) {
        all();
    } else {
        gen_tmp[x] = 1;
        gen(x + 1);
        gen_tmp[x] = 0;
        gen(x + 1);
    }
}

signed main() {
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        if (a == -1) {
            continue;
        }
        a--;
        g[a].push_back(i);
        g[i].push_back(a);
    }
    if (n <= 20) {
        gen_tmp.resize(n);
        gen(0);
        cout<< ans;
    }

    return 0;
}