#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

const int MOD = 1e9 + 7;

signed main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> pw(1e7, 1);
    for (int i = 1; i < 1e7; ++i) {
        pw[i] = (pw[i - 1] * n) % MOD;
    }
    if (m == 0 ) {
        int ans = 1;
        for (int i = 1; i <= k; ++i) {
            int cnt = 0;
            for (int j = 0; j <= 50; ++j) {
                if ((i >> j) & 1) {
                    cnt++;
                }
            }
            //cout << i << " " << cnt << endl;
            ans = (ans + pw[cnt]) % MOD;
        }
        cout << ans;
    }
    else {
        cout << 2;
    }
    return 0;
}
