#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

int n;
vector<int> a;

int cnt(int mask) {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            res++;
        }
    }
    return res;
}

int main19() {
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] != -1) {
            a[i]--;
        }
    }
    int mask = 0;

    int ans = 0;
    while (mask < (1 << n) - 1) {
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (a[i] != -1 && ((mask >> i) & 1) && ((mask >> a[i]) & 1)) {
                ok = false;
            }
        }
        if (ok) {
            ans = max(ans, cnt(mask));
        }
        mask++;
    }
    return ans;
}

vector<vector<int>> g;
vector<int> used;
vector<int> clr;
int clr0, clr1;

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            clr[u] = 1 - clr[v];
            if (clr[u] == 0) {
                clr0++;
            }
            else {
                clr1++;
            }
            dfs(u);
        }
    }
}

int main10() {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai;
        cin >> ai;
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    clr.resize(n, 0);
    used.resize(n, 0);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            clr0 = 1;
            clr1 = 0;
            dfs(i);
            ans += max(clr0, clr1);
        }
    }
    return ans;
}

vector<int> clrz;

void dfs_2(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            clr[u] = 1 - clr[v];
            clrz[clr[u]]++;
            dfs(u);
        }
    }
}

int main10_2() {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai;
        cin >> ai;
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    used.resize(n, 0);
    clr.resize(n, -1);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            clr[i] = 0;
            clrz.clear();
            clrz.resize(2, 0);
            clrz[clr[i]]++;
            dfs_2(i);
            ans = ans + max(clrz[0], clrz[1]);
        }
    }
    return ans;
}

signed main()
{
    cin >> n;
    if (n <= 20) {
        cout << main19();
    }
    else {
        cout << main10_2();
    }
    return 0;
}
