#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

/**
    
**/

using namespace std;

int n;
vector<int> a;

int cnt(int mask) {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            res++;
        }
    }
    return res;
}

int main19() {
    for (int i = 0; i < n; ++i) {
        if (a[i] != -1) {
            a[i]--;
        }
    }
    int mask = 0;

    int ans = 0;
    while (mask < (1 << n) - 1) {
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (a[i] != -1 && ((mask >> i) & 1) && ((mask >> a[i]) & 1)) {
                ok = false;
            }
        }
        if (ok) {
            ans = max(ans, cnt(mask));
        }
        mask++;
    }
    return ans;
}

vector<vector<int>> g;
vector<int> used;
vector<int> clr;
vector<int> clrz;

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            clr[u] = 1 - clr[v];
            clrz[clr[u]]++;
            dfs(u);
        }
    }
}

int main10() {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai = a[i];
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    used.resize(n, 0);
    clr.resize(n, -1);
    clrz.resize(2);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            clr[i] = 0;
            clrz[1 - clr[i]] = 0;
            clrz[clr[i]] = 1;
            dfs(i);
            ans = ans + max(clrz[0], clrz[1]);
        }
    }
    return ans;
}

signed main()
{
    cin >> n;
    a.resize(n);

    else if (n <= 20) {
        cout << main19();
    }
    else {
        cout << main19();
    }
    return 0;
}
/*
15
-1 -1 1 2 -1 4 6 3 8 5 7 9 5 12 10
*/
