#include <iostream>
#include <vector>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long
#define all(a) a.begin(), a.end()
#include <ctime>

/**
    
**/

using namespace std;

int n, k;

void main1() {
    vector<vector<int>> a(n, vector<int> (k, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int> mask(n);
    for (int i = 0; i < n; ++i) {
        mask[i] = i;
    }
    do {
        bool ok = true;
        for (int j = 0; j < k; ++j) {
            int l = -2 * 1e9;
            int r = 2 * 1e9;
            for (int i = 0; i < n; i += 2) {
                l = max(l, min(a[mask[i]][j], a[mask[i + 1]][j]));
                r = min(r, max(a[mask[i]][j], a[mask[i + 1]][j]));
            }
            if (l > r) {
                ok = false;
            }
        }
        if (ok) {
            cout << "YES\n";
            for (int i = 0; i < n; i += 2) {
                cout << mask[i] + 1 << " " << mask[i + 1] + 1 << endl;
            }
            return;
        }
        if (clock() > 0.9 * CLOCKS_PER_SEC) {
            break;
        }
    } while (next_permutation(all(mask)));
    cout << "NO\n";
    return;
}

void main2() {
    vector<int> a(n);
    vector<pair<int, int>> events;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        events.push_back({a[i], i});
    }
    sort(all(events));
    cout << "YES\n";
    for (int i = 0; i < n/2; ++i) {
        cout << events[i].second + 1 << " " << events[n - i - 1].second + 1 << endl;
    }

}

signed main()
{
    cin >> n >> k;
    if (n <= 20) {
        main1();
    }
    else if (k == 1) {
        main2();
    }
    return 0;
}

/*
22 1
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
*/
