#pragma GCC optimize("O3")
#include <iostream>
#include <fstream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#define x first
#define y second

using namespace std;

typedef long double ld;

const int N = 5e3 + 10;
const int M = 1e9 + 7;

int n, k;
map<pair<int, int>, int> dp, ndp;

inline void fast() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

inline int get_dp(bool fl=0) {
    dp.clear();
    ndp.clear();
    dp[{k, k}] = 1;
    int ans = 0;
    for (int cnt = 1; cnt < n; ++cnt) {
        ndp.clear();
        for (auto el : dp) {
            if (el.x.x == n) ans = (ans + el.y) % M;
            if (!fl) {
                for (int last = 1; last < el.x.y; ++last) {
                    if (el.x.x + last > n) break;
                    ndp[make_pair(el.x.x + last, last)] = (el.y + ndp[make_pair(el.x.x + last, last)]) % M;
                }
            } else {
                for (int last = el.x.y + 1; last < n; ++last) {
                    if (el.x.x + last > n) break;
                    ndp[make_pair(el.x.x + last, last)] = (el.y + ndp[make_pair(el.x.x + last, last)]) % M;
                }
            }
        }
        if (ndp.empty()) break;
        fl = (!fl);
        dp = ndp;
    }
    //for (auto el : dp) if (el.x.x == n) ++ans;
    return ans;
}

signed main() {
    fast();
    cin >> n >> k;
    if (k == n) {
        cout << 1;
        return 0;
    }
    int ans = get_dp();
    ans = (ans + get_dp(1)) % M;
    cout << ans;
    return 0;
}
