#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;
#define int long long

int inf = 1e18;
long long k;
int signk = 0;

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	cin >> k;
	if (k == 0) return cout << 0, 0;

	if (k < 0) signk = -1;
	else signk = 1;

	int ans = inf;

	for (int a = 1; a * a <= abs(k); a++) {
		if (a * a == -k) return cout << 0, 0;

		if (abs(k) % a == 0) {
			int b = abs(k) / a;
			int j = signk * a + b;
			if (j % 2 == 0) {
				j /= 2;
				//cout << j << " " << j - a << '\n';
				ans = min(ans, j);
			}
		}
	}

	if (ans != inf) {
		cout << ans;
	} else cout << "none";

	//system("pause");
	return 0;
}