#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}
int n, m, k, mod = 1e9 + 7;
vector<set<int>> kek;
int ans = 0;
vector<vector<int>> dp;

int lazy(int i, int l) {
	if (dp[i][l] == 0) {
		for (auto j : kek[i]) {
			dp[i][l] += lazy(j, l - 1);
		}
	}
	return dp[i][l];
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	
	cin >> n >> m >> k;
	while (m);

	kek.resize(k + 1);
	for (int i = 0; i <= k; i++) {
		for (int j = i; j <= k; j++) {
			if ((i & j) == i) {
				kek[i].insert(j);
			}
		}
	}

	dp.resize(k + 1);
	for (auto &i : dp) {
		i.resize(n + 1, 0);
	}

	for (int i = 0; i <= k; i++) {
		dp[i][1] = 1;
	}

	for (auto i = 0; i <= k; i++) {
		ans = (ans + lazy(i, n)) % mod;
		//cout << "dp[" << i << "] = " << lazy(i, n) << '\n';
	}

	cout << ans;

	//system("pause");
	return 0;
}