#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

long long a, b, c;

long long ceil_(long long a) {
	return a / 2 + a % 2;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	
	cin >> a >> b >> c;

	auto first = ceil_(c - 1) + 1;
	if (c == 2) first = 1;

	auto fc = ((a / c) + 1) * c;
	auto sc = (b / c) * c;

	if (fc >= sc) {
		cout << ceil_(b - a);
		//system("pause");
		return 0;
	}

	long long cnt = sc / c - fc / c;

	auto second = ceil_(fc - a - 1) + 1;

	auto third = ceil_(b - sc - 1);

	//cout << first << " " << cnt << "\n" << second << " " << fc << "\n" << third << " " << sc << '\n';
	cout << first * cnt + second + third;

	//system("pause");
	return 0;
}