#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

long long int mod = 1000000007;

int main() {
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	int* v = new int[m];
	int* max = new int[n];
	int* u = new int[m];
	for (int i = 0; i < n; i++) max[i] = -1;
	for (int i = 0; i < m; i++) {
		scanf("%d %d", &v[i], &u[i]);
		v[i]--; u[i]--;
		if (v[i] > max[u[i]]) max[u[i]] = v[i];
	}
	if (m == 0) {
		long long int** dp = new long long int*[n + 1];
		for (int i = 0; i <= n; i++) {
			dp[i] = new long long int[k + 1];
			for (int j = 0; j <= k; j++) dp[i][j] = 0;
		}
		for (int i = 0; i <= k; i++) dp[1][i] = 1;
		for (int i = 2; i <= n; i++) {
			for (int j = 0; j <= k; j++) {
				for (int q = 0; q <= j; q++) {
					if ((q & j) == q) {
						dp[i][j] += dp[i - 1][q];
					}
				}
				dp[i][j] %= mod;
			}
		}
		long long int cnt = 0;
		for (int i = 0; i <= k; i++) {
			cnt += dp[n][i];
		}
		printf("%lld", cnt % mod);
	}
	else {
		long long int*** dp = new long long int**[n + 1];
		for (int i = 0; i <= n; i++) {
			dp[i] = new long long int*[k + 1];
			for (int j = 0; j <= k; j++) {
				dp[i][j] = new long long int[n];
				for (int q = 0; q < n; q++) dp[i][j][q] = 0;
			}
		}
		for (int i = 0; i <= k; i++) dp[1][i][0] = 1;
		for (int i = 2; i <= n; i++) {
			for (int j = 0; j <= k; j++) {
				for (int q = 0; q <= k; q++) {
					if ((j & q) == q) {
						if (j == q) {
							for (int l = 0; l < n; l++) {
								if (max[i - 1] >= l) continue;
								dp[i][j][l] += dp[i - 1][q][l];
								dp[i][j][l] %= mod;
							}
						}
						else {
							for (int l = 0; l < n; l++) {
								dp[i][j][i - 1] += dp[i - 1][q][l];
							}
							dp[i][j][i - 1] %= mod;
						}
					}
				}
			}
		}
		long long int cnt = 0;
		for (int i = 0; i <= k; i++) {
			for (int j = 0; j < n; j++)
				cnt += dp[n][i][j];
		}
		printf("%lld", cnt % mod);
	}
	//system("pause");
	return 0;
}