#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <assert.h>

using namespace std;

long long int mod = 1000000007;

int main() {
	int n, k;
	scanf("%d %d", &n, &k);
	if (n == k) {
		printf("1");
		system("pause");
		return 0;
	}
	int*** dp = new int**[n + 1];
	for (int i = 0; i <= n; i++) {
		dp[i] = new int*[n + 1];
		for (int j = 0; j <= n; j++) {
			dp[i][j] = new int[2];
			dp[i][j][0] = 0;
			dp[i][j][1] = 0;
		}
	}
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int i = k + 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j > i) break;
			for (int q = 1; q < j; q++) dp[i][j][0] += dp[i - j][q][1];
			for (int q = j + 1; q <= n; q++) dp[i][j][1] += dp[i - j][q][0];
			dp[i][j][0] %= mod;
			dp[i][j][1] %= mod;
		}
	}
	long long int res = 0;
	for (int j = 1; j <= n; j++) {
		res += dp[n][j][0] + dp[n][j][1];
	}
	res %= mod;
	printf("%lld", res);
	system("pause");
	return 0;
}