#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

int*** g2;
int** s2;
int** g;
bool* t;
int* vis;
int* clr;
int* id;
int* dp1;
int* dp2;
int* s;
int* p;
int n;

int num = 0;

void paint(int v, int c) {
	if (vis[v] != -1) return;
	id[v] = num++;
	clr[c]++;
	vis[v] = c;
	for (int i = 0; i < s[v]; i++)
		paint(g[v][i], c);
}

int T;

bool check(int v, int c, int p = -1) {
	if (vis[v] == T) return true;
	vis[v] = T;
	bool res = false;
	for (int i = 0; i < s2[c][v]; i++)
		if (g2[c][v][i] != p)
			res |= check(g2[c][v][i], c, v);
	return res;
}

void dfs1(int v, int c, int p = -1) {
	vis[v] = 0;
	dp1[v] = 0;
	dp2[v] = 1;
	for (int i = 0; i < s2[c][v]; i++) {
		if (vis[g2[c][v][i]] == -1) {
			dfs1(g2[c][v][i], c, v);
			dp1[v] += dp2[g2[c][v][i]];
			if (dp2[g2[c][v][i]] < dp1[g2[c][v][i]])
				dp2[v] += dp2[g2[c][v][i]];
			else dp2[v] += dp1[g2[c][v][i]];
		}
	}
}

int get(int c, int r = 0) {
	dp1 = new int[clr[c]];
	dp2 = new int[clr[c]];
	for (int i = 0; i < clr[c]; i++) vis[i] = -1;
	dfs1(r, c);
	if (dp1[r] > dp2[r]) return dp2[r];
	else return dp1[r];
}

bool cl = false;
int u;

void cycle_cnt(int v, int c, int p = -1) {
	if (vis[v] == 0) {
		vis[v] = 1;
		u = v;
		cl = true;
		return;
	}
	vis[v] = 0;
	for (int i = 0; i < s2[c][v]; i++) {
		if (g2[c][v][i] != p)
			cycle_cnt(g2[c][v][i], c, v);
		if (cl) {
			if (v == u) cl = false;
			vis[v] = 1;
			return;
		}
	}
}

int get2(int c) {
	vis = new int[clr[c]];
	for (int i = 0; i < clr[c]; i++) vis[i] = -1;
	cycle_cnt(0, c);
	int cnt = 0;
	for (int i = 0; i < clr[c]; i++) {
		if (vis[i] == 1) cnt++;
	}
	int* cycle = new int[cnt];
	int S = 0;
	for (int i = 0; i < clr[c]; i++) {
		if (vis[i] == 1) cycle[S++] = i;
		else vis[i] = -1;
	}
	dp1 = new int[clr[c]];
	dp2 = new int[clr[c]];
	for (int i = 0; i < cnt; i++) dfs1(cycle[i], c);
	int* d10 = new int[cnt - 1];
	int* d11 = new int[cnt - 1];
	int* d20 = new int[cnt - 1];
	int* d21 = new int[cnt - 1];
	d10[0] = dp2[cycle[cnt - 1]] + dp1[cycle[0]];
	d11[0] = dp2[cycle[cnt - 1]] + dp2[cycle[0]];
	d20[1] = dp2[cycle[0]] + dp1[cycle[1]];
	d21[1] = dp2[cycle[0]] + dp2[cycle[1]];
	for (int i = 1; i < cnt - 1; i++) {
		d10[i] = d11[i - 1] + dp1[cycle[i]];
		if (d10[i - 1] < d11[i - 1]) d11[i] = d10[i - 1];
		else d11[i] = d11[i - 1];
		d11[i] += dp2[cycle[i]];
	}
	for (int i = 2; i < cnt; i++) {
		d20[i] = d21[i - 1] + dp2[cycle[i]];
		if (d20[i - 1] < d21[i - 1]) d21[i] = d20[i - 1];
		else d21[i] = d21[i - 1];
		d21[i] += dp2[cycle[i]];
	}
	int min1, min2;
	if (d10[cnt - 2] < d11[cnt - 2]) min1 = d10[cnt - 2];
	else min1 = d11[cnt - 2];
	if (d20[cnt - 1] < d21[cnt - 1]) min2 = d20[cnt - 1];
	else min2 = d21[cnt - 1];
	if (min1 < min2) return min1;
	else return min2;
}

int main() {
	scanf("%lld", &n);
	p = new int[n];
	g = new int*[n];
	clr = new int[n];
	s = new int[n];
	vis = new int[n];
	id = new int[n];
	for (int i = 0; i < n; i++) s[i] = 0;
	for (int i = 0; i < n; i++) {
		clr[i] = 0;
		vis[i] = -1;
		p[i] = abs(rand() % n) + 1;
		if (p[i] == i+ 1) p[i] = -1;
		p[i]--;
		if (p[i] != -2) {
			s[i]++;
			if (p[i] < i && p[p[i]] == i) {
				s[p[i]] = s[p[i]];
				p[i] = -2;
			}
			else s[p[i]]++;
		}
	}
	for (int i = 0; i < n; i++) printf("%d ", p[i]);
	printf("\n");
	for (int i = 0; i < n; i++) {
		g[i] = new int[s[i]];
		s[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		if (p[i] != -2) {
			g[i][s[i]++] = p[i];
			g[p[i]][s[p[i]]++] = i;
		}
	}
	int res = n;
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		num = 0;
		if (vis[i] == -1) paint(i, cnt++);
	}
	g2 = new int**[cnt];
	s2 = new int*[cnt];
	t = new bool[cnt];
	for (int i = 0; i < cnt; i++) {
		g2[i] = new int*[clr[i]];
		s2[i] = new int[clr[i]];
	}
	for (int i = 0; i < n; i++) {
		s2[vis[i]][id[i]] = s[i];
		g2[vis[i]][id[i]] = new int[s[i]];
		for (int j = 0; j < s[i]; j++) {
			g2[vis[i]][id[i]][j] = id[g[i][j]];
		}
		vis[i] = -1;
	}
	for (int i = 0; i < cnt; i++) {
		T = i;
		t[i] = check(0, i);
		if (t[i] == 0) res -= get(i);
		else {
			res -= get2(i);
		}
	}
	printf("%d\n", res);
	system("pause");
	return 0;
}