#include <bits/stdc++.h>
#define ff first
#define ss second
using namespace std;

vector<set<int>> pos;
vector<int> todo;
vector<int> cards;
vector<int> curr;

void state() {
	for (auto el: cards) {
		cout << el << " ";
	}
	cout << endl;
}

void place(int cid) {
	auto we = *pos[cid].begin();
	//cout << "place " << cid << " " << we << endl;
	//state();
	int mx = 0;
	for (int i = 0; i < cards.size(); i++) {
		int oth = *pos[cards[i]].begin();
		//cout << "? " << cards[i] << " " << oth << " " << we << endl;
		if (oth < we) {
			mx = max(mx, i);
		}
	}

	cards.push_back(0);
	for (int i = cards.size() - 1; i > mx + 1; i--) {
		cards[i] = cards[i - 1];
	}
	//cout << "--- mx: " << mx << endl;
	//state();
	cards[mx + 1] = cid;
	curr.push_back(mx + 2);
	//state();
	//cout << curr[curr.size() - 1] << endl;
	//cout << endl;
}


int main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	bool f1 = 1;
	bool f2 = 1;
	if (n != m) {
		f1 = f2 = 0;
	}
	pos.resize(n + 1);
	for (int i = 0; i <= n; i++) {
		pos[i].insert(m + 1);
	}
	todo.resize(m + 2);
	for (int i = 1; i <= m; i++) {
		cin >> todo[i];
		pos[todo[i]].insert(i);
	}
	todo[m + 1] = todo[m];
	cards.resize(n);
	for (int i = 0; i < n; i++) cin >> cards[i];
	int cnt = 0;

	if (n == m) {
		for (int i = 0; i < n; i++) {
			if (cards[i] != todo[i + 1]) f1 = 0;
			if (cards[i] != todo[n - i]) f2 = 0;
		}
	}

	int _ans;
	if (f1) {
		//cout << "F1: " << f1 << endl;
		_ans = n;
		cout << _ans << endl;
		for (int i = 0; i < n; i++) {
			cout << i + 1 << " ";
		}
		cout << endl;
		return 0;
	}

	if (f2) {
		//cout << "f2: " << f2 << endl;
		_ans = 2 * n - 1;
		cout << _ans << endl;
		for (int i = 1; i < n; i++) {
			cout << n << ' ';
		}
		for (int i = _ans - n + 1; i; i--) {
			cout << 1 << " ";
		}
		cout << endl;
		return 0;
	}

	for (int i = 1; i <= m; i++) {
		int it = 0;
		bool was = 0;
		while (it < n && cards[0] != todo[i]) {
			int we = cards[0];
			reverse(cards.begin(), cards.end());
			cards.pop_back();
			reverse(cards.begin(), cards.end());
			place(we);
			it++;
		}

		if (todo[i] == todo[i + 1]) {
			curr.push_back(1);
		}
		assert(it < n);
		//cout << "- " << (*pos[cards[0]].begin()) << endl;
		pos[cards[0]].erase(pos[cards[0]].begin());
	}

	cout << curr.size() << endl;
	for (auto el: curr) {
		cout << el << " ";
	}

	cout << endl;

	return 0;
}

/*
1 1
1
1

4 5
4 1 2 4 4
4 3 2 1

2 2
1 2
2 1

2 4
1 1 1 1
1 2

2 4
1 1 1 1
2 1

4 4
4 3 2 1
1 2 3 4
--
7
*/