#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 5179;

const int MOD = 1e9 + 7;

int dp[N][N][2];
int n, k;

int get_dp(int sum, int lst, bool b, bool ok=0) {
	if (sum > n) return 0;
	if (!ok) return dp[sum][lst][b];
	if (sum + lst > n) return 0;
	//cout << "! " << sum << " " << lst << " " << b << endl;
	dp[sum][lst][b] = 0;
	int step = 1;
	if (b == 1) step = -1;
	for (int start = lst + step; start > 0 && start <= n; start += step) {
		//cout << "run " << start << " " << b << " from " << sum << " " << lst << " " << b << endl; 
		dp[sum][lst][b] += get_dp(sum + lst, start, b ^ 1);
		dp[sum][lst][b] %= MOD;
	}
	return dp[sum][lst][b];
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return 0;
	}
	dp[n - k][k][0] = dp[n - k][k][1] = 1;

	for (int sum = n - k - 1; sum >= 0; sum--) {
		for (int lst = 1; lst <= n; lst++) {
			get_dp(sum, lst, 1, 1);
			get_dp(sum, lst, 0, 1);
		}
	}

	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans += get_dp(0, i, 1);
		ans %= MOD;
		//cout << "--- " << endl;
		ans += get_dp(0, i, 0);
		ans %= MOD;
		//cout << "% % % % " << endl;
	}
	cout << ans << endl;
}