#include <bits/stdc++.h>
#define ff first
#define ss second
using namespace std;

const int N = 3e5 + 179;
const int INF = 1e9 + 179;
vector<int> g[N];
int par[N];
bool is_on[N];
int used[N];
vector<vector<int>> cyc;
int n;
int dp[N][2];

vector<int> curr;

void dfs(int we) {
	used[we] = 2;
	curr.push_back(we);
	//cout << we << " " << par[we] << endl;

	if (par[we] != -1) {
		if (used[par[we]] == 2) {
			cyc.push_back({});
			for (int i = curr.size() - 1; i >= 0; i--) {
				cyc[cyc.size() - 1].push_back(curr[i]);
				is_on[curr[i]] = 1;
				if (curr[i] == par[we]) break;
			}
		} else if (used[par[we]] == 0) dfs(par[we]);
	} else {
		is_on[we] = 1;
		cyc.push_back({we});
	}

	curr.pop_back();
	used[we] = 1;	
}

int ans;

void dfsc(int we) {
	vector<pair<int, int>> v;
	for (auto el: g[we]) {
		if (is_on[el]) continue;
		dfsc(el);
		v.push_back({dp[el][0], dp[el][1]});
	}

	dp[we][1] = 1;
	for (auto el: v) dp[we][1] += el.ff;
	for (auto el: v) dp[we][0] += el.ss;

	dp[we][1] = max(dp[we][0], dp[we][1]);
	//cout << "we: " << we << " " << dp[we][0] << " " << dp[we][1] << endl;
}

int main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	/*for (int i = 1; i <= n; i++) {
		cin >> dp[i][0];
	}
	for (int i = 1; i <= n; i++) {
		cin >> dp[i][1];
	}*/
	for (int i = 1; i <= n; i++) {
		int a;
		cin >> a;
		par[i] = a;
		if (a != -1) g[a].push_back(i);
	}

	for (int i = 1; i <= n; i++) {
		if (used[i] == 0) {
			dfs(i);
		}
	}

	/*cyc.push_back({});
	for (int i = 1; i <= n; i++) {
		cyc[0].push_back(i);
	}*/

	for (auto el: cyc) {
		/*for (auto e: el) cout << e << ' ';
		cout << endl;
		cout << "sz: " << el.size() << endl;*/
		for (auto e: el) dfsc(e);
		if (el.size() == 1) {
			ans += dp[el[0]][1];
			continue;
		}

		vector<vector<array<array<int, 2>, 2>>> dp2(el.size());
		array<array<int, 2>, 2> bad;
		bad[0][0] = bad[1][0]= bad[0][1] = bad[1][1] = -INF;
		for (int i = 0; i < el.size(); i++) {
			dp2[i].resize(el.size(), bad);
		}

		for (int i = 0; i < el.size(); i++) {
			for (int b = 0; b < 2; b++) {
				dp2[i][i][b][b] = dp[el[i]][b];
			}
		}
		int mx = 0;
		for (int length = 2; length <= el.size(); length++) {
			for (int l = 0; l < el.size(); l++) {
				int r = (l + length - 1) % el.size();
				for (int b1 = 0; b1 < 2; b1++) {
					for (int b2 = 0; b2 < 2; b2++) {
						int curr = 0;
						int rp = (r + el.size() - 1) % el.size();
						int lp = (l + el.size() - 1) % el.size();
						if (lp == r && b2 && b1) continue;
						curr = dp2[l][rp][b1][0] + dp[el[r]][b2];
						dp2[l][r][b1][b2] = max(dp2[l][r][b1][b2], curr);
						if (b2 != 1) {
							curr = dp2[l][rp][b1][1] + dp[el[r]][b2];
							dp2[l][r][b1][b2] = max(dp2[l][r][b1][b2], curr);
						}
						mx = max(mx, dp2[l][r][b1][b2]);
						//cout << "dp[" << l << "][" << r << "][" << b1 << "][" << b2 << "] = " << dp2[l][r][b1][b2] << endl;
						
					}
				}
			}
		}
		ans += mx;
	}

	cout << ans << endl;

	return 0;
}

/*
4  
2
4
2
1
--
2


11
2
3
4
5
1
2
6
5
8
6
8
--
6

5
0 0 0 0 0
1 3 2 4 5
--
8


19
15
14
4
11
17
8
14
1
11
11
16
10
16
7
12
6
8
1
5
--
11

19
1 15
2 14
3 4
4 11
5 17
6 8
7 14
8 1
9 11
10 11
11 16
12 10
13 16
14 7
15 12
16 6
17 8
18 1
19 5
*/

/*
8 2 3 4 1
we: 7 0 1
we: 8 1 1
we: 2 0 1
we: 5 0 1
we: 3 1 1
we: 4 0 1
we: 1 0 1
*/