#include <map>
#include <vector>
#include <string>
#include <set>
#include <iomanip>
#include <algorithm>
#include <iostream>
#include <cmath>

using namespace std;

#define llong long long
#define all(x) x.begin(), x.end()
#define f first

#define s second


int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    vector<vector<int>> up(5005, vector<int>(5005, 0));
    vector<vector<int>> down(5005, vector<int>(5005, 0));
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        exit(0);
    }
    up[k][k] = 1;
    down[k][k] = 1;
    for (int i = k; i < n; i++) {
        for (int j = 0; j <= n; j++) {
            if (up[i][j] != 0) {
                for (int d = j + 1; n - i - d >= 0; d++) {
                    down[i + d][d] += up[i][j];
                }
            }
            if (down[i][j] != 0) {
                for (int d = 1; n - i - d >= 0 && d < j; d++) {
                    up[i + d][d] += down[i][j];
                }
            }

        }
    }
    int ans = 0;
    for (int i = 0; i <= n; i++) {
        ans += up[n][i];
        ans += down[n][i];
    }
    cout << ans;
}