#include <map>
#include <vector>
#include <string>
#include <set>
#include <iomanip>
#include <algorithm>
#include <iostream>
#include <cmath>
#include <unordered_set>

using namespace std;

#define llong long long
#define all(x) x.begin(), x.end()
#define f first

#define s second

int color_1 = 0;
int color_2 = 0;

pair<int, vector<int>> get_head(int v, vector<int> &a, unordered_set<int> &g) {
    while (v != a[v] || g.find(v) != g.end()) {
        g.insert(v);
        v = a[v];
    }
    return {v, {}};
}

void dfs(int v, vector<vector<int>> &b, int color, vector<bool> &ch) {
    ch[v] = true;
    if (color == 0) {
        color_1++;
    } else {
        color_2++;
    }
    for (int i = 0; i < b[v].size(); i++) {
        dfs(b[v][i], b, 1 - color, ch);
    }
}


bool val_in_ban(int a, vector<int> &ban) {
    for (int i = 0; i < ban.size(); i++) {
        if (a == ban[i]) {
            return true;
        }
    }
    return false;
}

int func(int v, vector<int> &ban, vector<int> &team, int ctr, vector<int> &a) {
    if (v == a.size()) {
        return ctr;
    } else {
        if (a[v] == -1) {
            if (!val_in_ban(v, ban)) {
                team.push_back(v);
                int res1 = func(v + 1, ban, team, ctr + 1, a);
                team.pop_back();
                int res2 = func(v + 1, ban, team, ctr, a);
                return max(res1, res2);
            } else {
                return func(v + 1, ban, team, ctr, a);
            }
        } else {
            if (val_in_ban(v, ban) || val_in_ban(a[v], team)) {
                return func(v + 1, ban, team, ctr, a);
            } else {
                ban.push_back(a[v]);
                team.push_back(v);
                int res1 = func(v + 1, ban, team, ctr + 1, a);
                ban.pop_back();
                team.pop_back();
                int res2 = func(v + 1, ban, team, ctr, a);
                return max(res1, res2);
            }
        }
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n, t1, TOT_ANS  = 0;
    cin >> n;

    if (n <= 20) {
        vector<int> a(n);
        vector<int> team;
        vector<int> ban;
        cout << func(0, ban, team, 0, a);
    }

    vector<int> a(n);
    vector<vector<int>> b(n);
    unordered_set<int> g;
    vector<bool> check(n, false);
    for (int i = 0; i < n; i++) {
        cin >> t1;
        if (t1 != -1) {
            a[i] = t1 - 1;
            b[t1 - 1].push_back(i);
        } else {
            a[i] = i;
        }
    }
    pair<int, vector<int>> ans;
            g = {};
    for (int i = 0; i < n; i++) {
        if (!check[i]) {
            ans = get_head(i, a, g);
            color_1 = 0;
            color_2 = 0;
            dfs(ans.f, b, 0, check);
            TOT_ANS += max(color_1, color_2);
        }
    }
    cout << TOT_ANS;
}
