#include<bits/stdc++.h>
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define endl '\n'
using namespace std; void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


const int inf = (int) 1e9 + 7;

struct node {
    node *left, *right;
    int sz; int min_val;
    int id, val, pri;

    node (int new_id, int new_val){
        val = new_val;
        id = new_id;
        pri = rand();
        sz = 1;
        min_val = val;
        left = right = nullptr;
    }
};

int get_sz(node* v){
    return v == nullptr ? 0 : v->sz;
}

int get_min_val(node* v){
    return v == nullptr ? inf : v->min_val;
}


void upd(node* v){
    if (v == nullptr){
        return;
    }
    v->sz = 1 + get_sz(v->left) + get_sz(v->right);
    v->min_val = min(v->val, min(get_min_val(v->left), get_min_val(v->right)));
}


pair<node*, node*> split(node* v, int sz) {
    if (v == nullptr){
        return {nullptr, nullptr};
    }
    if (get_sz(v->left) <= sz){
        auto splitted = split(v->left, sz);
        v->left = splitted.second;
        upd(v);
        return {splitted.first, v};
    }
    auto splitted = split(v->right, sz - get_sz(v->left) - 1);
    v->right = splitted.first;
    upd(v);
    return {v, splitted.second};
}

node* merge(node* a, node* b){
    if (a == nullptr || b == nullptr){
        return a == nullptr ? b : a;
    }
    if (a->pri > b->pri){
        a->right = merge(a->right, b);
        upd(a);
        return a;
    }
    b->left = merge(a, b->left);
    upd(b);
    return b;
}



void solve() {
    int n, m; cin >> m >> n;
    vector<int> a(n); forn (i, n) cin >> a[i]; forn (i, n) a[i]--;
    vector<int> b(m); forn (i, m) cin >> b[i]; forn (i, m) b[i]--;
    vector<int> next_oc(m, inf);
    forn (i, n){
        next_oc[a[i]] = min(next_oc[a[i]], i);
    }
    vector<vector<int>> all_oc(m);
    forn (i, n){
        all_oc[a[i]].push_back(i);
    }
    vector<int> ans;


    forn (i, n){
        bool found = false;
        while (!found) {
            if (b[0] == a[i]) {
                found = true;
                if (all_oc[a[i]].back() == i){
                    next_oc[b[0]] = inf;
                }
                else {
                    next_oc[a[i]] = *upper_bound(all(all_oc[a[i]]), i);
                }
            }
            int j;
            for (j = m - 1; j >= 0; --j){
                if (next_oc[b[j]] <= next_oc[b[0]])
                    break;
            }
            ans.push_back(j);
            vector<int> b_nxt;
            for (int k = 1; k <= j; ++k){
                b_nxt.push_back(b[k]);
            }
            b_nxt.push_back(b[0]);
            for (int k = j + 1; k < m; ++k){
                b_nxt.push_back(b[k]);
            }
            b = b_nxt;
        }
    }

    cout << len(ans) << endl;
    for (auto i : ans)
        cout << i + 1 << ' ';
    cout << endl;
}
