#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 3e5 + 5;
const int MAXT = 1e8;
vector <int> a;
vector <int> b;
int pos[MAXN];

void cycle(int pos) {
    for (int i = 0; i < pos; ++i) {
        swap(b[i], b[i + 1]);
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    a.resize(m);
    b.resize(n);
    for (int i = 0; i < MAXN; ++i) {
        pos[i] = MAXN;
    }
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    bool flag1 = false, flag2 = false;
    if (n == m) {
        flag1 = flag2 = true;
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                flag1 = false;
            }
            if (a[i] != b[n - i - 1]) {
                flag2 = false;
            }
        }
    }

    if (flag1) {
        cout << n << "\n";
        for (int i = 0; i < n; ++i) {
            cout << n << " ";
        }
    } else if (flag2) {
        cout << 2 * n - 1 << "\n";
        for (int i = 0; i < n - 1; ++i) {
            cout << n - i << " ";
        }
        for (int i = 0; i < n; ++i) {
            cout << n << " ";
        }
    } else {
        vector <int> ans;
        int cnt = 0;
        int cur = 0;
        while (true) {
            for (int i = 0; i < b.size(); ++i) {
                cerr << b[i] << " ";
            }
            cerr << "\n";
            if (b[0] == a[cur]) {
                ++cur;
                pos[b[0]] = MAXN;
                cerr << "cur = " << cur << "\n";
                cycle(n - 1);
                //b.push_back(b[0]);
                //b.erase(b.begin());
                ans.push_back(n);
                ++cnt;
                if (cur == m) {
                    break;
                }
                continue;
            }
            int ind = b.size();
            while (pos[b[ind - 1]] > pos[b[0]]) {
                --ind;
            }
            ans.push_back(ind);
            ++cnt;
            //b.insert(b.begin() + ind, b[0]);
            //b.erase(b.begin());
            cycle(ind - 1);
        }

        cout << cnt << "\n";
        for (auto i : ans) {
            cout << i << " ";
        }
    }
    return 0;
}

