#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 300005;

int n;
vector <int> g[MAXN];
bool used[MAXN];
int col[MAXN];

void dfs(int s) {
    //cerr << s << " " << col[s] << "\n";
    used[s] = true;
    for (auto v : g[s]) {
        if (col[s] == 0) {
            col[v] = 1;
        } else {
            col[v] = 0;
        }
        if (!used[v]) {
            dfs(v);
        }
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            --x;
            g[i].push_back(x);
            g[x].push_back(i);
        }
    }

    /*for (int i = 0; i < n; ++i) {
        for (auto v : g[i]) {
            cerr << v << " ";
        }
        cerr << "\n";
    }*/

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }

        col[i] = 0;
        //cerr << i << "\n";
        dfs(i);
        int ans1 = 0, ans2 = 0;
        for (int j = 0; j < n; ++j) {
            if (col[j] == 0) {
                ++ans1;
            } else if (col[j] == 1) {
                ++ans2;
            }

            col[j] = 2;
        }

        ans += max(ans1, ans2);
    }

    cout << ans;

    return 0;
}
