#include <bits/stdc++.h>

using namespace std;

int n, k;

pair <string, bool> check(string used, char next, vector <vector <int> > &a) {
    bool was = false;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (used[i] == '0' && used[j] == '0') {
                was = true;
                used[i] = next;
                used[j] = next;
                auto r = check(used, next + 1, a);
                used[i] = '0';
                used[j] = '0';
                if (r.second) return r;
            }
        }
    }

    if (!was) {
        //cout << used << "\n";
        vector <pair <int, int> > ch(k, {0, 0});
        bool up = true;
        for (int i = 0; i < used.size(); i++) {
            for (int j = i + 1; j < used.size(); j++) {
                if (used[i] == used[j]) {
                    for (int kk = 0; kk < k; kk++) {
                        if (up) {
                            ch[kk] = {min(a[i][kk], a[j][kk]), max(a[i][kk], a[j][kk])};
                        }
                        ch[kk].first = max(ch[kk].first, min(a[i][kk], a[j][kk]));
                        ch[kk].second = min(ch[kk].second, max(a[i][kk], a[j][kk]));
                    }
                    if (up) up = false;
                }
            }
        }

        for (int kk = 0; kk < k; kk++) {
            //cout << ch[kk].first << " " << ch[kk].second << "\n";
            if (ch[kk].first > ch[kk].second) {
                was = true;
            }
        }
    }

    if (!was) return {used, true};
    return {"", false};
}

void solve1(vector <vector <int> > &a, string used) {
    auto res = check(used, '1', a);

    if (res.second) {
        cout << "YES\n";
        for (int i = 0; i < res.first.size(); i++) {
            for (int j = i + 1; j < res.first.size(); j++) {
                if (res.first[i] == res.first[j]) {
                    cout << i + 1 << " " << j + 1 << "\n";
                    break;
                }
            }
        }
    }
    else {
        cout << "NO";
        exit(0);
    }
}

int main()
{
    cin >> n >> k;

    vector <vector <int> > a(n, vector <int>(k, 0) );

    for (int i = 0; i < n; i++) {
         for (int j = 0; j < k; j++) {
            cin >> a[i][j];
         }
    }

    string used = "";

    for (int i = 0; i < n; i++) {
        used += "0";
    }

    if (k == 2) {
        cout << "YES\n";
        vector <pair <int, int> > b(n, {0, 0});
        vector <pair <int, int> > b2(n, {0, 0});
        for (int i = 0; i < n; i++) {
            b[i] = {a[i][0], i};
        }
        for (int i = 0; i < n; i++) {
            b2[i] = {a[i][1], i};
        }

        sort(b.begin(), b.end());
        sort(b2.begin(), b2.end());

        int mid = 0;

        for (int i = 0; i < n / 2; i++) {
            a[b2[i].second][1] = 0;
        }
        for (int i = n / 2; i < n; i++) {
            a[b2[i].second][1] = 1;
        }

        stack <int> left;
        stack <int> right;

        for (int i = 0; i < n / 2; i++) {
            if (a[b[i].second][1] <= mid) {
                left.push(b[i].second);
            }
            else {
                right.push(b[i].second);
            }
        }

        //cout << left.size() << " " << right.size() << "\n";

        for (int i = n / 2; i < n; i++) {
            if (a[b[i].second][1] <= mid) {
                //cout << "r\n";
                cout << b[i].second + 1 << " " << right.top() + 1 << "\n";
                right.pop();
            }
            else {
                //cout << "l\n";
                cout << b[i].second + 1 << " " << left.top() + 1 << "\n";
                left.pop();
            }
        }


        return 0;
    }

    if (n <= 10) {
        solve1(a, used);
        return 0;
    }

    if (k == 1) {
        vector <pair <int, int> > b(n, {0, 0});
        for (int i = 0; i < n; i++) {
            b[i] = {a[i][0], i + 1};
        }

        sort(b.begin(), b.end());

        cout << "YES\n";

        for (int i = 0; i < n / 2; i++) {
            cout << b[i].second << " " << b[n - i - 1].second << "\n";
        }
        return 0;
    }


}

