

//#include "pch.h"
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <unordered_set>


using namespace std;


/*void DFS(vector<vector<int>> &a, vector<int> &v, vector<int> &color, int k) {
	for (int i : a[k]) {
		if (v[i] == 0) {
			v[i] = 1;
			color.push_back(i);
			DFS(a, v, color, i);
		}
	}
}*/
int df(vector<unordered_set<int>> &a, int k, int p, bool flag) {
	int ans = 0;
	if (flag) ans = 1;
	for (int i : a[k]) {
		if (i == p) continue;
		if (flag) {
			ans += df(a, i, k, false);
		}
		else {
			ans += max(df(a, i, k, true), df(a, i, k, false));
		}
	}
	return ans;
}

int DFS2(vector<unordered_set<int>> &a, vector<int> &v, int k, vector<int> &p, int n, int col) {
	for (int i : a[k]) {
		if (i == p[k]) continue;
		if (v[i] != col && v[i] != 0) return -1;
		if (v[i] == col) {
			int ans1 = 0, ans2 = 0;
			
			a[k].erase(i);
			a[k].erase(p[k]);
			a[p[k]].erase(k);
			a[i].erase(k);
			/*cout << "---" << k << " " << p[k] << " " << p[p[k]] << endl;
			for (int j = 0; j < n; ++j) {
				for (int u : a[j]) {
					cout << u << " ";
				}
				cout << endl;
			}*/
			ans1 = max(df(a, p[k], -1, true), df(a, p[k], -1, false)) + df(a, k, -1, false);
			a[k].insert(i);
			a[i].insert(k);
			a[p[p[k]]].erase(p[k]);
			a[p[k]].erase(p[p[k]]);
			/*cout << "---" << endl;
			for (int j = 0; j < n; ++j) {
				for (int u : a[j]) {
					cout << u << " ";
				}
				cout << endl;
			}
			cout << "---" << endl;*/
			ans2 = df(a, p[k], -1, false) + max(df(a, k, -1, true), df(a, k, -1, false));
			a[p[p[k]]].insert(p[k]);
			a[p[k]].insert(p[p[k]]);
			a[k].insert(p[k]);
			a[p[k]].insert(k);
			return max(ans1, ans2);
		}
		else {
			v[i] = col;
			p[i] = k;
			int ans = DFS2(a, v, i, p, n, col);
			if (ans != 0) return ans;
		}
	}
	return 0;
}





int main()
{
	int n;
	cin >> n;
	vector<unordered_set<int>> a(n, unordered_set<int>());
	vector<int> v(n, 0), p(n, -1);
	for (int i = 0; i < n; ++i) {
		int j;
		cin >> j;
		if (j == -1) continue;
		--j;
		a[i].insert(j);
		a[j].insert(i);
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int l = 0;
		if (v[i] == 0) {
			v[i] = i;
			l = DFS2(a, v, i, p, n, i + 1);
			if (l == -1) continue;
			/*cout << "+" << endl;
			cout << "=====" << endl;
			for (int j = 0; j < n; ++j) {
				for (int u : a[j]) {
					cout << u << " ";
				}
				cout << endl;
			}
			cout << "====" << endl;*/
			if (l == 0) ans += max(df(a, i, -1, true), df(a, i, -1, false));
			else ans += l;
		}
	}
	cout << ans << endl;

	/*
	for (vector<int> c : color) {
		int s = int(c.size());
		if (s > 4) {
			ord.push_back(n % 2);
		}
		else if (s == 1) {
			ord.push_back(1);
		}
		else if (s == 2) {
			ord.push_back(2);
		}
		else if (s == 3) {
			if (int(a[c[1]].size()) == 1 || int(a[c[2]].size()) == 1 || int(a[c[0]].size()) == 1) {
				ord.push_back(1);
			} else {
				ord.push_back(3);
			}
		}
		else if (s == 4) {
			for (int j : c) {
				if (int(a[j].size()) == 3) {
					if (!(a[j][0] == a[j][1] || a[j][0] == a[j][2] || a[j][1] == a[j][2])) {
						ord.push_back(2);
					}
				}
			}
		}
	}
	/*for (vector<int> c : color) {
		for (int i : c) {
			cout << i << " ";
		}
		cout << endl;
	}
	cout << "---" << endl;
	int maxel = 0, sum = 0;
	for (int k : ord) {
		sum += k;
		maxel = max(maxel, k);
	}
	if (2 * maxel > sum) {
		cout << (n - (maxel - (sum - maxel))) << endl;
	}
	else {
		cout << (n / 2) * 2 << endl;
	}
    //cout << "Hello World!\n"; 
	*/
}
