#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll k;
	cin >> k;
	bool getmax = k >= 0;
	k = abs(k);
	if (k == 0) {
		cout << "0\n";
		return 0;
	}
	ll mina = INF, minb = INF;
	for (ll d = 1; d * d <= k; ++d) {
		if (k % d) continue;
		ll e = k / d;
		if ((d ^ e) & 1) continue;
		chkmin(mina, (e - d) / 2);
		chkmin(minb, (e + d) / 2);
	}
	if (mina == INF) {
		cout << "none\n";
		return 0;
	}
	if (getmax)
		cout << minb << '\n';
	else
		cout << mina << '\n';
}

