#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 5038;
const ll MOD = 1e9 + 7;

int d[2][MAXN][MAXN];
int f[2][MAXN][MAXN];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	for (int i = 0; i <= n; ++i) {
		d[0][i][i] = d[1][i][i] = 1;
	}
	for (int i = 0; i <= n; ++i) {
		for (int k = 0; k < 2; ++k) {
			for (int j = 1; j < i; ++j) {
				if (k) {
					d[k][i][j] = f[1 - k][i - j][min(j - 1, i - j)];
				} else {
					d[k][i][j] = f[1 - k][i - j][i - j] - f[1 - k][i - j][min(i - j, j)];
					if (d[k][i][j] < 0) d[k][i][j] += MOD;
				}
			}
		}
		for (int k = 0; k < 2; ++k) {
			for (int x = 1; x <= i; ++x) {
				//int k1 = 1 - k;
				//if (k1) {
				//}
				f[k][i][x] = f[k][i][x - 1] + d[k][i][x];
				if (f[k][i][x] >= MOD)
					f[k][i][x] -= MOD;
			}
		}
	}
	if (n != k)
		cout << (d[0][n][k] + d[1][n][k]) % MOD << '\n';
	else
		cout << 1 << '\n';
	//cout << d[0][n][k] << ' ' << d[1][n][k] << '\n';
}

