#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>


#define ll long long
#define pii pair<ll, ll>
#define x first
#define y second
#define ld long double

using namespace std;

const ll NMAX = 5111;
const ll inf = 4e18;
const ll M = 1e9 + 7;

ll dp[NMAX][NMAX][2];
ll sum[NMAX][NMAX][2];

signed main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cout.precision(10);
	int n, k;
	cin >> n >> k;
	if (n == k)
	{
		cout << 1 << endl;
		return 0;
	}
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	sum[k][k][0] = 1;
	sum[k][k][1] = 1;
	for (int i = k + 1; i <= n; i++)
		sum[k][i][0] = 1, sum[k][i][1] = 1;
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			if (i - j > j)
			{
				dp[i][j][0] = (sum[i - j][i - j][1] - sum[i - j][j][1] + M) % M;
			}
			sum[i][j][0] = (dp[i][j][0] + sum[i][j - 1][0]) % M;

			dp[i][j][1] = (sum[i - j][j - 1][0] - sum[i - j][0][0] + M) % M;
			sum[i][j][1] = (dp[i][j][1] + sum[i][j - 1][1]) % M;
		}
		for (int j = i + 1; j <= n; j++)
		{
			sum[i][j][1] = sum[i][j - 1][1];
			sum[i][j][0] = sum[i][j - 1][0];
		}
	}
	ll ans = 0;
	for (int i = 1; i <= n; i++)
		ans = (ans + dp[n][i][0] + dp[n][i][1]) % M;
	cout << ans << endl;
	return 0;
}