#include <iostream>
#include <algorithm>
#include <vector>

#define INF 1000000007
using namespace std;

long long st2(int k){
    if (k==1) return 0;
    return st2(k/2)+1;
}

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    k++;
    long long k_sh = 0, k_nas = 1;
    while (k_nas<k) k_nas*=2, k_sh++;

    if (m!=0) return 0;
    vector<vector<long long> > A(n, vector<long long>(k_nas+1));
    for (long long i=0; i<k; i++){
        A[0][i] = 1;
    }
    for (long long i=0; i<n-1; i++){
        for (long long j=0; j<k; j++){
            A[i+1][j] = (A[i+1][j]+A[i][j])%INF;
            for (long long u=k_nas-j-1; u>0; u = (u-1)&(k_nas-j-1)){
                A[i+1][j+u] = (A[i+1][j+u]+A[i][j])%INF;
            }
        }
    }
    long long ans = 0;
    for (long long i=0; i<k; i++){
        ans = (ans+A[n-1][i])%INF;
    }
    for (long long i=0; i<n; i++){
        for (long long j=0; j<k; j++){
            cout << A[i][j] << " ";
        }
        cout << endl;
    }
    cout << ans << endl;
}

