#include <iostream>
#include <vector>
#include <algorithm>

#define INF 1000000007
using namespace std;

int main()
{
    long long n, k;
    cin >> n >> k;
    n++;
    vector<vector<long long> > dp1(n, vector<long long>(n)), dp2(n, vector<long long>(n));
    for (long long i=0; i<n; i++){
        dp1[0][i] = 1;
        dp2[0][i] = 1;
    }
    for (long long i=1; i<n; i++){
        for (long long j=0; j<=i; j++){
            //cout << i << " " << j << endl;
            for (long long t=1; t<j; t++){
                dp1[i][j] = (dp1[i][j]+dp2[i-t][t])%INF;
            }
            for (long long t=j+1; t<=i; t++){
                dp2[i][j] = (dp2[i][j]+dp1[i-t][t])%INF;
            }
        }
    }
    /*for (long long i=0; i<n; i++){
        for (long long j=0; j<n; j++){
            cout << dp1[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    for (long long i=0; i<n; i++){
        for (long long j=0; j<n; j++){
            cout << dp2[i][j] << " ";
        }
        cout << endl;
    }*/
    cout << (dp1[n-1][k]+dp2[n-1][k])%INF;
}

