#include <bits/stdc++.h>
using namespace std;

typedef unsigned long long ull;
typedef long long ll;

void dfs(vector<vector<int>>& a, int start, vector<int>& colour, int c){
    colour[start] = c;
    for(auto k:a[start])
        if (colour[k]==0)
            dfs(a, k, colour, 3-c);
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<vector<int>> a(n+1);
    for(int i = 1; i<=n; i++){
        int k;
        cin >> k;
        if (k!=-1) {
            a[i].push_back(k);
            a[k].push_back(i);
        }
    }
    vector<int> colour(n+1, 0);
    int ans = 0;
    for(int i = 1; i<=n; i++)
        if (!colour[i]) {
            dfs(a, i, colour, 1);
            ans += max(count(colour.begin(), colour.end(), 1), count(colour.begin(), colour.end(), 2));
            for(int i = 0; i<=n; i++)
                if (colour[i]!=0)
                    colour[i]=3;
        }
    cout << ans;
};