#include <iostream>
#include <vector>

using namespace std;

typedef long int i64;
typedef long unsigned int u64;
typedef int i32;
typedef unsigned int u32;

int main() {
   int n, m, k;
   cin >> n >> m >> k;
   bool andop[k][k];
   for (int i = 0; i < k; i++) {
       for (int j = 0; j < k; j++) {
           andop[i][j] = ((i + 1) & (j + 1)) == (j + 1);
       }
   }
/*
   for (int i = 0; i < k; i++) {
       for (int j = 0; j < k; j++) {
           cout << andop[i][j] << " ";
       }
       cout << endl;
   }
   cout << endl;
*/
   u32 mat[n][k+1];
   for (int i = 0; i <= k; i++) {
       mat[0][i] = 1;
   }
   for (int i = 0; i < n; i++) {
       mat[i][0] = 1;
   }
   for (int i = 1; i < n; i++) {
       for (int j = 1; j <= k; j++) {
           mat[i][j] = mat[i-1][0];
           for (int l = 1; l <= k; l++) {
               if (andop[j-1][l-1]) {
                   mat[i][j] = (mat[i][j] + mat[i-1][l]) % 1000000007;
               }
           }
       }
   }
    /*
   for (int i = 0; i <= k; i++) {
       for (int j = 0; j < n; j++) {
           cout << mat[j][i] << " ";
       }
       cout << endl;
   }
   cout << endl;
    */
   i64 s = 0;
   for (int i = 0; i <= k; i++) {
       s = (s + mat[n-1][i]) % 1000000007;
   }
   cout << s << endl;
}
