import java.util.*;

public class Main {
    private static int actions = 0;
    private static int rooms;
    private static List<Integer> ans = new ArrayList<>();
    private static void emplace(Map<Integer, Integer> positions2, int current, int curprior, int newprior) {
        actions++;
        ans.add(newprior);
        // move current to end
        for (int j = 0; j < rooms; j++) {
            if (j == current)
                positions2.put(j, newprior);
            else if (positions2.get(j) > curprior && positions2.get(j) <= newprior)
                positions2.put(j, positions2.get(j) - 1);
        }
    }

    public static void main(String[] args) {
        //List<Integer> positions = new ArrayList<>(); // Position of N -> N
        Map<Integer, Integer> positions2 = new HashMap<>(); // N -> Position of N
        List<Integer> reqarr = new ArrayList<>(); // unfinished requests
        //positions.add(0);

        Scanner sc = new Scanner(System.in);
        rooms = sc.nextInt();
        int reqs = sc.nextInt(), i, j, p, current, maxprior, curprior;
        for (i = 0; i < reqs; i++) reqarr.add(sc.nextInt());
        for (i = 0; i < rooms; i++) {
            p = sc.nextInt();
            positions2.put(p - 1, i);
        }

        i = 0;
        while (i < reqs  && actions < 100) {
            current = reqarr.get(i) - 1;
            curprior = maxprior = positions2.get(current);
            for (j = i + 1; j < reqs && positions2.get(reqarr.get(j) - 1) != 0; j++)
                if (maxprior < positions2.get(reqarr.get(j) - 1))
                    maxprior = positions2.get(reqarr.get(j) - 1);

            if (j == reqs) {
                if (positions2.get(reqarr.get(i) - 1) == 0) i++;
                emplace(positions2, current, curprior, rooms);
            } else if (j == i + 1) {
                i++;
                actions++;
                ans.add(1);
            } else {
                if (positions2.get(reqarr.get(i) - 1) == 0) i++;
                emplace(positions2, current, curprior, maxprior);
            }
        }

        System.out.println(actions);
        for (i = 0; i < actions; i++)
            System.out.print(ans.get(i) + " ");
    }
}