import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
    private static long n, z;
    private static long T = 1000000007;
    private static Map<Long, Long> ans1, ans2;

    private static long floor2k(long n) {
        long i = 1;
        while (n >= i)
            i *= 2;
        return i / 2;
    }

    private static long f(long b) {
        if (ans2.containsKey(b)) return ans2.get(b);
        if (b == 0) return 1;
        if (b == 1) return n + 1;
        long c = floor2k(b);
        long a = b - c;
        long d = c - 1;
        long answ = (f(d) + f(a) * n) % T;
        ans2.put(b, answ);
        return answ;
    }

    private static long g(long b) {
        if (ans1.containsKey(b)) return ans1.get(b);
        if (b == 0) return 1;
        if (b == 1) return z;
        long c = floor2k(b);
        long a = b - c;
        long d = c - 1;
        long answ = (g(d) + g(a) * n + (f(a) - g(a)) * z) % T;
        ans1.put(b, answ);
        return answ;
    }

    public static void main(String[] args) {
        ans1 = new HashMap<>();
        ans2 = new HashMap<>();

        Scanner sc = new Scanner(System.in);
        long m, k;
        n = sc.nextLong();
        m = sc.nextLong();
        k = sc.nextLong();

        long begin = 0, end = n + 1;
        long p, q;
        for (int i = 0; i < m; i++) {
            p = sc.nextLong();
            q = sc.nextLong();
            if (p > begin) begin = p;
            if (q < end) end = q;
        }
        z = Math.max(end - begin, 0);
        System.out.println(g(k));
    }
}