#include <iostream>
#include <algorithm>

using namespace std;
int **arrs;
int *averages;
int n, k;

bool overcalc(int m, pair<int, int>* arr) {
    int i, j;
    if (m * 2 == n) {
        for (i = 0; i < m; i++) {
            for (j = 0; j < k; j++)
                if ((arrs[j][arr[i].first] > averages[j] && arrs[j][arr[i].second] > averages[j]) ||
                        (arrs[j][arr[i].first] < averages[j] && arrs[j][arr[i].second] < averages[j]))
                    break;
            if (j != k) break;
        }
        if (m == i) {
            cout << "YES" << endl;
            for (i = 0; i < m; i++)
                cout << (arr[i].first + 1) << " " << (arr[i].second + 1) << endl;
            return true;
        }
        return false;
    }

    int possibilities[10], x = 0;
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++)
            if (arr[j].first == i || arr[j].second == i)
                break;
        if (j == m)
            possibilities[x++] = i;
    }

    for (i = 1; i < x; i++) {
        arr[m] = {possibilities[0], possibilities[i]};
        if (overcalc(m + 1, arr))
            return true;
    }
    return false;
}

int main() {
    int i, j, p = 0, q = 0;
    cin >> n >> k;

    arrs = new int*[k];
    for (i = 0; i < k; i++) arrs[i] = new int[n];
    for (i = 0; i < n; i++) for (j = 0; j < k; j++)
        cin >> arrs[j][i];

    int **morearrs = new int*[k];
    for (i = 0; i < k; i++) morearrs[i] = new int[n + 1];
    for (i = 0; i < n; i++) for (j = 0; j < k; j++)
         morearrs[j][i] = arrs[j][i];
    for (i = 0; i < k; i++) morearrs[i][n] = INT32_MAX;

    averages = new int[k];
    for (i = 0; i < k; i++) {
        nth_element(morearrs[i], morearrs[i] + n/2, morearrs[i] + n);
        averages[i] = morearrs[i][n/2];
    }

    if (n < 11) {
        auto *z = new pair<int, int>[n / 2];
        if (!overcalc(0, z))
            cout << "NO";
        delete[] z;
    } else if (k == 1) {
        int *a = new int[n/2], *b = new int[n/2];

        for (i = 0; i < n; i++)
            if (arrs[0][i] < averages[0])
                a[p++] = i + 1;
            else
                b[q++] = i + 1;

        cout << "YES" << endl;
        for (i = 0; i < n / 2; i++)
            cout << a[i] << " " << b[i] << endl;

        delete[] a;
        delete[] b;
    } else {
        q = 1 << k;
        int **z = new int*[q], *c = new int[q], *r = new int[q];
        for (i = 0; i < q; i++) {
            z[i] = new int[n];
            c[i] = 0;
            r[i] = 0;
        }

        for (i = 0; i < n; i++) {
            p = 0;
            for (j = 0; j < k; j++)
                p = p * 2 + (arrs[j][i] < averages[j] ? 1 : 0);
            c[p]++;
            z[p][r[p]++] = i + 1;
        }
        for (j = 0; j < q; j++)
            if (c[q - j - 1] != c[j]) {
                cout << "NO" << endl;
                break;
            }
        if (j == q) {
            cout << "YES" << endl;
            for (i = 0; 2 * i < q; i++)
                for (j = 0; j < c[i]; j++)
                    cout << z[i][j] << " " << z[q - i - 1][j] << endl;
        }

        for (i = 0; i < j; i++) delete[] z[i];
        delete[] z;
        delete[] c;
        delete[] r;
    }

    for (i = 0; i < k; i++) delete[] arrs[i];
    delete[] arrs;
    for (i = 0; i < k; i++) delete[] morearrs[i];
    delete[] morearrs;
    delete[] averages;
    return 0;
}