#include <bits/stdc++.h>

using namespace std;

#define int long long

const int R = 1e9 + 7;

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	++k;
	vector< vector< int > > dp(n, vector<int>(k));
	for (int i = 0; i < k; ++i) dp[0][i] = 1;
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			for (int x = 0; x <= j; ++x) {
				if ((x & j) == x) {
					dp[i][j] += dp[i - 1][x];
					dp[i][j] %= R;
				}
			}
		}
	}
	int ans = 0;
	for (int x : dp.back()) ans += x;
	cout << (ans % R) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}