// D.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;
using ll = long long;

const int lg = 62;
const int mod = 1000000007;

int main()
{
	int n, m;
	ll k;
	cin >> n >> m >> k;
	vector<array<ll, 2> > dp(lg);
	dp[lg - 1][0] = 0, dp[lg - 1][1] = 1;
	for (int i = lg - 2; i >= 0; i--) {
		dp[i][0] += dp[i + 1][0] * (n + 1);
		dp[i][0] %= mod;
		if ((k >> i) & 1) {
			//cout << i << endl;
			dp[i][0] += dp[i + 1][1];
			dp[i][1] += dp[i + 1][1] * n;
			dp[i][0] %= mod, dp[i][1] %= mod;
		}
		else {
			dp[i][1] += dp[i + 1][1];
			dp[i][1] %= mod;
		}
	}
	cout << (dp[0][0] + dp[0][1]) % mod << endl;
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
