// D.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;
using ll = long long;

const int lg = 62;
const int mod = 1000000007;

int main()
{
	int n, m;
	ll k;
	cin >> n >> m >> k;
	if (m == 0) {
		vector<array<ll, 2> > dp(lg);
		dp[lg - 1][0] = 0, dp[lg - 1][1] = 1;
		for (int i = lg - 2; i >= 0; i--) {
			dp[i][0] += dp[i + 1][0] * (n + 1);
			dp[i][0] %= mod;
			if ((k >> i) & 1) {
				//cout << i << endl;
				dp[i][0] += dp[i + 1][1];
				dp[i][1] += dp[i + 1][1] * n;
				dp[i][0] %= mod, dp[i][1] %= mod;
			}
			else {
				dp[i][1] += dp[i + 1][1];
				dp[i][1] %= mod;
			}
		}
		cout << (dp[0][0] + dp[0][1]) % mod << endl;
	}
	else {
		vector<pair<int, int> > seg(m);
		for (int i = 0; i < m; i++) {
			cin >> seg[i].first >> seg[i].second;
			seg[i].first--, seg[i].second--;
		}
		vector<vector<int> > dp(n + 1, vector<int>(k + 1));
		dp[0][0] = 1;
		for (int i = 1; i <= n; i++) {
			int l = 0;
			for (int x = 0; x < m; x++) {
				if (seg[x].first <= i - 1 && seg[x].second <= i - 1) {
					l = max(l, seg[x].first);
				}
			}
			for (int j = 0; j <= k; j++) {
				for (int j2 = 0; j2 <= k; j2++) {
					if ((j2 & j) != j2 || j2 == j) continue;
					for (int x = l; x < i; x++) {
						dp[i][j] += dp[x][j2];
						dp[i][j] %= mod;
					}
				}
			}
		}
		/*for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= k; j++) {
				cout << dp[i][j] << ' ';
			}
			cout << endl;
		}*/
		int ans = 0;
		for (int j = 0; j <= k; j++) {
			ans += dp.back()[j];
			ans %= mod;
		}
		cout << ans << endl;
	}
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
