#pragma GCC optimize("O3", "unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define ld long double
#define int long long

using namespace std;

inline bool check(int x) {
    if (x < 0) return 0;
    int k = sqrtl(x);
    return k*k == x;
}

int solve(int k) {
    if (abs(k) % 4 == 2) return -1;
    int cur = k;
    int x = max((int)sqrtl(max(0LL, k))-1, 0LL);
    int i;
    for (i = x; i <= k/2+23; ++i) {
	if (check(i*i-k)) {
	    return i;
	}
    }
    return -1;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // for (int k = 0; k <= 100; ++k) {
    // 	int ans = solve(k);
    // 	if (ans >= 0) {
    // 	    cout << k << " " << ans << " " << k%4 << endl;
    // 	}
    // }
    //  return 0;
    int k;
    cin >> k;
    int ans = solve(k);
    if (ans >= 0) {
	cout << ans << endl;
    }
    else {
	cout << "none" << endl;
    }
    return 0;
}
