#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k;

const ll mod = 1e9 + 7;

ll get(int n, int k, int increase)
{
    long long res = 0;
    if (n == k)
    {
        return 1;
    }
    if (increase == 0)
    {
        for (int j = 1; j < k; j++)
        {
            res += get(n - k, j, 1);
        }
    }
    else
    {
        for (int j = k + 1; j <= n; j++)
        {
            res += get(n - k, j, 0);
        }
    }
    return res;
}

int main()
{
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    cout << (get(n, k, 1) + get(n, k, 0)) % mod;
}
