#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k, NN;

const ll mod = 1e9 + 7;
int dp[5001][5001][2];
const int INF = 11;

int main()
{
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    for (int j = 1; j <= INF; j++)
    {
        dp[j][j][0] = 1;
        dp[j][j][1] = 1;
    }
    for (int n0 = 1; n0 <= INF; n0++)
    {
        for (int ai = 1; ai < n0; ai++)
        {
            long long res = 0;
            for (int aj = 1; aj <= min(n0 - ai, ai); aj++)
            {
                res += dp[n0 - ai][aj][1];
                res %= mod;
            }
            dp[n0][ai][0] = res;
            res = 0;
            for (int aj = ai + 1; aj <= n0 - ai; aj++)
            {
                res += dp[n0 - ai][aj][0];
                res %= mod;
            }
            dp[n0][ai][1] = res;
            //cout << dp[n0][ai][0] << " " << dp[n0][ai][1] << endl;
        }
        //cout << endl;
    }
    cout << (dp[n][k][0] + dp[n][k][1]) % mod;
}
