#include <bits/stdc++.h>

#define int long long
#define double long double
#define pr pair
#define vc vector
#define rep(n, i) for (int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define fs first
#define sc second
#define pb push_back
#define endd endl; return 0;
#ifdef LOCAL
#define cerr cout
#else
#define cerr if (0) cout
#endif
#define print(x) for (const auto &kek : x) { cerr << kek << ' '; } cerr << endl;

typedef long long ll;

using namespace std;

const int N = 1e5 + 5;
const int MOD = 1e9 + 7;
#ifdef LOCAL
int NN = 5;
#else
int NN = 5e4 + 5;
#endif

struct ST {
    vc<int> tree;
    vc<int> add;

    ST() {
        tree.resize(4 * NN);
        add.resize(4 * NN);
    }


    void push(int v, int vl, int vr) {
        tree[v] += add[v];
        if (vr - vl != 1) {
            add[2 * v] += add[v];
            add[2 * v + 1] += add[v];
            add[v] = 0;
        }
    }

    int mean(int ind, int v = 1, int vl = 0, int vr = NN) {
        push(v, vl, vr);
        if (vr - vl == 1) {
            return tree[v];
        }
        int mid = (vl + vr) >> 1;
        if (ind < mid) {
            return mean(ind, 2 * v, vl, mid);
        } else {
            return mean(ind, 2 * v + 1, mid, vr);
        }
    }

    void ch(int l, int r, int v = 1, int vl = 0, int vr = NN) {
        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            add[v] -= 1;
            return;
        }
        if (vr <= l || vl >= r) {
            return;
        }
        int mid = (vl + vr) >> 1;
        ch(l, r, 2 * v, vl, mid);
        ch(l, r, 2 * v + 1, mid, vr);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    // cout.precision(6); cout << fixed;
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vc<int> a(m), b(n);
    for (int &i : a) {
        cin >> i;
    }
    for (int &i : b) {
        cin >> i;
    }
    if (a[0] == b[0]) {
        cout << n << endl;
        rep(n, i) {
            cout << n << ' ';
        }
    } else {
        int k = 0;
        vc<int> ind(n + 5);
        for (int i = 0; i < (int) b.size(); ++i) {
            ind[b[i]] = i + 1;
        }
        ST st;
        for (int i : a) {
            cerr << i << ' ' << ind[i] << endl;
            k += ind[i] + st.mean(ind[i]);
            st.ch(ind[i] + 1, NN);
        }
        cout << k << endl;
        rep(k, i) {
            cout << n << ' ';
        }
    }
    return 0;
}