#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

struct object
{
    int idx;
    vector<int> p;
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vector<object> objects(n);
    for (int i = 0; i < n; i++)
    {
        objects[i].idx = i;
        objects[i].p.resize(k);
        for (int j = 0; j < k; j++)
            cin >> objects[i].p[j];
    }

    if (k == 1)
    {
        sort(objects.begin(), objects.end(), [](object a, object b){return a.p[0] < b.p[0];});
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++)
            cout << objects[i].idx + 1 << " " << objects[i + n / 2].idx + 1 << endl;
        return 0;
    }

    return 0;
}