#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve()
{
	ll k;
	cin >> k;

	if(k > 0)
	{
		ll ans = LL_INF;

		for(ll d1 = 1; d1 * d1 <= k; ++d1)
		{
			if(k % d1 == 0)
			{
				ll d2 = k / d1;

				ll m = d1 + d2;

				if(m % 2 == 0)
					ans = min(ans, m / 2);
			}
		}

		if(ans == LL_INF)
			cout << "none" << endl;
		else
			cout << ans << endl;
	}
	else if(k < 0)
	{
		ll ans = LL_INF;
		k = -k;

		for(ll d1 = 1; d1 * d1 <= k; ++d1)
		{
			if(k % d1 == 0)
			{
				ll d2 = k / d1;

				ll m = d2 - d1;

				if(m % 2 == 0)
					ans = min(ans, m / 2);
			}
		}

		if(ans == LL_INF)
			cout << "none" << endl;
		else
			cout << ans << endl;
	}
	else
	{
		cout << "0" << endl;
	}
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}