#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

//#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

ll dist(ll x, ll y)
{
	if(x > y)
		swap(x, y);

	return (y - x) / 2 + (y - x) % 2;
}

void solve()
{
	ll a, b, c;
	cin >> a >> b >> c;

	ll ft = (a - 1) / c + 1;
	ll lt = (b - 1) / c;

	DBG(ft); DBG(lt);

	ll ans = 0;

	if(c * ft >= b || c * ft <= a || c * lt >= b || c * ft <= a)
	{
		ans = dist(a, b);
	}
	else
	{
		ans += dist(a, c * ft - 1);
		ans += dist(b, c * lt + 1);
		DBG(ans);
		ans += (lt - ft + 1) * (1 + dist(0, c - 2)) - dist(0, c - 2);
	}

	cout << ans << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}