#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

vector<pii> p;

void solve()
{
	int n, k;
	vector<vector<int>> data;

	cin >> n >> k;

	if(k == 1)
	{
		p.resize(n);

		for(int i = 0; i < n; ++i)
		{
			int vl;
			cin >> vl;

			p[i].first = vl;
			p[i].second = i + 1;
		}

		sort(p.begin(), p.end());

		int i = 0, j = n - 1;

		cout << "YES" << endl;

		while(i < j)
		{
			cout << p[i].second << " " << p[j].second << endl;

			++i, --j;
		}

		return;
	}

	for(int i = 0; i < n; ++i)
	{
		data.push_back(vector<int>());
		data.rbegin()->resize(k);

		for(int j = 0; j < k; ++j)
			cin >> data[i][j];
	}
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}