#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>

using namespace std;
const int MAXN = 3 * 1e5 + 10;
vector <int> g[MAXN];
int n;
vector <int> root;
void read()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		if (x == -1)
		{
			root.push_back(i);
			continue;
		}
		x--;
		g[i].push_back(x);
		g[x].push_back(i);
	}
}

int h[MAXN];

int cnt1, cnt2;
void dfs(int v, int p, int len)
{
	h[v] = len++;
	if (h[v] % 2 == 0)
		cnt1++;
	else
		cnt2++;
	for (auto i : g[v])
		if (i != p)
			dfs(i, v, len);
}

int ans = 0;

void run()
{
	for (auto i : root)
	{
		cnt1 = 0;
		cnt2 = 0;
		dfs(i, i, 0);
		ans += max(cnt1, cnt2);
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
