#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
const int MAXN = 3 * 1e5 + 10;
vector <int> g[MAXN], gr[MAXN];
int n;
vector <int> a, root;
bool flag3;
void read()
{
	flag3 = true;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int v;
		cin >> v;
		if (v == -1)
		{
			a.push_back(v);
			root.push_back(i);
			continue;
		}
		v--;
		g[i].push_back(v);
		g[v].push_back(i);
		gr[v].push_back(i);
		a.push_back(v);
		if (i < v)
			flag3 = false;
	}
}

bool used[MAXN];
int color[MAXN];
int cnt1, cnt2;
void dfs(int v, int c)
{
	if (c == 1)
		for (auto i : g[v])
		{
			if (color[i] == 1)
			{
				c = 2;
				break;
			}
		}
	if (c == 1)
		cnt1++;
	else
		cnt2++;
	color[v] = c;
	used[v] = 1;
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i, 3 - c);
		}
	}
}

int ans;

void run()
{
	ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			cnt1 = 0;
			cnt2 = 0;
			dfs(i, 1);
			ans += max(cnt1, cnt2);
		}
	}
}

bool check(vector <int> x)
{
	for (int i = 0; i < n; i++)
	{
		if (a[i] == -1)
			continue;
		if (x[i] == 1 && x[a[i]] == 1)
			return false;
	}
	return true;
}

void run2()
{
	ans = 0;
	for (int i = 1; i <= n; i++)
	{
		vector <int> pos(n);
		for (int j = 0; j < i; j++)
			pos[n - j - 1] = 1;
		do
		{
			if (check(pos))
			{
				ans = i;
				break;
			}
		} while (next_permutation(pos.begin(), pos.end()));
		if (ans != i)
			break;
	}
}


int dp[MAXN][2];
void dfs_3(int v)
{
	int cnt = 0;
	for (auto i : gr[v])
	{
		dfs_3(i);
		cnt++;
	}
	if (cnt = 0)
		dp[v][1] = 1;
	int sum1 = 0, sum2 = 0;
	for (auto i : gr[v])
	{
		sum1 += dp[i][0];
		sum2 += max(dp[i][1], dp[i][0]);
	}
	dp[v][0] = sum2;
	dp[v][1] = sum1 + 1;
}

void run3()
{
	ans = 0;
	for (auto i : root)
	{
		dfs_3(i);
		ans += max(dp[i][1], dp[i][0]);
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	if (flag3)
		run3();
	else if (n <= 20)
		run2();
	else
		run();
	write();
	return 0;
}
