#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

struct Node{
    int x;
    int y;
    Node *L, *R;
    Node(int x1) {
        x = x1;
        y = rand();
        L = nullptr;
        R = nullptr;
    }
};

Node* merge(Node *v, Node *t) {
    if (!v && !t) {
        return nullptr;
    }
    if (!v) {
        return t;
    }
    if (!t) {
        return v;
    }
    if (v->y > t->y) {
        auto p = merge(v->R, t);
        v->R = p;
        return v;
    } else {
        auto p = merge(v, t->L);
        t->L = p;
        return t;
    }
}

pair<Node*, Node*> split(Node *v, int x) {//for seen
    if (!v) {
        return {nullptr, nullptr};
    }
    if (x < v->x) {
        auto p = split(v->L, x);
        v->L = p.second;
        return {p.first, v};
    } else {
        auto p = split(v->R, x);
        v->R = p.first;
        return {v, p.second};
    }
}

vector<int> dir;

void dfs(Node* t) {
    if (t == nullptr) {
        return;
    }
    dfs(t->L);
    dir.push_back(t->x);
    //cout << t->x << " ";
    dfs(t->R);
}

int right(Node *t) {
    if (!t->R && !t->L) {
        return t->x;
    }
    if (t->R) {
        return right(t->R);
    } else {
        return left(t->L);
    }
}

main() {
    int n, m;
    cin >> n >> m;
    vector<int> quest(m);
    map<int, set<int>> mapi;
    for (int i = 0; i < m; i++) {
        int a;
        cin >> a;
        quest[i] = a;
        mapi[a].insert(i);
    }
    Node* t = nullptr;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        t = merge(t, new Node(a));
    }
    int ind = 0;

    return 0;
}

