#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <functional>

using namespace std;

int main() {
	long long n;
	cin >> n;
	long long a;
	vector <long long> dp(n, 0);
	vector <vector <long long>> graf(n, vector <long long>(0));
	for (long long i = 0; i < n; i++) {
		cin >> a;
		a--;
		if ((a >= 0) && (dp[a] != i)) {
			graf[a].push_back(i);
			graf[i].push_back(a);
			dp[i] = a;
		}
	}

	vector <vector <long long>> ans(n, vector <long long>(2, 0));
	vector <long long> used(n, 0);
	function<void(long long, long long)> dfs = [&](long long v, long long prev) {
//		cout << v << "\n";
		if (prev == -1) {
			used[v] = 1;
		}
		else {
			used[v] = (used[prev] % 2) + 1;
		}
		ans[v][used[v] - 1] = 2;
		for (long long i = 0; i < graf[v].size(); i++) {
			long long to = graf[v][i];
			if (used[to] == 0) {
				dfs(to, v);
				ans[v][used[v] % 2] += ans[to][used[v] % 2];
				ans[v][used[v] - 1] += ans[to][used[v] - 1];
			}
			else if (used[to] == used[v]) {
				ans[v][used[v] - 1]--;
			}
		}
	};

	long long dp_ans = 0;
	for (long long i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs(i, -1);
			dp_ans += max(ans[i][0], ans[i][1]) / 2;
		}
	}

//	for (long long i = 0; i < n; i++) {
//		cout << ans[i][0] << " " << ans[i][1] << "\n";
//	}

	cout << dp_ans;
//	system("pause");
	return 0;
}