#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cout.setf(ios::fixed);
	cout.precision(2);
}

long long get_sum(long long n) {
	n += (n - 1);
	long long s1 = n * (n + 1) / 2;
	n /= 2;
	long long s2 = n * (n + 1) / 2;
	return s1 - 2 * s2;  
}

int main() {
	hello();

	long long k;
	cin >> k;

	if (k >= 0) {
		long long l = 0, r = 1e9;
		while (l < r - 1) {
			long long n = (r + l) / 2;
			long long s = get_sum(n);
			if (s <= k)
				l = n;
			else 
				r = n;
		}
		long long sum1 = get_sum(l);
		long long d = k - sum1;
		if (d == 0) {
			cout << (long long)sqrt(k) << endl;
			return 0;
		}
		long long val = 2 * l + 1;
		l = 0, r = 1e9;
		while (l < r - 1) {
			long long n = (r + l) / 2;
			long long s = get_sum(n);
			if (s + d <= val)
				l = n;
			else 
				r = n;
		}
		long long sum2 = get_sum(l);
		if (sum2 + d == val) {
			cout << (long long)sqrt(sum1 + sum2 + d) << endl;
		}
		else 
			cout << "none" << endl;

	}

	return 0;
}