#include <iostream>
#include <vector>
#include <algorithm>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

const long long MOD = 1e9 + 7;

int main() {
	hello();

	long long n, k;
	cin >> n >> k;
	vector<vector<long long> > dp(n + 1, vector<long long>(n + 1));
	dp[k][k] = 1;

	for (int sum = k; sum <= n; ++sum)
		for (int num = 1; num <= n; ++num) 
			if (sum - num >= 0) {
			long long cnt1 = 0, cnt2 = 0;
			for (int elem = 1; elem < num; ++elem)
				cnt1 = (cnt1 + dp[sum - num][elem]) % MOD;
			for (int elem = num + 1; elem <= n; ++elem)
				cnt2 = (cnt2 + dp[sum - num][elem]) % MOD;

			dp[sum][num] = (cnt1 + cnt2) % MOD;
		}

	long long ans = 0;
	for (int num = 1; num <= n; ++num)
		ans = (ans + dp[n][num]) % MOD;

	cout << ans << endl;
 
	return 0;
}