#include <iostream>
#include <vector>
#include <algorithm>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

const long long MOD = 1e9 + 7;

int main() {
	hello();

	long long n; cin >> n;
	int CNT = 0;
	vector<long long> a(n);
	for (long long i = 0; i < n; ++i) {
		cin >> a[i];
		if (i == a[i])
			CNT++;
	}

	if (n <= 20) {
		long long ans = 0, mask = 0;
		for (mask = 0; mask < (1 << n); ++mask) {
			vector<long long> used;
			for (long long i = 0; i < n; ++i)
				used.push_back((mask >> i) & 1);

			reverse(used.begin(), used.end());

			vector<long long> tmp;
			for (long long i = 0; i < n; ++i)
				if (used[i]) {
					tmp.push_back(i);
				}

			long long cnt = 0;
			for (auto item: tmp)
				if (find(tmp.begin(), tmp.end(), a[item] - 1) != tmp.end())
					cnt++;
			if (cnt == 0)
				ans = max(ans, (long long)tmp.size());
		}

		cout << ans << endl;
	}
	else if (a[0] == -1 && CNT == n - 1) {
		cout << (n + 2 - 1) / 2 << endl;
	}
	else {
		for (int i = 0; i < n; ++i)
		a[i]--;
	vector<int> cnt(n);

	for (int i = 0; i < n; ++i)
		if (a[i] >= 0)
			cnt[a[i]]++;
	
	int ans = 0;
	for (int i = n - 1; i >= 0; --i)
		if (cnt[i] == 0)
			ans++;
		else if (a[i] >= 0)
			cnt[a[i]]--;
			
	cout << ans << endl;
	}

	return 0;
}