#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> a(m);
	for(int i = 0; i < m; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<int> b(n);
	for(int i = 0; i < n; i++) {
		cin >> b[i];
		b[i]--;
	}

	bool forw = true;
	for(int i = 0; i < n; i++) {
		if(a[i] != b[i]) {
			forw = false;
			break;
		}
	}

	if(forw) {
		cout << m << endl;
		for(int i = 0; i < m; i++) {
			cout << n << endl;
		}
	} else {
		cout << 2 * m - 1 << endl;
		int x = n;
		for(int i = 0; i < m - 1; i++) {
			cout << x << endl;
			x--;
		}
		for(int i = 0; i < m; i++) {
			cout << n << endl;
		}
	}

	return 0;
}
