#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <random>
#include <algorithm>

using namespace std;

vector<int> a;
vector<bool> b;
int best = 0;
void gen(int n) {
	if(n == 0) {
		bool good = true;
		int cnt = 0;
		for(int i = 0; i < a.size(); i++) {
			int j = a[i];
			if(j != -1 && b[i] && b[j]) {
				good = false;
				break;
			}
			cnt += b[i];
		}
		if(good) {
			best = max(best, cnt);
		}
		return;
	}

	b.push_back(true);
	gen(n - 1);
	b.back() = false;
	gen(n - 1);
	b.pop_back();
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	a.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
		if(a[i] != -1) {
			a[i]--;
		}
	}

	gen(n);
	cout << best;

	return 0;
}