#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int64_t sqrtt(int64_t n){
    if (n < 0)
        return 0;
    int64_t l = 0;
    int64_t r = 3162278;
    while (r - l > 1){
        int64_t m = (r + l) / 2;
        int64_t x = m * m;
        if (x <= n && x >= 0)
            l = m;
        else
            r = m;
    }
    if (r * r <= n && (r * r) >= 0)
        return r;
    return l;
}

int main(){
    int64_t k, s_k, m = -1;
    bool kb0 = true;
    cin >> k;
    if (k == 0)
        m = 0;
    if (k < 0){
        kb0 = false;
        k = -k;
    }
    s_k = sqrtt(k);
    for (int64_t i = 1; i <= s_k; i++){
        if (k % i == 0){
            int64_t x = i, y = k / i;
            int64_t a = (x + y) / 2;
            int64_t b = a - x;
            if ((a - b) * (a + b) == k){
                if (kb0){
                    if (m == -1 || a < m)
                        m = a;
                } else {
                    if (m == -1 || b < m)
                        m = b;
                }
            }
        }
    }
    if (m == -1)
        cout << "none";
    else
        cout << m;
    return 0;
}
