#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int p[300005];
int d[2][300005];
pair <int, int> depth[300005];
bool cl[300005];

vector <vector <int> > G;

void dfs(int v, int x){
    depth[v] = make_pair(x, v);
    cl[v] = false;
    for (int i = 0; i < G[v].size(); i++){
        dfs(G[v][i], x + 1);
    }
}

int dfs2(int v, int u, int x){
    cl[v] = true;
    depth[v] = make_pair(x, v);
    for (int i = 0; i < G[v].size(); i++){
        if (G[v][i] == u){
            return x;
        } else {
            return dfs2(G[v][i], u, x + 1);
        }
    }
}

int main(){
    int n, ans = 0;
    cin >> n;
    G.resize(n);
    for (int i = 0; i < n; i++){
        cin >> p[i];
        if (p[i] != -1)
            G[p[i] - 1].push_back(i);
    }
    for (int i = 0; i < n; i++){
        if (p[i] == -1)
            dfs(i, 1);
    }
    for (int i = 0; i < n; i++){
        if (depth[i].first <= 0){
            int ans1 = dfs2(i, i, 1);
            ans += (ans1 + 1) / 2;
        }
    }
    sort(depth, depth + n);
    for (int i = n - 1; i >= 0; i--){
        int v = depth[i].second;
        if (!cl[v]){
            d[0][v] = 0;
            d[1][v] = 1;
            for (int j = 0; j < G[v].size(); j++){
                d[0][v] += d[1][G[v][j]];
                d[1][v] += d[0][G[v][j]];
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (p[i] == -1)
            ans += max(d[0][i], d[1][i]);
    }
    cout << ans;
    return 0;
}
