#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int p[300005];
pair <int, int> d[300005];
int dp[2][300005];
bool b[30];
int n, ans = 0;

vector <vector <int> > G;

void gen(int m){
    if (m == n){
        int x = 0;
        bool f = true;
        for (int i = 0; i < n; i++){
            if (b[i]){
                x++;
                if (p[i] != -1 && b[p[i] - 1])
                    f = false;
            }
        }
        if (f)
            ans = max(ans, x);
    } else {
        b[m] = false;
        gen(m + 1);
        b[m] = true;
        gen(m + 1);
    }
}

void dfs(int v, int x){
    d[v] = make_pair(x, v);
    for (int i = 0; i < G[v].size(); i++){
        dfs(G[v][i], x + 1);
    }
}

int main(){
    bool f = true;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> p[i];
    }
    if (p[0] != -1)
        f = false;
    for (int i = 1; i < n; i++){
        if (p[i] != i)
            f = false;
    }
    if (f){
        cout << (n + 1) / 2;
        return 0;
    }
    if (n <= 20){
        gen(0);
        cout << ans;
        return 0;
    }
    G.resize(n);
    for (int i = 1; i < n; i++){
        G[p[i] - 1].push_back(i);
    }
    dfs(0, 1);
    sort(d, d + n);
    for (int i = n - 1; i >= 0; i--){
        int v = d[i].second;
        dp[0][v] = 0;
        dp[1][v] = 1;
        for (int j = 0; j < G[v].size(); j++){
            dp[0][v] += max(dp[0][G[v][j]], dp[1][G[v][j]]);
            dp[1][v] += dp[0][G[v][j]];
        }
    }
    ans = max(dp[0][0], dp[1][0]);
    cout << ans;
    return 0;
}
