#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

const int m = 1e8;
const double e = 1e-6;

int main() {
	int64_t k;
	cin >> k;
	int64_t sum_odd = 0;
	for (int i = 1; i <= m; ++i) {
		int64_t num = k + sum_odd;
		sum_odd += 2 * i - 1;
		long double sq = sqrt(num);
		if (abs(sq - int(sq)) < e) {
			cout << int(sq);
			return 0;
		}
	}
	cout << "none";
}
