#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const uint64_t mod = 1e9 + 7;

uint64_t pow(uint64_t n, uint64_t deg) {
	if (deg == 0)
		return 1;
	if (deg % 2 == 0) {
		uint64_t n2 = pow(n, deg / 2);
		return (n2 * n2) % mod;
	}
	else
		return (n * pow(n, deg - 1)) % mod;
}

int main() {
	uint64_t n, m, k;
	cin >> n >> m >> k;
	uint64_t cp_k = k, digit = 0, power_k = 0;
	while (cp_k) {
		if (cp_k & 1)
			++digit;
		cp_k /= 2;
		++power_k;
	}
	//cout << pow(n + 1, power_k - 1) << " " << pow(n + 1, digit - 1) << "\n";
	uint64_t ans = (pow(n + 1, power_k - 1) + (n * pow(n + 1, digit - 1)) % mod) % mod;
	cout << ans;
}
