import java.io.*;
import java.util.*;


public class Main {

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int [] a = new int[m];
        int [] b = new int[n];

        ArrayList<Integer> [] arr = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            arr[i] = new ArrayList<>();
        }

        for (int i = 0; i < m; i++) {
            a[i] = nextInt() - 1;
        }

        for (int i = 0; i < n; i++) {
            b[nextInt() - 1] = i;
        }

        for (int i = 0; i < m; i++) {
            arr[b[a[i]]].add(i);
        }

        for (int i = 0; i < n; i++) {
            arr[i].add(Integer.MAX_VALUE);
        }

        int cur = 0;
        ArrayList<Integer> ans = new ArrayList<>();
        int col = 0;
        while (cur != m) {
            col++;
            if (arr[0].get(0) == cur) {
                arr[0].remove(0);
                cur++;
            }
            if (arr[0].get(0) == Integer.MAX_VALUE) {
                for (int i = 1; i < n; i++) {
                    arr[i - 1] = arr[i];
                }
                ans.add(n);
                arr[n - 1] = new ArrayList<>();
                arr[n - 1].add(Integer.MAX_VALUE);
                continue;
            }
            int count = -cur + arr[0].get(0);
            int i = 0;
            while (count != 0) {
                for (int j = 0; j < arr[i + 1].size(); j++) {
                    if (arr[i].get(0) > arr[i + 1].get(j)) {
                        count--;
                    }
                }
                ArrayList<Integer> q = arr[i];
                arr[i] = arr[i + 1];
                arr[i + 1] = q;
                i++;
            }
            ans.add(i + 1);
        }

        out.println(col);
        for (int i = 0; i < ans.size(); i++) {
            out.print(ans.get(i) + " ");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}

