
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <cmath>


using namespace std;

long long int K, L, M, N;

unsigned int dp[2][5000][5001];

int inf = -1000000;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long int n, k;
	cin >> n >> k;
	long long cap = n - k;
	if (n == k) cout << 1; else {
		dp[0][0][k] = dp[1][0][k] = 1;
		for (int sum = 0; sum < cap; sum++) {
			for (int last = 0; last < n; last++) {
				if (dp[0][sum][last] || dp[1][sum][last]) {
					for (int next = 1; sum + next <= cap; next++) {
						if (next < last) {
							if (!dp[1][sum][last]) {
								next = last;
								continue;
							}
							dp[0][sum + next][next] += dp[1][sum][last];
							dp[0][sum + next][next] %= 1000000007;
						}
						if (next > last) {
							if (!dp[0][sum][last]) break;
							dp[1][sum + next][next] += dp[0][sum][last];
							dp[1][sum + next][next] %= 1000000007;
						}
					}
				}
			}
		}
		long long int answ = 0;
		for (int b = 0; b < 2; b++) {
			for (int last = 1; last <= n; last++) {
				answ += dp[b][cap][last];
				answ %= 1000000007;
			}
		}
		cout << answ;
	}
	return 0;
}

