#include <bits/stdc++.h>

#define llong long long

using namespace std;

llong n = 0, k = 0;

const llong bignum = 1e18;

bool f(llong v, vector<vector<llong> > &a, vector<llong> &b)
{
    if (v < n)
    {
        if (b[v] == -1)
        {
            for (llong i = v + 1; i < n; i++)
            {
                if (b[i] == -1)
                {
                    b[v] = i;
                    b[i] = v;
                    if (f(v + 1, a, b))
                    {
                        return true;
                    }
                    b[v] = -1;
                    b[i] = -1;
                }
            }
            b[v] = -1;
            return false;
        }
        return f(v + 1, a, b);
    }
    else
    {
        llong L = 0, R = 0;
        for (llong i = 0; i < k; i++)
        {
            L = -bignum;
            R = bignum;
            for (llong j = 0; j < n; j++)
            {
                L = max(min(a[j][i], a[b[j]][i]), L);
                R = min(max(a[j][i], a[b[j]][i]), R);
            }
            if (R < L)
            {
                return false;
            }
        }
        cout << "YES\n";
        for (llong i = 0; i < n; i++)
        {
            if (b[i] > i)
            {
                cout << i + 1 << ' ' << b[i] + 1 << '\n';
            }
        }
        return true;
    }
}

int main(void)
{
    cin >> n >> k;
    if (n <= 11)
    {
        vector<vector<llong> > a(n, vector<llong> (k, 0));
        vector<llong> b(n, -1);
        for (llong i = 0; i < n; i++)
        {
            for (llong j = 0; j < k; j++)
            {
                cin >> a[i][j];
            }
        }
        if (!f(0, a, b))
        {
            cout << "NO";
        }
    }
    else
    {
        llong t = 0, x = 0;
        vector<vector<pair<llong, llong> > > a(k, vector<pair<llong, llong> > (n, {0, 0}));
        vector<vector<vector<llong> >> b(2, vector<vector<llong> > (k));
        set<llong> s;
        set<llong> u;
        t = 1;
        for (llong i = 0; i < k; i++)
        {
            t *= 2;
        }
        vector<vector<llong> > c(t);
        for (llong i = 0; i < n; i++)
        {
            for (llong j = 0; j < k; j++)
            {
                cin >> a[j][i].first;
                a[j][i].second = i;
            }
        }
        for (llong i = 0; i < k; i++)
        {
            sort(a[i].begin(), a[i].end());
            for (llong j = 0; j < n / 2; j++)
            {
                b[0][i].push_back(a[i][j].second);
                b[1][i].push_back(a[i][n - j - 1].second);
            }
        }
        for (llong i = 0; i < t; i++)
        {
            s.clear();
            for (llong j = 0; j < k; j++)
            {
                u.clear();
                if ((i & (1 << j)) == 0)
                {
                    x = 0;
                }
                else
                {
                    x = 1;
                }
                for (llong p = 0; p < b[x][j].size(); p++)
                {
                    if (j == 0 || s.count(b[x][j][p]) != 0)
                    {
                        u.insert(b[x][j][p]);
                    }
                }
                s.clear();
                //s = u;
                for (auto it = u.begin(); it != u.end(); it++)
                {
                    s.insert(*it);
                }
            }
            for (auto it = s.begin(); it != s.end(); it++)
            {
                c[i].push_back(*it);
            }
        }
        for (llong i = 0; i < t; i++)
        {
            if (c[i].size() != c[t - i - 1].size())
            {
                cout << "NO";
                return 0;
            }
        }
        cout << "YES" << '\n';
        for (llong i = 0; i < t / 2; i++)
        {
            for (llong j = 0; j < c[i].size(); j++)
            {
                cout << c[i][j] + 1 << ' ' << c[t - i - 1][j] + 1 << '\n';
            }
        }
    }
    return 0;
}
