#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

long long cnk1[100][100];

long long cnk(long long a1, long long b1) {
	if (cnk1[a1][b1] >= 0) {
		return cnk1[a1][b1];
	}
	else {
		cnk1[a1][b1] = cnk(a1 - 1, b1) + cnk(a1 - 1, b1 - 1);
		return cnk1[a1][b1];
	}
}

long long n;

long long p = 1e9 + 7;

long long prob[300002];

long long d[300002][64], znac[300002][64];


void din(long long maxn) {
	maxn++;
	d[0][0] = 1;
	long long pred = 0;
	vector<long long> sum3(maxn, 0);
	for (long i = 1; i <= n + 1; i++) {
		for (long j = 0; j < maxn; j++) {
			for (long k = 0; k <= j; k++) {
				d[i][j] += d[i - 1][k] * (cnk(j, k) % p);
				d[i][j] = d[i][j] % p;
			}
		}

		if (prob[i] > 0) {
			for (long j = 0; j < maxn; j++) {
				for (long long k = pred + 1; k <= prob[i]; k++) {
					if (prob[k] > 0) {
						sum3[j] = sum3[j] + znac[k][j];
					}
				}
				znac[i][j] = sum3[j] - d[prob[i]][j];
				sum3[j] = d[prob[i]][j];
				d[i][j] = d[i][j] + znac[i][j];
				d[i][j] = d[i][j] % p;
			}
			pred = prob[i];
		}
	}
}

int main() {
	for (long i = 0; i < 100; i++) {
		cnk1[i][0] = 1;
	}
	for (long i = 1; i < 100; i++) {
		for (long j = 1; j < 100; j++) {
			cnk1[i][j] = -1;
		}
	}
	long long m, k;
	cin >> n >> m >> k;
	for (long i = 0; i <= n + 1; i++) {
		prob[i] = 0;
	}
	for (long i = 0; i < m; i++) {
		long long n1, n2;
		cin >> n1 >> n2;
		if (prob[n2] < n1) {
			prob[n2] = n1;
		}
	}
	vector<long long> stk;
	for (long i = n; i > 0; i--) {
		if (prob[i] > 0) {
			while ((stk.size() > 0) && (prob[stk[stk.size() - 1]] <= prob[i])) {
				prob[stk[stk.size() - 1]] = 0;
				stk.pop_back();
			}
			stk.push_back(i);
		}
	}
	long long sum = 0;
	long long pow2 = 1;
	long long kol = 0;
	while (pow2 <= k) {
		pow2 = pow2 * 2;
		kol++;
	}
	vector<long long> ans;
	din(kol);
	for (long i = 0; i <= kol; i++) {
		ans.push_back(d[n][i]);
	}
	vector<long long> koef(kol + 1, 0);
	for (long i = 0; k >= 0; i++) {
		if (k == 0) {
			koef[i] += 1;
			break;
		}
		long long pow20 = 1;
		long long kol0 = 0;
		while (2 * pow20 <= k) {
			pow20 = pow20 * 2;
			kol0++;
		}
		k = k - pow20;
		for (long j = 0; j <= kol0; j++) {
			koef[j + i] += cnk(kol0, j);
		}
	}
	for (long i = 0; i <= kol; i++) {
		koef[i] = koef[i] % p;
		sum = sum + ans[i] * koef[i];
		sum = sum % p;
	}
	cout << sum;
}