#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

long long p = 1e9 + 7;

long d[2001][2001][2], s[2001][2001][2];

int main() {
	long long n, k;
	cin >> n >> k;
	for (long i = 1; i <= n; i++) {
		for (long j = 1; j <= n; j++) {
			if (j < i) {
				d[i][j][0] = s[i - j][j - 1][1];
				if (d[i][j][0] >= p) {
					d[i][j][0] -= p;
				}
				d[i][j][1] = p + s[i - j][i - j][0] - s[i - j][j][0];
				if (d[i][j][1] >= p) {
					d[i][j][1] -= p;
				}
			}
			else if (j == i) {
				d[i][j][0] = 1;
				d[i][j][1] = 1;
			}
			else {
				d[i][j][0] = 0;
				d[i][j][1] = 0;
			}
			s[i][j][0] = s[i][j - 1][0] + d[i][j][0];
			if (s[i][j][0] >= p) {
				s[i][j][0] -= p;
			}
			s[i][j][1] = s[i][j - 1][1] + d[i][j][1];
			if (s[i][j][1] >= p) {
				s[i][j][1] -= p;
			}
		}
	}
	if (n == k) {
		cout << 1;
	}
	else {
		cout << (d[n][k][0] + d[n][k][1]) % p;
	}
}