include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

long ans = 0;

long d[2002][2002], num[2002][2002];

bool rec(long i1, long j1) {
	num[i1][j1] = 1;
	if (d[i1][j1] == 1) {
		for (long i = i1 - 1;; i--) {
			if (d[i][j1] == -1) {
				d[i1][j1] = 0;
				num[i1][j1] = 0;
				ans++;
				return true;
			}
			else if (num[i][j1] == 1) {
				d[i1][j1] = 5;
				return false;
			}
			else if ((d[i][j1] >= 1) && (d[i][j1] <= 4)) {
				if (rec(i, j1) == false) {
					d[i1][j1] = 5;
					return false;
				}
			}
		}
	}
	else if (d[i1][j1] == 3) {
		for (long i = i1 + 1;; i++) {
			if (d[i][j1] == -1) {
				d[i1][j1] = 0;
				num[i1][j1] = 0;
				ans++;
				return true;
			}
			else if (num[i][j1] == 1) {
				d[i1][j1] = 5;
				return false;
			}
			else if ((d[i][j1] >= 1) && (d[i][j1] <= 4)) {
				if (rec(i, j1) == false) {
					d[i1][j1] = 5;
					return false;
				}
			}
		}
	}
	else if (d[i1][j1] == 2) {
		for (long j = j1 - 1;; j--) {
			if (d[i1][j] == -1) {
				d[i1][j1] = 0;
				num[i1][j1] = 0;
				ans++;
				return true;
			}
			else if (num[i1][j] == 1) {
				d[i1][j1] = 5;
				return false;
			}
			else if ((d[i1][j] >= 1) && (d[i1][j] <= 4)) {
				if (rec(i1, j) == false) {
					d[i1][j1] = 5;
					return false;
				}
			}
		}
	}
	else if (d[i1][j1] == 4) {
		for (long j = j1 + 1;; j++) {
			if (d[i1][j] == -1) {
				d[i1][j1] = 0;
				num[i1][j1] = 0;
				ans++;
				return true;
			}
			else if (num[i1][j] == 1) {
				d[i1][j1] = 5;
				return false;
			}
			else if ((d[i1][j] >= 1) && (d[i1][j] <= 4)) {
				if (rec(i1, j) == false) {
					d[i1][j1] = 5;
					return false;
				}
			}
		}
	}
}

int main() {
	long long n, m;
	cin >> n >> m;
	string s;
	for (long i = 0; i < 2002; i++) {
		for (long j = 0; j < 2002; j++) {
			d[i][j] = -1;
		}
	}
	for (long i = 1; i <= n; i++) {
		cin >> s;
		for (long j = 0; j < m; j++) {
			if (s[j] == '.') {
				d[i][j + 1] = 0;
			}
			else if (s[j] == 'N') {
				d[i][j + 1] = 1;
			}
			else if (s[j] == 'W') {
				d[i][j + 1] = 2;
			}
			else if (s[j] == 'S') {
				d[i][j + 1] = 3;
			}
			else if (s[j] == 'E') {
				d[i][j + 1] = 4;
			}
		}
	}
	/*for (long i = 1; i <= n; i++) {
		for (long j = 1; j <= m; j++) {
			cout << d[i][j] << ' ';
		}
		cout << endl;
	}*/
	for (long i = 1; i <= n; i++) {
		for (long j = 1; j <= m; j++) {
			if ((d[i][j] >= 1) && (d[i][j] <= 4)) {
				rec(i, j);
			}
		}
	}
	/*for (long i = 1; i <= n; i++) {
		for (long j = 1; j <= m; j++) {
			cout << d[i][j] << ' ';
		}
		cout << endl;
	}*/
	cout << ans;
}