#include <bits/stdc++.h>
using namespace std;

#define sz(v) int(v.size())
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    out << "\n";
    return out;
}

struct Node {
    int l, r, in;
    Node (int l = 0, int r = 0, int in = 0) :
        l(l), r(r), in(in) {};
};

const int N = 6e5 + 5;
const int K = 500;

int cnt[N];
Node ask[N];
int deep[N];
int lst[N];
int stc[N];
int prv[N];
int res[N];
int ans[N];
int RES = 0;

bool comp(Node & a, Node & b) {
    return ((a.l / K == b.l / K) ? (a.r < b.r) : (a.l / K < b.l / K));
}

inline void add(int x) {
    if (!cnt[lst[x]])
        RES++;
    cnt[lst[x]]++;
}

inline void del(int x) {
    cnt[lst[x]]--;
    if (!cnt[lst[x]])
        RES--;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> lst[i];
        lst[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> stc[i];
       stc[i]--;
       deep[stc[i]] = i;
       prv[i] = -1;
    }
    int d = 0, p = 0;
    for (int i = 0; i < m; i++) {
        while (d < deep[lst[i]]) {
            res[p++] = stc[d];
            d++;
        }
        if (deep[lst[i]] + 1 > d)
            d++;
        res[p++] = lst[i];
    }
    m = p;
    //cout << m << endl;
    for (int i = 0; i < m; i++) {
        lst[i] = res[i];
        cout << lst[i] + 1 << ' ';
    }
    //cout << endl;
    int C = 0;
    for (int i = m - 1; i >= 0; i--) {
        ans[i] = n - 1;
        if (prv[lst[i]] != -1) {
            //nxt[i] = prv[lst[i]];
            ask[C++] = Node(i + 1, prv[lst[i]] - 1);
        }
        prv[lst[i]] = i;
    }
    sort(ask, ask + C, &comp);
    int l = -1, r = -1;
    for (int i = 0; i < C; i++) {
        if (ask[i].l > ask[i].r) {
            ans[ask[i].l - 1] = 0;
            continue;
        }
        while (r < ask[i].r)
            r++, add(r);
        while (r > ask[i].r)
            del(r), r--;
        while (l + 1 < ask[i].l)
            l++, del(l);
        while (l + 1 > ask[i].l)
            add(l), l--;
        ans[ask[i].l - 1] = RES;
    }
    cout << m << '\n';
    for (int i = 0; i < m; i++)
        cout << ans[i] + 1 << ' ' ;
    return 0;
}
