#include <bits/stdc++.h>
using namespace std;

#define sz(v) int(v.size())
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    out << "\n";
    return out;
}

const int mod = 1e9 + 7;

struct Int {
    int x;
    Int (int x = 0) : x(x) {};
    Int operator + (Int y) {
        return (x + y.x) % mod;
    }
    Int operator += (Int y) {
        return x = (x + y.x) % mod;
    }
};


const int N = 500;
Int dp[2][N][N];

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    dp[0][k][k] = 1;
    dp[1][k][k] = 1;
    for (int i = k + 1; i <= n; i++) {
        for (int j = 1; j < i; j++) {
            for (int t = j + 1; t <= i - j; t++) {
                dp[0][i][j] += dp[1][i - j][t];
            }
            for (int t = 1; t <= min(j - 1, i - j); t++) {
                dp[1][i][j] += dp[0][i - j][t];
            }
            //dp[0][i][j] = dp[1][i - j][j + 1 ... (i - j)];
            //dp[1][i][j] = dp[0][i - j][1 ... j - 1];
        }
    }
    Int ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += dp[0][n][i];
        ans += dp[1][n][i];
    }
    cout << ans.x;
    return 0;
}
