#include <bits/stdc++.h>
using namespace std;

#define sz(v) int(v.size())
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    out << "\n";
    return out;
}

//const int N = 3e5 + 5;
//vector < int > gr[N];
//int pr[N];
//int used[N];
//bool us[N];
//int c = 1;
//int in[N];
//
//bool dfs(int v) {
//    if (used[v] = c)
//        return false;
//    used[v] = c;
//    for (auto u : gr[v]) {
//        if (pr[u] == -1 || dfs(pr[u])) {
//            pr[u] = v;
//            return true;
//        }
//    }
//    return false;
//}
//
//int cnt = 0;
//
//void clr(int v, bool t) {
//    if (t) {
//        cnt++;
//        us[v] = true;
//        if (pr[v] != -1)
//            clr(pr[v], 0);
//        return;
//    }
//    for (auto u : gr[v]) {
//        if (!us[u])
//            clr(u, 1);
//    }
//
//}

const int N = 3e2 + 5;
vector < int > gr[N];
int used[N];
int us[N];
int n;
vector < int > cyc;
int cnt[N][2];

pii cnt_dfs(int v, int pr) {
    int a = 1, b = 0;
    for (auto u : gr[v]) {
        if (u == pr)
            continue;
        pii k = cnt_dfs(u, v);
        a += k.S, b += k.F;
    }
    return {a, b};
}

void dfs_cyc(int v) {
    us[v] = 3;
    cyc.pb(v);
    for (auto u : gr[v]) {
        if (used[u] == 2 && us[u] != 3) {
            dfs_cyc(u);
        }
    }

    //int a = 0, b = 0;
    cnt[v][1] = 1;
    for (auto u : gr[v]) {
        if (used[u] == 2)
            continue;
        pii k = cnt_dfs(u, v);
        cnt[v][0] += k.F;
        cnt[v][1] += k.S;
    }
}

void get_cyc() {
    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            dfs_cyc(i);
            break;
        }
    }
}

int dfs(int v, int pr = -1) {
    used[v] = 2;
    int k = 1;
    for (auto u : gr[v]) {
        if (u == pr)
            continue;
        if (used[u] == 2) {
            get_cyc();
            return -1;
        } else {
            //assert(used[u] != 1);
            int p = dfs(u, v);
            if (p == -1)
                return -1;
            k += p;
        }

    }
    used[v] = 1;
    return k;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int v;
        cin >> v;
        if (v == -1)
            continue;
        v--;
        gr[i].pb(v);
        gr[v].pb(i);
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            int p = dfs(i);
            if (p == -1)
                break;
            res += (p - 1) / 2 + 1;
        }

    }
    if (cyc.size() == 0) {
        cout << res;
        return 0;
    }
    //cout << cyc ;
    int sz = cyc.size();
    if (sz % 2 == 0) {
        bool fl = 0;
        int a = 0, b = 0;
        for (auto v : cyc) {
            if (fl)
                a += cnt[v][0], b += cnt[v][1];
            else
                a += cnt[v][1], b += cnt[v][0];
            fl = 1 - fl;
        }
        cout << max(a, b);
        return 0;
    }
    int a = 0, b = 0;
    for (int i = sz - 1; i >= 0; i--) {
        a += cnt[cyc[i]][i % 2];
        b += cnt[cyc[i]][1 - (i % 2)];
    }
    int ans = 0;
    int x = 0, y = 0;
    for (int i = 0; i < sz; i++) {
        if (i % 2 == 0) {
            ans = max(a + x, ans);
        } else {
            ans = max(b + y, ans);
        }
        y += cnt[cyc[i]][i % 2];
        x += cnt[cyc[i]][1 - (i % 2)];
        a -= cnt[cyc[i]][i % 2];
        b -= cnt[cyc[i]][1 - (i % 2)];
    }
    cout << ans;
//    fill(pr, pr + n, -1);
//    for (int i = 0; i < n; i++) {
//        if (used[i] != c && dfs(i))
//            c++;
//    }
//    int ans = n;
//    for (int i = 0; i < n; i++)
//        if (pr[u] != -1)
//            in[pr[u]] = 1;
//        else
//            ans++;
//    c++;
//    for (int i = 0; i < n; i++) {
//        if (!in[i] && used[i] != c)
//            clr(i, 0);
//    }
//    cout << ans + n - cnt;
    return 0;
}
