#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MOD = 1e9 + 7;
vector<vector<int>> memo(65, vector<int> (65, -1));

int C(int n, int k) {
    if (n == 0 || n == 1) {
        return 1;
    }
    if (k == 0 || k == n) {
        return 1;
    }
    if (memo[n][k] != -1) {
        return memo[n][k];
    }
    return memo[n][k] = (C(n - 1, k) + C(n - 1, k - 1)) % MOD;
}



void lol(int n, int m, int k) {
    vector<vector<int>> dp((unsigned long) n, vector<int> (65));
    int cur_num = 0;
    int ones = 0;
    for (int i = 0; i < 64; i++) {
        if ((((unsigned long long) cur_num * 2 + 1) << (63 - i)) <= k) {
            for (int j = 0; j <= 63 - i; j++) {
                dp[0][ones + j] += C(63 - i, j);
            }
            ones += 1;
            cur_num *= 2;
            cur_num += 1;
        } else {
            cur_num *= 2;
        }
    }
    dp[0][ones] += 1;
    for (int i = 1; i < n; i++) {
        dp[i][64] = dp[i - 1][64];
        int a1 = dp[i][64];
        int a2 = a1;
        for (int on = 63; on >= 0; on--) {
            if (dp[i - 1][on]) {
                for (int j = on; j <= 64; j++) {
                    dp[i][on] += (dp[i - 1][j] * C(j, j - on)) % MOD;
                    if (dp[i][on] > MOD) {
                        dp[i][on] -= MOD;
                    }
                }
            }
        }
    }
    int sum = 0;
    for (int el : dp[n - 1]) {
        sum += el;
        if (sum > MOD) {
            sum -= MOD;
        }
    }
    assert(sum >= 0);
    cout << sum << endl;
}

int ans = 0;

vector<int> cur;
vector<vector<int>> g;

void gen(int n, int k, int last = -1) {
    if (n == 0) {
        ans += 1;
        return;
    }
    if (last == -1) {
        for (int i = 0; i <= k; i++) {
            cur.push_back(i);
            gen(n - 1, k, i);
            cur.pop_back();
        }
    } else {
        for (int i = last; i <= k; i++) {
            if ((i & last) == last) {
                bool good = true;
                for (int j : g[cur.size()]) {
                    if (i == cur[j]) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                    cur.push_back(i);
                    gen(n - 1, k, i);
                    cur.pop_back();
                }
            }
        }
    }
}



signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    if (m == 0) {
        lol(n, m, k);
        return 0;
    }
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[b].push_back(a);
    }
    gen(n, k);
    cout << ans << endl;
    return 0;
}
