#include <bits/stdc++.h>
using namespace std;

vector<int> no;
vector<vector<int>> reverse_e;

vector<int> last_cycle;
vector<int> visited;
int last = -1;

bool dfs1(int v) {
    if (no[v] == -1) {
        last = v;
        return false;
    }
    visited[v] = 1;
    if (visited[no[v]] == 1) {
        last_cycle.push_back(v);
        visited[v] = 2;
        visited[no[v]] = 2;
        return true;
    } else {
        if (dfs1(no[v])) {
            if (visited[v] == 1) {
                visited[v] = 2;
                last_cycle.push_back(v);
                return true;
            } else {
                last_cycle.push_back(v);
                return false;
            }
        }
    }
    return false;
}


vector<pair<int, int>> dp;

pair<int, int> dpp(int u) {
    if (visited[u] == 0) {
        visited[u] = 1;
    }
    if (dp[u] != (pair<int, int>){-1, -1}) {
        return dp[u];
    }
    int a = 1;
    int b = 0;
    for(int v : reverse_e[u]) {
        if (visited[v] != 2) {
            auto ab = dpp(v);
            a += ab.second;
            b += max(ab.first, ab.second);
        }
    }
    return dp[u] = {a, b};
}

int main() {
    int n;
    cin >> n;
    no.resize(n);
    reverse_e.resize(n);
    visited.resize(n);
    dp.resize(n, {-1, -1});
    for (int i = 0; i < n; i++) {
        cin >> no[i];
        if (no[i] != -1) {
            no[i]--;
            reverse_e[no[i]].push_back(i);
        }
    }
    int anss = 0;
    for (int u = 0; u < n; u++) {
        if (visited[u] == 0) {
            last_cycle.resize(0);
            last = -1;
            dfs1(u);
            if (last != -1) {
                auto x = dpp(last);
                anss += max(x.first, x.second);
            } else {
                int len = last_cycle.size();
                vector<pair<int, int>> arr(last_cycle.size());
                for (int i = 0; i < len; i++) {
                    arr[i] = dpp(last_cycle[i]);
                }
                if (len == 2) {
                    anss += max(arr[0].first + arr[1].second, arr[0].second + arr[1].first);
                    continue;
                }
                vector<pair<int, int>> dp1(len), dp2(len);
                dp1[0] = {arr[0].first, -300000};
                dp2[0] = {-300000, arr[0].second};
                dp1[1] = {dp1[0].second + arr[1].first, max(dp1[0].first, dp1[0].second) + arr[1].second};
                dp2[1] = {arr[1].first + dp2[0].second, max(dp2[0].first, dp2[0].second) + arr[1].second};
                for (int i = 2; i < len - 1; i++) {
                    dp1[i] = {dp1[i - 1].second + arr[i].first, max(dp1[i - 1].first, dp1[i - 1].second) + arr[i].second};
                    dp2[i] = {dp2[i - 1].second + arr[i].first, max(dp2[i - 1].first, dp2[i - 1].second) + arr[i].second};
                }
                dp1[len - 1] = {-1, max(dp1[len - 2].first, dp1[len - 2].second) + arr[len - 1].second};
                dp2[len - 1] = {dp2[len - 2].second + arr[len - 1].first, max(dp2[len - 2].first, dp2[len - 2].second) + arr[len - 1].second};
                anss += max(max(dp1[len - 1].first, dp1[len - 1].second), max(dp2[len - 1].first, dp2[len - 1].second));
            }
        }

    }
    cout << anss << endl;

}
