#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<long long,long long> pll;

void solve1();
void solve();

void gentest()
{

}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
/*
	while (true)
	{
		gentest();
		ans = solve();
		ans1 = solve1();

		if (ans != ans1)
		{
			break;
		}
	}
*/
	solve();

	return 0;
}

void dfs1(vector<set<int>>& gr, vector<int>& col, vector<bool>& used, int v, int c)
{
	used[v] = 1;
	col[v] = c;

	for (int u : gr[v])
	{
		if (!used[u])
			dfs1(gr, col, used, u, c);
	}
}

void dfs(vector<set<int>>& gr, vector<vector<int>>& dp, vector<bool>& used, int v)
{
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (int u : gr[v])
	{
		if (!used[u])
		{
			dfs(gr, dp, used, u);
			dp[v][0] += max( dp[u][0], dp[u][1] );
			dp[v][1] += dp[u][0];
		}
	}
}

pii dfs0(vector<set<int>>& gr, vector<bool>& used, vector<int>& par, int v, int p = -1)
{
	used[v] = 1;
	par[v] = p;

	for (int u : gr[v])
	{
		if (u == p)
			continue;
		if (used[u])
			return {u, v};
		dfs0(gr, used, par, u, v);
	}
	return {-1, -1};
}

void solve()
{
	int n;
	cin >> n;

	vector<set<int>> gr(n);
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		if (a == -1)
			continue;
		a--;
		gr[i].insert(a);
		gr[a].insert(i);
	}

	
	vector<bool> used(n);

	int c = 0;
	vector<int> col(n);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs1(gr, col, used, i, c);
			c++;
		}
	}
	vector<vector<int>> comps(c);
	for (int i = 0; i < n; i++)
	{
		comps[ col[i] ].push_back(i);
	}

	int res = 0;

	used.assign(n, 0);
	vector<int> par(n);
	for (int q = 0; q < c; q++)
	{
		bool cont = false;
		vector<int> cycle;
		pii kek = dfs0(gr, used, par, comps[q][0]);
		if (!(kek.first == -1 && kek.second == -1))
		{

			cout << "LOL" << endl;
			return;
			cont = true;
			vector<int> path1, path2;
			int p = par[kek.first];
			while (p != -1)
			{
				path1.push_back(p);
				p = par[p];
			}

			p = kek.second;
			while (p != -1)
			{
				path2.push_back(p);
				p = par[p];
			}

			reverse(path1.begin(), path1.end());
			reverse(path2.begin(), path2.end());

			int j;
			for (j = 0; j < (int)path1.size(); j++)
			{
				if (path1[j] != path2[j])
					break;
			}
			int s = path1[j - 1];
			cycle.push_back(s);
			for (int l = j; l < (int)path1.size(); l++)
			{
				cycle.push_back(path1[l]);
			}
			cycle.push_back(kek.first);
			for (int l = path2.size() - 1; l >= j; l--)
			{
				cycle.push_back(path2[l]);
			}
		}

		int m = (int)cycle.size();
		for (int i = 0; i < (int)cycle.size() - 1; i++)
		{
			int a = cycle[i];
			int b = cycle[i + 1];
			gr[a].erase(b);
			gr[b].erase(a);
		}
		if (cont)
		{
			int a = cycle[0];
			int b = cycle[cycle.size() - 1];
			gr[a].erase(b);
			gr[b].erase(a);
		}

		

		used.assign(n, 0);
		vector<vector<int>> dp(n, vector<int>(2));
		int ans = 0;
		
		if (cont)
		{
			vector<int> plus(cycle.size());
			vector<int> minus(cycle.size());

			for (int i = 0; i < m; i++)
			{
				dfs(gr, dp, used, cycle[i]);
				minus[i] = dp[ cycle[i] ][0];
				plus[i] = dp[ cycle[i] ][1];
			}

			int ans0 = minus[0];
			vector<int> dp0(m + 1);
			dp0[m] = 0;
			dp0[m - 1] = max(plus[m - 1], minus[m - 1]);
			for (int i = m - 2; i > 0; i--)
			{
				dp0[i] = max(plus[i] + minus[i + 1] + dp0[i + 2], minus[i] + dp0[i + 1]);
			}
			ans0 += dp0[1];

			int ans1 = plus[0] + minus[1] + minus[m - 1];
			vector<int> dp1(m);
			dp1[m - 1] = 0;
			dp1[m - 2] = max(plus[m - 2], minus[m - 2]);
			for (int i = m - 3; i > 1; i--)
			{
				dp1[i] = max(plus[i] + minus[i + 1] + dp1[i + 2], minus[i] + dp1[i + 1]);
			}
			ans1 += dp1[2];

			ans = max(ans0, ans1);
		}

		for (int i = 0; i < n; i++)
		{
			if (!used[i])
			{
				dfs(gr, dp, used, i);
				ans += max( dp[i][0], dp[i][1] );
			}
		}

		res += ans;
	}

	cout << res;
}
