#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<stdlib.h>
#include<math.h>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = ll(1e18) * 2;
ll inf = 1e9;
ll MOD = 1e9 + 7;
ld eps = 1e-9;


ll f(ll n, ll m, vector<ll>a, vector<ll>b) {
	for (ll i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
	}
	vector<ll>ans;

	for (ll i = 0; i < m; ) {
		ll fl = 0;
		while (fl == 0) {
			if (b[0] == a[i]) {
				i++;
				fl = 1;
			}

			ll cur = b[0];
			b.erase(b.begin());
			set<ll>need;
			for (ll j = i; j < m && a[j] != cur; j++) {
				need.insert(a[j]);
			}

			if (need.size() == 0) {
				ans.push_back(1);
				b.insert(b.begin(), cur);
				continue;
			}

			for (ll j = 0; j < b.size(); j++) {
				need.erase(b[j]);
				if (need.size() == 0) {
					ans.push_back(j + 2);
					b.insert(b.begin() + j + 1, cur);
					break;
				}
			}

		}
	}
	return ans.size();
}




ll t[10000000];

void update(ll v, ll tl, ll tr, ll pos, ll val) {
	if (tl == tr) {
		t[v] = val;
		return;
	}
	ll tm = (tl + tr) / 2;
	if (pos <= tm) {
		update(v * 2, tl, tm, pos, val);
	}
	else {
		update(v * 2 + 1, tm + 1, tr, pos, val);
	}
	t[v] = t[v * 2] + t[v * 2 + 1];
}


ll get(ll v, ll tl, ll tr, ll l, ll r) {
	l = max(l, tl);
	r = min(r, tr);
	if (l > r) return 0;
	if (tl == l && tr == r) {
		return t[v];
	}
	ll tm = (tl + tr) / 2;
	return get(v * 2, tl, tm, l, r) + get(v * 2 + 1, tm + 1, tr, l, r);
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m;
	cin >> n >> m;
	vector<ll>a(m), b(n);
	for (ll i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
	}
	vector<ll>ans;

	vector<pair<ll, ll>>ev;
	vector<ll>free(n + 1, 0);

	ll id = 0;

	for (ll i = 0; i < a.size();i++) {
		auto now = a[i];

		if (free[now] == 1) {
			ev.push_back({ now, -1 });
			//if (i + 1 != a.size()) {
			ev.push_back({ now,1 });
			//}
			continue;
		}

		while (free[now] != 1) {
			ev.push_back({ b[id],1 });
			free[b[id]] = 1;
			id++;
		}

	}


	vector<ll>prev(n + 1, -1);

	vector<ll>left_pair(ev.size(), -1);

	ans.resize(ev.size(), -1);

	for (ll i = 0; i < ev.size(); i++) {
		if (ev[i].second == 1) {
			prev[ev[i].first] = i;
		}
		else {
			left_pair[i] = prev[ev[i].first];
		}
	}

	vector<ll>last(n + 1, -1);
	for (ll i = 0; i < ev.size(); i++) {
		update(1, 0, ev.size(), last[ev[i].first], 0);
		last[ev[i].first] = i;
		update(1, 0, ev.size(), last[ev[i].first], 1);
		if (ev[i].second == -1) {
			ans[left_pair[i]] = get(1, 0, ev.size(), left_pair[i], i);
		}

	}



	ll cntans = 0;

	for (ll i = 0; i < ans.size(); i++) {
		if (ans[i] == -1 && ev[i].second == 1) {
			ans[i] = n;
		}
		if (ans[i] != -1) {
			cntans++;
		}
	}

	cout << cntans << '\n';

	for (ll i = 0; i < ans.size();i++) {
		if (ans[i] == -1 && ev[i].second == 1) {
			ans[i] = n;
		}
		if (ans[i] != -1) {
			cout << ans[i] << ' ';
		}
	}


	return 0;
}