#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<stdlib.h>
#include<math.h>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = ll(1e18) * 2;
ll inf = 1e9;
ll MOD = 1e9 + 7;
ld eps = 1e-9;

void solvem0(ll n, ll m, ll k) {
	vector<vector<ll>>dp(n, vector<ll>(k + 1, 0));
	for (ll i = 0; i <= k; i++) {
		dp[0][i] = 1;
	}

	for (ll i = 0; i < dp.size() - 1; i++) {
		for (ll last = 0; last <= k; last++) {
			for (ll last2 = last; last2 <= k; last2++) {
				if ((last&last2) == last) {
					dp[i + 1][last2] += dp[i][last];
					dp[i + 1][last2] %= MOD;
				}
			}
		}
	}

	ll ans = 0;
	for (ll i = 0; i <= k; i++) {
		ans += dp[n - 1][i];
		ans %= MOD;
	}

	cout << ans;
}


signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m, k;
	cin >> n >> m >> k;
	vector<ll>v(n + 1, 0);
	v[0] = -1;
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--; b--;
		v[b] = max(v[b], a);
	}

	if (m == 0) {
		solvem0(n, m, k);
		return 0;
	}


	
	vector<vector<vector<ll>>>dp(n, vector<vector<ll>>(n, vector<ll>(k + 1, 0)));
	for (ll i = 0; i <= k; i++) {
		dp[0][0][i] = 1;
	}

	for (ll i = 0; i < dp.size() - 1; i++) {
		for (ll pos = v[i]+1; pos <= i; pos++) {
			for (ll last = 0; last <= k; last++) {
				dp[i + 1][pos][last] += dp[i][pos][last];
				dp[i + 1][pos][last] %= MOD;
				for (ll last2 = last+1; last2 <= k; last2++) {
					if ((last&last2) == last) {
						dp[i + 1][i+1][last2] += dp[i][pos][last];
						dp[i + 1][i+1][last2] %= MOD;
					}
				}
			}
		}
	}

	ll ans = 0;
	for (ll pos = v[n-1] + 1; pos <= n-1; pos++){
		for (ll i = 0; i <= k; i++)  {
			ans += dp[n - 1][pos][i];
			ans %= MOD;
		}
	}

	cout << ans;



	return 0;
}