#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (int)(1e9) + 7
#define sz(a) (int)((a).size())

using namespace std;

int n;
int ans = 1;
int cur;
set<int> s;
vector<int> used;
vector<int> ms;
set<int> g[MAX];

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

void dfs(int u) {
    ++cur;
    used[u] = 1;
    if (ms[u]) s.insert(ms[u]);

    for (auto &v : g[u]) {
        if (!used[v] && !s.count(v)) {
            dfs(v);
        }
    }
}

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    start();

    cin >> n;
    used.resize(n + 1);
    ms.resize(n + 1);

    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            g[i].insert(j);
            //g[j].insert(i);
        }
    }

    for (int i = 1; i <= n; ++i) {
        int u;
        cin >> u;

        if (u != -1) {
            ms[i] = u;
            ms[u] = i;
        }
    }

    for (int i = 1; i <= n; ++i) {
        s.clear();
        fill(used.begin(), used.end(), 0);
        cur = 0;
        dfs(i);
        ans = max(ans, cur);
    }

    cout << ans << endl;
}
