#include <bits/stdc++.h>
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));
vector <int> steps(1e6);
vector <vector <int> > sparse;

int ind(const vector <int>&num, int x) {
    if (upper_bound(num.begin(), num.end(), x) == num.end()) return -1;
    return num[upper_bound(num.begin(), num.end(), x) - num.begin()];
}

vector <vector <int> > build_sparse(const vector <int>&num) {
    vector <vector <int> > res;
    int n = num.size();
    vector <int> smth;
    for (int i = 0; i < n; i++) {
        smth.push_back(num[i]);
    }
    res.push_back(smth);
    for (int x = 1; x < 20; x++) {
        if ((1 << x) > n) break;
        vector <int> kek;
        for (int j = 0; j < n - (1 << x) + 1; j++) {
            kek.push_back(min(res[x - 1][j], res[x - 1][j + (1 << (x - 1))]));
        }
        res.push_back(kek);
    }
    return res;
}

int get_min(int l, int r) {
    int len = r - l + 1;
    int x = steps[len];
    return min(sparse[len][l], sparse[len][l + (1 << x)]);
}

void precalc() {
    for (int i = 0; i < steps.size(); i++) {
        int l = 0;
        int r = 23;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((1 << m) <= i) l = m;
            else r = m;
        }
        steps[i] = l;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    /**precalc();
    int n;
    cin >> n;
    vector <int> num(n);
    cout << steps[13] << "\n";
    for (int i = 0; i < n; i++) cin >> num[i];
    sparse = build_sparse(num);
    for (int i = 0; i < sparse.size(); i++) {
        for (auto el : sparse[i]) cout << el << " ";
        cout << "\n";
    }**/
    int n, m;
    cin >> n >> m;
    deque <int> a, b;
    map <int, vector <int> > smth;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        a.push_back(x);
        smth[x].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        x--;
        b.push_back(x);
    }
    if (n == m) {
        bool fl = true;
        for (int i = 0; i < n; i++) {
            if (a[i] != b[n - i - 1]) fl = false;
        }
        if (fl) {
           // cout << "f";
            cout << n * 2 - 1 << "\n";
            for (int i = n; i >= 2; i--) cout << i << " ";
            for (int i = 0; i < n; i++) cout << n << " ";
            return 0;
        }
    }
    vector <int> position(n);
    for (int i = 0; i < n; i++) position[b[i]] = i;
    int i = 0;
    vector <int> ans;
   // cout << "\n";
    while (i < m) {
        int need = a[i];
        int pos = ind(smth[need], i);
        if (b[0] != need) {
            while (b[0] != need) {
              //  for (auto el : b) cout << el << " ";
              //  cout << endl;
                int now = b[0];
                int pos2 = ind(smth[now], i);
             //   cout << pos2 << "fdsio" << endl;
                if (pos2 == -1) {
                    ans.push_back(n);
                    b.pop_front();
                    b.push_back(now);
                    position[b.back()] = n;
                    for (int j = 0; j < n; j++) position[j]--;
                    continue;
                }
              //  set <int> all;
             //   for (int j = i; j < pos2; j++) all.insert(a[j]);
                int res = 0;
                for (int j = i; j < pos2; j++) {
                    int el = a[j];
                    res = max(res, position[el]);
                    /**for (int j = 0; j < n; j++) {
                        if (b[j] == el) {
                            res = max(res, j);
                        }
                    }**/
                }
               // cout << res << endl;
                ans.push_back(res + 1);
                int q = b[0];
                b.pop_front();
                deque <int> kek;
                for (int j = 0; j < res; j++) kek.push_back(b[j]);
                kek.push_back(q);
                for (int j = res; j < n - 1; j++) kek.push_back(b[j]);
                b = kek;
                position[q] = res;
                for (int j = 0; j < res; j++) position[b[j]]--;
            }
        }
        if (pos == -1) {
            ans.push_back(n);
            int lol = b[0];
            b.pop_front();
            b.push_back(lol);
            position[lol] = n;
            for (int j = 0; j < n; j++) position[j]--;
            i++;
            continue;
        }
        else {
          //  set <int> all;
           // for (int j = i + 1; j < pos; j++) all.insert(a[j]);
            int res = 0;
            for (int j = i + 1; j < pos; j++) {
                int el = a[j];
                res = max(res, position[el]);
            }
            ans.push_back(res + 1);
            b.pop_front();
            deque <int> kek;
            for (int j = 0; j < res; j++) kek.push_back(b[j]);
            kek.push_back(need);
            for (int j = res; j < n - 1; j++) kek.push_back(b[j]);
            b = kek;
            position[need] = res;
            for (int j = 0; j < res; j++) position[b[j]]--;
        }
        i++;
    }
    cout << ans.size() << "\n";
    for (auto el : ans) cout << el << " ";
    cout <<  "\n";
    return 0;
}
