#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <time.h>
using namespace std;

#define int long long

const int N = 5001;
const int MOD = (int)1e9 + 7;

int dp1[N][N];
int dp2[N][N];

signed main()
{
    int n, k;
    cin >> n >> k;
    dp1[k][k] = dp2[k][k] = 1;
    for(int i = 1; i <= n; ++i)
    {
        for(int j = 1; j < i; ++j)
        {
            if(j > 1)
            {
                dp1[i][j] = dp1[i - 1][j - 1] + dp2[i - j][j - 1];
                dp2[i][j] = (dp2[i - 1][j - 1] - dp1[i - j][j] + MOD) % MOD;
            }
            else
            {
                for(int h = 1; h < j; ++h)
                {
                    dp1[i][j] += dp2[i - j][h];
                }
                for(int h = j + 1; h <= n; ++h)
                {
                    dp2[i][j] += dp1[i - j][h];
                }
            }
        }
    }
    int ans = 0;
    if(k == n)
        --ans;
    for(int i = 1; i <= n; ++i)
    {
        ans += dp1[n][i] + dp2[n][i];
    }
    cout << ans;
}