#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

const int N = 3e5 + 2;
vector<int> g[N];
int used[N];
int dfs(int v)
{
    if(used[v])
    {
        return 0;
    }
    used[v] = 1;
    int res = 0;
    for(auto i : g[v])
    {
        res += dfs(i);
    }
    return res + 1;
}
signed main()
{
    int n;
    cin >> n;
    if(n > 20)
    {
        int ans = 0;
        for(int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            if(a != -1)
            {
                g[i + 1].push_back(a);
                g[a].push_back(i + 1);
            }
        }
        for(int i = n; i >= 0; --i)
        {
            ans += (dfs(i) + 1) / 2;
        }
        cout << ans;
    }
}