#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <time.h>
using namespace std;

#define int long long
const int INF = 1e9 + 228;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
        vector<vector<int>> b(n, vector<int> (k));
        for(int i = 0; i < n; ++i)
            for(int j = 0; j < k; ++j)
                cin >> b[i][j];
        vector<int> perm(n);
        for(int i = 0; i < n; ++i)
            perm[i] = i;
        do
        {
            if((double)(clock()) / CLOCKS_PER_SEC > 0.9)
            {
                cout << "NO";
                return 0;
            }
            vector<pair<vector<int>, vector<int>>> pars;
            for(int i = 0; i < n; i += 2)
            {
                pars.push_back({b[perm[i]], b[perm[i + 1]]});
            }
            vector<int> l(k, -INF);
            vector<int> r(k, INF);
            for(int i = 0; i < n / 2; ++i)
            {
                for(int j = 0; j < k; ++j)
                {
                    if(pars[i].first[j] > pars[i].second[j])
                        swap(pars[i].first[j], pars[i].second[j]);
                    l[j] = max(l[j], pars[i].first[j]);
                    r[j] = min(r[j], pars[i].second[j]);
                }
            }
            bool st = true;
            for(int i = 0; i < k; ++i)
            {
                if(r[i] < l[i])
                {
                    st = false;
                    break;
                }
            }
            if(st)
            {
                cout << "YES" << '\n';
                for(int i = 0; i < n; i += 2)
                {
                    cout << perm[i] + 1 << " " << perm[i + 1] + 1 << '\n';
                }
                return 0;
            }
        }while(next_permutation(perm.begin(), perm.end()));

    cout << "NO";
    return 0;
}