//{

#include <bits/stdc++.h>

#define all(x) (x).begin (), (x).end ()
#define rall(x) (x).rbegin (), (x).rend ()

//#define LOCAL

using namespace std;

using lli = long long;
using ld = long double;

mt19937 rnd (time (nullptr));

//}

const lli mod = 1e9 + 7;

const lli MAX_N = 5000 + 1;

lli prefix[2][MAX_N][MAX_N];

lli Mod (lli a, lli b)
{
    return (a % b + b) % b;
}

lli Query (lli* pref, lli l, lli r)
{
    if (l == 0)
        return pref[r];
    return Mod (pref[r] - pref[l - 1], mod);
}

inline void Solve ()
{
    lli n = 0, k = 0;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
        return;
    }
    prefix[0][k][k] = 1;
    prefix[1][k][k] = 1;
    for (lli j = 1; j <= n; j++)
    {
        prefix[0][k][j] = (prefix[0][k][j] + prefix[0][k][j - 1]) % mod;
        prefix[1][k][j] = (prefix[1][k][j] + prefix[1][k][j - 1]) % mod;
    }
    for (lli i = k + 1; i <= n; i++)
    {
        for (lli j = 1; j <= min (i, n); j++)
        {
            if (j + 1 <= i - j)
                prefix[0][i][j] = Query (prefix[1][i - j], j + 1, i - j);
            prefix[1][i][j] = Query (prefix[0][i - j], 1, min (j - 1, i - j));
        }
        for (lli j = 1; j <= n; j++)
        {
            prefix[0][i][j] = (prefix[0][i][j] + prefix[0][i][j - 1]) % mod;
            prefix[1][i][j] = (prefix[1][i][j] + prefix[1][i][j - 1]) % mod;
        }
    }
    lli result = 0;
    for (lli j = 0; j <= n; j++)
    {
        result = (result + Query (prefix[0][n], j, j)) % mod;
        result = (result + Query (prefix[1][n], j, j)) % mod;
    }
    cout << result;
}

signed main ()
{
#ifndef LOCAL
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
#endif
    Solve ();
    return 0;
}
