//{

#include <bits/stdc++.h>

#define all(x) (x).begin (), (x).end ()
#define rall(x) (x).rbegin (), (x).rend ()

#define LOCAL

using namespace std;

using lli = long long;
using ld = long double;

mt19937 rnd (time (nullptr));

//}

vector <vector <int>> tree;
vector <bool> used;
vector <vector <int>> dp;

void DFS (int v, int p)
{
    used[v] = true;
    dp[v][1] = 1;
    for (int u : tree[v])
    {
        if ((u == p) || (used[u]))
            continue;
        DFS (u, v);
        dp[v][1] += dp[u][0];
        dp[v][0] += dp[u][1];
    }
}

inline void Solve ()
{
    int n = 0;
    cin >> n;
    tree.resize (n);
    used.resize (n);
    dp.resize (n, vector <int> (2));
    for (int i = 0; i < n; i++)
    {
        int p = 0;
        cin >> p;
        if (p == -1)
            continue;
        p--;
        assert (p < i);
        tree[p].push_back (i);
    }
    int result = 0;
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            DFS (i, -1);
            result += max (dp[i][0], dp[i][1]);
        }
    }
    cout << result;
}

signed main ()
{
#ifndef LOCAL
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
#endif
    Solve ();
    return 0;
}
