#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

bool check(vector<int> &a, vector<int> &b) {
	for (int i = 0; i < sz(a); ++i) 
		if (a[i] > b[i]) return false;
	return true;
}

signed main() {
	FAST; FIXED; RANDOM;
	int n, k;
	cin >> n >> k;
	if (k == 1) {
		cout << "YES\n";
		vector<pii> arr(n);
		int cnt = 1;
		for (auto &i : arr) cin >> i.f, i.s = cnt++;
		sort(arr);
		for (int i = 0; i + i < n; ++i) cout << arr[i].s << ' ' << arr[n - i - 1].s << '\n';
	} else if (n <= 10) {
		vector<pair<vector<int>, int>> arr(n);
		int cnt = 0;
		for (auto &i : arr) i.f = vector<int>(k), cin >> i.f, i.s = cnt++;
		sort(arr); 
		vector<int> perm(n);
		for (int i = 0; i < n; ++i) perm[i] = i;
		while (true) {
			bool flag = true;
			for (int i = 0, j = n - 1; i < j; ++i, --j)
				if (!check(arr[perm[i]].f, arr[perm[j]].f)) {
					flag = false;
					break;
				}
			if (flag) {
				cout << "YES\n";
				for (int i = 0, j = n - 1; i < j; ++i, --j)
					cout << arr[perm[i]].s + 1 << ' ' << arr[perm[j]].s + 1 << '\n';
				exit(0);
			}
			if (!next_permutation(all(perm))) break;
		}
		cout << "NO";
	} else {
		vector<pair<vector<int>, int>> arr(n);
		int cnt = 0;
		for (auto &i : arr) i.f = vector<int>(k), cin >> i.f, i.s = cnt++;
		sort(arr); 
		for (auto i : arr) cout << i.s << '\n';
		bool flag = true;
		for (int i = 0, j = n - 1; i < j; ++i, --j)
			if (!check(arr[i].f, arr[j].f)) flag = false;
		if (!flag) cout << "NO";
		else {
			cout << "YES\n";
			for (int i = 0, j = n - 1; i < j; ++i, --j)
				cout << arr[i].s + 1 << ' ' << arr[j].s + 1 << '\n';
		}
	}
	return 0;
}