#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
vector<vector<pair<long long, long long>>> dp;
long long n;
long long Rec(long long cnt, long long start, long long mel)
{

    if (cnt < 0)
    {
        return 0;
    }
    if (cnt == 0)
    {

        return 1;
    }
    if (dp[cnt][start].first != -1e9 && mel)
    {
        return dp[cnt][start].first;
    }
    if (dp[cnt][start].second != -1e9 && !mel)
    {
        return dp[cnt][start].second;
    }
    if (mel)
    {
        long long summ = 0;
        for (int i = 1; i < start; i++)
        {
            summ += Rec(cnt - i, i, false);
            summ %= (long long)(1e9 + 7);
        }
        dp[cnt][start].first = summ;
        return summ;
    }
    else
    {
        int summ  = 0;
        for (int i = start + 1; i <= n; i++)
        {
            summ += Rec(cnt - i, i, true);
            summ %= (long long)(1e9 + 7);
        }
        dp[cnt][start].second = summ;
        return summ;
    }
}
int main()
{
    cin >> n;
    long long k;
    cin >> k;
    dp = vector<vector<pair<long long, long long>>> (n + 1, vector<pair<long long, long long>> (n + 1, {-1e9, -1e9}));
    if (k == n)
    {
        cout << 1;
        return 0;
    }
    cout << (Rec(n - k, k, false) + Rec(n - k, k, true)) % (long long)(1e9 + 7);

}

