#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) for (int i = 0; i < (x).size(); i++) cout << x[i] << ' '; cout << endl;

using namespace std;

const int INF = 1e9 + 7;

void solve1(int n, int m, int k)
{
    vector<vector<int> > dp(n, vector<int>(k + 1, 0));

    for (int i = 0; i <= k; i++)
        dp[0][i] = 1;

    for (int i = 1; i < n; i++)
    {
        for (int mask = 0; mask <= k; mask++)
        {
            for (int nxt = mask; nxt <= k; nxt++)
            {
                if ((mask | nxt) == nxt)
                {
                    //cout << mask << ' ' << nxt << ' ' << (mask | nxt) << endl;
                    dp[i][nxt] = (dp[i - 1][mask] + dp[i][nxt]) % INF;
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i <= k; i++)
        ans = (ans + dp[n - 1][i]) % INF;
    cout << ans;
}

void solve2(int n, int m, int k)
{
    vector<set<int> > g(k + 1);
    for (int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[r].insert(l);
    }

    vector<vector<vector<int> > > dp(n, vector<vector<int> >(n, vector<int>(k + 1, 0)));

    for (int i = 0; i <= k; i++)
        dp[0][0][i] = 1;

    for (int i = 1; i < n; i++)
    {
        for (int mask = 0; mask <= k; mask++)
        {
            for (int j = 0; j < n - 1; j++)
            {
                if (g[i].find(j) == g[i].end())
                    dp[i][j + 1][mask] = (dp[i][j + 1][mask] + dp[i - 1][j][mask]) % INF;
            }

            for (int nxt = mask + 1; nxt <= k; nxt++)
            {
                if ((mask | nxt) == nxt)
                {
                    for (int j = 0; j < n; j++)
                        dp[i][0][nxt] = (dp[i - 1][j][mask] + dp[i][0][nxt]) % INF;
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i <= k; i++)
        for (int j = 0; j < n; j++)
           ans = (ans + dp[n - 1][j][i]) % INF;
    cout << ans;
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    if (m == 0)
        solve1(n, m, k);
    else
        solve2(n, m, k);

    return 0;
}
