#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define rforn(i, x) for (int i = (int)x - 1; i >= 0; i--)

#define sz(x) (int)(x).size()

using namespace std;

vector<vector<int> > g;
vector<bool> used;
vector<int> color, cmp;

vector<set<int> > g1, g2;

int red, blue;

void dfs(int v, int col)
{
    used[v] = true;
    if (col)
    {
        color[v] = 0;
        red++;
    }
    else
    {
        color[v] = 1;
        blue++;
    }
    for (int to : g[v])
    {
        if (!used[to])
            dfs(to, col ^ 1);
        else if (used[to] && color[v] == color[to] && color[v] == 0)
        {
            g1[v].insert(to);
            g1[to].insert(v);
        }
        else if (used[to] && color[v] == color[to] && color[v] == 1)
        {
            g2[v].insert(to);
            g2[to].insert(v);
        }
    }

    cmp.pb(v);
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    g.resize(n);
    g1.resize(n);
    g2.resize(n);
    color.resize(n);
    used.assign(n, false);
    forn (i, n)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        g[i].pb(a - 1);
        g[a - 1].pb(i);
    }

    int ans = 0;
    forn (i, n)
    {
        if (!used[i])
        {
            red = 0;
            blue = 0;
            cmp.clear();

            dfs(i, 0);

            set<pii> s1, s2;
            int sum1 = 0, sum2 = 0;
            for (int v : cmp)
            {
                s1.insert({-sz(g1[v]), v});
                s2.insert({-sz(g2[v]), v});

                //cout << -sz(g2[v]) << ' ' << v << endl;

                sum1 += sz(g1[v]);
                sum2 += sz(g2[v]);
            }
            sum1 /= 2;
            sum2 /= 2;

            int cnt1 = 0;
            while (sum1)
            {
                int v = s1.begin()-> ss;
                for (int to : g1[v])
                {
                    s1.erase({-sz(g1[to]), to});
                    g1[to].erase(v);
                    s1.insert({-sz(g1[to]), to});
                    sum1--;
                }
                cnt1++;
            }

            /*for (int x : cmp)
            {
                cout << x << ':' << ' ';
                for (int v : g2[x])
                    cout << v << ' ';
                cout << endl;
            }*/

            int cnt2 = 0;
            while (sum2 && cnt2 < 4)
            {
                int v = s2.begin()-> ss;
                //cout << v << endl;
                for (int to : g2[v])
                {
                    s2.erase({-sz(g2[to]), to});
                    g2[to].erase(v);
                    s2.insert({-sz(g2[to]), to});
                    sum2--;
                }
                cnt2++;
            }

            ans += max(red - cnt1, blue - cnt2);
        }
    }

    cout << ans;
    return 0;
}
