#include <iostream>
using namespace std;

int mod = 1000000007;

int plans(int n, int k, bool up){
    if (n == 0) return 0;
    if (n == k) return 1;
    if (up){
        int sum = 0;
        for (int i = k + 1; i < n - k + 1; ++i){
            sum += plans(n - k, i, false);
            sum %= mod;
        }
        return sum;
    }
    int sum = 0;
    for (int i = 1; i < k; ++i){
        sum += plans(n - k, i, true);
        sum %= mod;
    }
    return sum;

}

int main() {
    int n0, k0;
    cin >> n0;
    cin >> k0;
    int res;
    if (n0 != k0){
        int upres = plans(n0, k0, true);
        int downres = plans(n0, k0, false);
        res = upres + downres;
        res %= mod;
    }
    else res = 1;
    cout << res << endl;
    return 0;
}