#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define int long long
#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

mt19937 gen(time(nullptr));

const int INF = 1e18, P = 1e9 + 7, X = 2007;
vector<int> idx, mod;

void push(int t, int l, int r) {
    if (l + 1 == r) {
        idx[l] -= mod[t];
    } else {
        mod[t * 2 + 1] = mod[t];
        mod[t * 2 + 2] = mod[t];
    }
    mod[t] = 0;
}

void upd(int t, int l, int r, int x, int y, int vl) {
    push(t, l, r);
    if (r <= x || y <= l) return;
    if (x <= l && r <= y) {
        mod[t] = vl;
        push(t, l, r);
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, y, vl);
    upd(t * 2 + 2, m, r, x, y, vl);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    idx.rsz(n + 1, INF);
    mod.rsz(4 * (n + 1));
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        idx[b[i]] = i;
    }
    vector<int> last(n + 1), ans;
    vector<bool> fl(n + 1);
    int i = 0, j = 0;
    while (i < m) {
        while (b[j] == 0) j++;
        int x = b[j];
        if (a[i] == x) {
            for (int k = 1; k <= n; k++) idx[k]--;
            idx[x] = n - 1;
            b.pb(x);
            j++;
            ans.pb(n);
            i++;
            last[x] = ans.size() - 1;
            fl[x] = true;
            continue;
        }
        if (!fl[a[i]]) {
            for (int k = 1; k <= n; k++) idx[k]--;
            idx[x] = n - 1;
            b.pb(x);
            j++;
            fl[x] = true;
            ans.pb(n);
            last[x] = ans.size() - 1;
            continue;
        }
        int id = idx[a[i]];
        ans[last[a[i]]] -= id;
        for (int k = 1; k <= n; k++) {
            if (idx[k] > id) idx[k]--;
        }
        idx[x] = n - 1;
        b.pb(b[id]);
        b[id] = 0;
        ans.pb(n);
        last[a[i]] = ans.size() - 1;
        i++;
    }
    cout << ans.size() << endl;
    for (int elem : ans) cout << elem << ' ';
    return 0;
}
