#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define int long long
#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

mt19937 gen(time(nullptr));

const int INF = 1e18, P = 1e9 + 7, X = 2007;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    vector<int> idx(n + 1, INF);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        idx[b[i]] = i;
    }
    if (n <= 2000 && m <= 2000) {
        vector<int> last(n + 1), ans;
        vector<bool> fl(n + 1);
        int i = 0;
        while (i < m) {
            int x = b[0];
            if (a[i] == x) {
                for (int k = 1; k <= n; k++) idx[k]--;
                idx[x] = n - 1;
                vector<int> c(n);
                for (int k = 1; k < n; k++) c[k - 1] = b[k];
                c[n - 1] = b[0];
                b = c;
                ans.pb(n);
                i++;
                last[x] = ans.size() - 1;
                fl[x] = true;
                continue;
            }
            if (!fl[a[i]]) {
                for (int k = 1; k <= n; k++) idx[k]--;
                idx[x] = n - 1;
                vector<int> c(n);
                for (int k = 1; k < n; k++) c[k - 1] = b[k];
                c[n - 1] = b[0];
                b = c;
                fl[x] = true;
                ans.pb(n);
                last[x] = ans.size() - 1;
                fl[x] = true;
                continue;
            }
            int id = idx[a[i]];
            ans[last[a[i]]] -= id;
            for (int k = 1; k <= n; k++) if (idx[k] > id) idx[k]--;
            idx[a[i]] = n - 1;
            vector<int> c(n);
            for (int i = 1; i <= n; i++) c[idx[i]] = i;
            ans.pb(n);
            last[a[i]] = ans.size() - 1;
            i++;
        }
        cout << ans.size() << endl;
        for (int elem : ans) cout << elem << ' ';
        return 0;
    }
    if (n == m) {
        bool fl1 = true, fl2 = true;
        for (int i = 0; i < n; i++) {
            if (a[i] != b[i]) fl1 = false;
            if (a[i] != b[n - i - 1]) fl2 = false;
        }
        if (fl1) {
            cout << n << endl;
            for (int i = 0; i < n; i++) cout << n << ' ';
            return 0;
        }
        if (fl2) {
            cout << 2 * n  - 1 << endl;
            for (int i = n; i >= 2; i--) cout << i << ' ';
            for (int i = 0; i < n; i++) cout << n << ' ';
            return 0;
        }
    }
}
