#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define int long long
#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

mt19937 gen(time(nullptr));

const int INF = 1e18, P = 1e9 + 7, X = 2007;

int my_pow(int a, int b) {
    if (b == 0) return 1;
    if (b % 2 == 0) {
        int t = my_pow(a, b / 2);
        return (t * t) % P;
    }
    return (my_pow(a, b - 1) * a) % P;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> dp(n, vector<int>(k + 1));
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            for (int j = 0; j <= k; j++) dp[i][j] = 1;
            continue;
        }
        for (int j = 0; j <= k; j++) {
            for (int q = 0; q <= k; q++) {
                if ((j & q) == j) {
                    dp[i][j | q] += dp[i - 1][j];
                    dp[i][j | q] %= P;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= k; i++) {
        ans += dp[n - 1][i];
        ans %= P;
    }
    cout << ans;
    return 0;
}
