#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ff first
#define ss second

using namespace std;

mt19937 gen(time(nullptr));

vector<vector<int>> g;
vector<bool> used;
vector<int> s, col;
vector<pii> dp;
int bl = 0, x = 0;

void dfs(int v) {
    used[v] = true;
    s.pb(v);
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

void cnt(int v) {
    used[v] = true;
    x++;
    for (int u : g[v]) if (!used[u]) cnt(u);
}

bool is_c(int v, int c) {
    col[v] = c;
    if (c == 1) bl++;
    for (int u : g[v]) {
        if (!col[u]) {
            if(!is_c(u, 3 - c)) return false;
        } else if (col[v] == col[u]) return false;
    }
    return true;
}

void dfs_dp(int v, int p) {
    used[v] = true;
    int cnt1 = 0, cnt2 = 0;
    bool fl = false;
    vector<pii> kek;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs_dp(u, v);
            cnt1 += max(dp[u].ff, dp[u].ss);
            cnt2 += dp[u].ss;
            kek.pb({u, 0});
        } else {
            if (p != u) {
                fl = true;
                kek.pb({u, 1});
            }
        }
    }
    if (!fl) {
        dp[v].ff = cnt2 + 1;
        dp[v].ss = cnt1;
    } else {
        int x, y = -1;
        for (int i = 0; i < kek.size(); i++) {
            if (kek[i].ss == 1) x = kek[i].ff;
            else y = kek[i].ff;
        }
        if (y == -1) return;
        dp[v].ff = (y == -1 ? 0 : dp[y].ss) - max(dp[x].ff, dp[x].ss) + dp[x].ss + 1;
        dp[v].ss = max(dp[v].ff, (y == -1 ? 0 : max(dp[y].ff, dp[y].ss)));
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    g.rsz(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x == -1) continue;
        x--;
        g[i].pb(x);
        g[x].pb(i);
    }
    used.rsz(n);
    col.rsz(n);
    dp.rsz(n);
    if (n <= 20) {
        vector<vector<int>> g2(n, vector<int> (n, 1));
        for (int i = 0; i < n; i++) {
            for (int j : g[i]) {
                g2[i][j] = 0;
                g2[j][i] = 0;
            }
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            s = {};
            bool fl = true;
            for (int i = 0; i < n; i++) if (((1 << i) | mask) == mask) s.pb(i);
            int x = s.size();
            for (int i = 0; i < s.size(); i++) {
                for (int j = 0; j < s.size(); j++) {
                    if (!g2[s[i]](y == -1 ? 0[s[j]]) fl = false;
                }
            }
            if (fl) ans = max(ans, x);
        }
        cout << ans;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_dp(i, -1);
            ans += max(dp[i].ff, dp[i].ss);
        }
    }
    cout << ans;
    return 0;
}
