#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll maxn = 30;
const ll maxx = 3e4 + 2;
const ll mod = (ll)1e9 + 7;

ll dp[maxx][maxn][maxn];
ll fac[100];
ll revfac[100];
ll cnt[maxx];


ll pw(ll a, ll p){
    if(p == 0)return 1;
    ll ca = pw(a, p / 2);
    ca = (ca * ca) % mod;
    if(p % 2 == 1){
        ca = (ca * a) % mod;
    }
    return ca;
}

ll n, m, k;


ll cnk(ll n, ll k){
    if(k > n)return 0;
    return (fac[n] * ((revfac[n - k] * revfac[k]) % mod)) % mod;
}


void solve(){
    fac[0] = 1;
    revfac[0] = pw(fac[0], mod - 2);
    for(ll i = 1; i < 100; ++i){
        fac[i] = (fac[i - 1] * i) % mod;
        revfac[i] = pw(fac[i], mod - 2);
    }
    cin >> n >> m >> k;
    // 1 - still same
    for(ll i = 0; i < maxn; ++i){
        dp[0][i][i] = 1;
    }
    for(ll i = 1; i < n; ++i){
        for(ll j = 0; j < maxn; ++j){
            for(ll k = 0; k <= j; ++k){
                for(ll from = k; from <= j; ++from){
                    dp[i][j][k] += (dp[i][j][from] * cnk(from, from - k)) % mod;
//                    cerr << k << " " << from - k << " " << cnk(k, from - k) << "\n";
                }
//                cerr << dp[i][j][k] << "\n";
                dp[i][j][k] %= mod;
            }
        }
    }
    for(ll j = 0; j < maxn; ++j){
        for(ll k = 0; k <= j; ++k){
            cnt[j] += dp[n - 1][j][k];
        }
        cnt[j] %= mod;
    }
//    cerr << dp[1][2][0] << "\n";
//    for(ll i = 0; i < 3; ++i){
//        cerr << cnt[i] << " ";
//    }
//    cerr << "\n";
    ll ans = 0;

    for(ll i = 0; i <= k; ++i){
        ll cur = __builtin_popcountll(i);
//        cerr << i << " " << cur << "\n";
        ans += cnt[cur];
        ans %= mod;
    }
    cout << ans << "\n";
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
