#include<bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

ll n;

vector < vector < ll > > dp;

vector < vector < ll > > g;
vector < ll > used;


void dfs(ll v){
    used[v] = 1;
    ll sons = 0;
    dp[v][1] = 1;
    for(ll u: g[v]){
        if(used[u])continue;
        dfs(u);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        dp[v][1] += dp[u][0];
    }

}



void solve(){
    cin >> n;
    g.resize(n);
    used.resize(n);
    dp.resize(n, vector < ll > (2));
    for(ll i = 0; i < n; ++i){
        ll t;
        cin >> t;
        if(t == -1)continue;
        t--;
        g[t].push_back(i);
        g[i].push_back(t);
    }
    ll ans = 0;
    for(ll i = 0; i < n; ++i){
        if(used[i] == 0){
            dfs(i);
            ans += max(dp[i][0], dp[i][1]);
        }
    }
    cout << ans << "\n";
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
