#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

typedef int ll;
typedef long double ld;

using namespace std;

ll n;

vector < vector < ll > > dp;
vector < vector < vector < ll > > > dp2;

vector < vector < ll > > g;
vector < bool > used, used1, used2;
vector < ll > a;
vector < bool > incyc;


inline void dfs(ll v){
    used[v] = 1;
    dp[v][1] = 1;
    for(ll u: g[v]){
        if(used[u] == 0 && !incyc[u]){
            dfs(u);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
}


inline void dfs1(ll v, vector < ll > &out){
    used1[v] = 1;
    out.push_back(v);
    for(ll u: g[v]){
        if(used1[u] == 0 && incyc[u]){
            dfs1(u, out);
        }
    }
}

vector < ll > st;


inline void restore(ll v){
//    cerr << v << "\n";
    for(ll i = st.size() - 1; i >= 0; --i){
        incyc[st[i]] = 1;
        if(st[i] == v){
            break;
        }
    }
}



inline void dfs2(ll v, ll p = -1){
    st.push_back(v);
    used2[v] = 1;
    for(ll u: g[v]){
        if(u == p)continue;
        if(used2[u] == 0){
            dfs2(u, v);
        } else if(used2[u] == 1){
//            cerr << u << "\n";
            restore(u);
        }
    }
    used2[v] = 2;
    st.pop_back();
}

ll ans = 0;


set < pair < ll, ll > > took;




void solve(){
    cin >> n;
    g.resize(n);
    used.resize(n);
    used1.resize(n);
    used2.resize(n);
    incyc.resize(n);
    dp.resize(n, vector < ll > (2));
    dp2.resize(n, vector < vector < ll > > (2, vector < ll > (2)));
    a.resize(n);
    for(ll i = 0; i < n; ++i){
        ll t;
        cin >> t;
        if(t != -1){
            t--;
            if(!took.count({i, t})){
                g[t].push_back(i);
                g[i].push_back(t);
                took.insert({i, t});
                took.insert({t, i});
            }
        }
    }
    for(ll i = 0; i < n; ++i){
        if(used2[i] == 0){
            dfs2(i, -1);
        }
    }
    vector < vector < ll > > allcyc;
    for(ll i = 0; i < n; ++i){
        if(used1[i] == 0 && incyc[i]){
            vector < ll > curcyc;
            dfs1(i, curcyc);
            allcyc.push_back(curcyc);
        }
    }
    for(ll i = 0; i < n; ++i){
        if(used[i] == 0 && incyc[i]){
            dfs(i);
        }
    }
    for(ll i = 0; i < n; ++i){
        if(!used[i]){
            dfs(i);
            ans += max(dp[i][0], dp[i][1]);
        }
    }
//    cout << allcyc.size() << "\n";
    for(ll i = 0; i < allcyc.size(); ++i){
//        cerr << "HERE\n";
        for(ll ind = 0; ind < allcyc[i].size(); ++ind){
            ll v = allcyc[i][ind];
            ll prv = allcyc[i][ind - 1];
            if(ind == 0){
                dp2[v][0][0] = dp[v][0];
                dp2[v][1][1] = dp[v][1];
            } else if(ind == allcyc[i].size() - 1){
                dp2[v][0][0] = max(dp2[prv][0][0] + dp[v][0], dp2[prv][0][1] + dp[v][0]);
                dp2[v][0][1] = dp2[prv][0][0] + dp[v][1];
                dp2[v][1][0] = max(dp2[prv][1][0] + dp[v][0], dp2[prv][1][1] + dp[v][0]);
                ll add = max(dp2[v][0][0], dp2[v][0][1]);
                add = max(add, dp2[v][1][0]);
//                cerr << "KEK " << add << "\n";
                ans += add;
            } else {
                dp2[v][0][0] = max(dp2[prv][0][0] + dp[v][0], dp2[prv][0][1] + dp[v][0]);
                dp2[v][0][1] = dp2[prv][0][0] + dp[v][1];
                dp2[v][1][0] = max(dp2[prv][1][0] + dp[v][0], dp2[prv][1][1] + dp[v][0]);
                dp2[v][1][1] = dp2[prv][1][0] + dp[v][1];
            }
        }
    }
    cout << ans << "\n";
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
