#include<bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

ll n, k;

void solve1(){
    vector < pair < ll, ll > > a(n);
    for(ll i = 0; i < n; ++i){
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    cout << "YES\n";
    for(ll i = 0; i < a.size() / 2; ++i){
        cout << a[i].second + 1 << " " << a[a.size() - i - 1].second + 1 << "\n";
    }
    cout << "\n";
    exit(0);
}

const ll inf = (ll)2e9;


pair < ll, ll > inter(pair < ll, ll > &a, pair < ll, ll > &b){
    return {max(a.first, b.first), min(a.second, b.second)};
}


void solvesmall(){
    vector < vector < ll > > a(n, vector < ll > (k));
    for(ll i = 0; i < n; ++i){
        for(ll j = 0; j < k; ++j){
            cin >> a[i][j];
        }
    }
    vector < ll > cur(n);
    for(ll i = 0; i < n; ++i){
        cur[i] = i;
    }
    while((ld)clock() / (ld)CLOCKS_PER_SEC <= 0.95){
        random_shuffle(cur.begin(), cur.end());
        bool ok = 1;
        for(ll i = 0; i < k; ++i){
            pair < ll, ll > curseg = {-inf, inf};
            for(ll j = 0; j < n; j += 2){
                pair < ll, ll > c = {a[cur[j]][i], a[cur[j + 1]][i]};
                if(c.second < c.first)swap(c.first, c.second);
                pair < ll, ll > in = inter(c, curseg);
                if(in.first > in.second){
                    ok = 0;
                    break;
                }
                curseg = in;
            }
            if(!ok)break;
        }
        if(ok){
            cout << "YES\n";
            for(ll i = 0; i < n; i += 2){
                cout << cur[i] + 1 << " " << cur[i + 1] + 1 << "\n";
            }
            cout << "\n";
            exit(0);
        }
    }
    cout << "NO\n";
    exit(0);
}




void solve(){
    cin >> n >> k;
    if(k == 1){
        solve1();
    }
    if(n <= 100){
        solvesmall();
    }
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
