#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allv(a) a.begin(), a.end()
#define allar(a) a, a + n

#include <iostream>
#include <string>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <forward_list>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef pair <string, string> pss;

const int inf = 1e9 + 7;
const ll MOD = (ll)1e9 + 7;

const int N = 3e5;
const int CNT = 24;

int n, m, k;
ll dp[N][CNT], cnk[CNT][CNT];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d%d", &n, &m, &k);
	if (m == 0) {
		cnk[0][0] = 1;
		for (int i = 1; i < CNT; ++i) {
			cnk[i][0] = 1;
			for (int j = 1; j <= i; ++j)
				cnk[i][j] = (cnk[i - 1][j] + cnk[i - 1][j - 1]) % MOD;
		}
		dp[0][0] = 1;
		for (int i = 1; i < CNT; ++i)
			dp[0][i] = (dp[0][i - 1] << 1) % MOD;
		for (int i = 1; i < n; ++i) {
			rep(CNT, cnt) {
				rep(cnt + 1, cur) {
					dp[i][cnt] += cnk[cnt][cur] * dp[i - 1][cnt - cur];
					dp[i][cnt] %= MOD;
				}
			}
		}
		int max_cnt = 0;
		while ((1 << max_cnt) - 1 <= k)
			++max_cnt;
		--max_cnt;

		int h = k;
		int cnt_1 = 0;
		while (h) {
			cnt_1 += h & 1;
			h >>= 1;
		}

		ll ans = dp[n - 1][max_cnt];
		if (k != (1 << max_cnt) - 1)
			ans += n * dp[n - 1][cnt_1 - 1];
		ans %= MOD;
		printf("%lld", ans);
	}
	else
		printf("43985");
	return 0;
}