#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allv(a) a.begin(), a.end()
#define allar(a) a, a + n

#include <iostream>
#include <string>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const ll MOD = (ll)1e9 + 7;
const int inf = (int)1e9 + 7;

const int N = 2e5;

int n, k;

void cmb(int ind, vector <int> & less, vector <int> & cur, vector <int> & ans, vector <vector <int>> & a) {
	if (ind == n) {
		vector <pii> LR(k);
		vector <pii> ind_pairs(n >> 1, mp(-1, -1));
		rep(n, i) {
			if (ind_pairs[cur[i]].first == -1)
				ind_pairs[cur[i]].first = i;
			else
				ind_pairs[cur[i]].second = i;
		}
		rep(k, i) {
			LR[i] = mp(-inf, inf);
			rep(n >> 1, j) {
				int cur_l = min(a[ind_pairs[j].first][i], a[ind_pairs[j].second][i]);
				int cur_r = max(a[ind_pairs[j].first][i], a[ind_pairs[j].second][i]);
				LR[i].first = max(LR[i].first, cur_l);
				LR[i].second = min(LR[i].second, cur_r);
			}
			if (LR[i].first > LR[i].second) return;
		}
		rep(n, i)
			ans[i] = cur[i];
		return;
	}
	rep(n, i) {
		if (cur[i] == -1) {
			cur[i] = less[ind];
			cmb(ind + 1, less, cur, ans, a);
			cur[i] = -1;
		}
	}
}

void solve1() {
	vector <vector <int>> a(n);
	vector <int> num_pair(n, -1), h(n, -1), nums(n);

	rep(n, i)
		nums[i] = i / 2;

	rep(n, i) {
		a[i].resize(k);
		rep(k, j)
			scanf("%d", &a[i][j]);
	}
	cmb(0, nums, h, num_pair, a);
	if (num_pair.front() == -1)
		printf("NO");
	else {
		printf("YES\n");
		vector <vector <int>> ans(n >> 1);
		rep(n, i)
			ans[num_pair[i]].push_back(i + 1);
		rep(n >> 1, i)
			printf("%d %d\n", ans[i][0], ans[i][1]);
	}
}

void solve2() {
	vector <pii> a(n);

	rep(n, i) {
		scanf("%d", &a[i].first);
		a[i].second = i + 1;
	}
	sort(allv(a));
	printf("YES\n");
	rep(n >> 1, i)
		printf("%d %d\n", a[i].second, a[n - i - 1].second);
}

void solve3() {
	vector <vector <pii>> a(k);
	vector <int> num(n, 0);
	vector <vector <int>> inds_on_num(1 << k);
	vector <pii> ans;

	rep(k, i)
		a[i].resize(n);
	rep(n, i) {
		rep(k, j) {
			scanf("%d", &a[j][i].first);
			a[j][i].second = i;
		}
	}
	rep(k, i) {
		sort(allv(a[i]));
		rep(n, j) {
			num[a[i][j].second] <<= 1;
			num[a[i][j].second] += (j >= (n >> 1));
		}
	}
	rep(n, i)
		inds_on_num[num[i]].push_back(i + 1);
	rep(1 << k - 1, i) {
		if (inds_on_num[i].size() != inds_on_num[(1 << k) - 1 - i].size()) {
			printf("NO");
			return;
		}
		while (inds_on_num[i].size()) {
			ans.push_back(mp(inds_on_num[i].back(), inds_on_num[(1 << k) - 1 - i].back()));
			inds_on_num[i].pop_back();
			inds_on_num[(1 << k) - 1 - i].pop_back();
		}
	}
	printf("YES\n");
	for (pii elem : ans)
		printf("%d %d\n", elem.first, elem.second);
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &k);
	if (n <= 10)
		solve1();
	else if (k == 1)
		solve2();
	else
		solve3();
	return 0;
}