#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	if (c > '9') return 0;
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int N = 1e6 + 1;

int n, m;
vector<int> a, b;
bool away[N];
vector<int> rep;
queue<int> order;
vector<int> ans;
vector<int> place[N];

int lst[N];
int sum[N];

void add(int i, int d) {
	while (i < N) {
		sum[i] += d;
		i |= (i + 1);
	}
}

int get(int i) {
	int ans = 0;
	while (i >= 0) {
		ans += sum[i];
		i &= (i + 1);
		--i;
	} 
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);	
	//read("input");
	cin >> n >> m;
	a.resize(m);
	b.resize(n);
	cin >> a >> b;
	for (auto i : b) order.push(i);
	for (auto i : a) {
		if (away[i]) {
			rep.pb(i);
		} else {
			while (order.front() != i) {
				rep.pb(order.front());
				away[rep.back()] = true;
				order.pop();
			}
			rep.pb(i);
			away[i] = true;
			order.pop();
		}
	}
	cout << rep.size() << '\n';
	for (int i = 0; i < rep.size(); ++i) {
		place[rep[i]].pb(i);
	}
	ans.resize(rep.size());
	for (int i = 0; i < rep.size(); ++i) {
		ans[i] = n;
		if (lst[rep[i]] != 0) {
			int s = get(i) - get(lst[rep[i]] - 1);
			ans[lst[rep[i]] - 1] = s + 1;
			add(lst[rep[i]], -1);
		} 
		add(i, 1);
		lst[rep[i]] = i + 1;
	}
	// cout << rep << '\n';
	for (int i = 0; i < rep.size(); ++i) {
		cout << ans[i] << ' ';
	}
	cout << '\n';
}