#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	if (c > '9') return 0;
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int N = 1e6 + 1;

int n;
bool used[N];
int p[N];
vector<int> edge[N];
int ans;

pair<int, int> dfs(int i) {
	used[i] = true;
	pair<int, int> cur = {0, 1};
	for (auto j : edge[i]) {
		if (used[j]) continue;
		auto res = dfs(j);
		cur.y += res.x;
		cur.x += max(res.x, res.y);
	}
	return cur;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);	
	//read("input");
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> p[i];
		if (p[i] != -1) {
			edge[p[i]].pb(i);
			edge[i].pb(p[i]);
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (used[i]) continue;
		int a = i, b = i;
		do {
			if (p[b] == -1 || p[p[b]] == -1) break;
			a = p[i], b = p[p[b]];
		} while (a != b);
		if (p[b] == -1 || p[p[b]] == -1) {
			a = i;
			while (p[a] != -1) a = p[a];
			auto res = dfs(a);
			ans += max(res.x, res.y);
		} else {
			vector<int> who;
			do {
				who.pb(a);
				used[a] = true;
				a = p[a];
			} while (a != b);
			cout << endl;
			int dp[2][2];
			dp[0][0] = dp[0][1] = dp[1][0] = dp[1][1] = -1e9;
			auto res = dfs(who[0]);
			dp[0][0] = res.x;
			dp[1][1] = res.y;
			for (int j = 1; j < who.size(); ++j) {
				int ndp[2][2];
				ndp[0][0] = ndp[0][1] = ndp[1][0] = ndp[1][1] = -1e9;
				auto res = dfs(who[j]);
				for (int t = 0; t < 2; ++t) {
					chkmax(ndp[t][0], res.x + max(dp[t][0], dp[t][1]));
					chkmax(ndp[t][1], res.y + dp[t][0]);
					dp[t][0] = ndp[t][0];
					dp[t][1] = ndp[t][1];
				}
			}
			ans += max(dp[1][0], dp[0][1]);
		}
	}
	cout << ans << '\n';
}