#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const ld EPS = 1e-7;

int n;
vector <vector <int> > g;
vector <bool> used;
vector <bool> take;

void dfs(int v, bool f) {
	used[v] = true;
	for (int to : g[v]) {
		if (take[to]) {
			f = false;
			break;
		}
	}
	take[v] = f;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to, !f);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(1234);
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a != -1) {
			g[a - 1].push_back(i);
			g[i].push_back(a - 1);
		}
	}
	vector <int> perm(n);
	for (int i = 0; i < n; ++i) { perm[i] = i; }
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		used.clear(); used.resize(n, false);
		take.clear(); take.resize(n, false);
		random_shuffle(all(perm));
		for (int it : perm) {
			if (!used[it]) {
				dfs(it, true);
			}
		}
		//for (bool it : take) { cout << it << " "; }
		//cout << endl;
		ans = max(ans, 1ll * count(all(take), true));
	}
	cout << ans << endl;
	return 0;
}