#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) a.begin(), a.end()
#define rall(v) a.rbegin(), a.rend()

const int INF = 1e18;
const ld EPS = 1e-7;

int n, k;
vector <vector <int> > a;

void solve1() {
	vector <int> perm(n);
	for (int i = 0; i < n; ++i) { perm[i] = i; }
	do {
		vector <pair <int, int> > segs(k, {-INF, INF});
		for (int i = 0; i < n; i += 2) {
			for (int j = 0; j < k; ++j) {
				int l = a[perm[i]][j];
				int r = a[perm[i + 1]][j];
				segs[j].first = max(segs[j].first, min(l, r));
				segs[j].second = min(segs[j].second, max(l, r));
			}
		}
		bool f = false;
		for (int i = 0; i < k; ++i) {
			if (segs[i].first > segs[i].second) {
				f = true;
				break;
			}
		}
		if (!f) {
			cout << "YES" << endl;
			for (int i = 0; i < n; i += 2) {
				cout << perm[i] + 1 << " " << perm[i + 1] + 1 << endl;
			}
			exit(0);
		}
	} while (next_permutation(all(perm)));
	cout << "NO" << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k;
	a.resize(n, vector <int>(k));
	for (auto& r : a) {
		for (int& it : r) {
			cin >> it;
		}
	}
	if (n <= 10) {
		solve1();
	}
	return 0;
}