#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

typedef long long ll;
typedef long double lld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll k, x, n;
    long double sq;
    cin >> k;

    if (k < 0) {
        n = 0;
    } else {
        n = sqrt((lld)k);
        if (n * n < k)
            ++n;
    }
    ll end_ = 2*1e9;
    if (end_ - n > 2*1e8)
        end_ = n + 2*1e8;
    for (; n < end_; ++n) {
        sq = sqrt((lld)(n * n - k));
        if (sq == trunc(sq)) {
            cout << n << endl;
            return 0;
        }
    }

    cout << "none\n";
    return 0;
}
