#include <iostream>
#include <vector>
#include <map>
#include <cmath>
using namespace std;

typedef unsigned long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1 << endl;
        return 0;
    }
    map<pair<int, int>, int> m1_up, m1_down, m2_up, m2_down;
    m1_up[{k, n - k}] = 1;
    m1_down[{k, n - k}] = 1;
    ll ans = 0;
    while (!m1_up.empty() || !m1_down.empty()) {

        /*

        cout << "---------------\n";
        for (auto p : m1_up) {
            cout << "for   k = " << p.first.first << ",  n = " << p.first.second << "  res is: " << p.second << endl;
        }
        cout << "---------------\n";
        for (auto p : m1_down) {
            cout << "for   k = " << p.first.first << ",  n = " << p.first.second << "  res is: " << p.second << endl;
        }
        cout << "-----------------------\n";

        */

        for (auto p : m1_up) {
            int k1 = p.first.first, n1 = p.first.second;
            if (n1 == 0) {
                ans += p.second;
                continue;
            }
            for (int i = 1, end_ = min(k1, n1 + 1); i < end_; ++i)
                m2_down[{i, n1 - i}] += p.second;
        }
        for (auto p : m1_down) {
            int k1 = p.first.first, n1 = p.first.second;
            if (n1 == 0) {
                ans += p.second;
                continue;
            }

            for (int i = k1 + 1; i <= n1; ++i)
                m2_up[{i, n1 - i}] += p.second;
        }
        m1_up = m2_up;
        m1_down = m2_down;
        m2_up.clear();
        m2_down.clear();
    }

    cout << ans << endl;
    return 0;
}
