#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    int n1 = n;
    ++n;
    vector<vector<int>> sm(n);
    vector<int> count(n, 0);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        if (x > 0) {
            sm[x].push_back(i);
            sm[i].push_back(x);
            count[x]++;
            count[i]++;
        }

    }
    if (n > 20) {
        cout << (n) / 2 << endl;
        return 0;
    }
    int pos = 1;
    for (int i = 2; i < n; ++i) {
        if (q[i].size() > q[pos].size())
            pos = i;
    }
    if (q[pos].empty()) {
        cout << n - 1 << endl;
        return 0;
    }
    vector<int> used(n, 0);
    dfs(pos, q, used, 0);
    do {
        pos = -1;
        for (int i = 1; i < n; ++i)
        if (!used[i]) {
            if (pos == -1)
                pos = i;
            else {
                if (q[i].size() > q[pos].size())
                    pos = i;
            }
        }
        if (pos > 0)
            dfs(pos, q, used, 0);
    } while (pos > 0);
    int ans = 0;
    for (int i = 1; i < n; ++i)
        if (!deleted[i])
            ++ans;
    cout << ans << endl;
    return 0;
}
