#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

ll n, m;
vll a, b;
vll c;
vector<vll> posa;
vll ans;
deque<pll> q;

ll getpos(ll v) {
	if (posa[v].empty()) {
		return -1;
	}
	ll pos = posa[v].back();
	return pos;
}
ll move2pos() {
	ll v = q.front().sd;
	q.popf();
	ll pos = getpos(v);
	if (pos == -1) {
		return n - 1;
	}
	q.pb({ pos, v });
	ll j = sz(q) - 1;
	while (j && q[j - 1].ft > q[j].ft) {
		swap(q[j - 1], q[j]);
		--j;
	}
	return j;
}

inline void solve() {
	for (ll i = 0; i < n; i++) {
		q.pb({ i, b[i] });
	}
	for (ll i = 0; i < m; i++) {
		while (q.front().sd != a[i]) {
			ans.pb(move2pos());
		}
		posa[q.front().sd].popb();
		ans.pb(move2pos());
	}
	cout << sz(ans) << endl;
	for (ll x : ans) {
		cout << x + 1 << " ";
	}
}

inline void read() {
	cin >> n >> m;
	a.resize(m);
	b.resize(n);
	posa.resize(n);
	for (ll i = 0; i < m; i++) {
		cin >> a[i];
		--a[i];
		posa[a[i]].pb(i);
	}
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		--b[i];
	}
	for (ll i = 0; i < n; i++) {
		reverse(all(posa[i]));
	}
}
