#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) ((a).begin(), (a).end())
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

struct graph {
	ll n;
	vector<bitset<20>> adj;
	graph() {}
	graph(ll n_) {
		n = n_;
		adj.resize(n);
		for (ll i = 0; i < n; i++) {
			adj[i].set();
		}
	}
	void add(ll v, ll u) {
		adj[v][u] = 0;
	}
};

ll n;
vll a;
graph g;
ll ans = 0;

inline void solve() {
	if (n > 20) {
		cout << (n + 1) / 2 << endl;
		return;
	}
	for (ll m = 0; m < (1ll << n); m++) {
		vll vs;
		for (ll i = 0; i < n; i++) {
			if (m & (1ll << i)) {
				vs.pb(i);
			}
		}
		bitset<20> adj = m;
		for (ll v : vs) {
			adj &= g.adj[v];
		}
		if (adj == m) {
			maxeq(ans, sz(vs));
		}
	}		cout << ans << endl;

}

inline void read() {
	cin >> n;
	a.resize(n);
	g = graph(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		--a[i];
		if (a[i] != -2) {
			g.add(i, a[i]);
		}
	}
}
