#include<bits/stdc++.h>

using namespace std;

int answer = 0;
int n;

vector<int> comp;
vector<bool> used;
vector<bool> used_cycle;
vector<int> hatred;
vector<vector<int>> g;


//int loc;
void dfs(int v) {
    used[v] = true;
    comp.push_back(v);
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

int dfs_cycle(int v) {
    used_cycle[v] = true;
    if (hatred[v] == -1) {
        return -1;
    }
    if (used_cycle[hatred[v]]) {
        return v;
    }
    return dfs_cycle(hatred[v]);
}

pair<int, int> dfs_loc(int v, int a, int b) {
    if (g[v].size() == 2 && ((g[v][0] == a && g[v][1] == b) || (g[v][0] == b && g[v][1] == a))) {
        return {0, 1};
    }
    int sum0 = 0, sum1 = 1;
    for (auto u : g[v]) {
        if (u != a && u != b) {
            auto p = dfs_loc(u, v, v);
            sum0 += max(p.first, p.second);
            sum1 += p.first;
        }
    }
    return {sum0, sum1};
}

void solve() {
    int v = dfs_cycle(comp[0]);
    vector<int> kek;
    if (v == -1) {
        auto p = dfs_loc(comp[0], -1, -1);
        answer += max(p.first, p.second);
        return;
    }
    int u = hatred[v];
    kek.push_back(v);
    while (u != v) {
        kek.push_back(u);
        u = hatred[u];
    }

    vector<int> dp1(kek.size()), dp0(kek.size());
    for (int i = 0; i < kek.size(); ++i) {
        auto p = dfs_loc(kek[i], kek[(i + 1) % kek.size()], kek[(i + kek.size() - 1) % kek.size()]);
        dp0[i] = p.first;
        dp1[i] = p.second;
        //cout << dp0[i] << " " << dp1[i] << endl;
    }
    int add = 0;
    int mx0 = dp0[0], mx1 = -1e9;
    for (int i = 1; i < kek.size(); ++i) {
        int n1, n0;
        n1 = mx0 + dp1[i];
        n0 = max(mx0, mx1) + dp0[i];
        mx0 = n0;
        mx1 = n1;
        //cout << mx1 << " " << mx0 << endl;
    }
    add = max(mx0, mx1);
    mx0 = -1e9, mx1 = dp1[0];
    for (int i = 1; i < kek.size(); ++i) {
        int n1, n0;
        n1 = mx0 + dp1[i];
        n0 = max(mx0, mx1) + dp0[i];
        mx0 = n0;
        mx1 = n1;
    }
    add = max(add, mx0);
    answer += add;
}

int main()
{
    cin >> n;
    hatred.resize(n);
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        hatred[i] = x;
        if (x == -2) {
            hatred[i] = -1;
            continue;
        }
        if (x > i || (x < i && hatred[x] != i)) {
            g[i].push_back(x);
            g[x].push_back(i);
        }
    }

    used.resize(n, false);
    used_cycle.resize(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.clear();
            dfs(i);
            /*for (auto elem : comp) {
                cout << elem << " ";
            }
            cout << endl << "//" << endl;*/
            solve();
        }
    }
    cout << answer;
    return 0;
}


