#define ll long long
#define forrange(i, a, b) for (ll i = a; i < b; ++i)
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

struct {
	bool operator()(pair<ll, ll> a, pair<ll, ll> b) const
	{
		return a.first < b.first;
	}
} customLess;

struct triplet
{
	ll f, s, ind;
	triplet(ll a, ll b, ll c) : f(a), s(b), ind(c) {};
};

struct {
	bool operator()(triplet a, triplet b) const
	{
		return a.f < b.f;
	}
} customMoreFirst;

struct {
	bool operator()(triplet a, triplet b) const
	{
		return a.s < b.s;
	}
} customMoreSec;

int main()
{
	ll n, k;
	cin >> n >> k;

	//2 
	if (k == 1)
	{
		ll temp;
		vector<pair<ll, ll>> artif;
		for (ll i = 1; i <= n; ++i)
		{
			cin >> temp;
			artif.push_back(make_pair(temp, i));
		}
		sort(artif.begin(), artif.end(), customLess);
		cout << "YES" << endl;
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			cout << artif[i].second << " " << artif[n - 1 - i].second << endl;
		}
		return 0;
	}

	//4 
	if (k == 2)
	{
		ll temp1, temp2;
		vector<triplet> artif;
		for (ll i = 1; i <= n; ++i)
		{
			cin >> temp1 >> temp2;
			artif.push_back(triplet(temp1, temp2, i));
		}
		sort(artif.begin(), artif.end(), customMoreFirst);

		vector<bool> group1(n+1, false);
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			group1[artif[i].ind] = true;
		}
		sort(artif.begin(), artif.end(), customMoreSec);
		
		vector<int> ff, fs, sf, ss;
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			if (group1[artif[i].ind]) ff.push_back(artif[i].ind);
			else sf.push_back(artif[i].ind);
		}
		for (ll i = n/2; i < n; ++i)
		{
			if (group1[artif[i].ind]) fs.push_back(artif[i].ind);
			else ss.push_back(artif[i].ind);
		}
		cout << "YES" << endl;
		for (int i = 0; i < ff.size(); ++i) cout << ff[i] << " " << ss[i] << endl;
		for (int i = 0; i < fs.size(); ++i) cout << fs[i] << " " << sf[i] << endl;

		return 0;
	}
	return 0;
}