#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
const ll MAXN = (ll)1000 * 1000 * 1000 * 1000;;


using namespace std;

int main()
{
	ll k;
	cin >> k;

	if (k == 0)
	{
		cout << 0 << endl;
		system("pause");
		return 0;
	}

	ll minval = MAXN;
	for (ll d = 1; d < (ll)sqrt(abs(k)) + 1; d++)
	{
		if (k % d == 0)
		{
			ll a = d, b = k / d;
			if ((a + b) % 2 == 0)
			{
				minval = min(minval, abs((a + b) / 2));
			}
		}
	}

	if (minval == MAXN)
	{
		cout << "none" << endl;
	}
	else
	{
		cout << minval << endl;
	}

	system("pause");
	return 0;
}