#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;

	vector<int> A(m);
	vector<int> B(n);

	vector<int> cnt(n);
	vector<int> dep(n);
	vector<vector<int>> arr(n);

	for (int i = 0; i < m; i++)
	{
		cin >> A[i];
		A[i]--;
		arr[A[i]].pb(i);
	}

	for (int i = 0; i < n; i++)
	{
		cin >> B[i];
		B[i]--;
		dep[B[i]] = i;
	}

	for (int i = 0; i < n; i++)
	{
		arr[i].pb(-1);
	}

	/*set<pair<int, int>> que;

	for (int i = 0; i < n; i++)
	{
		if (arr[i][0] != -1)
		{
			que.insert({ arr[i][0], i });
		}
	}
*/


	vector<int> ans;
	for (int i = 0; i < m; i++)
	{
		int cur = A[i];

		if (arr[cur][cnt[cur] + 1] == -1)
		{
			ans.pb(n - 1);
			continue;
		}

		set<int> que;
		for (int j = i + 1; j < arr[cur][cnt[cur] + 1]; j++)
		{
			que.insert(A[j]);
		}
		dep[cur] = (que.size());

		ans.pb(dep[cur]);
		cnt[cur]++;
	}

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << " ";
	cout << endl;

	system("pause");
	return 0;
}