#include <iostream>
#include <vector>
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
#define int ll
const int MAXN = 1000 * 1000 * 1000 + 7;

using namespace std;

signed main()
{
	int n, k;
	cin >> n >> k;

	if (n == k)
	{
		cout << 1 << endl;
		return 0;
	}

	vector<vector<vector<int>>> D(n + 1, vector<vector<int>>(n + 1, vector<int>(2)));

	D[k][k][0] = 1;
	D[k][k][1] = 1;
	

	for (int i = 1; i <= n; i++)
	{
		for (int a = 1; a <= n; a++)
		{
			for (int x = 0; x < a; x++)
			{
				if (i - a >= 0)
				{
					D[i][a][0] += D[i - a][x][1];
					D[i][a][0] %= MAXN;
				}
			}
			for (int x = a + 1; x < n; x++)
			{
				if (i - a >= 0)
				{
					D[i][a][1] += D[i - a][x][0];
					D[i][a][1] %= MAXN;
				}
			}
		}
	}

	int sum = 0;
	for (int i = 0; i < n + 1; i++)
	{
		sum += D[n][i][0];
		sum += D[n][i][1];
		sum %= MAXN;
	}

	cout << sum << endl;

	return 0;
}