#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	otuput(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll INF = 1e18;
ll k, ans = INF, ans2 = INF;

void go(ll x, ll y) {
	if (y >= x) {
		if ((x + y) % 2 == 0) {
			chkmin(ans, (x + y) / 2);
			chkmin(ans2, (y - x) / 2);
		}
	}
}

int main() {
	fast_io();
	cin >> k;

	if (k == 0) {
		cout << 0 << endl;
		return 0;
	}

	for (ll i = 1; i * i <= abs(k); ++i) {
		if (k % i == 0) {
			go(i, abs(k) / i);
			go(abs(k) / i, i);
		}
	}

	if (k < 0) {
		ans = ans2;
	}

	if (ans == INF) {
		cout << "none\n";
	}
	else {
		cout << ans << endl;
	}
}
