#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const ld pi = 3.1415926;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
#define int ll

template<typename T> void uin(T & a, T b) { if (b < a) a = b; }
template<typename T> void uax(T & a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

int d1[5001][5001], d2[5001][5001];
int pref1[5001][5002], pref2[5001][5001];
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	if (n == k) return cout << 1, 0;
	d1[k][k] = d2[k][k] = 1ll;
	for (int i = k; i <= n; ++i) pref2[k][i] = 1ll;
	for (int i = 1; i <= k; ++i) pref1[k][i] = 1ll;
	for (int i = k + 1; i <= n; ++i) {
		for (int j = 1; j < i; ++j) {
			d1[i][j] = pref2[i - j][j - 1];
			d2[i][j] = pref1[i - j][j + 1];
		}
		firn(j, i) pref2[i][j] = (pref2[i][j - 1] + d2[i][j]) % mod;
		for (int j = i - 1; j > 0; --j) pref1[i][j] = (pref1[i][j + 1] + d1[i][j]) % mod;
	}
	int ans = 0;
	firn(j, n + 1) ans = (ans + d1[n][j]) % mod;
	firn(j, n + 1) ans = (ans + d2[n][j]) % mod;
	ans = (ans % mod + mod) % mod;
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}