#include <bits/stdc++.h>

using namespace std;

const int M = 1000000007;
int main()
{
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;

    if (n == k)
    {
        cout << 1;
        return 0;
    }

    vector<vector<vector<int> > > dp(n + 1, vector<vector<int> >(n + 1, vector<int>(2, 0)));

    dp[k][k][0] = 1;
    dp[k][k][1] = 1;

    for (int sum = 1; sum <= n; sum++)
    {
        for (int last = 1; last <= n; last++)
        {
            if (sum - last < 0) continue;

            for (int j = 1; j <= last - 1; j++)
            {
                dp[sum][last][1] += dp[sum - last][j][0];
                dp[sum][last][1] %= M;
            }
            for (int j = last + 1; j <= n; j++)
            {
                dp[sum][last][0] += dp[sum - last][j][1];
                dp[sum][last][0] %= M;
            }
        }
    }

    int ans = 0;
    for (int last = 1; last <= n; last++)
    {
        ans += (dp[n][last][0] + dp[n][last][1]) % M;
        ans %= M;
    }
    cout << ans;
    return 0;
}
