#include <bits/stdc++.h>

using namespace std;

const long long M = 1000000007;
int main()
{
    ios_base::sync_with_stdio(false);
    long long n, k;
    cin >> n >> k;

    if (n == k)
    {
        cout << 1;
        return 0;
    }

    vector<vector<pair<int, int> > > dp(n + 1, vector<pair<int, int> >(n + 1, {0, 0}));
    vector<vector<pair<int, int> > > pref(n + 1, vector<pair<int, int> >(n + 1, {0, 0}));

    dp[k][k] = {1, 1};

    for (long long last = 1; last <= n; last++)
    {
        pref[k][last].second = pref[k][last - 1].second + dp[k][last].second;
        pref[k][last].first = pref[k][last - 1].first + dp[k][last].first;
    }

    for (long long sum = 1; sum <= n; sum++)
    {
        for (long long last = 1; last <= n; last++)
        {
            if (sum - last < 0)
            {
                pref[sum][last].second = pref[sum][last - 1].second;
                pref[sum][last].first = pref[sum][last - 1].first;
                continue;
            }

            dp[sum][last].second += (pref[sum - last][last - 1].first - pref[sum - last][0].first + M) % M;
            dp[sum][last].second %= M;
            pref[sum][last].second = pref[sum][last - 1].second + dp[sum][last].second;
            pref[sum][last].second %= M;

            dp[sum][last].first += (pref[sum - last][n].second - pref[sum - last][last].second + M) % M;
            dp[sum][last].first %= M;
            pref[sum][last].first = pref[sum][last - 1].first + dp[sum][last].first;
            pref[sum][last].first %= M;
        }
    }

    long long ans = 0;
    for (long long last = 1; last <= n; last++)
    {
        ans += (dp[n][last].first + dp[n][last].second) % M;
        ans %= M;
    }
    cout << ans;
    return 0;
}
