#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    int n, x;
    cin >> n;
    vector<vector<int> > graph(n);

    bool flag = true;
    bool flag2 = true;
    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x > 0) x--;
        flag &= (x == i - 1);
        if (x == -1) continue;
        flag2 &= (x < i);
        graph[x].push_back(i);
        graph[i].push_back(x);
    }

    if (flag)
    {
        cout << (n + 1) / 2;
        return 0;
    }

    if (flag2)
    {
        set<pair<int, int> > q;
        vector<int> used(n, 0);

        int ans = 0;
        for (int i = 0; i < n; i++)
        {
            if (graph[i].size() == 1)
            {
                q.insert({-1, i});
                used[i] = -1;
                ans++;
            }
        }

        cout << ans;
        /*
        13
        -1
        1
        2
        2
        3
        2
        6
        6
        8
        9
        9
        9
        9
        */
        while (q.size())
        {
            pair<int, int> edge = *(q.begin());
            q.erase(q.begin());
            int v = edge.second;

            //cout << "v:" << v << endl;
            for (auto u : graph[v])
            {
                if (!used[u])
                {
                    if (used[v] == -1)
                    {
                        used[u] = 1;
                        q.insert({1, u});
                    }
                    if (used[v] == 1)
                    {
                        used[u] = -1;
                        //cout << endl << u << endl;
                        ans++;
                        q.insert({-1, u});
                    }
                }
            }
        }
        cout << ans;
        return 0;
    }
}
