#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
using namespace std;
#define int long long
typedef long long ll;
#define pii pair<int, int>

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
};

const int N = 3e5 + 10;
const int MOD = 1e9 + 7;
int dpn[N];
int dpk[N];
int f[N];
int rf[N];
signed dpp[N][32];
int n, m, k;

int binpow(int a, int p) {
    if (p == 0) return 1;
    if (p % 2 == 1) return a * binpow(a, p - 1) % MOD;
    int u = binpow(a, p / 2);
    return u * u % MOD;
}

int rev(int x) {
    return binpow(x, MOD - 2);
}

void precalc() {
    f[0] = 1;
    for (int i = 1; i < N; i++) f[i] = (f[i - 1] * i) % MOD;
    rf[N - 1] = rev(f[N - 1]);
    for (int i = N - 2; i >= 0; i--) {
        rf[i] = rf[i + 1] * (i + 1) % MOD;
    }
    dpp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j < 32; j++) {
            dpp[i][j] = (i * (dpp[i][j - 1] + dpp[i - 1][j - 1])) % MOD;
        }
    }
}

int c(int n, int k) {
    return (f[n] * rf[k] % MOD) * rf[n - k] % MOD;
}

void solven() {
    for (int i = 0; i <= n; i++) dpn[i] = c(n, i);
}

void solvek() {
    int p = 1;
    int x = 0;
    while (p * 2 <= k) {p *= 2; x++; }
    int cc = 0;
    int tk = k;
    while (tk > 0) {
        cc++;
        tk = (tk & (tk - 1));
    }
    dpk[cc]++;
    int cur = 0;
    while (p > 0) {
        if ((p & k) > 0) {
            for (int tt = 0; tt <= x; tt++) {
                dpk[tt + cur] = (dpk[tt + cur] + c(x, tt)) % MOD;
            }
            cur++;
        }
        p /= 2;
        x--;
    }
}

signed main() {
    fast();
    cin >> n >> m >> k;
    precalc();
    if (m != 0) return -1;
    solven(); solvek();
    int answ = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = i; j < 32; j++) {
            answ = (answ + (dpn[i] * dpk[j] % MOD) * dpp[i][j] % MOD) % MOD;
        }
    }
    cout << answ;
    return 0;
}