//#include "pch.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000LL * 1000LL * 1000LL + 7LL;

ll n, k;

vvl arr1, arr2;

ll funk(ll k, ll n, bool q)
{
    ll ans = 0LL;
    if (q)// if q, funk should be <
    {
        for (ll k1 = k - 1LL; k1 > 0LL; k1--)
        {
            if (n - k1 > 0)
            {
                if (arr2[k1][n - k1] == -1) { ans += funk(k1, n - k1, false); ans %= INF; }
                else { ans += arr2[k1][n - k1]; ans %= INF; }
            }
            if (n - k1 == 0LL) { ans++; ans %= INF; }
        }
        arr2[k][n] = ans;
    }
    else
    {
        for (ll k1 = k + 1LL; k1 <= n; k1++)
        {
            if (n - k1 > 0)
            {
                if (arr1[k1][n - k1] == -1) { ans += funk(k1, n - k1, true); ans %= INF; }
                else { ans += arr1[k1][n - k1]; ans %= INF; }
            }
            if (n - k1 == 0) { ans++; ans %= INF; }
        }
        arr1[k][n] = ans;
    }
    return ans % INF;
}

int main()
{
    cin >> n >> k;
    if (n == k) { cout << 1LL << endl; return 0; }
    arr1.resize(n + 1LL, vl(n + 1LL, -1)); arr2.resize(n + 1LL, vl(n + 1LL, -1));
    cout << funk(k, n - k, false) + funk(k, n - k, true) << endl;

    return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
