#include <iostream>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

int n, m;
vector<int> A, B;
int L;

void read_all()
{
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        A.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        B.push_back(x);
    }
}

vector<int> res;

void action()
{
    set<int> st;
    if (B[0] == A[L])
        L++;
    for (int i = L; i < A.size(); i++) {
        if (A[i] == B[0])
            break;
        st.insert(A[i]);
    }
    int ind = 0;
    while (!st.empty()) {
        swap(B[ind], B[ind + 1]);
        st.erase(B[ind]);
        ind++;
    }
    res.push_back(ind + 1);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    if (n > 2000 && n == m && A[0] == B[0]) {
        cout << n << "\n";
        for (int i = 0; i < n; i++)
            cout << n << ' ';
        return 0;
    }
    if (n > 2000 && n == m && A[0] == B[n - 1]) {
        cout << 2 * n - 1 << "\n";
        for (int i = 1; i < n; i++)
            cout << 2 << ' ';
        for (int i = 0; i < n; i++)
            cout << n << ' ';
        return 0;
    }
    while (L < A.size())
        action();
    cout << res.size() << "\n";
    for (int x : res)
        cout << x << ' ';
    return 0;
}
