#include <iostream>
#include <vector>
#include <map>

#define endl '\n'

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	long long k;
	cin >> k;

	if (k == 0) {
		cout << 0;
		return 0;
	}

	bool f = k < 0;
	k = abs(k);

	vector<long long> div;
	for (long long i = 1; i * i <= k; i++) {
		if (k % i == 0) {
			div.push_back(i);
			if (i * i != k) {
				div.push_back(k / i);
			}
		}
	}

	for (int i = 0; i < div.size(); i++) {
		for (int j = 0; j < div.size(); j++) {
			auto a = div[i];
			auto b = div[j];
			long long y = (a - b) / 2;
			long long x = a - y;
			if (x >= 0 && y >= 0 && x > y && (x + y) * (x - y) == k) {
				if (f) {
					cout << y;
				}
				else {
					cout << x;
				}
				return 0;
			}
		}
	}
	cout << "none";
}