#include <iostream>
#include <vector>
#include <queue>

int ans = 0;
int n;

using namespace std;

bool check(vector<vector<int>> &graph, vector<int> &vec) {
    vector<int> forb(n, 0);
    for (int i = 0; i < vec.size(); i++) {
        forb[vec[i]] = 1;
    }
    for (int i = 0; i < vec.size(); i++) {
        for (auto elem : graph[vec[i]]) {
            if (forb[elem] == 1)
                return false;
        }
    }
    return true;
}

void pereb(vector<vector<int>> &graph, vector<int> taken, int u) {
    if (u == n) {
        if (check(graph, taken)) {
            int sz = taken.size();
            ans = max(ans, sz);
        }
    }
    else {
        pereb(graph, taken, u + 1);
        taken.push_back(u);
        pereb(graph, taken, u + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    if (n > 20) {
        cout << (n + 1) / 2;
        return 0;
    }
    vector<vector<int>> graph(n);
    int a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        if (a != -1) {
            graph[i].push_back(a - 1);
            graph[a - 1].push_back(i);
        }
    }
    vector<int> help(0);
    pereb(graph, help, 0);
    cout << ans;
    return 0;
}
