#include <iostream>
#include <vector>

using namespace std;

vector<vector<int>> ar;
vector<int> used;
vector<int> di;
vector<int> fup;
int cnt;

void dfs(int v, int p, int depth)
{
    used[v] = 1;
    di[v] = depth;
    fup[v] = di[v];
    for (int i = 0; i < ar[v].size(); ++i)
    {
        if (used[ar[v][i]] == 1 && ar[v][i] != p)
            fup[v] = min(fup[v],di[ar[v][i]]);
        else if (used[ar[v][i]] == 0)
        {
            dfs(ar[v][i],v,depth + 1);
            fup[v] = min(fup[v],fup[ar[v][i]]);
            if (fup[ar[v][i]] > di[v])
            {
                cnt += 1;
            }
        }
    }
    return;
}

int main()
{
    int q = 0;
    int n,ans3 = 0,ans = 0;
    cnt = 0;
    cin >> n;
    ar = vector<vector<int>>(n,vector<int>());
    used = vector<int>(n,0);
    di = vector<int>(n,0);
    fup = vector<int>(n,0);
    for (int i = 0; i < n; ++i)
    {
        int a;
        cin >> a;
        if (a > i)
            q = 1;
        if (a != -1){
            ar[i].push_back(a - 1);
            ar[a - 1].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        if (used[i] == 0)
            dfs(i,-1,0);
    }
    cout << cnt;
    return 0;
}
