#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


const int M = (int)1e9 + 7;
const int MAXN = 5001;


int dp[2][MAXN][MAXN], pref[2][MAXN][MAXN];


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    dp[0][k][k] = dp[1][k][k] = 1;
    pref[0][k][k] = pref[1][k][k] = 1;

    for (int cs = k + 1; cs <= n; ++cs) {
        for (int lt = 1; lt <= cs; ++lt) {
            dp[1][cs][lt] = pref[0][cs - lt][lt - 1];
            dp[0][cs][lt] = (pref[1][cs - lt][cs - lt] - pref[1][cs - lt][lt] + M) % M;
        }

        for (int c = 0; c < 2; ++c) {
            for (int lt = 1; lt <= cs; ++lt) {
                pref[c][cs][lt] = (pref[c][cs][lt - 1] + dp[c][cs][lt]) % M;
            }
        }
    }

    int answ = (pref[0][n][n] + pref[1][n][n]) % M;

    answ = (answ - dp[0][n][n] + M) % M;

    cout << answ;

    return 0;
}