#include <iostream>
#include <vector>

using namespace std;

int MOD = 1e9 + 7;

int main() {
    int n, k;

    cin >> n >> k;

    if (n == k)
        cout << 1 << endl;
    else {
        vector<vector<vector<vector<long long>>>> arr;
        arr.resize(2);
        for (int a = 0; a < 2; ++a) {
            arr[a].resize(n + 2);
            for (int i = 0; i <= n; ++i) {
                arr[a][i].resize(n + 1);
                for (int j = 0; j <= n; ++j) {
                    arr[a][i][j].resize(n + 1);
                }
            }
        }

        arr[0][0][k][k] = 1;
        arr[1][0][k][k] = 1;

        for (int b = 0; b < 2; ++b) {
            bool cur = b;
            for (int l = 0; l <= n; ++l) {
                for (int s = 1; s < n; ++s) {
                    for (int last = 1; last < n; ++last) {
                        if (cur) {
                            for (int new_last = last + 1; s + new_last <= n; ++new_last)
                                arr[!cur][l + 1][s + new_last][new_last] =
                                        (arr[cur][l][s][last] + arr[!cur][l + 1][s + new_last][new_last]) % MOD;
                        } else {
                            for (int new_last = last - 1; new_last > 0 && s + new_last <= n; ++new_last)
                                arr[!cur][l + 1][s + new_last][new_last] =
                                        (arr[cur][l][s][last] + arr[!cur][l + 1][s + new_last][new_last]) % MOD;
                        }
                    }
                }
                cur = !cur;
            }
        }

        long long ans = 0;
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= n; ++j) {
                ans = (ans + arr[0][i][n][j] + arr[1][i][n][j]) % MOD;
                //cout << i << " " << j << " " << arr[0][i][n][j] << " " << arr[1][i][n][j] << endl;
            }
        }

        cout << ans << endl;
    }

    return 0;
}