#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <set>
#include <map>
#define MAXN 2000000
#define int long long

using namespace std;

const int INF = 1000000000;
int n, ans, m, a[MAXN], b[MAXN], nxt[MAXN], mp[MAXN], pos[MAXN], num[MAXN], i, j, k;
set<pair<int, int> > s;
vector <int> answer;
map<int, int> cmp;
int f[MAXN];

void erase1(pair <int, int> x){
    s.erase(x);

    for(int i = cmp[x.first]; i < cmp.size(); i |= i + 1)
        f[i]--;
}

void insert1(pair <int, int> x, bool flag = 0){
    s.insert(x);

    for(int i = cmp[x.first]; i < cmp.size(); i |= i + 1)
        f[i]++;

    int ind = 0;
    for(int i = cmp[x.first]; i >= 0; i = (i & (i + 1)) - 1)
        ind += f[i];

    if(flag == 0)
        answer.push_back(ind);
}

main(){
   // freopen("input.txt", "r" , stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();

    scanf("%d%d", &n, &m);

    for(i = 0; i < m; i++)
        scanf("%d", &a[i]), a[i]--;

    for(i = 0; i < n; i++)
        scanf("%d", &b[i]), pos[--b[i]] = i;

    for(i = 0; i < n; i++)
        mp[i] = m;

    for(i = m - 1; i >= 0; i--){
        nxt[i] = mp[a[i]];
        mp[a[i]] = i;
        cmp[INF * (i + 1)] = 1;
    }

    cmp[INF * (m + 1)] = 1;

    int mx = 0;
    for(i = 0; i < m; i++){
        int cnt = pos[a[i]] - mx;

        if(mx <= pos[a[i]]){
            for(j = mx; j <= pos[a[i]]; j++){
                cmp[INF * (i + 1) - cnt] = 1;
                cnt--;
            }

            mx = pos[a[i]] + 1;
        }
    }

    map <int, int > :: iterator it2 = cmp.begin();

    int cnt = 0;
    while(it2 != cmp.end()){
        it2 -> second = cnt++;
        ++it2;
    }

    mx = 0;
    for(i = 0; i < m; i++){
        int cnt = pos[a[i]] - mx;

        if(mx <= pos[a[i]]){
            for(j = mx; j <= pos[a[i]]; j++){
                insert1({INF * (i + 1) - cnt, b[j]}, 1);
                cnt--;
            }

            mx = pos[a[i]] + 1;
        }
    }


    for(i = 0; i < n; i++)
        num[i] = mp[i];

    for(i = 0; i < m; i++){
        set<pair<int, int> > :: iterator it = s.begin();
        vector <pair<int, int> > res;
        vector <pair<int, int> > del;

        while(it != s.end()){
            int v = it -> second;

            //cout << it -> first << " " << it -> second + 1 << endl;
            if(v == a[i]){
                del.push_back(*it);
                break;
            }
            else{
                del.push_back(*it);
                res.push_back({(mp[v] + 1) * INF, v});
            }
            ++it;
        }

        //cout << "*************" << endl;

        for(j = 0; j < res.size(); j++){
            erase1(del[j]);
            insert1(res[j]);
        }

        erase1(del.back());
        ans += res.size() + 1;
        insert1({(nxt[num[a[i]]] + 1) * INF, a[i]});
        //cout << nxt[num[a[i]]] << endl;
         num[a[i]] = nxt[num[a[i]]];

    }

    printf("%d\n", answer.size());

    for(i = 0; i < answer.size(); i++)
        printf("%d ", answer[i]);
    return 0;
}


//v19.893.790
//Y4osXsHr



















