//v19.893.790
//Y4osXsHr

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <set>
#include <map>
#define MAXN 300005
#define int long long

using namespace std;

int n, ans, i, j, used[MAXN], p[MAXN], dp[MAXN][2][2], d[MAXN][2], f[MAXN];
bool flag[MAXN];
vector<int> g[MAXN], g1[MAXN], cycles[MAXN];

void dfs(int v, int t){
    int i, to;

    used[v] = 1;

    if(g[v].size() == 0)
        cycles[t].push_back(v);

    for(i = 0; i < g[v].size(); i++){
        to = g[v][i];

        if(!used[to]){
            p[to] = v;
            dfs(to, t);
        }
        else{
            if(used[to] == 1){
                int u = v;

                do{
                    cycles[t].push_back(u);
                    flag[u] = true;
                    u = p[u];
                    if(u == to){
                        cycles[t].push_back(u);
                        flag[u] = true;
                    }
                }while(u != to);


            }
        }
    }

    used[v] = 2;
}

void dfs2(int v){
    int i, to, sum = 0, sum2 = 0;
   // vector <int> c;

    for(i = 0; i < g1[v].size(); i++){
        int to = g1[v][i];

        if(flag[to])
            continue;

        dfs2(to);

        sum += d[to][0];
        sum2 += max(d[to][0], d[to][1]);
    }

    d[v][0] = sum2; d[v][1] = sum + 1;
}


main(){
    //freopen("input.txt", "r" , stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();

    cin >> n;

    for(i = 0; i < n; i++){
        cin >> f[i]; f[i]--;
        if(f[i] != -2){
            g[i].push_back(f[i]);
            g1[f[i]].push_back(i);
        }
    }

    vector <int> c;
    for(i = 0; i < n; i++){
        if(!used[i]){
            dfs(i, c.size());
            c.push_back(i);
        }
    }

    for(i = 0; i < c.size(); i++){
        if(cycles[i].size() == 0)
            continue;

        for(j = 0; j < cycles[i].size(); j++)
            dp[j][0][0] = dp[j][1][0] = dp[j][0][1] = dp[j][1][1] = 0;

        for(j = 0; j < cycles[i].size(); j++){
            int v = cycles[i][j];

            dfs2(v);

                  //      cout << v << " " << d[v][1] << " " << d[v][0] << endl;

            if(j == 0){
                dp[j][0][0] = d[v][0];
                dp[j][1][1] = d[v][1];
            }
            else{
                dp[j][0][1] = max(dp[j][0][1], dp[j - 1][0][0] + d[v][1]);
                dp[j][0][0] = max(dp[j][0][0], max(dp[j - 1][0][0], dp[j - 1][0][1] + d[v][0]));

                dp[j][1][1] = max(dp[j][1][1], dp[j - 1][1][0] + d[v][1]);
                dp[j][1][0] = max(dp[j][1][0], max(dp[j - 1][1][0], dp[j - 1][1][1] + d[v][0]));

                //cout << dp[j][0][0] << " " << dp[j][1][0] << " " << dp[j][0][1] << " " << dp[j][1][1] << endl;
            }
        }

        ans += max(dp[cycles[i].size() - 1][1][0], max(dp[cycles[i].size() - 1][0][0], dp[cycles[i].size() - 1][0][1]));
    }

    cout << ans;

    return 0;
}



