#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

vector < vector <long long int> > dp1;
vector < vector <long long int> > dp2;

int main(){


    long long int mod = 1e9 + 7;
    long long int n, k;
    cin >> n >> k;

    //dp.resize(n + 1, vector < vector <long long int>> (n + 1, vector <long long int> (2)));

    dp1.resize(n + 1, vector <long long int> (n + 1));
    dp2.resize(n + 1, vector <long long int> (n + 1));


    for (int i = k; i <= n; i++){
        dp1[k][i] = dp2[k][i] = 1;
    }

    for (int j = k + 1; j <= n; j++){

        for (int i = 1; i <= n; i++){
            if (i < j){

                dp1[j][i] = (dp2[j - i][i - 1] + dp1[j][i - 1]) % mod;//
                dp2[j][i] = (dp1[j - i][n] - dp1[j - i][i] + dp2[j][i - 1] + mod) % mod;//dp[j - i][n][1] - dp[j - i][i][1], dp[j - i][i - 1][0]

            }else{

                dp1[j][i] = dp1[j][i - 1];
                dp2[j][i] = dp2[j][i - 1];

            }
        }

    }
    if (k != n)
        cout << (dp1[n][n] + dp2[n][n]) % mod;
    else
        cout << 1;

    /*cout << '\n';

    for (int i = 0; i <= n; i++){

        for (int j = 0; j <= n; j++){

            cout << dp[i][j][0] << ", " << dp[i][j][1] << "   ";

        }

        cout << '\n';

    }*/

    return 0;
}
