#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define sh cin.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0); cout.tie(0);
using namespace std;
#define int long long

const int MAXN = 3e5 + 228;

vector<int> g[MAXN];
int color[MAXN];

void dfs(int v)
{
    bool c1 = 1, c2 = 1;
    for (auto to : g[v])
    {
        if (color[to] == 1)
            c1 = 0;
        if (color[to] == 2)
            c2 = 0;
    }
    if (c1)
        color[v] = 1;
    else if (c2)
        color[v] = 2;
    else
        color[v] = 3;
    for (auto to : g[v])
    {
        if (color[to] != 0)
            continue;
        dfs(to);
    }
}

signed main()
{
    sh;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int aa;
        cin >> aa;
        if (aa == -1)
            continue;
        g[i].pb(aa - 1);
        g[aa - 1].pb(i);
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            color[j] = 0;
        }
        dfs(i);
        for (int j = 0; j < n; j++)
        {
            if (color[j] == 0)
                dfs(j);
        }
        int now = 0;
        for (int j = 0; j < n; j++)
        {
            if (color[j] == 1)
                now++;
        }
        ans = max(ans, now);
    }
    cout << ans << endl;
}
