#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define sh cin.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0); cout.tie(0);
using namespace std;
//#define int long long

const int MAXN = 3e5 + 228;

vector<int> g[MAXN];
bool con[22][22];
int color[MAXN];

void dfs(int v)
{
    bool c1 = 1, c2 = 1;
    for (auto to : g[v])
    {
        if (color[to] == 1)
            c1 = 0;
        if (color[to] == 2)
            c2 = 0;
    }
    if (c1)
        color[v] = 1;
    else if (c2)
        color[v] = 2;
    else
        color[v] = 3;
    for (auto to : g[v])
    {
        if (color[to] != 0)
            continue;
        dfs(to);
    }
}

    int n;
string get(int mask)
{
    string res;
    while (mask != 0)
    {
        res += (mask % 2);
        mask /= 2;
    }
    char zero = 0;
    while (res.size() < n)
    {
        res += zero;
    }
    return res;
}

int dp[MAXN][2];
bool used[MAXN];
void rec(int v, int p)
{
    used[v] = 1;
    dp[v][0] = 1;
    for (auto to : g[v])
    {
        if (to == p)
            continue;

        if (used[to])
        {
            dp[v][0] -= dp[to][0];
            //dp[v][1] -= max(dp[to][1], dp[to][0]);
            continue;
        }
        rec(to, v);
        dp[v][0] += dp[to][1];
        dp[v][1] += max(dp[to][1], dp[to][0]);
    }
    //cout << v << ' ' << dp[v][0] << ' ' << dp[v][1] << endl;
}

void solve_t()
{
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (used[i])
            continue;
        rec(i, -1);
        ans += max(dp[i][0], dp[i][1]);
    }
    /*for (int i = 0; i < 2; i++)
    {
        for (int j = 0; j < n; j++)
        {
            color[j] = 0;
        }
        int now = 0;
        dfs(i);
        for (int j = 0; j < n; j++)
        {
            if (color[j] == 1)
                now++;
        }
        ans = max(ans, now);
    }*/
    cout << ans << endl;
}

void slow()
{
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        string m = get(mask);
        bool ch = 1;
        int cnt = 0;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (m[i] == 1 && m[j] == 1)
                {
                    if (con[i][j])
                        ch = 0;
                }
            }
        }
        if (!ch)
            continue;
        for (int i = 0; i < n; i++)
        {
            if (m[i] == 1)
                cnt++;
        }
        ans = max(ans, cnt);
    }
    cout << ans << endl;
}

signed main()
{
    sh;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int aa;
        cin >> aa;
        if (aa == -1)
            continue;
        g[i].pb(aa - 1);
        g[aa - 1].pb(i);
        if (n  < 22)
            con[i][aa - 1] = con[aa - 1][i] = 1;
    }
    if (n < 1)
        slow();
    else
    {
        solve_t();
    }
}
