#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define pb push_back
#define all(c) c.begin(), c.end()

/*vector<int> a;
vector<int> tree;

void build(int v, int l, int r) {
	if (l == r - 1) {
		tree[v] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m, r);
	tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int get(int v, int l, int r, int tl, int tr) {
	if (tl <= l && r <= tr) {
		return tree[v];
	}
	if (tl >= r && tr <= l) {
		return 0;
	}
	int m = (l + r) / 2;
	return get(2 * v, l, m, tl, tr) + get(2 * v + 1, m, r, tl, tr);
}

void update(int v, int l, int r, int u, int val) {
	if (l == r - 1) {
		tree[v] = val;
		return;
	}
	if (r >= u || l < u) {
		return;
	}
	int m = (l + r) / 2;
	if (u >= m) {
		update(2 * v + 1, m, r, u, val);
	}
	else {
		update(2 * v, l, m, u, val);
	}
	tree[v] = tree[2 * v] + tree[2 * v + 1];
}
*/
int main() {
	ll k;
	cin >> k;
	if (k >= 0 && sqrt(k) * sqrt(k) == k) {
		cout << 0;
		return 0;
	}
	bool flag = false;
	if (k < 0) {
		k = -k;
		flag = true;
	}
	for (ll d = 1; d <= sqrt(k); d++) {
		if (k % d == 0) {
			//c - i = d, c + i = k / d
			if (d % 2 != (k / d) % 2) {
				continue;
			}
			ll c = (k / d + d) / 2;
			ll i = (k / d - d) / 2;
			if (!flag) {
				cout << c;
			}
			else {
				cout << i;
			}
			//system("pause");
			return 0;
		}
	}
	cout << "none";
	//system("pause");
	return 0;
}