#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
#define pb push_back
#define all(c) c.begin(), c.end()

/*vector<ll> a;
vector<ll> tree;

void build(ll v, ll l, ll r) {
	if (l == r - 1) {
		tree[v] = a[l];
		return;
	}
	ll m = (l + r) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m, r);
	tree[v] = tree[2 * v] + tree[2 * v + 1];
}

ll get(ll v, ll l, ll r, ll tl, ll tr) {
	if (tl <= l && r <= tr) {
		return tree[v];
	}
	if (tl >= r && tr <= l) {
		return 0;
	}
	ll m = (l + r) / 2;
	return get(2 * v, l, m, tl, tr) + get(2 * v + 1, m, r, tl, tr);
}

void update(ll v, ll l, ll r, ll u, ll val) {
	if (l == r - 1) {
		tree[v] = val;
		return;
	}
	if (r >= u || l < u) {
		return;
	}
	ll m = (l + r) / 2;
	if (u >= m) {
		update(2 * v + 1, m, r, u, val);
	}
	else {
		update(2 * v, l, m, u, val);
	}
	tree[v] = tree[2 * v] + tree[2 * v + 1];
}
*/
int main() {
	set<int> ans;
	ll k;
	cin >> k;
	if (k >= 0 && sqrt(k) * sqrt(k) == k) {
		cout << 0;
		return 0;
	}
	if (k > 0 && k % 2 == 1) {
		cout << (k + 1) / 2;
		return 0;
	}
	else if (k < 0 && abs(k) % 2 == 1) {
		cout << (abs(k) - 1) / 2;
		return 0;
	}
	else if (k > 0) {
		for (ll d = 2; d <= sqrt(k); d++) {
			//cout << d << endl;
			if (k % d == 0 && (d + k / d) % 2 == 0) {
				ll c = (d + k / d) / 2;
				ll i = (-d + k / d) / 2;
				//cout << c;
				ans.insert(c);
			}
		}
		cout << *ans.begin();
		//system("pause");
		return 0;
	}
	else if (k < 0) {
		k = -k;
		for (ll d = 2; d <= sqrt(k); d++) {
			if (k % d == 0 && (d + k / d) % 2 == 0) {
				ll c = (d + k / d) / 2;
				ll i = (-d + k / d) / 2;
				ans.insert(i);
			}
		}
		cout << *ans.begin();
		//system("pause");
		return 0;
	}
	cout << "none";
	//system("pause");
	return 0;
}