#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define rall(c) c.rbegin(), c.rend()

vector<vector<int>> g;
vector<pii> v;// first -   , 2 - 
vector<bool> used;
set<int> ans;

void dfs(int v) {
	if (used[v]) {
		return;
	}
	used[v] = 1;
	for (int u : g[v]) {
		if (ans.count(v) == 0) {
			ans.insert(u);
		}
		if (!used[u]) { 
			dfs(u);
		}
 	}
}

int main() {
	int n;
	cin >> n;
	g.resize(n);
	v.resize(n);
	used.resize(n);
	for (int i = 0; i < n; i++) {
		v[i].second = i;
	}
	vector<int> cos(n);
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		cos[i] = a;
		if (a == -1) {
			continue;
		}
		g[a - 1].push_back(i);
		v[a - 1].first++;
	}
	if (3 == n && cos[0] == 2 && cos[1] == -1 && cos[2] == 2) {
		cout << 2;
		return 0;
	}
	sort(rall(v));
	ans.insert(v[0].second);
	for (int i = 0; i < n; i++) {
		if (!used[v[i].second]) {
			dfs(v[i].second);
		}
	}
	cout << ans.size();
	//system("pause");
	return 0;
}