#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define rall(c) c.rbegin(), c.rend()

vector<set<int>> g;
vector<bool> used;
set<int> ans;
vector<int> d;

void dfs(int v) {
	if (used[v]) {
		return;
	}
	used[v] = 1;
	for (int u : g[v]) {
		if (ans.count(v) == 0 && g[u].size() <= 1) {
			ans.insert(u);
		}
		if (!used[u]) { 
			dfs(u);
		}
 	}
}

set<int> t;
void rec(vector<int> m, int k) {
	if (k == m.size()) {
		int a = 0;
		for (int i : m) {
			a += i;
		}
		t.insert(-a);
		return;
	}
	bool zbs = true;
	for (int i = 0; i < k; i++) {
		if (m[i] && (g[k].count(i) || g[i].count(k))) {
			zbs = false;
		}
	}
	if (zbs) {
		m[k] = 1;
		rec(m, k + 1);
	}
	m[k] = 0;
	rec(m, k + 1);
}

int main() {
	int n;
	cin >> n;
	g.resize(n);
	used.resize(n);
	vector<int> beg;
	bool xxx = true;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		if (a == -1) {
			if (i != 0) {
				xxx = false;
			}
			continue;
		}
		if (a != i) {
			xxx = false;
		}
		g[a - 1].insert(i);
	}
	
	if (!xxx) {
		vector<int> m(n);
		rec(m, 0);
		cout << -(*t.begin());
		//system("pause");
		return 0;
	}
	ans.insert(0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	cout << ans.size();
	//system("pause");
	return 0;
}