#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

void run() {
	int n;
	cin >> n;
	vector<int> v(n);
	cin >> v;
	f(i, n) {
		v[i]--;
	}
	int rez = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		bool fail = false;
		f(i, n) {
			if ((1 << i) & mask) {
				if (v[i] == -2) continue;
				if ((1 << v[i]) & mask) {
					fail = true;
					break;
				}
			}
		}
		if (!fail) {
			rez = max(rez, __builtin_popcount(mask));
		}
	}
	cout << rez << endl;
}