#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <math.h>
#include <fstream>
#include <iomanip>

#define ll long long
#define ull unsigned long long
#define ld long double
#define u_map unordered_map
#define mp make_pair
#define pb push_back

using namespace std;

vector<int> Arr, Numb, Q, used, Ans;
int n, m;

int make(int pos, int card) {
	int i = pos + 1, max_pos = -1;
	while (i < m && Arr[pos] != Arr[i]) {
		if (Numb[Arr[i]] > max_pos)
			max_pos = Numb[Arr[i]];
		i++;
	}
	if (pos == -1)
		return n - 1;
	return max_pos;
}

int main() {
	ios_base::sync_with_stdio(0);
	int i;
	cin >> n >> m;
	Arr = vector<int>(m);
	Numb = vector<int>(n + 1, -1);
	Q = vector<int>(n);
	//used = vector<int>(m, 0);
	Ans = vector<int>(0);
	for (i = 0; i < m; i++)
		cin >> Arr[i];
	for (i = 0; i < n; i++) {
		//int temp;
		//cin >> temp;
		//Q[i] = temp - 1;
		cin >> Q[i];
		Numb[Q[i]] = i;
	}
	for (i = 0; i < m; i++) {
		while (Arr[i] != Q[0]) {
			int pos = make(i, Q[0]);
			int temp = Q[0];
			for (int j = 0; j <= pos; j++) {
				if (j < n - 1) {
					Q[j] = Q[j + 1];
					Numb[Q[j]] = j;
				}
			}
			Q[pos] = temp;
			Numb[temp] = pos;
			Ans.pb(pos);
		}
		int pos = make(i, Q[0]);
		int temp = Q[0];
		for (int j = 0; j <= pos; j++) {
			if (j < n - 1) {
				Q[j] = Q[j + 1];
				Numb[Q[j]] = j;
			}
		}
		Q[pos] = temp;
		Numb[temp] = pos;
		Ans.pb(pos);
	}
	cout << Ans.size() << '\n';
	for (i = 0; i < Ans.size(); i++)
		cout << Ans[i] + 1 << ' ';
	return 0;
}
