#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228

const int MOD = 1000 * 1000 * 1000 + 7;

const int maxn = 300 * 1000 + 228;

int n, m, k;

int C[100][100];

int left[maxn];

void add(int &x, int y) {
	x += y;
	if (x >= MOD) x -= MOD;
}

void CNK() {
	for (int i = 0; i < 100; ++i) {
		C[i][0] = 1;
	}
	for (int i = 1; i < 100; ++i) {
		for (int j = 1; j < 100; ++j) {
			C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % MOD;
		}
	}
}

int dp[maxn][25];

void solve0() {
	for (int k = 0; k < 25; ++k) {
		dp[1][k] = 1;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < 24; ++j) {
			for (int l = 0; l <= j; ++l) {
				add(dp[i][j], (dp[i - 1][l] * C[j][l]) % MOD);
			}
		}
	}
	int res = 0;
	for (int last = 0; last <= k; ++last) {
		add(res, dp[n][__builtin_popcount(last)]);
	}
	cout << res << '\n';
}

int d[100][100][100];

void solve1() {
	for (int i = 0; i <= k; ++i) {
		d[1][i][1] = 1;
	}
	for (int i = 1; i < n; ++i) {
		for (int mask = 0; mask <= k; ++mask) {
			for (int last = 1; last <= i; ++last) {
				for (int kek = mask; kek <= k; kek = (kek + 1) | mask) {
					if (kek == mask && left[i + 1] >= last) continue;
					if (kek == mask) {
						add(d[i + 1][kek][last], d[i][mask][last]);
					} else {
						add(d[i + 1][kek][i + 1], d[i][mask][last]);
					}
				}
			}
		}
	}
	int res = 0;
	for (int x = 0; x <= k; ++x) {
		for (int i = 1; i <= n; ++i) {
			add(res, d[n][x][i]);
			// cout << "d[n][" << x << "][" << i << "]=" << d[n][x][i] << endl;
		}
	}
	cout << res << '\n';
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> k;
	CNK();
	if (m == 0) {
		solve0();
	} else {
		for (int i = 0; i < m; ++i) {
			int li, ri;
			cin >> li >> ri;
			uax(left[ri], li);
		}
		solve1();
	}
	return 0;
}