
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int maxn = 300 * 1000 + 228;

vector<int> g[maxn];
bool used[maxn], bip = 1;
int dp[maxn][2];

void DFS(int v, int par = -1) {
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (int to : g[v]) {
		if (to != par) {
			DFS(to, v);
			dp[v][0] += max(dp[to][0], dp[to][1]);
			dp[v][1] += dp[to][0];
		}
	}
}

bool in[21];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector< pair<int, int> > heh;
	for (int i = 1; i <= n; ++i) {
		int ai;
		cin >> ai;
		if (ai != -1) {
			heh.push_back({i, ai});
			g[i].push_back(ai);
			g[ai].push_back(i);
		}
	}
	if (n <= 20) {
		int res = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			memset(in, 0, sizeof(in));
			for (int i = 0; i < n; ++i) {
				if ((mask >> i) & 1) {
					in[i + 1] = 1;
				}
			}
			bool good = 1;
			for (auto p : heh) {
				if (in[p.first] && in[p.second]) {
					good = 0;
					break;
				}
			}
			if (good) {
				uax(res, __builtin_popcount(mask));
			}
		}
		cout << res << '\n';
		return 0;
	}
	int res = 0;
	for (int i = 1; i <= n; ++i) {
		if (dp[i][1] == 0) {
			DFS(i);
			res += max(dp[i][0], dp[i][1]);
		}
	}
	cout << res << endl;
	return 0;
}