#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int maxn = 200 * 1000 + 228;

int n, k;
int a[maxn][7];
bool ok[500][500];

bool dead[maxn];

void gen(int i, vector< pair<int, int> > res) {
	if (i == n / 2) {
		cout << "YES\n";
		for (auto P : res) {
			cout << P.first << " " << P.second << "\n";
		}
		exit(0);
	}
	for (int a = 1; a <= n; ++a) {
		if (!dead[a]) {
			for (int b = a + 1; b <= n; ++b) {
				if (!dead[b] && ok[a][b]) {
					dead[a] = dead[b] = 1;
					res.push_back({a, b});
					gen(i + 1, res);
					res.pop_back();
					dead[a] = dead[b] = 0;
				}
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			int l = min(a[i][0], a[j][0]);
			int r = max(a[i][0], a[j][0]);
			for (int t = 0; t < k; ++t) {
				uax(l, min(a[i][t], a[j][t]));
				uin(r, max(a[i][t], a[j][t]));
			}
			if (l <= r) {
				ok[i][j] = ok[j][i] = 1;
			}
		}
	}
	vector< pair<int, int> > heh;
	gen(0, heh);
	cout << "NO\n";
	return 0;
}
