#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int n = 0;

int getTrains(int m, int first, bool up, int num, int last)
{
	if (num < m)
	{
		int sum = 0;
		if (up)
		{
			for (int k = last + 1; k <= (n - first); k++)
				sum += getTrains(m, first + k, !up, num + 1, k);
		}
		else
		{
			for (int k = last - 1; k > 0; k--)
				sum +=  getTrains(m, first + k, !up, num + 1, k);
		}
		return sum;
	}
	else
		if (first == n) return 1;
	return 0;
}

int main()
{
	int k = 0, m = 0;
	cin >> n >> k;
	if (n == k) cout << 1 << endl;
	else
	{
		long  sum = 0;
		for (int i = 0; i <= n - k + 1; i++)
		{
			sum += getTrains(i, k, true, 1, k);
			sum += getTrains(i, k, false, 1, k);
		}
		cout << sum % 1000000007 << endl;
	}
	
	return 0;
}