#include <iostream>
#include <vector>
#include <set>

using namespace std;

struct person
{
	vector<int> enemies;
	int index = 0;
};

int compareFunc(const void* val1, const void* val2)
{
	return (((person*)val1)->enemies.size() - ((person*)val2)->enemies.size());
}

int main()
{
	int n = 0, num = 0;
	cin >> n;
	vector<person> people(n);
	for (int i = 0; i < n; i++)
	{
		cin >> num;
		num--;
		if (num >= 0)
		{
			people[i].enemies.push_back(num);
			people[num].enemies.push_back(i);
		}	
	}

	qsort(&(people[0]), people.size(), sizeof(people[0]), compareFunc);
		
	int count = 0;
	set<int> left;
	for (int i = n - 1; i >= 0; i--)
	{
		if (left.count(i) == 0)
		{
			count++;
			for (int j = 0; j < people[i].enemies.size(); j++)
				left.insert(people[i].enemies[j]);
		}
	}

	cout << count << endl;
	//system("pause");
	return 0;
}