#include <iostream>
#include <vector>
#include <set>
#include <utility>

using namespace std;

struct thing
{
	vector<int> parameters;
	int index = 0;
};

int compareFunc(const void* val1, const void* val2)
{
	return (((thing*)val1)->parameters[0] - ((thing*)val2)->parameters[0]);
}

int main()
{
	int n = 0, k = 0;
	cin >> n >> k;
	vector<thing> things(n);
	for (int i = 0; i < n; i++)
	{
		things[i].parameters.resize(k);
		things[i].index = i;
		for (int j = 0; j < k; j++)
			cin >> things[i].parameters[j];
	}

	qsort(&(things[0]), things.size(), sizeof(things[0]), compareFunc);

	if (k == 1)
	{
		cout << "YES" << endl;
		for (int i = 0; i < n / 2; i++)
			cout << things[i].index + 1 << " " << things[n - i - 1].index + 1 << endl;
	}

	//system("pause");
	return 0;
}

