#include <iostream>
#include <vector>
#include <set>
#include <utility>

using namespace std;

struct thing
{
	vector<int> parameters;
	int index = 0;
	int compareIndex = 0;
};

int compareFunc(const void* val1, const void* val2)
{
	return (((thing*)val1)->parameters[((thing*)val1)->compareIndex] - ((thing*)val2)->parameters[((thing*)val2)->compareIndex]);
}

bool difGroups(vector<int> a, vector<int> b)
{
	for (int i = 0; i < a.size(); i++)
		if (a[i] == b[i]) return false;
	return true;
}

int main()
{
	int n = 0, k = 0;
	cin >> n >> k;
	vector<thing> things(n);
	vector<vector<int>> positions(n);
	for (int i = 0; i < n; i++)
	{
		things[i].parameters.resize(k);
		things[i].index = i;
		for (int j = 0; j < k; j++)
			cin >> things[i].parameters[j];
	}

	

	if (k == 1)
	{
		qsort(&(things[0]), things.size(), sizeof(things[0]), compareFunc);
		cout << "YES" << endl;
		for (int i = 0; i < n / 2; i++)
			cout << things[i].index + 1 << " " << things[n - i - 1].index + 1 << endl;
	}
	else
	{
		for (int i = 0; i < n; i++)
			positions[i].resize(k);
		for (int i = 0; i < k; i++)
		{
			for (int j = 0; j < n; j++)
				things[j].compareIndex = i;
			qsort(&(things[0]), things.size(), sizeof(things[0]), compareFunc);
			for (int j = 0; j < n / 2; j++)
				positions[things[j].index][i] = 1;
		}
		bool found = false;
		vector<pair<int, int>> pairs;
		set<int> indexes;
		for (int i = 0; i < n; i++)
		{
			if (indexes.count(i) == 0)
			{
				found = false;
				for (int j = i + 1; j < n; j++)
				{
					if (difGroups(positions[i], positions[j]) && indexes.count(j) == 0)
					{
						pairs.push_back(pair<int, int>(i, j));
						found = true;
						indexes.insert(j);
						indexes.insert(i);
						break;
					}
				}
				if (!found) break;
			}
		}

		if (found)
		{
			cout << "YES" << endl;
			for (int i = 0; i < n / 2; i++)
				cout << pairs[i].first + 1 << " " << pairs[i].second + 1 << endl;
		}
		else
			cout << "NO" << endl;
	}

	//system("pause");
	return 0;
}

