#include <iostream>
#include <cmath>

#ifndef LOCAL_D
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif


using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll k;
    cin >> k;
    for (int i = 0; i < 100000000; i++) {
        if (k + i * i < 0)
            continue;
        int s = sqrt(k + i * i);
        if (s * s == k + i * i) {
            cout << s;
            return 0;
        }
    }
    cout << "none";
    return 0;
}