#include <iostream>

#ifndef LOCAL_D
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif


using namespace std;

const int MOD = 1e9 + 7;

typedef long long ll;

int rec(int last, int depth, int n, bool less) {
    if (depth == 0)
        return 1;
    int ans = 0;
    if (less) {
        for (int i = min(last - 1, depth); i > 0; i--) {
            ans += rec(i, depth - i, n, 0);
            ans %= MOD;
        }
    } else {
        for (int i = min(last + 1, depth); i < n; i++) {
            ans += rec(i, depth - i, n, 1);
            ans %= MOD;
        }
    }
    return ans % MOD;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    if (n == k)
        cout << 1;
    else
        cout << rec(k, n - k, n, 0) + rec(k, n - k, n, 1);
    return 0;
}