#include <iostream>
#include <vector>

/*#ifndef LOCAL_D
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif*/


using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(n + 1, vector<ll>(2, 0)));
    dp[k][k][0] = 1;
    dp[k][k][1] = 1;
    for (int i = k + 1; i <= n; i++) {
        for (int j = 1; j <= i; j++) {
            for (int c = 0; c < j; c++) {
                dp[i][j][0] += dp[i - j][c][1];
                dp[i][j][0] %= MOD;
            }
            for (int c = j + 1; c <= n; c++) {
                dp[i][j][1] += dp[i - j][c][0];
                dp[i][j][1] %= MOD;
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans += dp[n][i][0] % MOD + dp[n][i][1] % MOD;
        ans %= MOD;
    }
    cout << ans;
    return 0;
}