#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(c) c.begin(), c.end()
#define sz(c) (int)c.size()

const int MAXN = (int)3e5 + 1, INF = (int)1e9 + 1;
int n, m;
vector<int> a, b;
vector<int> num;
int tree[4 * MAXN];
int add[4 * MAXN];
vector<int> pos[MAXN];
int ind[MAXN];
bool used[MAXN];
void push(int v, int L, int R)
{
    tree[v] += add[v];
    int mid = (L + R) / 2;
    add[2 * v + 1] += add[v];
    add[2 * v + 2] += add[v];
    add[v] = 0;
}
void build(int v, int L, int R)
{
    add[v] = 0;
    if (L == R - 1)
    {
        tree[v] = num[a[L]];
        //cout << v << " " << L << " " << R << " " << num[a[L]] << endl;
        return;
    }
    int mid = (L + R) / 2;
    build(v * 2 + 1, L, mid);
    build(v * 2 + 2, mid, R);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}
void upd(int v, int L, int R, int pos, int val)
{
    if (L == R - 1)
    {
        tree[v] = val;
        add[v] = 0;
        return;
    }
    push(v, L, R);
    int mid = (L + R) / 2;
    if (pos < mid)
    {
        upd(v * 2 + 1, L, mid, pos, val);
    }
    else
    {
        upd(v * 2 + 2, mid, R, pos, val);
    }
    tree[v] = max(tree[2 * v + 1] + add[2 * v + 1], tree[2 * v + 2] + add[2 * v + 2]);
}
int get(int v, int L, int R, int l, int r)
{
    if (l >= r) return 0;
    if (R <= l || r <= L) return -INF;
    push(v, L, R);
    if (L >= l && r >= R)
    {
        return tree[v] + add[v];
    }
    int mid = (L + R) / 2;
    int left = get(v * 2 + 1, L, mid, l, r);
    int right = get(v * 2 + 2, mid, R, l, r);
    return max(left, right);
}
void seg(int v, int L, int R, int l, int r, int val)
{
    if (R <= l || r <= L) return;
    push(v, L, R);
    if (L >= l && r >= R)
    {
        add[v] += val;
        return;
    }
    int mid = (L + R) / 2;
    seg(v * 2 + 1, L, mid, l, r, val);
    seg(v * 2 + 2, mid, R, l, r, val);
    tree[v] = max(tree[2 * v + 1] + add[2 * v + 1], tree[2 * v + 2] + add[2 * v + 2]);
}
vector<int> ans;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    num.assign(n, -1);
    for (int i = 0; i < m; ++i)
    {
        int temp;
        cin >> temp;
        temp--;
        a.pb(temp);
        pos[temp].pb(i);
    }
    for (int i = 0; i < n; ++i)
    {
        int temp;
        cin >> temp;
        temp--;
        b.pb(temp);
        num[temp] = i;
    }
    build(0, 0, m);
    int cnt = 0, first = 0;
    for (int i = 0; i < m; ++i)
    {
        if (get(0, 0, m, i, i + 1) != 0)
        {
            while (b[first] != a[i])
            {
                if (used[b[first]])
                {
                    first++;
                    continue;
                }
                int place = 0;
                if (ind[b[first]] == sz(pos[b[first]]))
                {
                    place = n - 1;
                    seg(0, 0, m, i, m, -1);
                }
                else
                {
                    int nx = pos[b[first]][ind[b[first]]];
                    place = get(0, 0, m, i, nx);
                    upd(0, 0, m, nx, place);
                    seg(0, 0, m, i, nx, -1);
                }
                ans.pb(place + 1);
                ++cnt;
                used[b[first]] = true;
                first++;
            }
        }
        int place = 0;
        ind[a[i]]++;
        if (ind[a[i]] == sz(pos[a[i]]))
        {
            place = n - 1;
            seg(0, 0, m, i, m, -1);
        }
        else
        {
            place = get(0, 0, m, i + 1, pos[a[i]][ind[a[i]]]);
            upd(0, 0, m, pos[a[i]][ind[a[i]]], place);
            seg(0, 0, m, i + 1, pos[a[i]][ind[a[i]]], -1);
        }
        ans.pb(place + 1);
        ++cnt;
        used[a[i]] = true;
    }
    cout << cnt << endl;
    for (int el : ans) cout << el << " ";
    cout << endl;
}
