#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
#define int ll
int n, m, k;
const int MOD = 1e9 + 7;

int bp(int a, int N) {
	if (!N) {
		return 1;
	}
	if (N & 1) {
		return (a * bp(a, N - 1)) % MOD;
	}
	return bp((a * a) % MOD, N >> 1);
}

void init() {

}

void solve() {
	init();
	int ans = 0;
	if (m == 0) {
		int ans = 0;
		int cur = 0;
		for (int i = 63; i >= 0; i--) {
			if (k & ((int)1 << i)) {
				ans += (bp(n, cur) * bp(n + 1, i)) % MOD;
				ans %= MOD;
				cur++;
			}
		}
		ans += bp(n, cur);
		ans %= MOD;
		cout << ans << '\n';
	}
}

signed main() {
	#ifdef DEBUG
		freopen("D.in", "r", stdin);
		freopen("D.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> k) {
		solve();
	}
}