#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
 const int MAXK = 7;

int n, k;
int val[MAXN][MAXK];
int color[MAXN][MAXK];
int mask[MAXN];

vector<int> total[1 << MAXK];

void init() {

}

void solve() {
	init();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cin >> val[i][j];
		}
	}
	for (int i = 0; i < k; i++) {
		vector<pair<int, int>> clr(n);
		for (int j = 0; j < n; j++) {
			clr[j] = make_pair(val[j][i], j);
		}
		sort(clr.begin(), clr.end());
		for (int j = 0; j < n / 2; j++) {
			color[clr[j].second][i] = 1;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			mask[i] += color[i][j] * (1 << j);
		}
		total[mask[i]].push_back(i);
	}
	int all_mask = (1 << k) - 1;
	for (int i = 0; i < (1 << k); i++) {
		if (total[i].size() != total[all_mask ^ i].size()) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (int i = 0; i < (1 << (k - 1)); i++) {
		while (total[i].size()) {
			cout << total[i].back() + 1 << ' ';
			cout << total[i ^ all_mask].back() + 1 << '\n';
			total[i].pop_back();
			total[i ^ all_mask].pop_back();
		}
	}
}

signed main() {
	#ifdef DEBUG
		freopen("D.in", "r", stdin);
		freopen("D.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}