#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt")

#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<int> a;
vector<int> b;
vector<int> ans;
vector<int> t;

void build(int v, int tl, int tr) {
	if (tr == tl + 1)
		t[v] = a[tl];
	else {
		int tm = (tl + tr) / 2;
		build(2 * v + 1, tl, tm);
		build(2 * v + 2, tm, tr);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
}

int sum(int v, int tl, int tr, int L, int R) {
	if (tr <= L || R <= tl)
		return 0;
	else if (L <= tl && tr <= R)
		return t[v];
	else {
		int tm = (tl + tr) / 2;
		return sum(2 * v + 1, tl, tm, L, R) + sum(2 * v + 2, tm, tr, L, R); 
	}
}

void add(int v, int tl, int tr, int i, int x) {
	if (tl == i && tr == i + 1)
		t[v] += x;
	else if (tl > i || tr <= i)
		return;
	else {
		int tm = (tl + tr) / 2;
		add(2 * v + 1, tl, tm, i, x);
		add(2 * v + 2, tm, tr, i, x);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
}

void s3t(int v, int tl, int tr, int i, int x) {
	if (tl == i && tr == i + 1)
		t[v] = x;
	else if (tl > i || tr <= i)
		return;
	else {
		int tm = (tl + tr) / 2;
		add(2 * v + 1, tl, tm, i, x);
		add(2 * v + 2, tm, tr, i, x);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
}

void solve() {
	vector<int> pos(n);
	for (int i = 0; i < n; ++i)
		pos[b[i]] = i;
	for (int i = 0; i < m; ++i) {
		while (b[0] != a[i]) {
			// for (auto q : b) cout << q << ' '; cout << endl;
			int found = 0;
			int maxx = 0;
			int cur = b[0];
			for (int t = i; t < m; ++t) {
				if (a[t] == cur) {
					found = 1;
					break;
				}
				maxx = max(maxx, pos[a[t]]);
			}
			if (!found) maxx = n - 1;
			ans.push_back(maxx + 1);
			for (int t = 0; t < maxx; ++t)
				b[t] = b[t + 1];
			b[maxx] = cur;
			for (int t = 0; t < n; ++t)
				pos[b[t]] = t;
		}
		int found = 0;
		int maxx = 0;
		int cur = b[0];
		for (int t = i + 1; t < m; ++t) {
			if (a[t] == cur) {
				found = 1;
				break;
			}
			maxx = max(maxx, pos[a[t]]);
		}
		if (!found) maxx = n - 1;
		ans.push_back(maxx + 1);
		for (int t = 0; t < maxx; ++t)
			b[t] = b[t + 1];
		b[maxx] = cur;
		for (int t = 0; t < n; ++t)
			pos[b[t]] = t;
	}
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve1() {
	for (int i = 0; i < n; ++i)
		ans.push_back(n);
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve2() {
	for (int i = 0; i < n - 1; ++i)
		ans.push_back(n - i);
	for (int i = 0; i < n; ++i)
		ans.push_back(n);
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve3() {
	int leave = 0;
	vector<int> pos(n);
	for (int i = 0; i < n; ++i)
		pos[b[i]] = i;
	vector<int> posa(n);
	for (int i = 0; i < n; ++i)
		posa[a[i]] = i;
	vector<int> got0(n);
	int cur = -1;
	for (int i = 0; i < n; ++i)
		got0[a[i]] = cur = max(cur, pos[a[i]]);
	// for (int i : pos) cout << i << ' '; cout << endl;
	// for (int i : got0) cout << i << ' '; cout << endl;
	vector<bool> moved(n, false);
	int j = 0, i = 0;
	while (i != n) {
		if (moved[a[i]] || b[j] == a[i]) {
			ans.push_back(n);
			s3t(0, 0, n, a[i], 0);
			if (b[j] == a[i]) j++;
			i++;
		} else {
			int cur = b[j];
			// for (int i = 0; i < n; ++i)
			// 	cout << sum(0, 0, n, i, i + 1) << ' ';
			// cout << endl;
			int ps = got0[cur] - i - sum(0, 0, n, posa[cur], n);
			ans.push_back(ps + 1);
			moved[b[j]] = true;
			add(0, 0, n, posa[cur], 1);
			j++;
		}
		
	}
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	t.resize(4 * n);
	a.resize(m);
	b.resize(n);

	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		b[i]--;
	}

	bool case1 = true;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[i]) {
			case1 = false;
			break;
		}

	bool case2 = true;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[n - i - 1]) {
			case2 = false;
			break;
		}

	bool case3 = true;
	vector<bool> used(n);
	for (int i = 0; i < m; ++i) {
		if (used[a[i]]) {
			case3 = false;
			break;
		}
		used[a[i]] = true;
	}

	if (case1)
		solve1();
	else if (case2)
		solve2();
	else if (case3)
		solve3();
	else
		solve();
}