#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt")

#include <bits/stdc++.h>

using namespace std;

int n;
vector<vector<int>> g;
vector<int> take;
vector<int> netake;
vector<int> pr;
vector<int> cycl;
vector<vector<int>> cycles;

const int INF = 1e9 + 7;

void dfs(int v) {
	take[v] = 1;
	for (int to : g[v]) {
		if (cycl[to] == -1 && to != pr[v]) {
			dfs(to);
			take[v] += netake[to];
			netake[v] += max(take[to], netake[to]);
		}
	}
}

int cnt = 0;
int err = -1;

void find_cycl(int v) {
	cycl[v] = INF;
	if (pr[v] != -2 && cycl[pr[v]] == INF) { cycl[v] = cnt; cycles.push_back(vector<int>()); cycles[cnt].push_back(v); err = pr[v]; return; }
	if (pr[v] == -2) { cycl[v] = -1; return; }
	if (cycl[pr[v]] == -INF) find_cycl(pr[v]);
	if (v != err && err != -1) { cycl[v] = cnt; cycles[cnt].push_back(v); return; }
	if (v == err) { cycl[v] = cnt; cycles[cnt].push_back(v); err = -1; cnt++; return; }
	cycl[v] = -1;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	g.resize(n);
	take.resize(n);
	netake.resize(n);
	pr.resize(n);
	cycl.resize(n, -INF);
	for (int i = 0; i < n; ++i) {
		int x; cin >> x; x--;
		pr[i] = x;
		if (x != -2) g[x].push_back(i);
	}
	for (int i = 0; i < n; ++i)
		if (cycl[i] == -INF)
			find_cycl(i);
	// for (auto v : cycles) {
	// 	for (auto i : v) cout << i << ' ';
	// 	cout << endl;
	// }
	int ans = 0;
	for (int i = 0; i < n; ++i)
		if (cycl[i] != -1 || pr[i] == -2) {
			dfs(i);
			if (pr[i] == -2)
				ans += max(take[i], netake[i]);
		}
	for (auto v : cycles) {
		int cur_ans = 0;
		vector<int> da(v.size());
		vector<int> net(v.size());
		da[(int)v.size() - 1] = -INF;
		net[(int)v.size() - 1] = netake[v[(int)v.size() - 1]];
		for (int i = (int)v.size() - 2; i >= 0; --i) {
			da[i] = take[v[i]] + net[i + 1];
			net[i] = netake[v[i]] + max(da[i + 1], net[i + 1]);
		}
		cur_ans = max(da[0], net[0]);
		da = vector<int>(v.size());
		net = vector<int>(v.size());
		da[(int)v.size() - 1] = take[v[(int)v.size() - 1]];
		net[(int)v.size() - 1] = -INF;
		for (int i = (int)v.size() - 2; i > 0; --i) {
			da[i] = take[v[i]] + net[i + 1];
			net[i] = netake[v[i]] + max(da[i + 1], net[i + 1]);
		}
		da[0] = -INF;
		net[0] = netake[v[0]] + max(da[0 + 1], net[0 + 1]);
		cur_ans = max(cur_ans, max(da[0], net[0]));
		ans += cur_ans;
	}
	cout << ans << endl;
} 