#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt")

#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;
int n, k, x;
vector<vector<int>> a;
vector<set<pair<int, int>>> fr;

void solve1() {
	vector<int> fir;
	for (auto p : fr[0]) {
		fir.push_back(p.second);
		if (fir.size() == n / 2) break;
	}
	vector<int> sec;
	for (int i = 0; i < n; ++i)
		if (!count(fir.begin(), fir.end(), i))
			sec.push_back(i);

	sort(sec.begin(), sec.end());
	bool ok = false;
	do {
		ok = true;
		for (int i = 0; i < k; ++i) {
			int left = -INF;
			int right = INF;
			for (int j = 0; j < n / 2; ++j) {
				left = max(left, min(a[fir[j]][i], a[sec[j]][i]));
				right = min(right, max(a[fir[j]][i], a[sec[j]][i]));
			}
			if (left > right) { ok = false; break; } 
		}
	} while (!ok && next_permutation(sec.begin(), sec.end()));
	if (!ok) {
		cout << "NO" << endl;
		return;
	}
	cout << "YES" << endl;
	int cnt = 0;
	for (int i = 0; i < n / 2; ++i)
		cout << fir[i] << ' ' << sec[i] << endl;
}

void solve() {
	set<int> fir;
	for (auto p : fr[0]) {
		fir.insert(p.second);
		if (fir.size() == n / 2) break;
	}
	vector<int> sec;
	for (int i = 0; i < n; ++i)
		if (!fir.count(i))
			sec.push_back(i);
	cout << "YES";
	int cnt = 0;
	for (int i : fir) {
		cout << i + 1 << ' ' << sec[cnt++] + 1 << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k;
	a = vector<vector<int>> (n, vector<int> (k));
	fr.resize(k);
	for (int i = 0; i < n; ++i)
	for (int j = 0; j < k; ++j) {
		cin >> x;
		a[i][j] = x;
		fr[j].insert({x, i});
	}

	if (n <= 10)
		solve1();
	else
		solve();
}