#include <iostream>
#include <vector>
using namespace std;
vector<vector<vector<long long int>>> prefixsums;
vector<vector<vector<long long int>>> dp;
int n;

int sum0(int i, int l, int r) {
    return (prefixsums[i][r][0] - prefixsums[i][l - 1][0] + 1000000007) % 1000000007;
}

int sum1(int i, int l, int r) {
    return (prefixsums[i][r][1]- prefixsums[i][l - 1][1] + 1000000007) % 1000000007;
}

void fillprefixsums(int i) {
    for (int j=1; j<n+1; ++j) {
        prefixsums[i][j] = {
        (prefixsums[i][j - 1][0] + dp[i][j][0]) % 1000000007,
        (prefixsums[i][j - 1][1] + dp[i][j][1]) % 1000000007
        };
    }
}
int main()
{
    int k;
    cin >> n >> k;
    for (int i=0; i<n+1; ++i) {
        dp.push_back(vector<vector<long long int>>(n + 1, vector<long long int>(2, 0)));
        prefixsums.push_back(vector<vector<long long int>>(n + 1, vector<long long int>(2, 0)));
    }
    dp[k][k] = {1, 1};
    fillprefixsums(k);

    if (n == k) {
        cout << '1';
    }
    else {
        for (int i=k+1; i<n+1; ++i) {
            for (int j=1; j<i-k+1; ++j) {
              dp[i][j] = {
                  sum1(i - j, 1, j - 1),
                  sum0(i - j, j + 1, n)
              };
            }
            fillprefixsums(i);
        }
        long long int ans=0;
        for (int j=0; j<n + 1; ++j) {
            ans = (ans + dp[n][j][0] + dp[n][j][1]) % 1000000007;
        }
        cout << ans;
    }
    return 0;
}
