#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);
using ll = long long;
int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}
#define all(x) x.begin(), x.end()

const ll INF = 1e18;
const ll MOD = 1'000'000'007;
void entry(int test_id) {
    (void) test_id;
    int n, m;
    scanf("%d %d", &n, &m);
    vector<int> requests(m);
    for (int i = 0; i < m; ++i) {
        int x;
        scanf("%d", &x);
        requests[i] = x - 1;
    }
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        int p;
        scanf("%d", &p);
        order[i] = p - 1;
    }
    vector<int> ans;
    for (int j = 0; j < m; ++j) {
        while (true) {
            int cur = order[0];

            int npos = 0;
            for (int k = j; k < m; ++k) {
                if (k != j && requests[k] == cur) break;
                int ps = find(all(order), requests[k]) - order.begin();
                npos = max(npos,ps);
            }
            ans.push_back(npos);
            order.erase(order.begin());
            order.insert(order.begin() + npos, cur);
            if (cur == requests[j]) break;
        }
    }
    printf("%lld\n", ans.size());
    for (int npos : ans) {
        printf("%d ", npos + 1);
    }
    printf("\n");
}