#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);
using ll = long long;
int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

const ll INF = 1e18;
const ll MOD = 1'000'000'007;
void entry(int test_id) {
    (void) test_id;
    ll N, M, K;
    scanf("%lld %lld %lld", &N, &M, &K);
    vector<int> max_s(N);
    for (int i = 0; i < N; ++i) {
        max_s[i] = i+1;
    }
    for (int i = 0; i < M; ++i) {
        int l, r;
        scanf("%d %d\n", &l, &r);
        --l;
        --r;
        max_s[r] = r - l;
    }
    int T = 0;
    while ((1 << T) -1 <=N ) ++T;
    vector<vector<vector<ll>>> dp(N+1, vector<vector<ll>>(N+1, vector<ll>(T+1)));
    dp[0][1][0] = 1;

    ll ans = 0;
    for (int n = 1; n <= N; ++n) {
        for (int s = 1; s <= max_s[n-1]; ++s) {
            for (int t = 1; t <= T; ++t) {
                if (s > 1) {
                    dp[n][s][t] = dp[n-1][s-1][t];
                }else {
                    for (int j = 0; j < t; ++j) {
                        dp[n][s][t] += dp[n-1][1][j];
                        dp[n][s][t]%= MOD;
                    }
                }
                if (n == N) {
                    ans += dp[n][s][t];
                    ans %= MOD;
                }
            }
        }
    }
    printf("%lld\n", ans);
}