#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);
using ll = long long;
int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

const ll INF = 1e18;
const ll MOD = 1'000'000'007;
void entry(int test_id) {
    (void) test_id;
    ll N, M, K;
    scanf("%lld %lld %lld", &N, &M, &K);
    vector<int> max_s(N);
    for (int i = 0; i < N; ++i) {
        max_s[i] = i+1;
    }
    for (int i = 0; i < M; ++i) {
        int l, r;
        scanf("%d %d\n", &l, &r);
        --l;
        --r;
        max_s[r] = r - l;
    }
    int T = 0;
    while ((1 << T) -1 <=N ) ++T;
    vector<vector<ll>> dp(N+1, vector<ll>(K+1));
    dp[0][0]= 1;
    ll ans = 0;
    for (int n = 1; n <= N; ++n) {
        for (int x = 0; x <= K; ++x) {
            for (int y = x; y >= 0; y = (y-1)&x) {
                dp[n][x] += dp[n-1][y];
                dp[n][x] %= MOD;
                if (y == 0) break;
            }
            if (n == N) {
                ans += dp[n][x];
                ans %= MOD;
            }
        }
    }
    printf("%lld\n", ans);
}