#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()

const ll INF = 1e18;
const ll MOD = 1'000'000'007;

vector<vector<int>> req_ids;

template<typename T>
struct MinStack {
    vector<pair<T, T>> v;
    void push (T x) {
        T m = x;
        if (!v.empty()) {
            m = min(m, v.back().second);
        }
        v.emplace_back(x, m);
    }
    T pop() {
        T ret = v.back().first;
        v.pop_back();
        return ret;
    }

    T get() {
        return v.back().second;
    }
};

template<typename T>
struct MinQueue {
    MinStack<T> head, tail;
    void rebuild() {
        while (!head.v.empty()) {
            tail.push(head.pop());
        }
    }

    void push(T x) {
        head.push(x);
    }

    void pop() {
        if (tail.v.empty()) {
            rebuild();
        }
        tail.pop();
    }

    T get() {
        if (tail.v.empty()) {
            return head.get();
        }
        T res = tail.get();
        if (!head.v.empty()) {
            res = min(res, head.get());
        }
        return res;
    }
};

const ll TAMB = 1;

void entry(int test_id) {
    (void) test_id;
    ll a, b, c;
    scanf("%lld %lld %lld", &a, &b, &c);
    ll ans = 0;
    if (c > TAMB) {
        while (a != b) {
            ll bl_end = a;
            if (a %c == 0) {
                bl_end += c - 1;
            } else {
                bl_end -= a %c ;
                bl_end += c- 1;
            }
            if (bl_end == a) {
                ++ans;
                a += 2;
                continue;
            }
            ll targ = min(b, bl_end);
            ll dist = targ - a;
            ll dans = (dist-1)/2+1;
            if (dist == 0) dans = 0;
            ans += dans;
            a = targ;
        }
    }

    printf("%lld\n", ans);
}