#include <iostream>
#include <vector>

using namespace std;

const long long mod = 1000000007;

int main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector <vector <pair <long long, long long>>> dp(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(n);
        dp[i][i] = {1, 1};
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            dp[i][j] = {0, 0};
            for (int l = 0; l < j; l++) {
                dp[i][j].first = (dp[i][j].first + dp[i - j - 1][l].second) % mod;
            }
            for (int l = j + 1; l < n; l++) {
                dp[i][j].second = (dp[i][j].second + dp[i - j - 1][l].first) % mod;
            }
        }
    }
    cout << (dp[n - 1][k - 1].first + dp[n - 1][k - 1].second) % mod;
    return 0;
}
