#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 505, mod = 1e9 + 7;

int n, m, k, tmp;
int dp[MAXN][MAXN];
vector<pair<int, int> > forb;

signed main() {
	cin >> n >> m >> k;

	for (int i = 0; i < m; ++i) {
		int u, v;
		--u, --v;
		forb.push_back({ min(u, v), max(u, v) });
	}

	if (m == 0) {
		for (int i = 0; i <= k; ++i) {
			dp[0][i] = 1;
		}

		for (int i = 1; i < n; ++i) {
			for (int j = 0; j <= k; ++j) {
				for (int p = 0; p <= k; ++p) {
					if ((p & j) == p) {
						dp[i][j] += dp[i - 1][p];
						dp[i][j] %= mod;
						if (dp[i][j] < 0) dp[i][j] += mod;
					}
				}
			}
		}

		int ans = 0;
		for (int i = 0; i <= k; ++i) {
			ans += dp[n - 1][i];
			ans %= mod;
			if (ans < 0) ans += mod;
		}
		cout << ans << endl;
	}
	else {
		for (int i = 0; i <= k; ++i) {
			dp[0][i] = 1;
		}

		for (int i = 1; i < n; ++i) {
			for (int j = 0; j <= k; ++j) {
				for (int p = 0; p <= k; ++p) {
					if ((p & j) == p) {
						if (p != j) {
							dp[i][j] += dp[i - 1][p];
							dp[i][j] %= mod;
							if (dp[i][j] < 0) dp[i][j] += mod;
						}
						else {
							for (auto v : forb) {
								if (v.second == i) {
									dp[i][j] += dp[i - 1][p] - dp[v.first][p];
									dp[i][j] %= mod;
									if (dp[i][j] < 0) dp[i][j] += mod;
								}
							}
						}
					}
				}
			}
		}
	}
	return 0;
} 