#include <iostream>

using namespace std;

const long long MOD = 1e9 + 7;
const int MAXN = 5005;

int n, k;
int dp[MAXN][MAXN][2];
long long sum[MAXN][MAXN][2];

signed main() {
	cin >> n >> k;
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int nk = k; nk <= n; ++nk) {
		sum[k][nk][0] = 1;
		sum[k][nk][1] = 1;
	}

	for (int ns = k + 1; ns <= n; ++ns) {
		for (int ps = k; ps < ns; ++ps) {
			int nk = ns - ps;
			dp[ns][nk][0] += ((long long)sum[ps][n][1] - (long long)sum[ps][nk][1]) % MOD;
			if (dp[ns][nk][0] < 0) dp[ns][nk][0] += MOD;

			dp[ns][nk][1] += (long long)sum[ps][nk - 1][0] % MOD;
			if (dp[ns][nk][1] < 0) dp[ns][nk][1] += MOD;
		}

		for (int nk = 1; nk <= n; ++nk) {
			sum[ns][nk][0] = ((long long)sum[ns][nk - 1][0] + (long long)dp[ns][nk][0]) % MOD;
			if (sum[ns][nk][0] < 0) sum[ns][nk][0] += MOD;

			sum[ns][nk][1] = ((long long)sum[ns][nk - 1][1] + (long long)dp[ns][nk][1]) % MOD;
			if (sum[ns][nk][0] < 0) sum[ns][nk][0] += MOD;
		}
	}

	if (n == k) cout << 1 << endl;
	else cout << sum[n][n][0] + sum[n][n][1] << endl;
	return 0;
}