#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 3e5 + 5;

int n, p[MAXN], dp[MAXN][2], res;
vector<int> g[MAXN];
bool used[MAXN];

void dfs(int v) {
	used[v] = 1;
	int s0 = 0, s1 = 0;
	for (int u : g[v]) {
		dfs(u);
		s0 += dp[u][0];
		s1 += dp[u][1];
	}
	dp[v][0] = s1;
	dp[v][1] = s0 + 1;
}

signed main() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		g[p[i] - 1].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
			res += max(dp[i][0], dp[i][1]);
		}
	}
	cout << res << endl;
	return 0;
}