#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int MAXN = 2e5 + 5, MAXA = 1e9 + 7;

int n, k, cnt;
int a[MAXN][8];
int col[MAXN];
vector<pair<int, int> > ans;
bool f = 0;

void gen() {
	if (f) return;

	if (cnt * 2 == n) {
		bool ok = 1;
		vector<pair<int, int> > seg;
		for (int i = 0; i < k; ++i) {
			int l = -MAXA, r = MAXA;

			for (auto p : ans) {
				int ln = min(a[p.first][i], a[p.second][i]), rn = max(a[p.first][i], a[p.second][i]);

				l = max(ln, l);
				r = min(rn, r);
			}

			if (l > r) ok = 0;
		}

		if (ok) f = 1;
		return;
	}

	++cnt;
	for (int i = 0; i < n; ++i) {
		if (!col[i]) {
			col[i] = cnt;
			for (int j = i + 1; j < n; ++j) {
				if (!col[j]) {
					col[j] = cnt;
					ans.push_back({ i, j });
					gen();
					if (f) return;
					ans.pop_back();
					col[j] = 0;
				}
			}
			col[i] = 0;
		}
	}
	--cnt;
}

signed main() {
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}

	if (k == 1) {
		vector<pair<int, int> > arr;
		for (int i = 0; i < n; ++i) {
			arr.push_back({a[i][0], i});
		}
		sort(arr.begin(), arr.end());
		cout << "YES\n";
		for (int i = 0; i < n / 2; ++i) {
			cout << arr[i].second + 1 << " " << arr[n - i - 1].second + 1 << endl;
		}
	}
	else if (n <= 10) {
		gen();
		if (f) {
			cout << "YES" << endl;
			for (auto p : ans) {
				cout << p.first + 1 << " " << p.second + 1 << endl;
			}
		}
		else {
			cout << "NO" << endl;
		}
	}
	return 0;
}