#include <bits/stdc++.h>

using namespace std;

struct seg_tree
{
    int sz;
    vector<int> L, R, DO;
    seg_tree(int n)
    {
        sz = 1;
        while (sz < n) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
    }
    seg_tree(vector<int> a)
    {
        sz = 1;
        while(sz < a.size()) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
        for (int i = 0; i < a.size(); ++i)
            DO[sz + i] = a[i];
        for (int i = sz - 1; i > 0; --i)
        {
            DO[i] = DO[i << 1] + DO[i << 1 | 1];
        }
    }
    int sum(int l, int r, int x = 1)
    {
        if (l <= L[x] && R[x] <= r) return DO[x];
        if (R[x] < l || r < L[x]) return 0;
        return sum(l, r, x << 1) + sum(l, r, x << 1 | 1);
    }
    void change(int pos, int val, int x = 1)
    {
        if (pos < L[x] || R[x] < pos) return;
        if (L[x] == R[x])
        {
            DO[x] = val;
            return;
        }
        change(pos, val, x << 1);
        change(pos, val, x << 1 | 1);
        DO[x] = DO[x << 1] + DO[x << 1 | 1];
    }
};

int main()
{

}
