#include <iostream> 
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n, a;

	cin >> n;

	vector<int> bad(n);
	vector<pair<int, int>> count(n);
	vector<int> link(n);

	for (int i = 0; i < n; i++) {
		count[i] = { 0, i };
	}

	for (int i = 0; i < n; i++) {
		cin >> a;

		bad[0] = a - 1;

		if (a != -1)
			count[a - 1] = { count[a - 1].first + 1, a - 1 };
	}

	sort(count.begin(), count.end());
	reverse(count.begin(), count.end());

	for (int i = 0; i < n; i++) {
		link[count[i].second] = i;
	}

	bool end = false;

	for (int i = 0; i < count.size() && !end; i++) {
		if (count[i].first == 0) {
			cout << count.size() - i;
			end = true;
		}
	}

	if(n % 2 == 0)
		cout << n / 2;
	else cout << n / 2 + 1;

	system("pause");
}