#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 100;

vector <int> g[MAXN];

vector <bool> us(MAXN, false);

void DFS(int v, int p, int &sum)
{
    us[v] = true;
    if (p)
        sum++;
    p = 1 - p;
    for (auto it : g[v])
        DFS(it, p, sum);
}

vector <int> clr(MAXN, -1);

void CClear(int v)
{
    clr[v] = -1;
    for (auto it : g[v])
        if (clr[it] != -1)
            CClear(it);
}

void pokras(int v, int p, int &sum)
{
    us[v] = true;
    bool f = false;
    for (auto to : g[v])
    {
        if (clr[to] == p && p == 1)
            f = true;
    }
    if (f)
        p = 0;
    clr[v] = p;
    if (p)
        sum++;
    p = 1 - p;
    for (auto to : g[v])
            if (clr[to] == -1)
                pokras(to, p, sum);

}
int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector <int> v(n + 1);
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i];
        g[v[i]].push_back(i);
    }
    if (v[1] != -1)
        assert(0);
    int ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (v[i] == -1)
        {
            int k = 0, t = 0;
            DFS(i, 1, k);
            DFS(i, 0, t);
            ans += max(k, t);
        }
    }
    for (int i = 1; i <= n; i++)
        if (v[i] != -1)
            g[i].push_back(v[i]);
    for (int i = n; i >= 1; i--)
    {
        if (us[i])
            continue;
        int k = 0, t = 0;
        pokras(i, 0, k);
        CClear(i);
        pokras(i, 1, t);
        CClear(i);
        ans += max(k, t);
    }
    cout << ans;
    return 0;
}
