#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 100;

vector <int> g[MAXN];

int dp[MAXN][2];

void DFS(int v)
{
    dp[v][1] = 1;
    for (auto it : g[v])
    {
        DFS(it);
        dp[v][1] += dp[it][0];
        dp[v][0] += max(dp[it][1], dp[it][0]);
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector <int> v(n + 1);
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i];
        g[v[i]].push_back(i);
    }
    if (n <= 20)
    {
        int k = (1 << n), ans = 0;
        for (int i = 0; i < k; i++)
        {
            vector <bool> s(n, false);
            int g = i, y = 0;
            for (int j = 0; j < n; j++)
            {
                if (g % 2)
                {
                    s[j] = true;
                    y++;
                }
                g /= 2;
            }
            bool t = true;
            for (int i = 0; i < n; i++)
            {
                if (s[i] && s[v[i]])
                    t = false;
            }
            if (t)
                ans = max(ans, y);
        }
        cout << ans;
        return 0;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (v[i] == -1)
        {
            DFS(i);
            ans += max(dp[i][0], dp[i][1]);
        }
    }
    cout << ans;
    return 0;
}
