#include <iostream>
#include <cmath>

using namespace std;

int64_t sign(int64_t k)
{
    return k < 0 ? -1 : 1;
}

int64_t scnd(int64_t k)
{
    if(k == 0) {
        return 0;
    }
    int64_t a = round(sqrt(llabs(k)));
    int64_t b = k / a;
    while (a > 1 && (a * b != k || a * (2 * ((b - a) / 2) + a) != k)) {
        a -= sign(k);
        b = k / a;
    }
    if (a * b == k) {
        int64_t l = a;
        int64_t f = (b - a) / 2 * sign(k);
        if(l * (2 * f * sign(k) + l) == k)
            return llabs(f + l * sign(k));
        else
            return -1;
    } else {
        return -1;
    }
}

int main() {
    int64_t k;
    cin >> k;
    int64_t r = scnd(k);
    if(r == -1)
        cout << "none";
    else
        cout << r;
    return 0;
}
