#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<vector<long long> > > Matrix;

long long findcombs(int last, int nleft, int turn)
{
    if(nleft < 0)
        return 0;
    if(nleft == 0)
        return 1;
    if(Matrix[last][nleft][turn] != -1)
        return Matrix[last][nleft][turn];
    long long res = 0;
    int a, b;
    if(turn == 0)
    {
        a = last + 1;
        b = nleft;
    }
    else
    {
        a = 1;
        b = last - 1;
    }
    for(int i = a; i <= b; i++)
        res += findcombs(i, nleft - i, 1 - turn);
    Matrix[last][nleft][turn] = res % 1000000007;
    return res % 1000000007;
}

int main() {
    int n, k;
    cin >> n >> k;
    Matrix.resize(n);
    for(int i = 0; i < n; i++)
    {
        Matrix[i].resize(n);
        for(int j = 0; j < n; j++)
        {
            Matrix[i][j].resize(2);
            Matrix[i][j][0] = -1;
            Matrix[i][j][1] = -1;
        }
    }
    cout << findcombs(k, n - k, 0) + findcombs(k, n - k, 1);
    return 0;
}
