#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second;
}

int main() {
    long long n;
    cin >> n;
    vector<int> inp;
    inp.resize(n);
    for(int i = 0; i < n; i++)
        cin >> inp[i];
    vector<pair<int, int> > loss;
    loss.resize(n, {0, 0});
    for(int i = 0; i < n; i++)
    {
        loss[inp[i] - 1].first = i;
        loss[inp[i] - 1].second++;
    }
    vector<bool> result;
    result.resize(n, false);
    sort(loss.begin(), loss.end(), cmp);
    for(int i = 0; i < n; i++)
        if(result[inp[loss[i].first] - 1] == false)
            result[loss[i].first] = true;
    int res = 0;
    for(int i = 0; i < result.size(); i++)
        res += result[i];
    cout << res;
    return 0;
}
