#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstring>

using namespace std;
int n, k;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second;
}

bool cmp2(pair<int, int> a, pair<int, int> b)
{
    return a.second > b.second;
}

int main() {
    cin >> n >> k;
    vector<vector<pair<int, int> > > artf;
    artf.resize(k);
    for (int i = 0; i < k; i++)
        artf[i].resize(n);
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < k; j++) {
            cin >> artf[j][i].second;
            artf[j][i].first = i;
        }
    }
    for(int i = 0; i < k; i++)
        sort(artf[i].begin(), artf[i].end(), cmp);
    vector<vector<pair<int, int> > > sol;

    sol.resize(n);
    for(int i = 0; i < n; i++)
    {
        sol[i].resize(n, {0, -100000000});
        for(int j = 0; j < n; j++)
            sol[i][j].first = i;
    }

    for(int i = 0; i < k; i++)
        for(int j = 0; j < n / 2; j++)
        {
            for(int z = 0; z < n / 2; z++)
                sol[j][z].second = -1000000000;
            for(int z = n / 2; z < n; z++)
                sol[j][z].second++;
        }
    vector<bool> used;
    used.resize(n, false);
    vector<pair<int, int> > res;
    res.resize(n / 2);
    for(int i = 0; i < n / 2; i++)
    {
        sort(sol[i].begin(), sol[i].end(), cmp2);
        int j = 0;
        while(j < used.size() && used[j])
            j++;
        if(j >= used.size() || j <= 0)
        {
            cout << "NO";
            return 0;
        }
        used[j] = true;
        res[i].first = i;
        res[i].second = j;
    }
    cout << "YES" << endl;
    for(int i = 0; i < res.size(); i++)
        cout << res[i].first << " " << res[i].second << endl;
    return 0;
}

/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
 * */