#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second;
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > art;
    art.resize(n);
    if(k == 1)
    {
        for(int i = 0; i < n; i++)
        {
            art[i].first = i;
            cin >> art[i].second;
        }
        sort(art.begin(), art.end(), cmp);
        cout << "YES" << endl;
        for(int i = 0; i < n / 2; i++)
            cout << art[i].first + 1 << " " << art[n - i - 1].first + 1 << endl;
    } else {
        vector<vector<int> > artf;
        artf.resize(n);
        for(int i = 0; i < n; i++)
            artf[i].resize(k);
        for(int i = 0; i < n; i++)
            for(int j = 0; j < k; j++)
                cin >> artf[i][j];
        vector<int> pers;
        pers.resize(n);
        for(int i = 0; i < n; i++)
            pers[i] = i;
        bool succop;
        do
        {
            succop = true;
            for(int j = 0; j < k; j++)
            {
                long long mind = -1000000000;
                long long maxd = -mind;
                for(int i = 0; i < n / 2; i++)
                {
                    int currmin = min(artf[pers[i]][j], artf[pers[i + n / 2]][j]);
                    int currmax = max(artf[pers[i]][j], artf[pers[i + n / 2]][j]);
                    if(currmin > mind)
                        mind = currmin;
                    if(currmax < maxd)
                        maxd = currmax;
                }
                if(maxd < mind) {
                    succop = false;
                    break;
                }
            }
            if(succop)
                break;
        } while(next_permutation(pers.begin(), pers.end()));
        if(succop)
        {
            cout << "YES" << endl;
            for(int i = 0; i < n / 2; i++)
                cout << pers[i] + 1 << " " << pers[i + n / 2] + 1<< endl;
        }
        else
            cout << "NO";
    }
    return 0;
}