 #include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define forn(i,a,b)for(int i=a;i<=b;++i)
#define dbg_var(x) cout << #x << ": " << x << endl;
template<typename T>
void dbg_vector(const vector<T>&v)
{
	forn(i,0,v.size()-1)cout<<v[i]<<' ';
	cout<<endl;
}
void dbg(){cout<<endl;}
template<typename Head,typename... Tail>
void dbg(Head H,Tail... T)
{
	cerr << H << ' ';
	dbg(T...);
}

ll n;
vector<vector<ll> >g;
vector<int>used;

pair<ll,ll> dfs(ll i,int p)
{
	used[i]=true;
	pair<ll,ll>res={0,0};
	if(p==0)res.first++;
	else res.second++;
	for(ll j:g[i])
	{
		if(!used[j])
		{
			auto res_=dfs(j,1-p);
			res.first+=res_.first;
			res.second+=res_.second;
		}
	}
	return res;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin>>n;
	g.resize(n+1),used.resize(n+1);
	forn(i,1,n)
	{
		ll a;cin>>a;
		if(a!=-1)
		{
			g[i].push_back(a);
			g[a].push_back(i);
		}
	}
	ll ans=0;
	forn(i,1,n)
	{
		if(!used[i])
		{
			auto res=dfs(i,0);
			ans+=max(res.first,res.second);
		}
	}
	cout<<ans<<endl;
}
/*

*/