#include<iostream>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
#include<stack>
using namespace std;

#define pii pair<int,int>
#define mp make_pair
vector<int> used;
vector<int> circle;
vector<int> comp;
void dfs1(int v, vector<vector<int>> &g, stack<int> &st, int p) {
    used[v] = 1;
    st.push(v);
    for (auto u : g[v]) {
        if (used[u] == 1 && u != p) {
            circle.push_back(u);
            while (st.top() != u) {
                circle.push_back(st.top());
                st.pop();
            }
        }
        else if (used[u] == 0) {
           // st.push(u);
            dfs1(u, g, st, v);
        }

    }
    used[v] = 2;
    comp.push_back(v);
}
int counter;
int N;
void dfs2(int v, vector<vector<int>> &g, int c, int a1, int a2) {
    used[v] = 2;
    ++N;
    if (c)++counter;
    for (auto u : g[v]) {
        if (used[u] == 0 && u != a1 && u != a2) {
            dfs2(u, g, (c + 1) % 2, a1, a2);
        }
    }
}
int main() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        if (a == -1)continue;
        --a;
        g[i].push_back(a);
        g[a].push_back(i);
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++)
    {
        if (g[i].size() == 0) {
            ++ans;
            used[i] = 2;
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (used[i] == 0) {
            circle.clear();
            comp.clear();
            stack<int> st;
            dfs1(i, g, st, -1);
            for (auto v : comp) {
                used[v] = 0;
            }
            if (circle.size() == 0) {
                circle.push_back(i);
            }
            vector<pii> d(circle.size(), mp(0, 0));
            int k0 = 0;
            for (int j = 0; j < circle.size(); j++)
            {
                counter = 0, N = 0;
                int sz = circle.size();
                int a1 = circle[(j + sz + 1) % sz];
                int a2 = circle[(j + sz - 1) % sz];
                dfs2(circle[j], g, 1, a1, a2);
                if (counter > N - counter) {
                    d[j] = mp(counter, 1);
                }
                else {
                    d[j] = mp(N - counter, 0);
                    ++k0;
                }
            }
            int beg = 0;
            if (k0 > 0) {
                for (int j = 0; j < circle.size(); j++)
                {
                    if (d[j].second == 0) {
                        beg = j;
                        break;
                    }
                }
            }
            int h = 0;
            for (int j = beg; j < beg+circle.size(); j++)
            {
                if (d[j%circle.size()].second == 0) {
                    ans += d[j%circle.size()].first;
                    h = 0;
                }
                else if (h % 2 == 0) {
                    ans += d[j%circle.size()].first;
                    h = (h + 1) % 2;
                }
                else {
                    ans += d[j%circle.size()].first - 1;
                    h = (h + 1) % 2;
                }
            }
        }
    }
    cout << ans;
    system("pause");
}