//#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long
const int MAXN = 5001;
int dp[MAXN][MAXN][2];
const int mod = 1e9 + 7;

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			for (int l = 0; l < j && l <= i - j; l++)
			{
				dp[i][j][1] += dp[i - j][l][0];
				dp[i][j][1] %= mod;
			}
			for (int l = j + 1; l <= i - j; l++)
			{
				dp[i][j][0] += dp[i - j][l][1];
				dp[i][j][0] %= mod;
			}
		}
	}
	int ans = (k == n);
	for (int i = 1; i < n; i++)
	{
		ans += dp[n][i][0] + dp[n][i][1];
		ans %= mod;
	}
	cout << ans;
}
