#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cmath>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define popb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


const int INF = (int) 1e18;
int k;

int getPozitive(int p, int q) {
	if (p > q) swap(p, q);
	if (abs(p + q) % 2) return -1;

	int x = (q - p) / 2;
	int a = (q + p) / 2;

	if (x < 0 || a < 0) return -1;

	return a;
}

int getNegative(int p, int q) {
	return getPozitive(p, q);
}

signed main() {

	// for (int k = 0; k < 10; ++k) {
	// 	for (int i = 0; i < 10; ++i) {
	// 		if ((int) sqrt(i * i + k) * (int) sqrt(i * i + k) == i * i + k) {
	// 			cout << "|" << i * i + k << "| ";
	// 			continue;
	// 		}
	// 		cout << i * i + k << " ";
	// 	}
	// 	cout << endl;
	// }

	cin >> k;

	bool negative = false;

	if (k >= 0) {
		int sqrtk = (int) sqrtl(k);
		sqrtk += 3;
		while (sqrtk * sqrtk > k) {
			--sqrtk;
		}
		if (sqrtk * sqrtk == k) {
			cout << 0 << endl;
			return 0;
		}
	}
	else {
		negative = true;
		k = -k;
	}

	int ans = INF;

	for (int i = 1; i * i <= k; ++i) {
		if (k % i == 0) {
			int p = i, q = k / i;
			int kek = -1;
			if (negative) {
				int w, e;
				w = getNegative(-p, q);
				e = getNegative(p, -q);

				cout << w << " " << e << endl;
				if (w != -1) {
					kek = w;
					if (e != -1) {
						kek = min(kek, e);
					}
				}
				else if (e != -1) {
					kek = e;
				}
			}
			else {
				kek = getPozitive(p, q);			
			}


			if (kek == -1) continue;

			ans = min(ans, kek);
		}
	}

	if (ans == INF) {
		cout << "none" << endl;
	}
	else {
		cout << ans << endl;
	}

	return 0;
}