#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = (int) 1e9 + 7;

inline int add(int a, int b) {
	return (a + b) % mod; 
}

int ans = 0;
int N = 0;
int cur = 0;
void rec(int last, bool vzr) {
	if (cur == N) {
		ans = add(ans, 1LL);
		return;
	}
	int i = 1;
	if (vzr) {
		i = last + 1;
	}
	for ( ; i <= N - cur; ++i) {
		// if (vzr && i <= last) continue;
		// cout << i << endl;
		if (!vzr && i >= last) break;
		cur += i;
		// cout << "go" << endl;
		rec(i, !vzr);
		cur -= i;
	}
	// cout << endl;
}

signed main() {

	int n, K;
	cin >> n >> K;
	N = n;

	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int>(n + 1)));
	for (int i = 1; i + K <= n; ++i) {
		// cout << i + K << " " << i << " " << K << endl;
		dp[i + K][i][K] = 1;
	}

	if (K == n) {
		cout << 1 << endl;
		return 0;
	}

	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			for (int k = 1; k <= n; ++k) {
				if (i < k) break;
				if (j < k) {
					for (int p = j + 1; p <= n; ++p) {
						dp[i][j][k] = add(dp[i][j][k], dp[i - k][p][j]);
					}
				}
				else {
					for (int p = 1; p < j; ++p) {
						dp[i][j][k] = add(dp[i][j][k], dp[i - k][p][j]);
					}
				}
			}
		}
	}

	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j + i <= n; ++j) {
			ans = add(ans, dp[n][i][j]);
		}
	}

	cout << ans << endl;

	return 0;

	// vector<vector<vector<int>>> dp(n, vector<int>(n + 1, vector<int>(2)));
	// vector<int> pr_ubv(n + 1);
	// vector<int> sf_ubv(n + 1);
	// vector<int> pr_vzr(n + 1);
	// vector<int> sf_vzr(n + 1);
	
	// dp[0][k][0] = dp[0][k][1] = 1;
	// for (int i = 1; i < n + 1; ++i) {
	// 	pr_ubv[i] = pr_ubv[i - 1] + dp[0][i][0];
	// 	pr_vzr[i] = pr_vzr[i - 1] + dp[0][i][1];
	// }

	// for (int i = n - 1; i >= 0; --i) {
	// 	sf_ubv[i] = sf_ubv[i + 1] + dp[0][i][0];
	// 	sf_vzr[i] = sf_vzr[i + 1] + dp[0][i][1];
	// }

	cur += K;
	if (N == K) --ans;
	rec(K, true);
	rec(K, false);

	cout << ans << endl;

	return 0;
}