/*#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("Ofast")*/

#include <bits/stdc++.h>

#define endl "\n"
#define pii pair<int,int>
//#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const double EPS = 1e-10;
const int Q = 31;
const ll P = 1e9 + 7;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}


void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<pii>& arr)
{
    for (auto i : arr)
        cout << i.first << " " << i.second << "    ";
    cout << endl;
}
void show(vector<vector <int>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}
void show(vector<vector <pii>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}



struct node
{
    node *left, *right;
    int l, r;
    int sum;
    node()
    {
        left = right = nullptr;
        l = r = -1;
        sum = 0;
    }
};

node* build(vector<int>& data, node* root, int l, int r)
{
    root = new node();

    if (l == r)
    {
        root->sum = data[l];
    }
    else
    {
        int m = (l + r) / 2;
        root->left = build(data, root->left, l, m);
        root->right = build(data, root->right, m + 1, r);
        root->sum = root->left->sum + root->right->sum;
    }

    root->l = l;
    root->r = r;

    return root;
}

int query(node* root, int l, int r)
{
    if (root->l >= l && root->r <= r)
        return root->sum;
    if (root->l > r || root->r < l)
        return 0;

    return query(root->left, l, r) + query(root->right, l, r);
}

void change(node* root, int ind, int val)
{
    if (root->r < ind || root->l > ind)
        return;
    if (root->l == root->r)
    {
        root->sum = val;
        return;
    }

    change(root->left, ind, val);
    change(root->right, ind, val);
    root->sum = root->left->sum + root->right->sum;
}





signed main()
{
    hello();

    int n, k;
    cin >> n >> k;

    if (n == k)
    {
        cout << 1 << endl;
        return 0;
    }

    vector <vector<pii>> dp(n + 1, vector <pii>(n + 1));
    vector <vector <pii>> tsum(n + 1, vector <pii>(n + 1));

    dp[k][k] = {1, 1};

    for (int i = 1; i <= n; ++i)
    {
        for (int k = 1; k <= n; ++k)
        {
            if (i - k <= 0)
                break;

            if (k > i)
            {
                dp[i][k].first = tsum[i - k][i].second;
            }
            else
            {
                dp[i][k].first = tsum[i - k][k - 1].second;
                dp[i][k].second = (tsum[i - k][i - 1].first - tsum[i - k][k].first + P * P) % P;
            }
            /*for (int j = 1; j <= n; ++j)
            {
                if (j >= i)
                    break;

                if (j < k)
                    dp[i][k].first = (dp[i][k].first + dp[i - k][j].second) % P;
                if (j > k)
                    dp[i][k].second = (dp[i][k].second + dp[i - k][j].first) % P;
            }*/
        }

        for (int j = 1; j <= n; ++j)
            tsum[i][j] = {(tsum[i][j - 1].first + dp[i][j].first) % P, (tsum[i][j - 1].second + dp[i][j].second) % P};
    }

    //show(dp);



    int res = 0;
    for (int i = 1; i <= n; ++i)
    {
        res += dp[n][i].first + dp[n][i].second;
        res %= P;
    }
    cout << res << endl;

}
