#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#define lint long long
using namespace std;


int main()
{
    int n, k;
    cin >> n >> k;
    if(n == k)
    {
        cout << "1\n";
        return 0;
    }
    vector<vector<vector<int>>> dp1(n - k + 2), dp2(n - k + 2); // [size][lastel][sum]
    for(int i = 1; i <= n - k + 1; i++)
    {
        dp1[i].resize(n + 1);
        dp2[i].resize(n + 1);
        for(int j = 1; j <= n; j++)
        {
            dp1[i][j].resize(n + 1);
            dp2[i][j].resize(n + 1);
            for(int l = 1; l <= n; l++)
            {
                if(j > l) continue;
                if(i == 1)
                {
                    if(j == k && l == k)
                    {
                        dp1[i][j][l] = 1;
                        dp2[i][j][l] = 1;
                    }
                    else
                    {
                        dp1[i][j][l] = 0;
                        dp2[i][j][l] = 0;
                    }
                }
                else if(i % 2 == 1)
                {
                    for(int e = 1; e <= n; e++)
                    {
                        if(e < j)
                        {
                            dp1[i][j][l] += dp1[i - 1][e][l - j];
                        }
                        else if(e > j)
                        {
                            dp2[i][j][l] += dp2[i - 1][e][l - j];
                        }
                    }
                }
                else
                {
                    for(int e = 1; e <= n; e++)
                    {
                        if(e > j)
                        {
                            dp1[i][j][l] += dp1[i - 1][e][l - j];
                        }
                        else if(e < j)
                        {
                            dp2[i][j][l] += dp2[i - 1][e][l - j];
                        }
                    }
                }
                dp1[i][j][l] %= 1000000007;
                dp2[i][j][l] %= 1000000007;
            }
        }
    }
    int sum = 0;
    for(int i = 1; i <= n - k + 1; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            sum += dp1[i][j][n];
            sum %= 1000000007;
            sum += dp2[i][j][n];
            sum %= 1000000007;
        }
    }
    cout << sum;
}
