#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

const int NN = 5 * 1000 + 100;

const long long MOD = 1000 * 1000 * 1000 + 7;
long long dp[NN][NN][2];

long long solve(long long n, long long k) {
    //memset(dp, 0, sizeof(dp));
    ++n;
    dp[k][k][0] = 1;
    dp[k][k][1] = 1;
    if (n - 1 == k)
        return 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= i; ++j) {
            if (!dp[i][j][0] && !dp[i][j][1])
                continue;
            if (dp[i][j][1]) {
                for (long long k1 = 1; k1 < j; ++k1) {
                    dp[i + k1][k1][0] = (dp[i + k1][k1][0] + dp[i][j][1]) % MOD;
                }
            }
            if (dp[i][j][0]) {
                for (long long k1 = j + 1; k1 < n - i; ++k1) {
                    dp[i + k1][k1][1] = (dp[i + k1][k1][1] + dp[i][j][0]) % MOD;
                }
            }
        }
    }
    long long res = 0;
    for (int i = 1; i < n; ++i) {
        res = (res + dp[n - 1][i][0]) % MOD;
        res = (res + dp[n - 1][i][1]) % MOD;
    }


    return res;
}


int main()
{
   long long n, k;
    cin >> n >> k;
    cout << solve(n, k);
//    solve(3, 1);
   /*for (int i = 5; i <= 10; ++i) {
        for (int j = 1; j <= i; ++j) {
            cout << i << ' ' << j << '\n';
            cout << solve(i, j) << '\n' << '\n';
        }
    }*/
   
}
 