#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define f   first
#define s   second

typedef pair<int, int> ppp;

struct pr {
    int a, b;
    int ind;
};

vector<pr> v;

bool cmp(pr x, pr y) {
    return x.a < y.a;
}
bool cmp1(pr x, pr y) {
    return x.b < y.b;
}

vector<ppp> res;

bool solve() {
    sort(v.begin(), v.end(), cmp);
    vector<pr> v1;
    vector<pr> v2;
    for (int i = 0; i < (int)v.size() / 2; ++i)
        v1.push_back(v[i]);
    for (int i = (int)v.size() / 2; i < v.size(); ++i)
        v2.push_back(v[i]);
    sort(v1.begin(), v1.end(), cmp1);
    sort(v2.begin(), v2.end(), cmp1);
    reverse(v2.begin(), v2.end());
   
    int l = -(1 << 30);
    int r = (1 << 30);
    for (int i = 0; i < (int)v.size() / 2; ++i) {
        pr g1 = v1[i];
        pr g2 = v2[i];
        l = max(l, min(g1.b, g2.b));
        r = min(l, max(g1.b, g2.b));
        res.push_back({ g1.ind, g2.ind });
    }
    if (r - l < 0)
        return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (k == 2) {

        for (int i = 0; i < n; ++i) {
            int a, b;
            cin >> a >> b;
            v.push_back({ a, b, i + 1 });
        }
        if (!solve()) {
            cout << "NO";
            exit(0);
        }
        cout << "YES\n";
        for (auto e : res) {
            cout << e.first << ' ' << e.second << '\n';
        }
    }

}