#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	int mod = 1e9 + 7;
	int n, k;
	cin >> n >> k;
	vector<vector<pair<int,int>>> dp(n + 2, vector<pair<int, int>>(n + 2, { 0,0 })), dp1(n + 2, vector<pair<int, int>>(n + 2));
	dp[k][k] = { 1,1 };
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= i; j++) {
			dp[i][j].first += dp1[i - j][j - 1].second;
			dp[i][j].first %= mod;
		}
		for (int j = i; j > 0; j--) {
			dp[i][j].second += dp1[i - j][j + 1].first;
			dp[i][j].second %= mod;
		}
		for (int j = n; j > 0; j--) {
			dp1[i][j].first = dp1[i][j + 1].first + dp[i][j].first;
			dp1[i][j].first %= mod;
		}
		for (int j = 1; j <= n; j++) {
			dp1[i][j].second = dp1[i][j - 1].second + dp[i][j].second;
			dp1[i][j].second %= mod;
		}
	}
	long long ans = 0;
	if (n == k) {
		ans--;
	}
	for (auto i : dp[n]) {
		ans += i.first + i.second;
		ans %= mod;
	}
	cout << ans;
	system("pause");
}
