#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> ans;
vector<int> used;
pair<int, int> pp;

void dfs(int v, int last) {
	used[v] = 1;
	ans[v] = { 1,0 };
	for (auto i : g[v]) {
		if (used[i]==0) {
			dfs(i, v);
			ans[v].first += ans[i].second;
			ans[v].second += max(ans[i].first, ans[i].second);
		}
		else {
			if (i != last) {
				pp.first = i;
				pp.second = v;
			}
		}
	}
}

void dfs1(int v, int is,int x) {
	used[v] = x;
	ans[v] = { 1,0 };
	for (auto i : g[v]) {
		if (used[i]<x) {
			dfs1(i, is, x);
			if (i != is) {
				ans[v].first += ans[i].second;
				ans[v].second += max(ans[i].first, ans[i].second);
			}
			else {
				ans[v].first += ans[i].second;
				ans[v].second += ans[i].second;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> ms(n, vector<int>(m + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> ms[i][j];
		}
		ms[i][m] = i;
	}
	sort(ms.begin(), ms.end());
	cout << "YES" << '\n';
	for (int i = 0; i < n / 2; i++) {
		cout << ms[i][m] + 1 << ' ' << ms[n - 1 - i][m] + 1 << '\n';
	}
	system("pause");
}
