#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1, MAXK = 8;
int k;
vector<int> a[MAXN];
vector<int> features[MAXK];
int b[MAXK];
vector<int> masks;

int pw(int x, int n) {
	int res = 1;
	for (int i = 0; i < n; ++i)
		res *= x;
	return res;
}

vector<int> mask[pw(3, MAXK)];
vector<int> to_vector[pw(3, MAXK)];
int binmask[pw(3, MAXK)];

int to_mask(vector<int> & kek) {
	int res = 0;
	for (int i = 0; i < kek.size(); ++i) {
		res = res * 3 + kek[i];
	}
	return res;
}

bool match(int i, int j) {
	vector<int> a = to_vector[i], b = to_vector[j];
	for (int l = 0; l < k; ++l) {
		if (a[l] == 1 || b[l] == 1) continue;
		if (a[l] == b[l]) return false;
	}
	return true;
}

void init() {
	for (int i = 0; i < pw(3, k); ++i) {
		int mask = i;
		while (to_vector[i].size() < k) {
			to_vector[i].pb(mask % 3);
			mask /= 3;
		}
		reverse(to_vector[i].begin(), to_vector[i].end());
		for (int j = 0; j < k; ++j)
			if (to_vector[i][j] == 1)
				binmask[i] |= (1 << j);
		masks.pb(i);
	}
}

bool cmp(int a, int b) {
	return (binmask[a] & binmask[b]) == binmask[a];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
//	freopen("input.txt", "r", stdin);
//	 freopen("output.txt", "w", stdout);

	int n;
	cin >> n >> k;
	init();
	sort(masks.begin(), masks.end(), cmp);

	for (int i = 0; i < n; ++i) {
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			features[j].pb(a[i][j]);
		}
	}
	for (int j = 0; j < k; ++j) {
		sort(features[j].begin(), features[j].end());
		b[j] = features[j][n / 2];
	}
	for (int i = 0; i < n; ++i) {
		vector<int> cur(k);
		for (int j = 0; j < k; ++j) {
			if (a[i][j] < b[j])
				cur[j] = 0;
			if (a[i][j] == b[j])
				cur[j] = 1;
			if (a[i][j] > b[j])
				cur[j] = 2;
		}
		mask[to_mask(cur)].pb(i);
	}
	vector<pair<int, int>> ans;
	for (int i = 0; i < masks.size(); ++i) {
		int cmask = masks[i];
		while (!mask[cmask].empty()) {
			bool fl = false;
			for (int j = i; j < masks.size(); ++j) {
				int tmask = masks[j];
				if (mask[tmask].empty() || !match(cmask, tmask)) continue;
				ans.pb({mask[cmask].back(), mask[tmask].back()});
				mask[cmask].pop_back();
				mask[tmask].pop_back();
				fl = true;
				break;
			}
			if (!fl) {
				cout << "NO";
				return 0;
			}
		}
	}
	cout << "YES\n";
	for (auto i : ans)
		cout << i.f + 1 << ' ' << i.s + 1 << '\n';
//	int cnt = 0;
//	k = 7;
//	for (int i = 0; i < 2187; ++i) {
//		vector<int> cur = to_vector(i);
//		bool fl = false;
//		for (int j = 0; j < 7; ++j) {
//			if (cur[j] == 1)
//				fl = true;
//		}
//		if (!fl) continue;
//		for (int j = 0; j < 2187; ++j) {
//			if (match(i, j)) {
//				++cnt;
//			}
//		}
//	}
//	cout << cnt;
    return 0;
}