#include <iostream>

using namespace std;

long long sqrt(long long a) {
    long long l = 0, r = a + 1, m;
    while (r > l + 1) {
        m = (l + r) / 2;
        if ((m * m) > a) r = m;
        else l = m;
    }
    return l;
}

int main() {
    long long k;
    cin >> k;
    long long r = sqrt(k);
    if (r * r == k) cout << r << endl;
    else {
        r = 2 * sqrt(abs(k));
        for (long long a = 1; a < r; ++a) {
            long long d = k + (a - 1) * (a - 1);
            long long sd = sqrt(d);
            if (sd * sd == d) {
                cout << sd << endl;
                return 0;
            }
        }
        cout << "none" << endl;
    }
    return 0;
}