#include <iostream>
#include <vector>
#include <map>
#pragma GCC optimize "O3"

using namespace std;
int con = 1000000007;

struct trip {
    int f, s;
    bool l;
    trip(int f0, int s0, bool l0) {
        f = f0;
        s = f0;
        l = l0;
    }
};

bool operator< (trip a, trip b) {
    if (a.f == b.f) {
        if (a.s == b.s) {
            return a.l < b.l;
        } else {
            return a.s < b.s;
        }
    } else {
        return a.f < b.f;
    }
}

map<trip, int> mem;

int rec (int s, int n, bool b) {
    int ans = 0;
    if (b) {
        if (s == 0) return 1;
        for (int i = n + 1; i <= s; ++i) {
            if (i == s) ans = (ans + 1) % con;
            else {
                trip a = trip(s - i, i, false);
                if (mem.find(a) == mem.end()) ans = ((mem[a] = (rec(s - i, i, false) % con)) + ans) % con;
                else ans = (ans + mem[a]) % con;
            }
        }
    } else {
        for (int i = 1; i <= min(s, n - 1); ++i) {
            if (i == s) ans = (ans + 1) % con;
            else {
                trip a = trip(s - i, i, true);
                if (mem.find(a) == mem.end()) ans = ((mem[a] = (rec(s - i, i, true) % con)) + ans) % con;
                else ans = (ans + mem[a]) % con;
            }
        }
    }
    return ans;
}

int main() {
    int n, k;
    cin >> n >> k;
    cout << rec(n - k, k, true) + rec(n - k, k, false) << endl;
    return 0;
}