#include <bits/stdc++.h>
using namespace std;

#define MOD 1000000007

long long dp1[5002][5002];
long long dp2[5002][5002];

int main() {
    int n, k;
    cin >> n >> k;
    if(n == k) {
        cout << 1 << endl;
        return 0;
    }

    for(int i = 1; i <= n; ++i) {
        dp1[i][i] = 1;
        dp2[i][i] = 1;
    }

    for(int st = n; st >= 0; --st) {
        dp1[1][st] += dp1[1][st + 1];
        dp1[1][st] %= MOD;
    }

    for(int st = 1; st <= n; ++st) {
        dp2[1][st] += dp2[1][st - 1];
        dp2[1][st] %= MOD;
    }

    for(int sum = 2; sum <= n; ++sum) {
        for(int st = 1; st < sum; ++st) 
            dp1[sum][st] = dp2[sum - st][st - 1];
        for(int st = n; st >= 0; --st) {
            dp1[sum][st] += dp1[sum][st + 1];
            dp1[sum][st] %= MOD;
        }

        for(int st = 1; st < sum; ++st) 
            dp2[sum][st] = dp1[sum - st][st + 1];
        for(int st = 1; st <= n; ++st) {
            dp2[sum][st] += dp2[sum][st - 1];
            dp2[sum][st] %= MOD;
        }
    }


    long long a = dp1[n][k] - dp1[n][k + 1];
    if(a < 0)
        a += MOD;
    a %= MOD;

    long long b = dp2[n][k] - dp2[n][k - 1];
    if(b < 0)
        b += MOD;
    b %= MOD;

    cout << (a + b) % MOD << endl;

    return 0;
}