#include <bits/stdc++.h>
using namespace std;

#define sz(x) ((int)(x).size())

vector< vector<int> > g;

char used_d[300000];
char used[300000];
int dth[300000];
int len = 0;

void d_dfs(int v, int d) {
    used_d[v] = true;
    dth[v] = d;
    for(int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        if(!used_d[to]) {
            d_dfs(to, d + 1);
        }
        else if(abs(dth[v] - dth[to]) > 1) {
            len = abs(dth[v] - dth[to]) + 1;
        }
    }
}
int dfs1 (int v, int d) {
    used[v] = true;
    int tmp = (d + 1) % 2;
    for(int i = 0; i < sz(g[v]); ++i) 
        if(!used[g[v][i]]) 
            tmp += dfs1(g[v][i], d + 1);
    return tmp;
}

pair<int, int> dfs2 (int v, int d) {
    used[v] = true;
    pair<int, int> tmp = {d % 2, (d + 1) % 2};
    for(int i = 0; i < sz(g[v]); ++i) 
        if(!used[g[v][i]]) {
            pair<int, int> tmp2 = dfs2(g[v][i], d + 1);
            tmp.first += tmp2.first;
            tmp.second += tmp2.second;
        }
    return tmp;
}

int main() {
    int n;
    cin >> n;
    g.resize(n);
    memset(used, 0, sizeof(used));
    memset(used_d, 0, sizeof(used));

    for(int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if(t == -1)
            continue;
        t--;
        g[t].push_back(i);
        g[i].push_back(t);
    }

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        if(!used[i]) {
            len = 0;
            d_dfs(i, 0);

            if(len == 0) {
                if(i == 0)
                    ans += dfs1(i, 0);
                else {
                    pair<int, int> temp = dfs2(i, 0);
                    ans += max(temp.first, temp.second);
                }
            }
            else {
                if(len % 2 == 0) {
                    if(i == 0)
                        ans += dfs1(i, 0);
                    else {
                        pair<int, int> temp = dfs2(i, 0);
                        ans += max(temp.first, temp.second);
                    }
                }
                else {
                    ans += 0;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}