// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef int64_t ll;
typedef long double ld;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

inline void solve() {
	ll k;
	cin >> k;
	k = abs(k);
	if (k == 0) {
		cout << 0 << endl;
		return;
	}
	ll res = 1e18;
	for (ll i = 1; i * i <= k; ++i) {
		if (k % i) {
			continue;
		}
		ll a = k / i;
		ll b = i;
		if ((a + b) % 2) {
			continue;
		}
		res = min(res, (a - b) / 2);
	}
	if (res == 1e18) {
		cout << "none" << endl;
	}
	else {
		cout << res << endl;
	}
}

int main() {
	start();
	solve();
	return 0;
}
