// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef int64_t ll;
typedef long double ld;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

inline void solve() {
	ll k;
	cin >> k;
	if (k == 0) {
		cout << 0 << endl;
		return;
	}
	ll res = -1;
	ll flag = 1;
	for (ll i = 1; i * i <= abs(k); ++i) {
		if (k % i) {
			continue;
		}
		ll a = k / i;
		ll b = i;
		if (a < b) {
			swap(a, b);
		}
		if ((a - b) % 2) {
			continue;
		}
		flag = 0;
		res = (a + b) / 2;

	}
	if (flag) {
		cout << "none" << endl;
	}
	else {
		cout << abs(res) << endl;
	}
}

int main() {
	start();
	solve();
	return 0;
}
