// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;
typedef long double ld;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

inline void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(m);
	vector<ll> b(n);
	for (ll i = 0; i < m; ++i) {
		cin >> a[i];
	}
	for (ll i = 0; i < n; ++i) {
		cin >> b[i];
	}
	reverse(b.begin(), b.end());
	vector<ll> used(n + 1);
	vector<ll> d;
	for (ll i = 0; i < m; ++i) {
		if (used[a[i]]) {
			d.emplace_back(a[i]);
		}
		else {
			while (b.back() != a[i]) {
				used[b.back()] = 1;
				d.emplace_back(b.back());
				b.pop_back();
			}
			used[b.back()] = 1;
			d.emplace_back(b.back());
			b.pop_back();
		}
	}
	vector<ll> id(n + 1, -1);
	vector<ll> res(d.size());
	for (ll i = d.size() - 1; i >= 0; --i) {
		if (id[d[i]] == -1) {
			res[i] = n;
		}
		else {
			vector<ll> cnt(n + 1);
			for (ll j = i; j <= id[d[i]]; ++j) {
				if (cnt[d[j]] == 0) {
					++res[i];
				}
				++cnt[d[j]];
			}
		}
		id[d[i]] = i;
	}
	cout << res.size() << endl;
	for (ll i : res) {
		cout << i << " ";
	}
}

int main() {
	start();
	solve();
	return 0;
}
