// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MAX_N = 5'001;
const ll MOD = 1'000'000'007;
ll dp[MAX_N][MAX_N][2];

inline void solve() {
	ll n, k;
	cin >> n >> k;
	dp[k][k][1] = dp[k][k][0] = 1;
	for (ll i = k; i <= n; ++i) {
		vector<ll> add1(n + 1);
		vector<ll> add2(n + 1);
		for (ll j = 1; j <= n; ++j) {
			add1[j - 1] = (add1[j - 1] + dp[i][j][0]) % MOD;
			add2[j + 1] = (add2[j + 1] + dp[i][j][1]) % MOD;
		}
		for (ll j = 1; j <= n; ++j) {
			add2[j] = (add2[j] + add2[j - 1]) % MOD;
		}
		for (ll j = n - 1; j >= 0; --j) {
			add1[j] = (add1[j] + add1[j + 1]) % MOD;
		}
		for (ll j = 1; k + j <= n; ++j) {
			dp[k + j][j][0] = add2[k + j];
			dp[k + j][j][1] = add1[k + j];
		}
	}
	ll res = 0;
	for (ll i = 0; i <= n; ++i) {
		res = (res + dp[n][i][0] + dp[n][i][1]) % MOD;
	}
	cout << res << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
