// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

vector<vector<ll>> g;
vector<ll> used;
vector<ll> res;
vector<ll> kek;

bool f(vector<ll>& a, vector<ll>& b) {
	for (ll i = 0; i < (int)a.size(); ++i) {
		ll mx = max(a[i], b[i]);
		ll mn = min(a[i], b[i]);
		if (mn > kek[i] || mx < kek[i]) {
			return false;
		}
	}
	return true;
}

bool dfs_kun(ll v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (res[u] == -1) {
			res[u] = v;
			return true;
		}
	}
	for (auto u : g[v]) {
		if (used[res[u]]) {
			continue;
		}
		if (dfs_kun(res[u])) {
			res[u] = v;
			return true;
		}
	}
	return false;
}

inline void solve() {
	ll n, k;
	cin >> n >> k;
	vector<vector<ll>> a(n, vector<ll>(k));
	vector<vector<ll>> lol(k, vector<ll>(n));
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < k; ++j) {
			cin >> a[i][j];
			lol[j][i] = a[i][j];
		}
	}
	for (ll i = 0; i < k; ++i) {
		sort(lol[i].begin(), lol[i].end());
	}
	for (ll i = 0; i < k; ++i) {
		kek.emplace_back(lol[n / 2]);
	}
	g.resize(n);
	res.resize(n, -1);
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			if (f(a[i], a[j])) {
				g[i].emplace_back(j);
				g[j].emplace_back(i);
			}
		}
	}

	ll cnt = 0;
	for (ll i = 0; i < n; ++i) {
		used.resize(n);
		if (dfs_kun(i)) {
			++cnt;
		}
		used.clear();
	}
	if (cnt == n) {
		cout << "YES" << endl;
		used.resize(n);
		for (ll i = 0; i < n; ++i) {
			if (used[i]) {
				continue;
			}
			used[i] = 1;
			used[res[i]] = 1;
			cout << i + 1 << " " << res[i] + 1 << endl;
		}
	}
	else {
		cout << "NO" << endl;
	}
}

int32_t main() {
	start();
	solve();
	return 0;
}
