// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

vector<vector<ll>> g;
vector<ll> used;
vector<ll> res;
vector<ll> kek;

bool f(vector<ll>& a) {
	for (ll i = 0; i < (int)a.size(); ++i) {
		if (a[i] < kek[i]) {
			return false;
		}
	}
	return true;
}

inline void solve() {
	ll n, k;
	cin >> n >> k;
	vector<vector<ll>> a(n, vector<ll>(k));
	vector<vector<ll>> lol(k, vector<ll>(n));
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < k; ++j) {
			cin >> a[i][j];
			a[i][j] *= 2;
			lol[j][i] = a[i][j];
		}
	}
	for (ll i = 0; i < k; ++i) {
		sort(lol[i].begin(), lol[i].end());
	}
	for (ll i = 0; i < k; ++i) {
		kek.emplace_back((lol[i][n / 2 - 1] + lol[i][n / 2]) / 2);
	}
	vector<ll> left;
	vector<ll> right;
	for (ll i = 0; i < n; ++i) {
		if (f(a[i])) {
			left.emplace_back(i + 1);
		}
		else {
			right.emplace_back(i + 1);
		}
	}
	if (left.size() == right.size()) {
		cout << "YES" << endl;
		for (ll i = 0; i < n / 2; ++i) {
			cout << left[i] << " " << right[i] << endl;
		}
	}
	else {
		cout << "NO" << endl;
	}
}

int32_t main() {
	start();
	solve();
	return 0;
}
