#include <iostream>
#include <vector>

using namespace std;

int n, k;

vector<vector<vector<int> > > dp;

int check(int now, bool up, int sum){
    if (sum == n){
        return 1;
    }
    if (dp[sum][now][up] != -1){
        return dp[sum][now][up];
    }
    int ans = 0;
    if (up){
        for (int nx = now + 1; sum + nx <= n; nx++){
            ans += check(nx, 0, sum + nx);
        }
    }else{
        for (int nx = 1; nx <= min(n - sum, now - 1); nx++){
            ans += check(nx, 1, sum + nx);
        }
    }
    dp[sum][now][up] = ans;
    return ans;
}

int main()
{
    cin >> n >> k;
    dp.resize(n + 1, vector<vector<int> > (n + 1, vector<int>(2, 0)));
    if (n == k){
        cout << 1 << endl;
        return 0;
    }
    for (int i = 1; i <= n; i++){
        dp[n][i][0] = dp[n][i][1] = 1;
    }
    for (int sum = n - 1; sum >= k; sum--){
        vector<vector<int> > pref(n + 2, vector<int>(2));
        for (int i = 1; i + sum <= n; i++){
            pref[i + 1][0] = pref[i][0] + dp[sum + i][i][0];
            pref[i + 1][1] = pref[i][1] + dp[sum + i][i][1];
        }
        for (int i = 1; i <= n; i++){
            dp[sum][i][0] = pref[min(n - sum, i - 1) + 1][1];
            dp[sum][i][1] = pref[n - sum + 1][0] - pref[i + 1][0];
        }
    }
    cout << dp[k][k][0] + dp[k][k][1];
    return 0;
}
