#include <iostream>
#include <vector>

#define int long long

using namespace std;

const int MOD = 1e9 + 7;
int n, k;

vector<vector<vector<int> > > dp;

void prt(vector<vector<int> > a){
    for (auto i : a){
        for (auto j : i){
            cout << j << ' ';
        }
        cout << "   ";
    }
    cout << endl;
}

signed main()
{
    cin >> n >> k;
    dp.resize(n + 1, vector<vector<int> > (n + 1, vector<int>(2, 0)));
    if (n == k){
        cout << 1 << endl;
        return 0;
    }
    for (int i = 1; i <= n; i++){
        dp[n][i][0] = dp[n][i][1] = 1;
    }
    for (int sum = n - 1; sum >= k; sum--){
        vector<vector<int> > pref(n + 2, vector<int>(2));
        for (int i = 0; i + sum <= n; i++){
            pref[i + 1][0] = pref[i][0] + dp[sum + i][i][0];
            pref[i + 1][1] = pref[i][1] + dp[sum + i][i][1];
            pref[i + 1][0] %= MOD;
            pref[i + 1][1] %= MOD;
        }
        for (int i = n - sum + 1; i <= n; i++){
            pref[i + 1][0] = pref[i][0];
            pref[i + 1][1] = pref[i][1];
        }
        //cout << sum << endl;
        //prt(pref);
        //cout << endl;
        for (int i = 1; i <= n; i++){
            dp[sum][i][0] = pref[min(n - sum, i - 1) + 1][1];
            dp[sum][i][1] = max(0ll, pref[n - sum + 1][0] - pref[i + 1][0]) % MOD;
        }
    }
    /*for (auto i : dp){
        prt(i);
    }*/
    cout << (dp[k][k][0] + dp[k][k][1]) % MOD;
    return 0;
}
