#include <iostream>
#include <vector>

using namespace std;

vector<vector<int> > g;
vector<bool> used;
vector<int> p;

bool kun(int v){
    if (used[v]){
        return false;
    }
    used[v] = true;
    for (auto i : g[v]){
        if (p[i] == -1 || kun(p[i])){
            p[i] = v;
            p[v] = i;
            return true;
        }
    }
    return false;
}

int cnt = 0;

void dfs(int v, bool l){
    if (l){
        cnt++;
    }
    used[v] = true;
    if (l){
        if (p[v] != -1 && !used[p[v]]){
            dfs(p[v], false);
        }
    }else{
        for (auto i : g[v]){
            if (!used[i] && i != p[v]){
                dfs(i, true);
            }
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    g.resize(n);
    used.resize(n);
    p.resize(n, -1);
    int ans = 0;
    for (int i = 0; i < n; i++){
        int sup;
        cin >> sup;
        sup--;
        g[sup].push_back(i);
        g[i].push_back(sup);
    }
    for (int i = 0; i < n; i++){
        used.resize(0);
        used.resize(n);
        ans += kun(i);
    }
    used.resize(0);
    used.resize(n, 0);
    for (int i = 0; i < n; i++){
        if (!used[i] && p[i] != -1){
            dfs(i, 1);
        }
    }
    ans += n - cnt;
    cout << ans << endl;
    return 0;
}
