#include <iostream>
#include <vector>

using namespace std;
long long mod = 1000000007;

int main() {
	int n, k, i, j, l;
	cin >> n >> k;
	long long sum;

	vector<vector<long long>> a(n + 1);
	vector<vector<long long>> d(n + 1);

	for (i = 0; i <= n; i++) {
		for (j = 0; j <= i; j++) {
			if (i == 0) {
				a[i].push_back(0);
				d[i].push_back(0);
				//cout << i << " " << j << ": " << a[i][j] << " " << d[i][j] << endl;
				continue;
			}
			if (j == 0) {
				a[i].push_back(0);
				d[i].push_back(0);
				//cout << i << " " << j << ": " << a[i][j] << " " << d[i][j] << endl;
				continue;
			}
			if (i == k && j == k) {
				a[i].push_back(1);
				d[i].push_back(1);
				//cout << i << " " << j << ": " << a[i][j] << " " << d[i][j] << endl;
				continue;
			}
			sum = 0;
			for (l = j + 1; l <= i - j; l++) {
				sum = (sum + d[i - j][l]) % mod;
			}
			a[i].push_back(sum);
			sum = 0;
			for (l = 0; l < j; l++) {
				if (l <= i - j) {
					sum = (sum + a[i - j][l]) % mod;
				}
			}
			d[i].push_back(sum);
			//cout << i << " " << j << ": " << a[i][j] << " " << d[i][j] << endl;
		}
	}

	sum = 0;
	for (i = 0; i <= n; i++) {
		sum = (sum + a[n][i] + d[n][i]) % mod;
	}
	if (n == k) {
		sum -= 1;
		if (sum < 0) {
			sum += mod;
		}
	}

	cout << sum << endl;
	return 0;
}