#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int MAXN = 1e6;

int k;
bool les;

signed main() {

    vector<int> sums(MAXN);
    for (int i = 1; i < MAXN; ++i) {
        sums[i] = sums[i - 1] + 2 * i;
    }
    cin >> k;
    les = k < 0;
    k = abs(k);
    if (k == 0) {
        cout << 0;
    }
    int mx = -1;
    for (int x = 1; x < MAXN; ++x) {
        if (x * x - x < k && k % x == 0 &&
            ((k - sums[x - 1]) / x) % 2 == 1) {
            mx = max(mx, x);
        }
    }
    if(mx==-1){
        cout <<"none";
        return 0;
    }
    int st = (k - sums[mx - 1]) / mx;
    if (les) {
        cout << st / 2;
    } else {
        cout << (st + mx * 2)/2;
    }
    return 0;
}