#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void put(int k, int x) {
    k += n;
    tree[k] = x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int mx(int a, int b) {
    a += n;
    b += n;
    int res = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            res = max(res, tree[a++]);
        }
        if (b % 2 == 0) {
            res = max(res, tree[b--]);
        }
        a /= 2;
        b /= 2;
    }
    return res;
}


signed main() {
    int m;
    cin >> n >> m;
    vector<int> q(n);
    vector<int> need(m);
    for (int i = 0; i < m; ++i) {
        cin >> need[i];
        need[i]--;
    }
    for (int i = 0; i < n; ++i) {
        cin >> q[i];
        q[i]--;
    }

    if (n == m) {
        if (q[0] == need[0]) {
            cout << n << "\n";
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
        } else {
            cout << n * 2 - 1 << "\n";
            for (int i = 0; i < n - 1; ++i) {
                cout << n - i << " ";
            }
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
        }
        return 0;
    }
    vector<int> next(m, -1);
    vector<int> pos(n, -1);
    for (int i = m - 1; i >= 0; --i) {
        next[i] = pos[need[i]];
        pos[need[i]] = i;
    }
    for (int j = 0; j < m; ++j) {
        while (q[0] != need[j]) {
            int x = *q.erase(q.begin());
        }
    }
}