#include <bits/stdc++.h>

using namespace std;

#define int unsigned int
const int MOD = 1e9 + 7;

struct DO {
    int n;
    vector<int> tree;

    DO(long long n) : n(n) {
        tree.resize(n * 2, 0);
    }

public:
    void add(int k, int x) {
        k += n;
        tree[k] += x;
        for (k /= 2; k >= 1; k /= 2) {
            tree[k] = f(tree[k * 2], tree[k * 2 + 1]);
        }
    }

    int sum(int a, int b) {
        a += n;
        b += n;
        int res = 0;
        while (b >= a) {
            if (a % 2 == 1) {
                res += tree[a++];
            }
            if (b % 2 == 0) {
                res += tree[b--];
            }
            a /= 2;
            b /= 2;
        }
        return res;
    }

private:
    int f(int a, int b) {
        int res = a + b;
        if (res >= MOD) {
            res -= MOD;
        }
        return res;
    }
};

int _sum(int a, int b) {
    int res = a + b;
    if (res >= MOD) {
        res -= MOD;
    }
    return res;
}

signed main() {
    int n, k;
    cin >> n >> k;
    if(n==k){
        cout <<1;
        return 0;
    }
    vector<vector<int>> dp_les(n + 1, vector<int>(n + 1));
    vector<vector<int>> dp_les_posf(n + 1, vector<int>(n + 1));
    vector<vector<int>> dp_gre(n + 1, vector<int>(n + 1));
    vector<vector<int>> dp_gre_pref(n + 1, vector<int>(n + 1));
    for (int sum = 0; sum <= n; ++sum) {
        for (int cur = 1; cur <= sum; ++cur) {
            if (sum == cur) {
                dp_gre[sum][cur] = dp_les[sum][cur] = 1;
            } else {
                int ost = sum - cur;
                dp_les[sum][cur] = dp_gre_pref[ost][cur - 1];
                dp_gre[sum][cur] = dp_les_posf[ost][cur];
            }
        }
        for (int i = 1; i <= n; ++i) {
            dp_gre_pref[sum][i] = _sum(dp_gre_pref[sum][i - 1], dp_gre[sum][i]);
        }
        for (int i = n - 1; i > 0; --i) {
            dp_les_posf[sum][i] = _sum(dp_les_posf[sum][i + 1], dp_les[sum][i + 1]);
        }
        dp_les_posf[sum][0] = _sum(dp_les_posf[sum][1], dp_les[sum][1]);
    }
    cout << (dp_gre[n][k] + dp_les[n][k]) %MOD;
    return 0;
}