#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#include <random>
#define int long long

/**
    
**/

using namespace std;

int n;
vector<int> a;

int cnt(int mask) {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            res++;
        }
    }
    return res;
}

int main19() {
    for (int i = 0; i < n; ++i) {
        if (a[i] != -1) {
            a[i]--;
        }
    }
    int mask = 0;

    int ans = 0;
    //int bestmask = 0;

    while (mask < (1 << n) - 1) {
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (a[i] != -1 && ((mask >> i) & 1) && ((mask >> a[i]) & 1)) {
                ok = false;
            }
        }
        if (ok) {
            /*
            if (cnt(mask) > ans) {
                ans = cnt(mask);
                bestmask = mask;
            }
            */
            ans = max(ans, cnt(mask));
        }
        mask++;
    }
    /*
    for (int i = 0; i < n; ++i) {
        if ((bestmask >> i) & 1) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    */
    return ans;
}

vector<vector<int>> g;
vector<int> used;
vector<int> clr;
vector<int> clrz;

void dfs10(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            clr[u] = 1 - clr[v];
            clrz[clr[u]]++;
            dfs10(u);
        }
    }
}

int main10() {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai = a[i];
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    used.resize(n, 0);
    clr.resize(n, -1);
    clrz.resize(2);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            clr[i] = 0;
            clrz[1 - clr[i]] = 0;
            clrz[clr[i]] = 1;
            dfs10(i);
            ans += max(clrz[0], clrz[1]);
        }
    }
    return ans;
}

vector<vector<int>> dp;

void dfs15(int v) {
    used[v] = true;
    dp[v][1] = 1;
    dp[v][0] = 0;
    for (int u: g[v]) {
        if (!used[u]) {
            dfs15(u);
            dp[v][1] += dp[u][0];
            dp[v][0] += max(dp[u][0], dp[u][1]);
        }
    }
}

int main15() {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai = a[i];
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    dp.resize(n);
    for (int i = 0; i < n; ++i) {
        dp[i].resize(2, 0);
    }
    used.resize(n, 0);
    int ans = 0;
    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs15(v);
            ans += max(dp[v][0], dp[v][1]);
        }
    }
    cout << ans;
}

signed main()
{
    /// 
    cin >> n;
    a.resize(n);
    bool gr2 = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] != -1 && a[i] != i) {
            gr2 = false;
        }
    }
    if (n <= 20) {
        cout << main19();
    }
    else if (gr2) {
        cout << main10();
    }
    else {
        cout << main15();
    }
    return 0;
}
/*
15
-1 -1 1 2 -1 4 6 3 8 5 7 9 5 12 10
*/
