#pragma GCC optimize("O3")
#include <iostream>
#include <fstream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#define x first
#define y second

using namespace std;

typedef long double ld;

const int N = 510;
const int M = 1e9 + 7;

int n, k, dp[N][N][N];

inline void fast() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

inline void get_dp(bool fl = 0) {
    for (int i = 0; i < n; ++i) for (int j = 0; j <= n; ++j) for (int k = 0; k <= n; ++k) dp[i][j][k] = 0;
    dp[0][k][k] = 1;
    for (int i = 1; i < n; ++i) {
        for (int sum = k; sum <= n; ++sum) {
            for (int last = 1; last <= n; ++last) {
                if (!fl) {
                    for (int cur = 1; cur < last; ++cur) {
                        if (sum + cur > n) break;
                        dp[i][sum + cur][cur] = (dp[i - 1][sum][last] + dp[i][sum + cur][cur]) % M;
                    }
                } else {
                    for (int cur = last + 1; cur <= n; ++cur) {
                        if (sum + cur > n) break;
                        dp[i][sum + cur][cur] = (dp[i - 1][sum][last] + dp[i][sum + cur][cur]) % M;
                    }
                }
            }
        }
        fl = !fl;
    }
}

signed main() {
    fast();
    cin >> n >> k;
    get_dp();
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int last = 1; last <= n; ++last) ans = (ans + dp[i][n][last]) % M;
    }
    if (k == n) {
        cout << ans;
        return 0;
    }
    get_dp();
    for (int i = 0; i < n; ++i) {
        for (int last = 1; last <= n; ++last) ans = (ans + dp[i][n][last]) % M;
    }
    cout << ans;
}
