#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

bool flag = 0;

void F (vector <vector <long> > &v, vector <long> b, long sum, long k, long c, vector <pair <long long int, long long int> > p) {
    if (sum == b.size() && !flag) {
        flag = 1;
        vector <pair <long, long> > now(c - 1, {-1, -1});
        for (int i = 0; i < b.size(); i++) {
            if (now[b[i] - 1].first == -1) now[b[i] - 1].first = i + 1;
            else now[b[i] - 1].second = i + 1;
        }
        cout << "YES" << endl;
        for (int i = 0; i < now.size(); i++) cout << now[i].first << " " << now[i].second << endl;
    }
    if (!flag) {
        for (int i = 0; i < b.size(); i++) {
            if (b[i] == 0) {
                for (int j = i + 1; j < b.size(); j++) {
                    if (b[j] == 0) {
                        bool flag1 = 0;
                        for (int z = 0; z < k; z++) {
                            long l = min(v[i][z], v[j][z]);
                            long r = max(v[i][z], v[j][z]);
                            if (l > p[z].second || r < p[z].first) {
                                flag1 = 1;
                                break;
                            }
                        }
                        if (!flag1) {
                            vector <pair <long long int, long long int> > p1(k);
                            for (int z = 0; z < k; z++) {
                                long long int l = min(v[i][z], v[j][z]);
                                long long int r = max(v[i][z], v[j][z]);
                                p1[z].first = max(p[z].first, l);
                                p1[z].second = min(p[z].second, r);
                            }
                            b[i] = c;
                            b[j] = c;
                            F(v, b, sum + 2, k, c + 1, p1);
                            b[i] = 0;
                            b[j] = 0;
                        }
                    }
                }
            }
        }
    }
}
int main() {
    long n, k;
    cin >> n >> k;
    if (k != 1) {
        vector <vector <long> > v(n, vector <long> (k, 0));
        vector <pair <long long int, long long int> > p(k, {-1e10, 1e10});
        for (int i = 0; i < n; i++)
            for (int j = 0; j < k; j++)
                cin >> v[i][j];
        vector <long> b(n, 0);
        F(v, b, 0,  k, 1, p);
        if (!flag) cout << "NO";
    }
    else {
        bool flag2 = 0;
        vector <pair <long long int, long long int> > v1(n);
        for (int i = 0; i < n; i++) {
            cin >> v1[i].first;
            v1[i].second = i;
        }
        sort(v1.begin(), v1.end());
        vector <pair <long long int, long long int> > answer;
        long long int l = -1e10, r = 1e10;
        for (int i = 0; i < n / 2; i++) {
            l = max(l, v1[i].first);
            r = min(r, v1[n - i - 1].first);
            if (l > r) {
                cout << "NO";
                return 0;
            }
            answer.push_back({v1[i].second + 1, v1[n - i - 1].second + 1});
        }
        cout << "YES" << endl;
        for (int i = 0; i < answer.size(); i++) cout << answer[i].first << " " << answer[i].second << endl;
    }
}

