#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

struct type {
	int num, i, cnt;
};

bool operator <(const type& a, const type& b) {
	if (a.num != b.num) return a.num < b.num;
	if (a.i != b.i) return a.i < b.i;
	return a.cnt < b.cnt;
}

int n, m;
vector<int> a;

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	cin >> n >> m;
	a.resize(m);

	if (n > 2000 || m > 2000) {
		vector<int> dat;
		dat.resize(n + 1, -1);

		for (int i = 0; i < m; i++) {
			cin >> a[i];
			dat[a[i]] = i + 1;
		}
		vector<int> ans;
		deque<int> card;

		for (int i = 0; i < n; i++) {
			int z;
			cin >> z;
			card.push_back(z);
		}

		set<type> buf;
		buf.insert({ inf, inf, inf });
		int cnt = 1, j = 0, cnt1 = 0;

		while (cnt <= m) {
			auto f = buf.lower_bound({ a[cnt - 1], 0, 0 });
			auto f1 = *f;
			if (f1.num == a[cnt - 1]) {
				buf.erase(f);
				ans.push_back(n);
				ans[f1.i] = j - f1.i - cnt1 + f1.cnt;
				cnt++;
				cnt1++;
				j++;
				continue;
			}

			int now = card[0];
			card.pop_front();
			if (a[cnt - 1] == now) {
				ans.push_back(n);
				cnt++;
				j++;
				continue;
			}

			buf.insert({ now, j, cnt1});
			ans.push_back(-1);
			j++;
		}

		cout << ans.size() << '\n' << ans;

		//system("pause");
		return 0;
	}
	vector<vector<int>> dat;
	vector<int> pos;

	pos.resize(n + 1);
	dat.resize(n + 1);

	vector<int> ans;

	for (int i = 0; i < m; i++) {
		cin >> a[i];
		dat[a[i]].push_back(i + 1);
	}
	for (auto &i : dat) {
		i.push_back(inf);
	}

	for (int i = 1; i <= n; i++) {
		int k;
		cin >> k;
		pos[k] = i;
	}
	int cnt = 1;

	while (cnt <= m) {

		int now = -1;
		for (int j = 1; j <= n; ++j) {
			if (pos[j] == 1) {
				now = j;
			}
		}
		if (now == -1) cout << "error\n";

		int kek = lower_bound(dat[now].begin(), dat[now].end(), cnt) - dat[now].begin();
		if (dat[now][kek] == cnt) {
			cnt++;
			kek++;
		}
		kek = dat[now][kek];
		int pos_now = 1;

		for (int i = 1; i <= n; i++) {
			if (i == now) continue;

			int smth = lower_bound(dat[i].begin(), dat[i].end(), cnt) - dat[i].begin();

			if (dat[i][smth] < kek) {
				pos_now = max(pos_now, pos[i]);
			}
		}

		ans.push_back(pos_now);

		for (int i = 1; i <= n; i++) {
			if (pos[i] <= pos_now) pos[i]--;
		}
		pos[now] = pos_now;
	}

	cout << ans.size() << '\n' << ans;

	//system("pause");
	return 0;
}