#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

#define int long long

const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

int kek(int a) {
	return a / 2 + a % 2;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	
	long long a, b, c;
	cin >> a >> b >> c;

	int left_c = (a / c + 1) * c;
	int right_c = (b / c) * c;
	int cnt = (right_c - left_c) / c;

	if (cnt < 0) {
		cout << kek(b - a);
	}
	else {
		int len1 = kek(left_c - 1 - a) + 1;
		int len2 = kek(b - (right_c + 1));
		int len3 = kek(c);

		cout << len1 + len2 + cnt * len3;
	}

	//system("pause");
	return 0;
}