#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

long long int mod = 1000000007;

int n, k;

int main() {
	scanf("%d %d", &n, &k);
	if (n == k) {
		printf("1");
		system("pause");
		return 0;
	}
	vector<vector<long long int>> dp(2, vector<long long int>(n + 1));
	vector<vector<vector<long long int>>> dp2(2, vector<vector<long long int>>(n + 1, vector<long long int>(n + 1)));
	dp[0][k] = 1;
	dp[1][k] = 1;
	for (int i = k; i <= n; i++) {
		dp2[0][i][k] = 1;
		dp2[1][i][k] = 1;
	}
	for (int i = k + 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j > i) break;
			dp[0][j] = dp2[1][j - 1][i - j];
			dp[1][j] = dp2[0][n][i - j] - dp2[0][j][i - j];
			dp[0][j] %= mod;
			dp[1][j] %= mod;
		}
		for (int j = 1; j <= n; j++) {
			dp2[0][j][i] = dp[0][j] + dp2[0][j - 1][i];
			dp2[1][j][i] = dp[1][j] + dp2[1][j - 1][i];
		}
	}
	long long int res = 0;
	for (int j = 1; j <= n; j++) {
		res += dp[0][j] + dp[1][j];
	}
	res %= mod;
	printf("%lld", res);
	system("pause");
	return 0;
}