#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

int*** g2;
int** s2;
int** g;
bool* t;
int* vis;
int* clr;
int* id;
int* dp1;
int* dp2;
int* s;
int* p;
int n;

int num = 0;

void paint(int v, int c) {
	if (vis[v] != -1) return;
	id[v] = num++;
	clr[c]++;
	vis[v] = c;
	for (int i = 0; i < s[v]; i++)
		paint(g[v][i], c);
}

int T;

bool check(int v, int c, int p = -1) {
	if (vis[v] == T) return true;
	vis[v] = T;
	bool res = false;
	for (int i = 0; i < s2[c][v]; i++)
		if(g2[c][v][i] != p)
			res |= check(g2[c][v][i], c, v);
	return res;
}

void dfs1(int v, int c, int p = -1) {
	if (vis[v] != -1) return;
	vis[v] = 0;
	dp1[v] = 0;
	dp2[v] = 1;
	for (int i = 0; i < s2[c][v]; i++) {
		if (g2[c][v][i] != p) {
			dfs1(g2[c][v][i], c, v);
			dp1[v] += dp2[g2[c][v][i]];
			if (dp2[g2[c][v][i]] < dp1[g2[c][v][i]])
				dp2[v] += dp2[g2[c][v][i]];
			else dp2[v] += dp1[g2[c][v][i]];
		}
	}
}

int get(int c, int r = 0) {
	dp1 = new int[clr[c]];
	dp2 = new int[clr[c]];
	for (int i = 0; i < clr[c]; i++) vis[i] = -1;
	dfs1(r, c);
	if (dp1[r] > dp2[r]) return dp2[r];
	else return dp1[r];
}

int main() {
	scanf("%lld", &n);
	p = new int[n];
	g = new int*[n];
	clr = new int[n];
	s = new int[n];
	vis = new int[n];
	id = new int[n];
	for (int i = 0; i < n; i++) s[i] = 0;
	for (int i = 0; i < n; i++) {
		clr[i] = 0;
		vis[i] = -1;
		scanf("%d", &p[i]);
		p[i]--;
		if (p[i] != -2) {
			s[i]++;
			s[p[i]]++;
		}
	}
	for (int i = 0; i < n; i++) {
		g[i] = new int[s[i]];
		s[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		if (p[i] != -2) {
			g[i][s[i]++] = p[i];
			g[p[i]][s[p[i]]++] = i;
		}
	}
	int res = n;
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		num = 0;
		if (vis[i] == -1) paint(i, cnt++);
	}
	g2 = new int**[cnt];
	s2 = new int*[cnt];
	t = new bool[cnt];
	for (int i = 0; i < cnt; i++) {
		g2[i] = new int*[clr[i]];
		s2[i] = new int[clr[i]];
	}
	for (int i = 0; i < n; i++) {
		s2[vis[i]][id[i]] = s[i];
		g2[vis[i]][id[i]] = new int[s[i]];
		for (int j = 0; j < s[i]; j++) {
			g2[vis[i]][id[i]][j] = id[g[i][j]];
		}
		vis[i] = -1;
	}
	for (int i = 0; i < cnt; i++) {
		T = i;
		t[i] = check(0, i);
		if (t[i] == 0) res -= get(i);
	}
	printf("%d", res);
	system("pause");
	return 0;
}