#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 5179;

const int MOD = 1e9 + 7;

int n, k;

const vector<int> steps = {1, -1};

int dp[N][2][N];

void change(int sum, bool f, int pos, int pls) {
	for (int i = pos; i < N; i =i|(i + 1)) {
		dp[sum][f][i] += pls;
		dp[sum][f][i] %= MOD;
	}
}

int get(int sum, bool f, int pos) {
	int res = 0;
	for (int i = pos; i >= 0; i = (i&(i + 1)) - 1) {
		res += dp[sum][f][i];
		res %= MOD;
	}
	return res;
}

int get(int sum, bool f, int l, int r) {
	return ((get(sum, f, r) - get(sum, f, l - 1)) % MOD + MOD) % MOD;
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return 0;
	}
	change(n - k, 0, k, 1);
	change(n - k, 1, k, 1);

	for (int sum = n - k - 1; sum >= 0; sum--) {
		for (int lst = 1; lst <= n && sum + lst <= n; lst++) {
			
			for (int b = 0; b < 2; b++) {
				int res = 0;

				if (b == 0) {
					res = get(sum + lst, b ^ 1, lst + 1, n);
				} else {
					res = get(sum + lst, b ^ 1, 1, lst - 1);
				}

				change(sum, b, lst, res);

				/*int step = 1;
				if (b == 1) step = -1;
				for (int start = lst + step; start > 0 && start <= n; start += step) {
					//cout << "run " << start << " " << b << " from " << sum << " " << lst << " " << b << endl; 
					dp[sum][lst][b] += dp[sum + lst][start][b ^ 1];
					dp[sum][lst][b] %= MOD;
				}*/
			}
		}
	}

	int ans = get(0, 1, n);
	ans += get(0, 0, n);
	ans %= MOD;
	cout << ans << endl;
}