#include <bits/stdc++.h>
#define ff first
#define ss second
using namespace std;

vector<vector<int>> arr;
vector<pair<int, int>> ans;
int n, k;
const int INF = 1e9 + 179;

bool check(vector<pair<int, int>> curr) {
	/*cout << "check b" << endl;
	for (auto el: curr) cout << "{" << el.ff << ";" << el.ss <<"} ";
	cout << endl;*/
	vector<int> mn(k, -INF);
	vector<int> mx(k, INF);

	for (auto el: curr) {
		//cout << el.ff << "-" << el.ss << endl;
		for (int i = 0; i < k; i++) {
			int a = arr[el.ff][i];
			int b = arr[el.ss][i];
			if (a > b) swap(a, b);
			//cout << 
			mn[i] = max(mn[i], a);
			mx[i] = min(mx[i], b);
		}
	}

	for (int i = 0; i < k; i++) {
		//cout << mx[i] << ".." << mx[i] << endl;
		if (mn[i] > mx[i]) {
			//cout << "check e" << endl;
			return 0;
		}
	}
	return 1;
}

const int N = 412;

int edge[N][N];
vector<int> g[N];

bool cmp(vector<int>& a, vector<int>& b) {
	for (int i = 0; i < k; i++) {
		if (a[i] < b[i]) return 1;
		if (a[i] > b[i]) return 0;
	}
	return 0;
}

int who[N];
int used[N];

bool dfs(int i) {
	if (used[i] == 1) return 0;
	used[i] = 1;
	for (auto el: g[i]) {
		if (who[el] == -1 || dfs(who[el])) {
			who[el] = i;
			return 1;
		}
	}
	return 0;
}

int main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	arr.resize(n, vector<int>(k));
	for (int i = 0; i < n; i++) {
		vector<int> curr(k + 1);
		curr[k] = i + 1;
		for (int j = 0; j < k; j++) cin >> curr[j];
		arr[i] = curr;
	}

	if (k == 1) {
		sort(arr.begin(), arr.end(), cmp);
		int mn = -INF;
		int mx = INF;
		cout << "YES" << endl;
		for (int i = 0; i < n / 2; i++) {
			cout << arr[i][1] << " " << arr[n - i - 1][1] << endl;
		}
		return 0;
	}

	for (int j = 0; j < k; j++) {
		vector<pair<int, int>> brr;
		for (int i = 0; i < n; i++) {
			brr.push_back({arr[i][j], i});
		}
		sort(brr.begin(), brr.end());
		int val = brr[n / 2].ff;
		int val2 = brr[n / 2 - 1].ff;
		for (int i = 0; i < n; i++) {
			if (brr[i].ff > val2) break;
			for (int i2 = i + 1; i2 < n; i2++) {
				if (val > brr[i2].ff) continue;
				//cout << "+ " << brr[i].ss << " " << brr[i2].ss << endl;
				edge[brr[i].ss][brr[i2].ss]++;
				edge[brr[i2].ss][brr[i].ss]++;
			}
		}
		//cout << "val: " << val << endl;
	}

	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << edge[i][j] << ' ';
		}
		cout << endl;
	}*/

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (edge[i][j] == k) g[i].push_back(j);
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; i++) who[i] = -1;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) used[i] = 0;
		if (dfs(i)) {
			cnt++;
		}
	}

	if (cnt != n) {
		cout << "NO" << endl;
		return 0;
	}

	cout << "YES" << endl;
	set<pair<int, int>> s;
	for (int i = 0; i < n; i++) {
		int a = i + 1;
		int b = who[i] + 1;
		if (a > b) swap(a, b);
		s.insert({a, b});
	}
	for (auto el: s) {
		cout << el.ff << " " << el.ss << endl;
	}



	return 0;
}

/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2

4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1

4 2
1 1
1 1
1 1
1 1

*/