#include <bits/stdc++.h>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define endl '\n'
#define ll long long
#define ull unsigned long long

using namespace std;
const int MAXN = 3e5+1;
char color1[MAXN],color2[MAXN],color3[MAXN],color4[MAXN];
bool used1[MAXN], used2[MAXN], used3[MAXN], used4[MAXN];
vector<vector<int> > arr;
pair<int,int> cnt;
int cycle = -1;
void dfs1(int pos, int father = -1, int color = 1)
{
    used1[pos]  = true;
    color1[pos] = color;
    for(int i = 0; i < arr[pos].size();i++){
        int vert  = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(used1[vert]){
            if(color1[vert] == color1[pos]){
                color = -1;
                color1[pos] = -1;
                cycle = pos;
            }
        }
    }
    if(color == 1){
        cnt.first++;
    }
    if(color == 2){
        cnt.second++;
    }
    if(color == -1){
        color = 1;
    }
    for(int i = 0; i < arr[pos].size();i++){
        int vert = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(!used1[vert]){
            if(color == 1){
                dfs1(vert,pos,2);
            }
            else{
                dfs1(vert,pos,1);
            }
        }
    }
}
void dfs2(int pos, int father = -1, int color = 2)
{
    used2[pos]  = true;
    color2[pos] = color;
    for(int i = 0; i < arr[pos].size();i++){
        int vert  = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(used2[vert]){
            if(color2[vert] == color2[pos]){
                color = -1;
                color2[pos] = -1;
                cycle = pos;
            }
        }
    }
    if(color == 1){
        cnt.first++;
    }
    if(color == 2){
        cnt.second++;
    }
    if(color == -1){
        color = 2;
    }
    for(int i = 0; i < arr[pos].size();i++){
        int vert = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(!used2[vert]){
            if(color == 1){
                dfs2(vert,pos,2);
            }
            else{
                dfs2(vert,pos,1);
            }
        }
    }

}
void dfs3(int pos, int father = -1, int color = 1)
{
    used3[pos]  = true;
    color3[pos] = color;
    for(int i = 0; i < arr[pos].size();i++){
        int vert  = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(used3[vert]){
            if(color3[vert] == color3[pos]){
                color = -1;
                color3[pos] = -1;
                cycle = pos;
            }
        }
    }
    if(color == 1){
        cnt.first++;
    }
    if(color == 2){
        cnt.second++;
    }
    if(color == -1){
        color = 1;
    }
    for(int i = 0; i < arr[pos].size();i++){
        int vert = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(!used3[vert]){
            if(color == 1){
                dfs3(vert,pos,2);
            }
            else{
                dfs3(vert,pos,1);
            }
        }
    }

}
void dfs4(int pos, int father = -1, int color = 2)
{
    used4[pos]  = true;
    color4[pos] = color;
    for(int i = 0; i < arr[pos].size();i++){
        int vert  = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(used4[vert]){
            if(color4[vert] == color4[pos]){
                color = -1;
                color4[pos] = -1;
                cycle = pos;
            }
        }
    }
    if(color == 1){
        cnt.first++;
    }
    if(color == 2){
        cnt.second++;
    }
    if(color == -1){
        color = 2;
    }
    for(int i = 0; i < arr[pos].size();i++){
        int vert = arr[pos][i];
        if(vert == father){
            continue;
        }
        if(!used2[vert]){
            if(color == 1){
                dfs4(vert,pos,2);
            }
            else{
                dfs4(vert,pos,1);
            }
        }
    }

}
int main()
{
	fast;
    int n;
    cin >> n;
    int a;
    arr.resize(n+1);
    for(int i =1; i <=n;i++){
        cin >> a;
        if(a!=-1){
            arr[a].push_back(i);
            arr[i].push_back(a);
        }
    }
    ll ans = 0;
    for(int i = 1; i <=n;i++){
        if(!used1[i]){
            int tmp_ans = 0;
            cycle = -1;
            cnt = {0,0};
            dfs1(i);
            tmp_ans = max(tmp_ans,max(cnt.first,cnt.second));
            cnt  ={0,0};
            dfs2(i);
            tmp_ans = max(tmp_ans,max(cnt.first,cnt.second));
            if(cycle != -1){
                int root = cycle;
                cnt  ={0,0};
                dfs3(root);
                tmp_ans = max(tmp_ans,max(cnt.first,cnt.second));
                cnt = {0,0};
                dfs4(root);
                tmp_ans = max(tmp_ans,max(cnt.first,cnt.second));
            }
            ans+=tmp_ans;
        }
    }
    cout << ans << endl;
	return 0;
}

