#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
//#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long MOD = 1e9 + 7;

int main()
{
	long long k, n, i, g, j;
	cin >> n >> k;
	vector<vector<vector<int>>> d(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
	d[k][k][0] = 1;
	d[k][k][1] = 1;
	for (i = k; i < n; ++i)
	{
		for (g = 1; g <= n; ++g)
		{
			if (d[i][g][0] != 0)
			{
				for (j = min(g - 1, n - i); j > 0; --j)
				{
					d[i + j][j][1] = (d[i + j][j][1] + d[i][g][0]) % MOD;
				}
			}
			if (d[i][g][1] != 0)
			{
				for (j = g + 1; (i + j) <= n ; ++j)
				{
					d[i + j][j][0] = (d[i + j][j][0] + d[i][g][1]) % MOD;
				}
			}
		}
	}
	long long ans = 0;
	for (i = 1; i <= n; ++i)
	{
		ans = (ans + d[n][i][0]) % MOD;
		ans = (ans + d[n][i][1]) % MOD;
	}
	if (n != k)
		cout << ans << endl;
	else
		cout << 1 << endl;
	//system("pause");
	return 0;
}

/*
int main()
{
	long long a, i, b, c, ans = 0;
	cin >> a >> b >> c;
	if (c == 2)
	{
		ans = (b - a) / 2;
	}
	else
	{
		if (b < -1000000)
		{
			for (i = a; i < b;)
			{
				if ((i + 2) == b || (i + 1) == b)
				{
					++ans;
					break;
				}
				if ((i + 2) % c != 0)
				{
					i += 2;
					++ans;
				}
				else
				{
					++i;
					++ans;
				}
			}
		}
		else
		{
			if (c % 2 == 0)
			{
				if ((c - (a % c)) % 2 == 0)
				{
					++ans;
					++a;
					ans = (b - a) / 2 + (b - a) % 2;
				}
				else
				{
					ans = (b - a) / 2 + (b - a) % 2;
				}
			}
			else
			{
				if ((c - (a % c)) % 2 == 0)
				{
					++ans;
					++a;
					long long cnt = c / 2 + 1;
					long long x = (b - a) % c;
					ans = (b - a) / c * cnt;
				}
				else
				{
					long long cnt = (b - a) % (c / 2 + 1);
					ans = (b - a) / (c / 2 + 1) + cnt / 2 + cnt % 2;
					if ()
				}
			}
		}
	}
	cout << ans << endl;
	//system("pause");
	return 0;
}
*/
