#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int ans = 0, n, x;

vector<bool> used;
vector<int> m;


void dfs(int v)
{
	used[v] = true;
	int to = m[v];
	++x;
	if (to != -2 && used[to] == false)
		dfs(to);
}

void get_ans()
{
	for (int i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			x = 0;
			dfs(i);
			if (x == 1)
				ans += 1;
			else
				ans += x / 2;
		}
	}
}

int main()
{
	int i;
	cin >> n;
	used.resize(n, false);
	m.resize(n);
	for (i = 0; i < n; ++i)
	{
		cin >> m[i];
		--m[i];
	}
	get_ans();
	cout << ans;
	//system("pause");
	return 0;
}

/*
const int MOD = 1e9 + 7;
int main()
{
	int k, n, i, g, j;
	cin >> n >> k;
	//vector<vector<vector<int>>> d(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
	int d[5005][5005][2];
	for (i = 0; i < 5005; ++i)
	{
		for (g = 0; g < 5005; ++g)
		{
			d[i][g][0] = 0;
			d[i][g][1] = 0;
		}
	}
	d[k][k][0] = 1;
	d[k][k][1] = 1;
	int temp;
	for (i = k; i < n; ++i)
	{
		for (g = 1; g <= n; ++g)
		{
			if (d[i][g][0] != 0)
			{
				temp = g - 1;
				if (temp > n - i)
					temp = n - i;
				for (j = temp; j > 0; --j)
				{
					d[i + j][j][1] = (d[i + j][j][1] + d[i][g][0]) % MOD;
				}
			}
			if (d[i][g][1] != 0)
			{
				for (j = g + 1; (i + j) <= n ; ++j)
				{
					d[i + j][j][0] = (d[i + j][j][0] + d[i][g][1]) % MOD;
				}
			}
		}
	}
	int ans = 0;
	for (i = 1; i <= n; ++i)
	{
		ans = (ans + d[n][i][0]) % MOD;
		ans = (ans + d[n][i][1]) % MOD;
	}
	if (n != k)
		cout << ans << endl;
	else
		cout << 1 << endl;
	//system("pause");
	return 0;
}
*/

/*
int main()
{
	long long a, i, b, c, ans = 0;
	cin >> a >> b >> c;
	if (c == 2)
	{
		ans = (b - a) / 2;
	}
	else
	{
		if (b < -1000000)
		{
			for (i = a; i < b;)
			{
				if ((i + 2) == b || (i + 1) == b)
				{
					++ans;
					break;
				}
				if ((i + 2) % c != 0)
				{
					i += 2;
					++ans;
				}
				else
				{
					++i;
					++ans;
				}
			}
		}
		else
		{
			if (c % 2 == 0)
			{
				if ((c - (a % c)) % 2 == 0)
				{
					++ans;
					++a;
					ans = (b - a) / 2 + (b - a) % 2;
				}
				else
				{
					ans = (b - a) / 2 + (b - a) % 2;
				}
			}
			else
			{
				if ((c - (a % c)) % 2 == 0)
				{
					++ans;
					++a;
					long long cnt = c / 2 + 1;
					long long x = (b - a) % c;
					ans = (b - a) / c * cnt;
				}
				else
				{
					long long cnt = (b - a) % (c / 2 + 1);
					ans = (b - a) / (c / 2 + 1) + cnt / 2 + cnt % 2;
					if ()
				}
			}
		}
	}
	cout << ans << endl;
	//system("pause");
	return 0;
}
*/
