#include<bits/stdc++.h>
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define endl '\n'
using namespace std; void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


const int inf = (int) 1e9 + 7;

struct node {
    node *left, *right;
    int sz; int min_val;
    int id, val, pri;

    node (int new_id, int new_val){
        val = new_val;
        id = new_id;
        pri = rand();
        sz = 1;
        min_val = val;
        left = right = nullptr;
    }
};

int get_sz(node* v){
    return v == nullptr ? 0 : v->sz;
}

int get_min_val(node* v){
    return v == nullptr ? inf : v->min_val;
}


void upd(node* v){
    if (v == nullptr){
        return;
    }
    v->sz = 1 + get_sz(v->left) + get_sz(v->right);
    v->min_val = min(v->val, min(get_min_val(v->left), get_min_val(v->right)));
}


pair<node*, node*> split(node* v, int sz) {
    if (v == nullptr){
        return {nullptr, nullptr};
    }
    if (get_sz(v->left) >= sz){
        auto splitted = split(v->left, sz);
        v->left = splitted.second;
        upd(v);
        return {splitted.first, v};
    }
    auto splitted = split(v->right, sz - get_sz(v->left) - 1);
    v->right = splitted.first;
    upd(v);
    return {v, splitted.second};
}

node* merge(node* a, node* b){
    if (a == nullptr || b == nullptr){
        return a == nullptr ? b : a;
    }
    if (a->pri > b->pri){
        a->right = merge(a->right, b);
        upd(a);
        return a;
    }
    b->left = merge(a, b->left);
    upd(b);
    return b;
}



void print_tree(node* v){
    if (v == nullptr)
        return;
    print_tree(v->left);
    cout << v->id << ' ';
    print_tree(v->right);
}


int get_first(node* v){
    auto splitted = split(v, 1);
    int ans = splitted.first->id;
    v = merge(splitted.first, splitted.second);
    return ans;
}


void solve() {
    int n, m; cin >> m >> n;
    vector<int> a(n); forn (i, n) cin >> a[i]; forn (i, n) a[i]--;
    vector<int> b(m); forn (i, m) cin >> b[i]; forn (i, m) b[i]--;
    vector<int> next_oc(m, inf);
    forn (i, n){
        next_oc[a[i]] = min(next_oc[a[i]], i);
    }
    vector<vector<int>> all_oc(m);
    forn (i, n){
        all_oc[a[i]].push_back(i);
    }
    vector<int> ans;

    node* tree = nullptr;
    forn (i, m){
        tree = merge(tree, new node(b[i], next_oc[b[i]]));
    }
    forn (i, n){
        bool found = false;
        while (!found) {
            int b0 = get_first(tree);
            if (b0 == a[i]) {
                found = true;
                if (all_oc[a[i]].back() == i){
                    next_oc[b0] = inf;
                }
                else {
                    next_oc[a[i]] = *upper_bound(all(all_oc[a[i]]), i);
                }



                auto splitted = split(tree, 1);
                splitted.first->val = next_oc[a[i]]; upd(splitted.first);
                tree = merge(splitted.first, splitted.second);
            }
            int l = 0, r = n;
            while (r - l > 1){
                int mid = (l + r) / 2;
                auto splitted = split(tree, m - mid);
                int minval = get_min_val(splitted.second);
                tree = merge(splitted.first, splitted.second);
                if (minval > next_oc[a[i]]){
                    l = mid;
                }
                else {
                    r = mid;
                }
            }


            int j = n - r;
            ans.push_back(j);
            if (len(ans) == 2){

            }
            if (j != 0) {
                auto splitted1 = split(tree, 1);
                auto splitted2 = split(splitted1.second, j);
                tree = merge(splitted2.first, merge(splitted1.first, splitted2.second));
            }
        }
    }
    cout << len(ans) << endl;
    for (auto i : ans)
        cout << i + 1 << ' ';
    cout << endl;
}
