#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

ll Dist(ll a, ll b) {
	return (b - a + 1) / 2;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll a, b, c;
	cin >> a >> b >> c;
	if (a / c == b / c) {
		cout << Dist(a, b) << '\n';
		return 0;
	}
	ll k = a / c + 1;
	ll l = b / c;
	cout << Dist(a, k * c - 1) + Dist(l * c + 1, b) + 1 + (l - k) * ((c + 1) / 2) << '\n';
}

