#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <time.h>
#include<ctime>

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
typedef long long ll;

using namespace std;

vector<vector<int>> g;

vector<int> used;
vector<int> tsort;
int n;

void dfs(int v)
{
    used[v] = true;
    for (int u : g[v])
    {
        if (!used[u])
        dfs(u);
    }
    tsort.push_back(v);
}

void dfs2(int v)
{
    used[v] = true;
    for (int u : g[v])
    {
    used[u] = true;
    }
}

//#define int long long
int res()
{
    int cnt = 0;
    used.clear();
    used.resize(n);

    for (int i = 0; i < n; ++i)
    {
        if (used[tsort[i]] == 0)
        {
           int v = tsort[i];
            used[v] = 1;
            //cout << endl;
            for (int u : g[v])
            {
               // cout << v << " " << used[u] << '\n';
                if (used[u] == 1)
                    used[v] = 2;
            }
            //cout << " u v"<< used[v] << '\n';

            if (used[v] == 1)
                for (int u : g[v])
                    used[u] = 2;
            if (used[v] == 1)
                ++cnt;
        }
    }

    return cnt;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    //auto st = clock();
    //freopen("input.txt", "r", stdin);
    srand(time(0));
    cin >> n;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i< n; ++i)
    {
        int u;
        cin >> u;
        --u;
        if (u == -2)
            continue;
        g[u].push_back(i);
        //cout << u << " " << i << "\n";
    }
    for (int i = 0; i< n; ++i)
    {
        if (!used[i])
            dfs(i);
    }
    reverse(tsort.begin(), tsort.end());
    int cnt = res();
    used.clear();
    used.resize(n);
    for (int i = 0; i < 1000000 / n; ++i)
    {
        cnt = max(cnt , res());
        random_shuffle(tsort.begin(), tsort.end());
    }
    cout << cnt << '\n';

    return 0;
}
