#include <iostream>
#include <vector>
using namespace std;
const int MOD = 1000000007;
int main() {
    int n = 0, k = 1;
    cin >> n >> k;
    if(k == n){
        cout << 1;
        return 0;
    }
    vector <vector <int> > dp1(n+1, vector <int> (n+1, 0));
    vector <vector <int> > dp2(n+1, vector <int> (n+1, 0));
    vector <vector <int> > V1(n+1, vector <int> (n+1, 0));
    vector <vector <int> > V2(n+1, vector <int> (n+1, 0));
    dp1[k][k] = 1;
    dp2[k][k] = 1;
    V1[k][k] = 1;
    V2[k][k] = 1;
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <=n; ++j){
            if (i == k && j == k)
                continue;
            if (i < j){
                V1[i][j] = (V1[i][j-1] + dp1[i][j]) % MOD;
                V2[i][j] = (V2[i][j-1] + dp2[i][j]) % MOD;
                continue;
            }

            dp1[i][j] = V2[i-j][j-1];
            dp2[i][j] = (MOD + V1[i-j][n]-V1 [i-j][j]) % MOD;
            V1[i][j] = (V1[i][j-1] + dp1[i][j]) % MOD;
            V2[i][j] = (V2[i][j-1] + dp2[i][j]) % MOD;
        }
    }
    /*for (int i = 1; i <= n; i++){
        for (int j = 1; j <=n; ++j)
            cout << dp2[i][j] << " ";
        cout << '\n';
    }*/
    cout << (V1[n][n] + V2[n][n]) % MOD;
    return 0;
}