#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>


#define ll long long
#define pii pair<ll, ll>
#define x first
#define y second
#define ld long double

using namespace std;

const ll NMAX = 311111;
const ll inf = 4e18;
const ll M = 1e9 + 7;

int a[NMAX];

int used[NMAX];

vector<int> circ[NMAX];

int c[NMAX];

int dfs1(int v, int p)
{
	used[v] = 1;
	if (a[v] == -1)
	{
		c[v] = 1;
		circ[v].push_back(v);
		used[v] = 2;
		return -1;
	}
	if (used[a[v]] == 2)
	{
		used[v] = 2;
		return -1;
	}
	else if (used[a[v]] == 1)
	{
		used[v] = 2;
		circ[a[v]].push_back(v);
		c[v] = 1;
		return a[v];
	}
	else
	{
		int u = dfs1(a[v], v);
		if (u == -1)
		{
			used[v] = 2;
			return -1;
		}
		else
		{
			if (u == v)
			{
				used[v] = 2;
				circ[u].push_back(v);
				c[v] = 1;
				return -1;
			}
			else
			{
				circ[u].push_back(v);
				c[v] = 1;
				used[v] = 2;
				return u;
			}
		}
	}
}

vector<int> g[NMAX];

int dp[NMAX][2];

void dfs2(int v, int p)
{
	dp[v][1] = 1;
	dp[v][0] = 0;
	for (int u : g[v])
	{
		if (u != p && c[u] == 0)
		{
			dfs2(u, v);
			dp[v][1] += dp[u][0];
			dp[v][0] += max(dp[u][0], dp[u][1]);
		}
	}
	return;
}

int dp2[NMAX][2][2];

signed main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cout.precision(10);
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	for (int i = 1; i <= n; i++)
		if (used[i] == 0)
			dfs1(i, 0);
	for (int i = 1; i <= n; i++)
	{
		if (a[i] != -1)
		{
			g[i].push_back(a[i]);
			g[a[i]].push_back(i);
		}
	}
	for (int i = 1; i <= n; i++)
	{
		if (c[i])
		{
			dfs2(i, 0);
		}
	}
	ll ans = 0;
	for (int i = 1; i <= n; i++)
	{
		if (!circ[i].empty())
		{
			if (circ[i].size() == 1)
			{
				ans += max(dp[i][0], dp[i][1]);
				continue;
			}
			dp2[circ[i][0]][0][0] = dp[circ[i][0]][0];
			dp2[circ[i][0]][1][1] = dp[circ[i][0]][1];
			for (int j = 1; j < circ[i].size(); j++)
			{
				for (int q = 0; q < 2; q++)
				{
					dp2[circ[i][j]][q][0] = max(dp2[circ[i][j - 1]][q][0], dp2[circ[i][j - 1]][q][1]) + dp[circ[i][j]][0];
					dp2[circ[i][j]][q][1] = dp2[circ[i][j - 1]][q][0] + dp[circ[i][j]][1];
				}
			}
			ans += max(max(dp2[circ[i][circ[i].size() - 1]][0][1], dp2[circ[i][circ[i].size() - 1]][1][0]), dp2[circ[i][circ[i].size() - 1]][0][0]);
		}
	}
	cout << ans << endl;
	return 0;
}