#include <iostream>
#include <algorithm>
#include <vector>

#define INF 1000000007
using namespace std;

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    k++;
    if (m!=0) return 0;
    vector<vector<long long> > A(n, vector<long long>(k));
    for (long long i=0; i<k; i++){
        A[0][i] = 1;
    }
    for (long long i=0; i<n-1; i++){
        for (long long j=0; j<k; j++){
            A[i+1][j] = (A[i+1][j]+A[i][j])%INF;
            long long u=1;
            while (j+u<k){
                A[i+1][j+u] = (A[i+1][j+u]+A[i][j])%INF;
                u*=2;
            }
        }
    }
    long long ans = 0;
    for (long long i=0; i<k; i++){
        ans = (ans+A[n-1][i])%INF;
    }
    cout << ans << endl;
}

