#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, ma = 0;

void rec(int v, vector<int> &A, set<int> &Nab)
{
    if (v==n){
        for (auto i:Nab){
            if (Nab.find(A[i]-1)!=Nab.end()){
                /*for (auto j: Nab){
                    cout << j << " ";
                }
                cout << endl;*/
                return;
            }
        }
        /*cout << "!!!";
        for (auto j: Nab){
            cout << j << " ";
        }
        cout << endl;*/
        ma = max(ma, (int)Nab.size());
        return;
    }
    rec(v+1, A, Nab);
    Nab.insert(v);
    rec(v+1, A, Nab);
    Nab.erase(v);
}

bool kuhn(int v, vector<set<int> > &gr, vector<int> &par, vector<bool> &Is)
{
    if (Is[v]) return false;
    Is[v] = true;
    for (auto i:gr[v]){
        if (par[v]==i) continue;
        if (par[i]==-1 || kuhn(par[i], gr, par, Is)){
            if (par[v]!=-1) par[par[v]] = -1;
            par[i] = v;
            if (par[v]!=-1){
                par[par[v]] = -1;
                kuhn(par[v], gr, par, Is);
            }
            par[v] = i;
            return true;
        }
    }
    return false;
}

int main()
{

    cin >> n;
    vector<int> A(n);
    bool q = true;
    for (int i=0; i<n; i++){
        cin >> A[i];
        if (A[i]>i+1) q = false;
    }
    if (q){
        vector<set<int> > sp(n);

        vector<int> B(n, -1);

        for (int i=0; i<n; i++){
            if (A[i]!=-1){
                sp[i].insert(A[i]-1);
                sp[A[i]-1].insert(i);
            }
        }

        for (int i=0; i<n; i++){
            vector<bool> Is(n);
            kuhn(i, sp, B, Is);
        }

        int ans = 0;
        for (int i=0; i<n; i++){
            if (B[i]!=-1) ans++;
        }
        cout << n-ans/2 << endl;
    }
    else{
        set<int> R;
        rec(0, A, R);
        cout << ma << endl;
    }
}



