#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;


ll intsqrt(ll k)
{
    if (k < 0) {
        throw runtime_error("intsqrt(k < 0)");
    }

    ll l = 0, r = k + 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (m * m <= k) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


int main()
{
    ll k;
    cin >> k;
    try {
        auto t = intsqrt(k);
        if (t * t == k) {
            cout << t << endl;
            return 0;
        }
    } catch (...) {
    }

    ll clim = 4 * intsqrt(abs(k));
    
    bool found = false;
    ll mint = 999'999'999'999'999LL;
    for (ll c = 1; c <= clim; ++c) {
        if ((k - c*c) % (2 * c) != 0) {
            continue;
        }
        ll x = (k - c*c) / (2*c);
        ll sq = k + x * x;
        db(x);
        db(sq);
        ll t = intsqrt(sq);
        if (t * t == sq && t < mint) {
            mint = t;
            found = true;
        }
    }

    if (!found) {
        cout << "none" << endl;
    } else {
        cout << mint << endl;
    }
}
