#include <bits/stdc++.h>

using namespace std;

#define int long long

int BIG = 1e9 + 7;

int logarifm(int c) {
    int ans = 1, st = 1;
    while (st <= c) {
        st *= 2;
        ++ans;
    }
    return ans - 1;
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <int> left(n, n + 1);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        if (r > l) swap(l, r);
        left[r] = min(left[r], l);
    }
    vector <vector <int> > dp(n + 1, vector <int> (k + 1, 0));
    int l = logarifm(k);
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= k; ++j) {
            if (dp[i][j] != 0) {
                for (int tmp = j; tmp <= k; ++tmp) {
                    if ((j & tmp) == j) {
                        dp[i + 1][tmp] += dp[i][j];
                        dp[i + 1][tmp] %= BIG;
                    }
                }
                if (left[i] != n + 1) dp[i + 1][j] -= dp[left[i]][j];
                dp[i + 1][j] %= BIG;
            }
        }
        //for (int j = 0; j <= k; j++) dp[i + 1][j] = dp[i][j];
    }
    /*for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= k; ++j) cout << dp[i][j] << " ";
        cout << "\n";
    }*/
    int ans = 0;
    for (int i = 0; i <= k; ++i) {
        ans += dp[n][i];
        ans %= BIG;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
