#include <bits/stdc++.h>

using namespace std;

#define int long long

const int BIG = 1e9 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return;
    }
    vector <vector <pair <int, int> > > dp(n + 1, vector <pair <int, int> > (n + 1, {0, 0}));
    dp[k][k] = {1, 1};
    //vector <vector <int> > pr(n + 1, vector <int> (n + 1, 0));
    for (int i = k; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int l = n - i; l > 0; --l) {
                if (j < l) {
                    dp[i + l][l].first += dp[i][j].second;
                    dp[i + l][l].first %= BIG;
                }
                else if (j > l) {
                    dp[i + l][l].second += dp[i][j].first;
                    dp[i + l][l].second %= BIG;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans += dp[n][i].first;
        ans %= BIG;
        ans += dp[n][i].second;
        ans %= BIG;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
