#include <bits/stdc++.h>

using namespace std;

#define int long long

const int BIG = 1e9 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return;
    }
    vector <vector <pair <int, int> > > dp(n + 1, vector <pair <int, int> > (n + 1, {0, 0}));
    dp[k][k] = {1, 1};
    //vector <vector <int> > pr(n + 1, vector <int> (n + 1, 0));
    for (int i = k; i <= n; ++i) {
        int sum1 = 0, sum2 = 0;
        for (int j = 0; j <= n; ++j) {
            if (j > n - i) {
                sum1 += dp[i][j].first;
                sum1 %= BIG;
            }
            else {
                sum2 += dp[i][j].second;
                sum2 %= BIG;
            }
        }
        //cout << sum1 << " " << sum2 << "\n";
        for (int j = n - i; j > 0; --j) {
            /*if (dp[i][j].first != 0 || dp[i][j].second != 0) {
                for (int l = n - i; l > 0; --l) {
                    if (j < l) {
                        dp[i + l][l].first += dp[i][j].second;
                        dp[i + l][l].first %= BIG;
                    }
                    else if (j > l) {
                        dp[i + l][l].second += dp[i][j].first;
                        dp[i + l][l].second %= BIG;
                    }
                }
            }*/
            //cout << sum1 << " " << sum2 << " " << j << "\n";
            sum2 = (sum2 + BIG - dp[i][j].second) % BIG;
            dp[i + j][j].first = sum2;
            dp[i + j][j].second = sum1;
            sum1 += dp[i][j].first;
            sum1 %= BIG;
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans += dp[n][i].first;
        ans %= BIG;
        ans += dp[n][i].second;
        ans %= BIG;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
