#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <set <int> > g;
vector <int> color;

int cnt = 0;

void dfs(int v) {
    color[v] = 1;
    ++cnt;
    for (auto u : g[v]) {
        if (color[u] == 0) dfs(u);
    }
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    color.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        if (v != -2) {
            g[i].insert(v);
            g[v].insert(i);
        }
    }
    int ans = 0;
    int vers = n, udv = -1;
    vector <int> ban(n, 0);
    while (udv != 0) {
        udv = 0;
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 0 && color[i] == 0) {
                --vers;
                ++udv;
                color[i] = 1;
                if (!ban[i]) ++ans;
            }
            else if (g[i].size() == 1 && color[i] == 0) {
                vers -= 2;
                udv += 2;
                int u;
                for (auto elem : g[i]) u = elem;
                color[i] = 1;
                color[u] = 1;
                if (!ban[i]) ++ans;
                for (auto elem : g[u]) g[elem].erase(u);
                g[u].clear();
                ban[u] = 1;
            }
        }
        //cout << udv;
    }
    for (int i = 0; i < n; ++i) {
        if (g[i].size() > 0 && !color[i]) {
            cnt = 0;
            dfs(i);
            ans += cnt / 2;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

