#include <bits/stdc++.h>
using namespace std;

#define FAST ios_base::sync_with_stdio(false); \
             cin.tie(0); \
             cout.tie(0)

#define ll long long


const ll MOD = 1e9+7;
struct mint
    {
    int val;

    mint()
        {
        val = 0;
        }

    mint(ll value)
        {
        val = value;
        }

    void operator= (mint over)
        {
        val = over.val;
        }
    void operator= (ll over)
        {
        val = over%MOD;
        }

    mint operator+ (mint over)
        {
        return mint((val+over.val)%MOD);
        }

    mint operator- (mint over)
        {
        return mint((val-over.val+MOD)%MOD);
        }

    void operator+= (mint over)
        {
        val = (val+over.val)%MOD;
        }

    mint operator* (mint over)
        {
        return mint((val*over.val)%MOD);
        }
    void operator*= (mint over)
        {
        val = (val*over.val)%MOD;
        }

    };


ll n, m, k, a, b, c, ans = 0;
vector<ll> data;

int main()
    {
    cin >> n >> k;

    if (n == k)
        {
        cout << 1;
        return 0;
        }

    vector<vector<pair<mint, mint>>> dp/*[502][502][2]*/(5001);
    vector<vector<pair<mint, mint>>> dp_prec/*[502][502][2]*/(5001);

    for(int i = 0; i < 5001; ++i)
        {
        dp[i].resize(i+1);
        dp_prec[i].resize(i+1);
        }

    for(int i = 1; i < 5001; ++i)
        {
        dp[i][i] = {1, 1};
        }

    for(int l_l = 1; l_l <= n; ++l_l)
        {
        dp_prec[l_l][0].first = 0;
        dp_prec[l_l][0].second = 0;

        for(int last = 1; last < l_l; ++last)
            {
            dp[l_l][last].first = dp_prec[l_l-last][min(last-1, l_l-last)].second;
            dp[l_l][last].second = dp_prec[l_l-last][l_l-last].first - dp_prec[l_l-last][min(last, l_l-last)].first;

            //cout << endl << l_l-last << " " <<min(last+1, l_l-last) <<endl;

            dp_prec[l_l][last].first = dp_prec[l_l][last-1].first + dp[l_l][last].first;
            dp_prec[l_l][last].second = dp_prec[l_l][last-1].second + dp[l_l][last].second;

            //cout << l_l << " "<< last<< "{[ " << dp[l_l][last].first.val << ", " <<dp[l_l][last].second.val << "], [" << dp_prec[l_l][last].first.val << ", " << dp_prec[l_l][last].second.val <<" ]}\n";
            }

        dp_prec[l_l][l_l].first = dp_prec[l_l][l_l-1].first + dp[l_l][l_l].first;
        dp_prec[l_l][l_l].second = dp_prec[l_l][l_l-1].second + dp[l_l][l_l].second;
        }





    cout << (dp[n][k].second + dp[n][k].first).val;
    }

