#include <iostream>

using namespace std;

typedef long int i64;
typedef long unsigned int u64;
typedef int i32;
typedef unsigned int u32;

i64 sqrt(i64 n) {
    if (n == 0) {
        return 0;
    }
    i64 a = n;
    for (int _ = 0; _ < 64; _++) {
        a = (a + n / a) / 2;
    }
    while (a * a > n) {
        a--;
    }
    return a;
}

i64 sqr(i64 n) {
    return n * n;
}

int main() {
    i64 k;
    cin >> k;
    if (k >= 0 && sqr(sqrt(k)) == k) {
        cout << sqrt(k) << endl;
    } else if (k > 0) {
        i64 m = sqr((k + 1) / 2);
        i64 a = k;
        for (int i = 1; a <= m; i += 2) {
            if (sqr(sqrt(a)) == a) {
                m = sqrt(a);
                break;
            }
            a += i;
        }
        if (m * m < a) {
            cout << "none" << endl;
        } else {
            cout << m << endl;
        }
    } else {
        i64 t = sqrt(sqr((-k + 1) / 2) + k);
        if (sqrt(-k) >= t) {
            cout << sqrt(sqr((-k + 1) / 2) + k) << endl;
        } else {
            cout << "none" << endl;
        }
    }
}
