#include <iostream>

using namespace std;

static const int N = 1000;
static int mat[N][N], maf[N][N];

int vars(int n, int o, bool f) {
    if (o == 0) {
        return 1;
    } else {
        int res = 0;
        if (f) {
            for (int i = 1; i < min(n, o + 1); i++) {
                if (mat[i][o-i] == -1) {
                    mat[i][o-i] = vars(i, o - i, false);
                }
                res = (res + mat[i][o-i]) % 1000000007;
            }
        } else {
            for (int i = n + 1; i <= o; i++) {
                if (maf[i][o-i] == -1) {
                    maf[i][o-i] = vars(i, o - i, true);
                }
                res = (res + maf[i][o-i]) % 1000000007;
            }
        }
        return res;
    }
}

void nil() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            mat[i][j] = maf[i][j] = -1;
        }
    }
}

int main() {
    int n, k;

    cin >> n >> k;

    if (n != k) {
        nil();
        cout << (vars(k, n - k, true) + vars(k, n - k, false)) % 1000000007;
    } else {
        cout << 1;
    }
}
