#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>

using namespace std;

vector <int> g[300010];
int cvet[300010];

long long b = 0, w = 0;
long long n;

void dfs(int in, int color)
{
	cvet[in] = color + 1;

	for (int i = 0; i < g[in].size(); ++i)
		if (cvet[g[in][i]] == 0)
			dfs(g[in][i], (color + 1) % 2);

	bool flag = 1; 

	for (int i = 0; i < g[in].size(); ++i)
		if (cvet[g[in][i]] == color + 1)
		{
			flag = 0;
			cvet[in] = 3;
		}

	if (flag)
	{
		if (color == 0)
			w++;
		else
			b++;
	}
}

int main()
{
	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		x--;

		if (x != -2)
		{
			g[i].push_back(x);
			g[x].push_back(i);
		}

		cvet[i] = 0;
	}

	long long ans = 0;

	for (int i = 0; i < n; ++i)
	{
		if (cvet[i] == 0)
		{
			dfs(i, 0);
			ans += max(b, w);
			b = 0;
			w = 0;
		}
	}

	for (int i = 0; i < n; ++i)
		if (cvet[i] == 0)
			ans++;

	cout << ans;

	system("pause");
	return 0;
}