#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>

using namespace std;

vector <int> g[300010];
int cvet1[300010];
int cvet2[300010];

long long b = 0, w = 0;
long long n;
long long ans = 0;

bool flag = 0;

void dfs2(int in, int color)
{
	cvet2[in] = color + 1;

	for (int i = 0; i < g[in].size(); ++i)
		if (cvet2[g[in][i]] == 0)
			dfs2(g[in][i], (color + 1) % 2);

	if (color == 0)
		w++;
	else
		b++;
}

void dfs1(int in, int color)
{
	cvet1[in] = color + 1;

	for (int i = 0; i < g[in].size(); ++i)
		if (cvet1[g[in][i]] == 0)
			dfs1(g[in][i], (color + 1) % 2);

	for (int i = 0; i < g[in].size(); ++i)
		if (cvet1[g[in][i]] == color + 1)
		{
			cvet1[in] = 3;
			cvet2[in] = 3;
			for (int j = 0; j < g[in].size(); ++j)
			{
				flag = 1;
				if (!cvet2[g[in][j]])
					dfs2(g[in][j], 0);
				ans += max(b, w);
				b = 0;
				w = 0;
			}
		}
}

int main()
{
	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		x--;

		if (x != -2)
		{
			g[i].push_back(x);
			g[x].push_back(i);
		}

		cvet1[i] = 0;
		cvet2[i] = 0;
	}

	for (int i = 0; i < n; ++i)
	{
		if (cvet1[i] == 0)
		{
			dfs1(i, 0);
			if (!flag)
				dfs2(i, 0);
			flag = 0;
			ans += max(b, w);
			b = 0;
			w = 0;
		}
	}

	for (int i = 0; i < n; ++i)
		if (cvet1[i] == 0)
			ans++;

	cout << ans;

	system("pause");
	return 0;
}