#include <bits/stdc++.h>

using namespace std;

#define int long long

bool check(int val) {
	if (val < 0) return false;
	int left = 0, right = 1e9;
	while (left != right - 1) {
		int mid = (left + right) >> 1;
		if (mid * mid <= val) {
			left = mid;
		} else {
			right = mid;
		}
	}
	return left * left == val;
}

void solve() {
	int st = clock();
	int k;
	cin >> k;
	int cur = 1;
	int MX_T = 0.95 * CLOCKS_PER_SEC;
	while ((clock() - st) < MX_T) {
		for (int t = 0; t < 1024; ++t) {
			if (check(k)) {
				int left = 0, right = 1e9;
				while (left != right - 1) {
					int mid = (left + right) >> 1;
					if (mid * mid <= k) {
						left = mid;
					} else {
						right = mid;
					}
				}
				cout << left << endl;
				return;
			}
			k += cur;
			cur += 2;
		}
	}
	cout << "none" << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}