// C.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int mv(vector<int>& cur, int val) {
	int pos = find(cur.begin(), cur.end(), val) - cur.begin();
	cur.erase(cur.begin() + pos);
	cur.insert(cur.begin(), val);
	return pos;
}

int main()
{
	ios::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<int> b(m), a(n);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<int> ans;
	vector<int> cnt(n);
	for (int i = 0; i < m; i++) {
		cnt[b[i]]++;
	}
	int j = n - 1;
	while (j >= 0 && cnt[a[j]] == 0) j--;
	vector<int> cur = a;
	for (int i = m - 1; i >= 0; i--) {
		int pos = mv(cur, b[i]);
		ans.push_back(pos);
		cnt[b[i]]--;
		while (j >= 0 && cnt[a[j]] == 0) {
			//cout << "j = " << j << endl;
			int pos = mv(cur, a[j]);
			if (pos != 0) ans.push_back(pos);
			j--;
		}
		/*for (auto elem : cur) {
			cout << elem << ' ';
		}
		cout << endl;*/
	}
	reverse(ans.begin(), ans.end());
	cout << (int)ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << endl;
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
