#include<set>
#include<map>
#include<list>
#include<cmath>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

struct priority
{
    vector<int> q, p;
    int cur = 0;
};

vector<priority> b;

bool cmp(int x, int y)
{
    return b[x].q[b[x].cur] < b[y].q[b[y].cur];
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
    
    int n, m;
    cin >> n >> m;

    list<int> a;
    vector<list<int>::iterator> pos_it(n + 1);
    set<int> q_pos;
    vector<int> querry(m), q_pos_a(n + 1);
    vector<pair<int, int>> ans;
    b.resize(n + 1);

    for (int i = 1, lst = 0, x; i <= m; i++)
    {
        cin >> x;
        querry[i - 1] = x;
        b[x].q.push_back(i);
        b[x].p.push_back(lst);
        lst = x;
    }

    for (int i = 0, x; i < n; i++)
    {
        cin >> x;
        a.push_back(x);
        pos_it[x] = a.end();
    }

    for (int i = 1; i <= n; i++)
    {
        b[i].q.push_back(m);
    }

    int global_cnt = 0;

    for (int i : querry)
    {
        vector<int> erased;

        int cnt = 1;
        while (a.front() != i)
        {
            int x = a.front();
            a.pop_front();
            erased.push_back(x);

            auto it = q_pos.find(x);
            if (it != q_pos.end())
            {
                ans.push_back({ q_pos_a[x], cnt });
                q_pos.erase(it);
            }

            ++cnt;
            q_pos.insert(x);
            q_pos_a[x] = global_cnt++;
        }

        int x = a.front();
        erased.push_back(x);

        auto it = q_pos.find(x);
        if (it != q_pos.end())
        {
            ans.push_back({ q_pos_a[x], cnt });
            q_pos.erase(it);
        }

        ++cnt;
        q_pos.insert(x);
        q_pos_a[x] = global_cnt++;
        ++b[x].cur;

        sort(erased.begin(), erased.end(), cmp);

        for (int x : erased)
        {
            if (b[x].q[b[x].cur] == m)
            {
                a.push_back(x);
                pos_it[x] = a.end();
            }
            else
            {
                pos_it[x] = ++a.insert(pos_it[b[x].p[b[x].cur]], x);
            }
        }

        a.pop_front();
    }

    int cnt = 1;
    while (!q_pos.empty())
    {
        int x = a.front();
        auto it = q_pos.find(x);
        if (it != q_pos.end())
        {
            ans.push_back({ q_pos_a[x], cnt });
            q_pos.erase(it);
        }
        ++cnt;
        a.pop_front();
    }

    sort(ans.begin(), ans.end());

    cout << ans.size() << '\n';

    for (auto i : ans)
    {
        cout << i.second << ' ';
    }
}