#include<set>
#include<map>
#include<list>
#include<cmath>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

const int MOD = 1e9 + 7, N = 10 + 1;

int dp[N][N][2], sum[N][N][2];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int n, k;
    cin >> n >> k;

    dp[k][k][0] = dp[k][k][1] = 1;
    dp[0][0][0] = dp[0][0][1] = 1;

    for (int i = 0; i < k; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            sum[i][j][0] = sum[i][j - 1][0] + dp[i][j - 1][0];
            if (sum[i][j][0] >= MOD) sum[i][j][0] -= MOD;
        }

        for (int j = n - 2; j >= 1; j--)
        {
            sum[i][j][1] = sum[i][j + 1][1] + dp[i][j + 1][1];
            if (sum[i][j][1] >= MOD) sum[i][j][1] -= MOD;
        }
    }

    for (int i = k + 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            sum[i - 1][j][0] = sum[i - 1][j - 1][0] + dp[i - 1][j - 1][0];
            if (sum[i - 1][j][0] >= MOD) sum[i - 1][j][0] -= MOD;
        }

        for (int j = n - 1; j >= 1; j--)
        {
            sum[i - 1][j][1] = sum[i - 1][j + 1][1] + dp[i - 1][j + 1][1];
            if (sum[i - 1][j][1] >= MOD) sum[i - 1][j][1] -= MOD;
        }

        for (int j = 1; j < i; j++)
        {
            dp[i][j][1] = sum[i - j][j][0];
            dp[i][j][0] = sum[i - j][j][1];
        }
    }

    int ans = 0;

    for (int i = 1; i < n; i++)
    {
        ans += dp[n][i][1];
        if (ans >= MOD) ans -= MOD;
        ans += dp[n][i][0];
        if (ans >= MOD) ans -= MOD;
    }

    ans += dp[n][n][0];
    if (ans >= MOD) ans -= MOD;

    cout << ans;
}