#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k, NN;

const ll mod = 1e9 + 7;
int dp[5001][5001][2];
const int INF = 5000;

long long get(int n, int k, int inc)
{
    if (n == k)
        return 1;
    if (n <= 0)
        return 0;
    if (dp[n][k][inc] != -1)
        return dp[n][k][inc];
    ll res = 0;
    if (inc == 0)
    {
        res = 0;
        for (int j = 1; j < k; j++)
            res += get(n - k, j, 1);
        res %= mod;
    }
    else
    {
        res = 0;
        for (int j = k + 1; j <= n - k; j++)
            res += get(n - k, j, 0);
        res %= mod;
    }
    dp[n][k][inc] = res;
    return res;
}

int main()
{
    cin >> n >> k;
    for (int i = 0; i <= INF; i++)
    {
        for (int j = 0; j <= INF; j++)
        {
            dp[i][j][0] = -1;
            dp[i][j][1] = -1;
        }
    }
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    cout << (get(n, k, 0) + get(n, k, 1)) % mod;
}
