#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

long long n;
vector<int> graph[300001];
long long c[400000];
long long v, e, bl, wh;

long long dfs(int i, int fl)
{
    c[i] = fl;
    if (fl == 1) bl++;
    else wh++;
    v++;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        if (c[u] == 0)
        {
            dfs(u, 3 - fl);
            e++;
        }
    }
}

long long solve(int i)
{
    v = 0;
    e = 0;
    bl = 0, wh = 0;
    dfs(i, 1);
    if (e == v - 1)
    {
        //cout << bl << " " << wh << endl;
        return max(bl, wh);
    }
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        graph[a].push_back(i);
        graph[i].push_back(a);
    }
    long long ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (c[i] == 0)
        {
            ans += solve(i);
        }
    }
    cout << ans;
    return 0;
}
