#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

//#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAX_N = 3e5 + 666;

set<int> idxs[MAX_N];

int n, m;
vector<int> a, b;

void solve()
{
	cin >> n >> m;

	a.resize(m); b.resize(n);

	for(auto& el: a)
		cin >> el;

	for(auto& el: b)
		cin >> el;

	for(int i = 0; i < m; ++i)
		idxs[a[i]].insert(i);

	for(auto el: b)
		idxs[el].insert(INT_INF);

	//for(int i = 0; i < n; ++i)
		//my_insert(i, b[i]);

	vector<int> ans;

	for(int i = 0; i < m;)
	{
		int val = b[0];
		int ni = n - 1;

		int time = *idxs[val].upper_bound(i);

		if(val == a[i])
		{
			while(ni > 0 && *idxs[b[ni]].upper_bound(i) > time)
				--ni;
		}
		else
		{
			while(ni > 0 && *idxs[b[ni]].lower_bound(i) > time)
				--ni;
		}

		DBG(ni);

		b.erase(b.begin());
		b.insert(b.begin() + ni, val);
		
#ifdef __LOCAL
		for(auto el: b)
			cout << el << " ";

		cout << endl;
#endif

		ans.push_back(ni + 1);

		if(val == a[i])
			++i;
	}

	cout << ans.size() << endl;

	for(auto el: ans)
		cout << el <<  " ";

	cout << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}