#include <bits/stdc++.h>
#define MOD 1000000007
#define fast_io() cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

using namespace std;

string bin(long long x) {
	unsigned long long cw = 1;
	string s = "";
	for (int i = 0; i < 24; i++) {
		s = s + (char)(x % 2 + '0');
		x >>= 1;
	}
	return s;
}

inline long long binp(long long a, long long n) {
	if (n == 0)
		return 1;
	if (n % 2)
		return (a * binp(a, n - 1)) % MOD;
	return binp((a * a) % MOD, n / 2);
}

long long obr[64];

inline long long get_cnk(long long n, long long k) {
	if (k == n || k == 0)
		return 1;
	if (k > n)
		return 0;
	long long gg = 1;
	for (long long i = n - k + 1; i <= n; i++)
		gg = (gg * i) % MOD;
	for (long long i = 1; i <= k; i++) {
		long long ob = obr[i];
		gg = (gg * ob) % MOD;
	}
	return gg;
}

int main() {
	fast_io();
	long long n, m, k;
	cin >> n >> m >> k;
	if (m != 0 || k > 10000000)
		return 0;
	long long dp[n + 1][64];
	for (int i = 0; i < n + 1; i++)
		for (int j = 0; j < 64; j++)
			dp[i][j] = 0;
	string bs = bin(0);
	int pc = 0;
	for (int i = 0; i <= k; i++) {
		dp[1][pc]++;
		int j;
		for (j = bs.size() - 1; j >= 0 && bs[j] == '1'; --pc, --j) bs[j] = '0';
		++pc; 
		bs[j] = '1';
	}
	long long cnks[64][64];
	for (int i = 1; i < 64; i++)
		obr[i] = binp(i, MOD - 2);
	for (int i = 0; i < 32; i++)
		for (int j = 0; j < 32; j++)
			cnks[i][j] = get_cnk(i, j);
	for (int i = 2; i <= n; i++) {
		for (int j = 0; j < 24; j++) {
			dp[i][j] = 0;
			for (int l = j; l < 24; l++) 
				dp[i][j] = (dp[i][j] + cnks[l][j] * dp[i - 1][l]) % MOD;  
		}
	}
	long long sm = 0;
	for (int i = 0; i < 32; i++)
		sm = (sm + dp[n][i]) % MOD;
	cout << sm;
}