#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define int long long
const int MOD = 1e9 + 7;
int n, m, k;
void read()
{
	cin >> n >> m >> k;
}
int ans;
const int MAXN = 3 * 1e5 + 10;
int dp[MAXN][510];
void run()
{
	for (int i = 0; i <= k; i++)
		dp[0][i] = 1;
	for (int i = 1; i < n; i++)
	{
		for (int x = 0; x <= k; x++)
		{
			for (int y = 0; y <= k; y++)
			{
				if ((x & y) == x)
				{
					dp[i][y] += dp[i - 1][x];
					dp[i][y] %= MOD;
				}
			}
		}
	}
	ans = 0;
	for (int i = 0; i <= k; i++)
		ans += dp[n - 1][i];
	ans %= MOD;
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
