#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
int n;
vector <int> a;
void read()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		if (x > 0)
			x--;
		a.push_back(x);
	}
}
int ans;

bool check(vector <int> x)
{
	for (int i = 0; i < n; i++)
	{
		if (a[i] == -1)
			continue;
		if (x[i] == 1 && x[a[i]] == 1)
			return false;
	}
	return true;
}

void run()
{
	ans = 0;
	for (int i = 1; i <= n; i++)
	{
		vector <int> pos(n);
		for (int j = 0; j < i; j++)
			pos[n - j - 1] = 1;
		do
		{
			if (check(pos))
			{
				ans = i;
				break;
			}
		} while (next_permutation(pos.begin(), pos.end()));
		if (ans != i)
			break;
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
