#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
vector <vector <int>> g, gr;
int n;
void read()
{
	cin >> n;
	gr.resize(n);
	for (int i = 0; i < n; i++)
	{
		int v;
		cin >> v;
		if (v == -1)
			continue;
		v--;
		gr[i].push_back(v);
		gr[v].push_back(i);
	}
}
const int MAXN = 2010;
bool used[MAXN];
int color[MAXN];
int cnt1, cnt2;
void dfs(int v, int c)
{
	if (c == 1)
		for (auto i : g[v])
		{
			if (color[i] == 1)
			{
				c = 3;
				break;
			}
		}
	if (c == 3)
	{
		g[v].clear();
		color[v] = c;
		used[v] = 1;
		return;
	}

	if (c == 1)
		cnt1++;
	else if (c == 2)
		cnt2++;
	color[v] = c;
	used[v] = 1;
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i, 3 - c);
		}
	}
}

int ans;
void run()
{
	ans = 0;
	for (int j = 0; j < n; j++)
	{
		int fans = 0;
		for (int x = 0; x < n; x++)
		{
			used[x] = 0;
			color[x] = 0;
		}
		g = gr;
		cnt1 = 0;
		cnt2 = 0;
		dfs(j, 1);
		fans += max(cnt1, cnt2);
		for (int i = 0; i < n; i++)
		{
			if (!used[i])
			{
				cnt1 = 0;
				cnt2 = 0;
				dfs(i, 1);
				fans += max(cnt1, cnt2);
			}
		}
		ans = max(ans, fans);
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
