#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
const int MAXN = 3 * 1e5 + 10;
vector <int> g[MAXN];
int n;
void read()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int v;
		cin >> v;
		if (v == -1)
			continue;
		v--;
		g[i].push_back(v);
		g[v].push_back(i);
	}
}

bool used[MAXN];
int color[MAXN];
int cnt1;
void dfs(int v)
{
	used[v] = true;
	cnt1++;
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i);
		}
	}
}

int ans;
void run()
{
	ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			cnt1 = 0;
			dfs(i);
			ans += cnt1 / 2;
		}
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
