#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int main() {
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	vector<vector<vector<int>>> d(n + 1, vector<vector<int>>(n + 1, vector<int>(2)));

	d[k][k][0] = 1;
	d[k][k][1] = 1;
	for (int sum = k; sum <= n; sum++) {
		for (int i = 0; i <= sum; i++) {
			for (int j = 1; j < i; j++) {
				d[i][sum][0] += d[j][sum - i][1];
			}
			for (int j = i + 1; j <= n; j++) {
				d[i][sum][1] += d[j][sum - i][0];
			}
		}
	}
	int ans = 0;
	for (int i = 0; i <= n; i++) {
		ans += d[i][n][0];
		ans += d[i][n][1];
	}
	cout << ans;


	return 0;
}