#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int mod = 1e9 + 7;

int main() {
	ll n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	vector<vector<vector<ll>>> d(n + 1, vector<vector<ll>>(n + 1, vector<ll>(2)));

	d[k][k][0] = 1;
	d[k][k][1] = 1;
	for (ll sum = k; sum <= n; sum++) {
		for (ll i = 0; i <= sum; i++) {
			for (ll j = 1; j < i; j++) {
				d[i][sum][0] += d[j][sum - i][1];
				d[i][sum][0] %= mod;
			}
			for (ll j = i + 1; j <= n; j++) {
				d[i][sum][1] += d[j][sum - i][0];
				d[i][sum][1] %= mod;
			}
		}
	}
	ll ans = 0;
	for (ll i = 0; i <= n; i++) {
		ans += d[i][n][0];
		ans += d[i][n][1];
		ans %= mod;
	}
	cout << ans;


	return 0;
}