#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<vector<int>> way;
vector<int> used, para;

int bl = 0, wh = 0;

bool dfs(int v) {
	if (used[v] == 1) {
		return false;
	}
	used[v] = 1;
	for (int u : way[v]) {
		if (para[u] == -1 || dfs(para[u])) {
			para[u] = v;
			return true;
		}
	}
	return false;
}


int main() {
	int n;
	cin >> n;
	way.resize(n);
	used.resize(n);
	para.resize(n, -1);
	for (int i = 0; i < n; i++) {
		int b;
		cin >> b;
		if (b != -1) {
			way[b - 1].push_back(i);
			way[i].push_back(b - 1);
		}
	}
	for (int i = 0; i < n; i++) {
		if (dfs(i)) {
			//used.clear();
			//used.resize(n);
		}
	}
	int ans = 0;
	for (int i : para) {
		if (i != -1) {
			ans++;
		}
	}
	cout << ans;
	


  	return 0;
}