#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>

using namespace std;

vector<vector<int>> way;
vector<int> used;

int bl, wh;

void dfs(int v, int p, int c) {
	if (used[v] == 1) {
		return;
	}
	used[v] = 1;
	if (c == 0) {
		bl++;
	}
	else {
		wh++;
	}
	for (int u : way[v]) {
		if (u == p) {
			continue;
		}
		dfs(u, v, 1 - c);
	}
}

int main() {
	int n;
	cin >> n;
	vector<int> a(n);
	way.resize(n);
	used.resize(n);
	int f = 0;
	for (int i = 0; i < n; i++) {
		int b;
		cin >> b;
		a[i] = b - 1;
		if (b != -1) {
			way[b - 1].push_back(i);
			way[i].push_back(b - 1);
		}
		if (i + 1 <= b - 1) {
			f = 1;
		}
	}
	if (f == 0) {
		int ans = 0;
		for (int i = 0; i < n; i++) {
			if (used[i] == 0) {
				bl = 0;
				wh = 0;
				dfs(i, -1, 0);
				ans += max(bl, wh);
			}
		}
		cout << ans;
		return 0;
	}
	int ans = 0;
	for (int i = 0; i < (1 << n); i++) {
		int now = 0;
		for (int j = 0; j < n; j++) {
			if ((i & (1 << j)) != 0) {
				if (a[j] == -2) {
					now++;
					continue;
				}
				if ((i & (1 << (a[j]))) != 0) {
					break;
				}
				now++;
			}
		}
		ans = max(now, ans);
	}
	cout << ans;

	return 0;
}