#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <functional>

using namespace std;

int main() {
	int n;
	cin >> n;
	int a;
	vector <vector <int>> dp_graf(n, vector <int>(n, 0));
	vector <vector <int>> graf(n, vector <int>(0));
	for (int i = 0; i < n; i++) {
		cin >> a;
		a--;
		if ((a >= 0) && (dp_graf[a][i] == 0)) {
			graf[a].push_back(i);
			graf[i].push_back(a);
			dp_graf[a][i] = 1;
			dp_graf[i][a] = 1;
		}
	}

	int q = 0;
	vector <vector <int>> ans(n, vector <int>(2, 0));
	vector <int> used(n, 0);
	function<void(int, int)> dfs = [&](int v, int prev) {
//		cout << v << "\n";
		if (prev == -1) {
			used[v] = 1;
		}
		else {
			used[v] = used[prev] % 2 + 1;
		}
		ans[v][used[v] - 1] = 2;
		for (int i = 0; i < graf[v].size(); i++) {
			int to = graf[v][i];
			if (used[to] == 0) {
				dfs(to, v);
				ans[v][used[v] % 2] += ans[to][used[v] % 2];
				ans[v][used[v] - 1] += ans[to][used[v] - 1];
			}
			else if (used[to] == used[v]) {
				ans[v][used[v] - 1]--;
				q--;
			}
		}
	};

	int dp_ans = 0;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			q = 2;
			dfs(i, -1);
			dp_ans += max(ans[i][0], ans[i][1]) / 2;
			if (q < 0) {
				cout << "Chto za dich?";
				return 0;
			}
		}
	}

//	for (int i = 0; i < n; i++) {
//		cout << ans[i][0] << " " << ans[i][1] << "\n";
//	}

	cout << dp_ans;
//	system("pause");
	return 0;
}