#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

const long long MOD = 1e9 + 7;

int main() {
	hello();

	long long n, k;
	cin >> n >> k;

	if (n == k) {
		cout << 1 << endl;
		return 0;
	}

	vector<vector<vector<long long> > > dp(n + 1, vector<vector<long long> >(n + 1, vector<long long>(2)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;

	for (int sum = k + 1; sum <= n; ++sum)
		for (int num = 1; num <= n; ++num) 
			if (sum - num >= 0) 
				for (int flag = 0; flag <= 1; ++flag) 
					if (flag == 0) {
						for (int elem = 1; elem < num; ++elem)
								dp[sum][num][flag] = (dp[sum][num][flag] + dp[sum - num][elem][1]) % MOD;
					}
					else {
						for (int elem = num + 1; elem <= n; ++elem)
							dp[sum][num][flag] = (dp[sum][num][flag] + dp[sum - num][elem][0]) % MOD;
					}

	long long ans = 0;
	for (int num = 1; num <= n; ++num)
		ans = (ans + dp[n][num][0] + dp[n][num][1]) % MOD;

	cout << ans << endl;
 
	return 0;
}