#include <iostream>
#include <vector>
#include <algorithm>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

const long long MOD = 1e9 + 7;

bool isCorrect(vector<pair<int, int> > &event) {
	sort(event.begin(), event.end());

	int cnt = 0, ind = 0;
	while (ind < event.size() && event[ind].second == -1) {
		cnt++;
		ind++;
	}
	if (cnt == (int)event.size() / 2)
		return true;
	else 
		return false;
}	

int main() {
	hello();

	int n, k;
	cin >> n >> k;
	if (k == 1) {
		vector<pair<int, int> > a(n);
		for (int i = 0; i < n; ++i) {
			int x; cin >> x;
			a[i] = {x, i};
		}

		sort(a.begin(), a.end());

		cout << "YES" << endl;
		int i = n / 2 - 1, j = n / 2;
		while (i >= 0) {
			int ind1 = a[i].second, ind2 = a[j].second;
			cout << ind1 + 1 << " " << ind2 + 1 << endl;
			i--, j++;
		}
	}
	else {
		vector<int> per;
		for (int i = 0; i < n; ++i)
			per.push_back(i);

		// random_shuffle(per.begin(), per.end());

		vector<vector<int> > a(n, vector<int>(k));
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < k; ++j)
				cin >> a[i][j];
		
		int cnt = 0;
		do {
			vector<vector<pair<int, int> > > event(k);
			for (int i = 0; i < n; i += 2) {
				int ind1 = per[i], ind2 = per[i + 1];
				for (int j = 0; j < k; ++j) {
					int l = a[ind1][j], r = a[ind2][j];
					if (l > r)
						swap(l, r);
					event[j].push_back({l, -1});
					event[j].push_back({r, 1});
				}
			}

			bool flag = true;
			for (int j = 0; j < k; ++j)
				if (!isCorrect(event[j]))
					flag = false;
				
			if (flag) {
				cout << "YES" << endl;
				for (int i = 0; i < n; i += 2) {
					int ind1 = per[i], ind2 = per[i + 1];
					cout << ind1 + 1 << " " << ind2 + 1 << endl;
				}
				return 0;
			}
			cnt++;
		} while (cnt < 1e5 && next_permutation(per.begin(), per.end()));
		
		cout << "NO" << endl;
	}
	
	return 0;
}