#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k;
	cin >> k;

	if(k % 2 == 0 && k % 4 != 0) {
		cout << "none";
		return 0;
	}

	int sum = 0;
	int least = 1;
	for(int i = 1; i < 10000000; i += 2) {
		while(sum > k) {
			sum -= least;
			least += 2;
		}

		if(sum == k) {
			cout << (i - 1) / 2;
			return 0;
		}

		sum += i;
	}

	assert(false);

	return 0;
}