#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

long long sqrtt(long long n){
    long long l = 0;
    long long r = 1414214;
    while (r - l > 1){
        long long m = (r + l) / 2;
        long long x = m * m;
        if (x <= n && x >= 0)
            l = m;
        else
            r = m;
    }
    if (r * r <= n && (r * r) >= 0)
        return r;
    return l;
}

int main(){
    long long k;
    cin >> k;
    for (long long i = 0; i * i <= 1000000000000; i++){
        long long x = i * i - k;
        long long y = sqrtt(x);
        if (y * y == x){
            cout << i;
            return 0;
        }
    }
    cout << "none";
    return 0;
}
