#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int64_t sqrtt(int64_t n){
    if (n < 0)
        return 0;
    int64_t l = 0;
    int64_t r = 3162278;
    while (r - l > 1){
        int64_t m = (r + l) / 2;
        int64_t x = m * m;
        if (x <= n && x >= 0)
            l = m;
        else
            r = m;
    }
    if (r * r <= n && (r * r) >= 0)
        return r;
    return l;
}

int main(){
    int64_t k;
    cin >> k;
    if (k % 2 == 1){
        int64_t x = 0;
        int64_t a = 2;
        int64_t an = k;
        int64_t a0 = 1;
        int64_t n = (an - a0) / a + 1;
        x = a0 * n + (n * (n - 1) * a) / 2;
        cout << sqrtt(x);
        return 0;
    }
    for (int64_t i = 0; i * i <= 10000000000000; i++){
        int64_t x = i * i - k;
        int64_t y = sqrtt(x);
        if (y * y == x){
            cout << i;
            return 0;
        }
    }
    cout << "none";
    return 0;
}
