#include "bits/stdc++.h"

using namespace std;


void check (int* M, int* Is, int* Bad, int n);
int Tree (int* M, int* Is, int* Bad, int n);
int check_tree (int* M, int n);
int Circle (int* M, int* Is, int* Bad, int n, int* S);
void Clear (int* M, int* Is, int* Bad, int n, int* S);

int main ()
{
    int n = 0;
    cin >> n;
    int* M = new int [n];
    int* Bad = new int [n];
    int* Is = new int [n];
    int* Was = new int [n];
    int* S = new int [n];
     int* Done= new int [n];
    int Ans = 0;

    vector <vector<int>> r_in;
    r_in.resize (n);

    for (int i = 0; i < n; i++)
    {
        M[i] = 0;
        Bad[i] = 0;
        Is[i] = 0;
        Was[i] = 0;
        S[i] = 0;
        Done[i] = 0;
    }
//cout << "0 ";
    for (int i = 0; i < n; i++)
    {//cout << "g ";
        cin >> M[i];

        if (M[i] != -1) M[i] --;
        if (M[i] != -1) Bad[M[i]] = 1;

        if (M[i] != -1) r_in[i].push_back(M[i]);
        if (M[i] != -1) r_in[M[i]].push_back(i);
    }
    queue <int> Q;
//cout << "1 ";
    for (int i = 0; i < n; i++)
    {//cout << "2 ";
        if (Was[i] == 0)
        {
        Q.push(i);
        Was[i] = 1;

        Is[i] = 1;
        S[i] = 1;

        while (Q.size () > 0)
            {
            for (int j = 0; j < r_in [Q.front ()].size(); j++)
                if (Was[r_in [Q.front ()][j]] == 0)
                {
                    //cout << " |" << r_in [Q.front ()][j] << "| ";

                    Was[r_in [Q.front ()][j]] = 1;
                    Q.push (r_in [Q.front ()][j]);

                    Is[r_in [Q.front ()][j]] = 1;
                    S[r_in [Q.front ()][j]] = 1;

                }

            Q.pop ();
            }
        //for (int k = 0; k < n; k++) cout << " {" << i << " " << S[k] << "}\n";;
        Ans+=Circle (M, Is, Bad, n, S);
        }

    for (int i = 0; i < n; i++)
    {
        Bad[i] = 0;
        Is[i] = 0;
        S[0] = 0;
    }
    }
//cout << "3 ";
    cout << Ans;

    return 0;
}

int check_tree (int* M, int n)
    {
        int x = 0;
    for (int i = 0; i < n; i++)
    {
        x = i;
        while (1)
        {
            if (M[x] == -1) break;
            if (M[x] == i) return i;
            x = M[x];
        }
    }
    return -1;
    }

int Circle (int* M, int* Is, int* Bad, int n, int* S)
{
    int h = check_tree (M, n);
    int l = M[h];
    if (h == -1) return Tree (M, Is, Bad, n);
    else
    {
        int m = 0,  r = 5, z = 0;

        z = M[h];
        M[h] = -1;
        Is[h] = 0;
        r = Circle (M, Is, Bad, n, S);
        m = r;
        M[h] = z;
        Clear (M, Is, Bad, n, S);

        while (h != l)
        {
            z = M[l];
            M[l] = -1;
            Is[l] = 0;
            r = Circle (M, Is, Bad, n, S);

            if (m < r) m = r;
            M[l] = z;Clear (M, Is, Bad, n, S);

            l = M[l];
        }

    return r;
    }
}

int Tree (int* M, int* Is, int* Bad, int n)
    {
         int s = 0;
    vector<int> v1;
    vector<int> v2;
    while (1)
    {
        v1.clear ();
        check (M, Is, Bad, n);

        for (int i = 0; i < n; i++)
        {
            if (Bad[i] == 0 && Is[i] == 1) {v1.push_back(i); Is[i] = 0;}
        }

        for (int i = 0; i < v1.size (); i++)
        {
            if (M[v1[i]] != -1) Is[(M[v1[i]])] = 0;
        }

        s+= v1.size ();
        if (v1.size () == 0) break;
    }
    //if (s == 3) for (int i = 0; i < n; i++)cout << M[i] << " ";
    return s;
    }

void check (int* M, int* Is, int* Bad, int n)
{
    for (int i = 0; i < n; i++)
    {
        Bad[i] = 0;
    }
    for (int i = 0; i < n; i++)
    {
        if (Is[i] == 1) if (M[i] != -1) Bad[M[i]] = 1;
    }
}

void Clear (int* M, int* Is, int* Bad, int n, int* S)
{
    for (int i = 0; i < n; i++)
    {
        Bad[i] = 0;
        Is[i] = S[i];
    }

    for (int i = 0; i < n; i++)
    {
        if (M[i] != -1) Bad[M[i]] = 1;
    }
}
