#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int mod = 1e9 + 7;
int ans = 0;

void up(int n, int end);
void down(int n, int end);

void up(int n, int end) {
	if (n < 0)
		return;
	if (n == 0) {
		++ans;
		if (ans == mod)
			ans = 0;
	}
	else
		for (int i = end + 1; i <= n; ++i)
			down(n - i, i);
}

void down(int n, int end) {
	if (n < 0)
		return;
	if (n == 0) {
		++ans;
		if (ans == mod)
			ans = 0;
	}
	else
		for (int i = end - 1; i > 0; --i)
			up(n - i, i);
}

int main() {
	int n, k;
	cin >> n >> k;
	if (n == k)
		cout << 1;
	else if (n < k)
		cout << 0;
	else {
		up(n - k, k);
		down(n - k, k);
		cout << ans;
	}
}
