#include <bits/stdc++.h>

using namespace std;

#define boost() ios_base::sync_with_stdio(0)
#define wasted() srand(time(0))

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define rfile(s) freopen(s, "r", stdin)
#define wfile(s) freopen(s, "w", stdout)\

int n;
vector<int> v;

void rec(const vector<vector<int>> &d, int i, vector<int> &color, int c)
{
    color[i] = c;
    //cout << "color[" << i << "] = " << c << endl;
    for (int j = 0; j < d[i].size(); j++)
    {
        int i1 = d[i][j];
        if (color[i1] == -1)
        {
            rec(d, i1, color, (c + 1) % 2);
        }
    }
}

void group(const vector<vector<int>> &d, int i, const vector<int> &color, vector<int> &used, int num)
{
    used[i] = num;

    for (int j = 0; j < d[i].size(); j++)
    {
        int i1 = d[i][j];
        if (used[i1] == -1)
        {
            group(d, i1, color, used, num);
        }
    }
}

int main()
{
    //boost();
        rfile("input.txt");
    cin >> n;
    v.resize(n);
    vector<vector<int>> d(n);
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        if (x != -1)
        {
            x--;
            d[x].push_back(i);
            d[i].push_back(x);
        }
        v[i] = x;
    }

    vector<int> color(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            rec(d, i, color, 0);
        }
    }

    vector<int> used(n, -1);
    int num = 0;
    for (int i = 0; i < n; i++)
    {
        if (used[i] == -1)
        {
            group(d, i, color, used, num);
            num++;
        }
    }
    vector<vector<int>> k(num, vector<int> (2, 0));
    for (int i = 0; i < n; i++)
    {
        if (!(v[i] != -1 && color[v[i]] == color[i]))
        {
            k[used[i]][color[i]]++;
        }
    }
    int ans = 0;
    for (int i = 0; i < num; i++)
    {
        ans += max(k[i][0], k[i][1]);
    }
    cout << ans;
    return 0;
}
