#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using  namespace std;

//#define DEBUG

int main() {
	int n, k;
	int Q = 1e9 + 7;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	vector <vector <int>> dp_min(n + 1, vector <int>(n + 1, 0)), dp_max(n + 1, vector <int>(n + 1, 0));
	dp_max[k][k] = 1;
	dp_min[k][k] = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= i; j++) {
			for (int k = 0; k <= i; k++) {
				if (j > k) {
					dp_max[i][j] += dp_min[i - j][k];
					dp_max[i][j] %= Q;
				}
				if (j < k) {
					dp_min[i][j] += dp_max[i - j][k];
					dp_min[i][j] %= Q;
				}
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans += dp_max[n][i];
		ans %= Q;
		ans += dp_min[n][i];
		ans %= Q;
	}
	cout << ans;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}