#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using  namespace std;

//#define DEBUG

int sempl1(int n, vector <int> &a) {
	int ans = 0;
	for (int i = 0; i < (1 << n); i++) {
		vector <int> used(n, 0);
		int tmp = i, tmp_ans = 0, ind = 0;
		while (tmp > 0) {
			used[ind] = tmp % 2;
			ind++;
			tmp_ans += tmp % 2;
			tmp /= 2;
		}
		bool correct = 1;
		for (int i = 0; i < n; i++) {
			if (used[i] && a[i] != -2 && used[a[i]]) {
				correct = 0;
				break;
			}
		}
		if (correct) ans = max(ans, tmp_ans);
	}
	return ans;
}

int main() {
	int n, ans = 0;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	if (n <= 20) {
		cout << sempl1(n, a);
		return 0;
	}
	/*bool f = a[0] == -2;
	for (int i = 1; i < n; i++) {
		f = f && a[i] == (i - 1);
	}
	if (f) {
		cout << (n - 1) / 2 + 1;
		return 0;
	}*/
	vector <pair <int, int>> dp(n);
	dp[0] = { 1, 0 };
	int max_dp = 1;
	for (int i = 1; i < n; i++) {
		dp[i].second = max_dp;
		if (a[i] == -2) {
			dp[i].first = max_dp + 1;
			max_dp++;
		}
		else {
			dp[i].first = dp[a[i]].second + 1;
			max_dp = max(max_dp, dp[a[i]].second + 1);
		}
	}
	cout << max_dp;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}