#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>

using namespace std;


int N, K, M;

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	long long int n, m;
	cin >> n >> m;
	vector <int> req(m);
	vector <int> cards(n);
	for (int i = 0; i < m; i++) {
		cin >> req[i];
		req[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> cards[i];
		cards[i]--;
	}
	vector <vector<int>> nc(m, vector<int>());
	for (int i = 0; i < n; i++) {
		nc[req[i]].push_back(i);
	}
	for (int i = 0; i < m; i++) {
		reverse(nc[i].begin(), nc[i].end());
		if (nc[i].size() == 0) nc[i].push_back(1000000000);
	}
	vector <int> history;
	for (int rn = 0; rn < m; rn++) {
		int wanted = req[rn];
		while (cards[0] != wanted) {
			int cur = cards[0];
			int to_change = 0;
			for (int i = n - 1; i > 0; i--) {
				if (cards[i] == wanted) {
					to_change = i;
					break;
				}
				else {
					if (nc[cur].back() > nc[cards[i]].back()) {
						to_change = i;
						break;
					}
				}
			}
			for (int i = 0; i < to_change; i++) {
				cards[i] = cards[i + 1];
			}
			cards[to_change] = cur;
			history.push_back(to_change);
		}
		nc[cards[0]].pop_back();
		if (nc[cards[0]].size() == 0) nc[cards[0]].push_back(1000000000);
		if (1) {
			int cur = cards[0];
			int to_change = 0;
			for (int i = n - 1; i > 0; i--) {
				if (cards[i] == wanted) {
					to_change = i;
					break;
				}
				else {
					if (nc[cur].back() > nc[cards[i]].back()) {
						to_change = i;
						break;
					}
				}
			}
			for (int i = 0; i < to_change; i++) {
				cards[i] = cards[i + 1];
			}
			cards[to_change] = cur;
			history.push_back(to_change);
		}
	}
	cout << history.size() << "\n";
	for (auto h : history) cout << h + 1 << " ";
	return 0;
}


