#include <bits/stdc++.h>
using namespace std;

#define sz(v) int(v.size())
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    out << "\n";
    return out;
}

const int N = 3e5 + 5;
vector < int > gr[N];
vector < int > cyc;
int cnt[N][2];
int used[N];
int us[N];
int ans = 0;
stack < int > oh;

pii clr_dfs(int v) {
    us[v] = 1;
    int a = 1, b = 0;
    for (auto u : gr[v]) {
        if (us[u])
            continue;
        pii k = clr_dfs(u);
        a += k.S, b += max(k.S, k.F);
    }
    return {a, b};
}

void get_cyc() {
    while (oh.size()) {
        cyc.pb(oh.top());
        us[cyc.back()] = 1;
        oh.pop();
    }
    for (int u : cyc) {
        pii k = clr_dfs(u);
        cnt[u][0] = k.S;
        cnt[u][1] = k.F;
    }
    int sz = cyc.size();
    if (sz % 2 == 0) {
        bool fl = 0;
        int a = 0, b = 0;
        for (auto u : cyc) {
            a += cnt[u][fl], b += cnt[u][1 - fl];
            fl = 1 - fl;
        }
        ans += max(a, b);
        return;
    }
    int a = 0, b = 0;
    for (int i = sz - 1; i >= 0; i--) {
        a += cnt[cyc[i]][i % 2];
        b += cnt[cyc[i]][1 - (i % 2)];
    }
    int res = 0;
    int x = 0, y = 0;
    for (int i = 0; i < sz; i++) {
        if (i % 2 == 0) {
            res = max(a + x, ans);
        } else {
            res = max(b + y, ans);
        }
        y += cnt[cyc[i]][i % 2];
        x += cnt[cyc[i]][1 - (i % 2)];
        a -= cnt[cyc[i]][i % 2];
        b -= cnt[cyc[i]][1 - (i % 2)];
    }
    ans += res;
    return;
}

void dfs(int v, int pr = -1) {
    used[v] = 1;
    oh.push(v);
    for (auto u : gr[v]) {
        if (u == pr)
            continue;
        if (used[u]) {
            if (!cyc.size())
                get_cyc();
        } else
            dfs(u, v);
    }
    if (oh.size())
        oh.pop();
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int v;
        cin >> v;
        if (v == -1)
            continue;
        v--;
        gr[i].pb(v);
        gr[v].pb(i);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            if (!cyc.size()) {
                pii k = clr_dfs(i);
                ans += max(k.F, k.S);
            } else {
                cyc.clear();
            }
        }
    }
    cout << ans;
    return 0;
}
