#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e3 + 1, MOD = 1e9 + 7;
int dp1[MAXN][MAXN], dp2[MAXN][MAXN], pref[MAXN][MAXN], suf[MAXN][MAXN];

main() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    dp1[k][k] = 1;
    dp2[k][k] = 1;
    for (int i = k; i <= n; ++i) {
        pref[k][i] = 1;
    }
    for (int i = 0; i <= k; ++i) {
        suf[k][i] = 1;
    }
    for (int i = k + 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            dp1[i][j] = suf[i - j][j + 1];
            pref[i][j] = (pref[i][j - 1] + dp1[i][j]) % MOD;
        }
        for (int j = i; j > 0; --j) {
            dp2[i][j] = pref[i - j][j - 1];
            suf[i][j] = (suf[i][j + 1] + dp2[i][j]) % MOD;
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans += dp1[n][i];
        ans %= MOD;
        ans += dp2[n][i];
        ans %= MOD;
    }
    cout << ans;
    return 0;
}
