#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 2e9;
bool used[MAXN];
pair<int, int> ans[MAXN];
pair<int, int> arr[7][MAXN];
int n, k;
bool f = false;

bool check() {
    for (int i = 0; i < k; ++i) {
        int l = -INF, r = INF;
        for (int j = 0; j < n / 2; ++j) {
            int l1 = min(arr[i][ans[j].first].first, arr[i][ans[j].second].first);
            int r1 = max(arr[i][ans[j].first].first, arr[i][ans[j].second].first);
            l = max(l, l1);
            r = min(r, r1);
        }
        if (l > r) {
            return false;
        }
    }
    return true;
}

bool solve1(int now) {
    if (now == 0) {
        if (check()) {
            return true;
        }
        return false;
    }
    int x = 0;
    while (used[x]) x++;
    used[x] = true;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            used[i] = true;
            ans[now - 1] = {x, i};
            if (solve1(now - 1)) {
                return true;
            }
            ans[now - 1] = {0, 0};
            used[i] = false;
        }
    }
    used[x] = false;
    return false;
}

void solve2() {
    sort(arr[0], arr[0] + n);
    for (int i = 0; i < n / 2; ++i) {
        ans[i] = {arr[0][i].second, arr[0][n - i - 1].second};
    }
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> arr[j][i].first;
            arr[j][i].second = i + 1;
        }
    }
    if (n <= 10) {
        if (solve1(n / 2)) {
            cout << check() << endl;
            cout << "YES" << endl;
            for (int i = 0; i < n / 2; ++i) {
                cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
            }
        } else {
            cout << "NO";
        }
        return 0;
    }
    if (k == 1) {
        solve2();
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; ++i) {
            cout << ans[i].first << " " << ans[i].second << endl;
        }
        return 0;
    }
    return 0;
}
