#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<long long,long long> pll;

void solve1();
void solve();

void gentest()
{

}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
/*
	while (true)
	{
		gentest();
		ans = solve();
		ans1 = solve1();

		if (ans != ans1)
		{
			break;
		}
	}
*/
	solve();

	return 0;
}

void dfs(vector<vector<int>>& gr, vector<vector<int>>& dp, vector<bool>& used, int v)
{
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (int u : gr[v])
	{
		if (!used[u])
		{
			dfs(gr, dp, used, u);
			dp[v][0] += max( dp[u][0], dp[u][1] );
			dp[v][1] += dp[u][0];
		}
	}
}

void solve()
{
	int n;
	cin >> n;

	vector<vector<int>> gr(n);
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		if (a == -1)
			continue;
		a--;
		gr[i].push_back(a);
		gr[a].push_back(i);
	}

	vector<bool> used(n);
	vector<vector<int>> dp(n, vector<int>(2));

	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(gr, dp, used, i);
			ans += max( dp[i][0], dp[i][1] );
		}
	}

	cout << ans;
}
