#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<stdlib.h>
#include<math.h>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<ctime>

using namespace std;

typedef int ll;
typedef long double ld;

ll INF = ll(1e18) * 2;
ll inf = 1e9;
ll MOD = 1e9 + 7;
ld eps = 1e-9;

ll dp[5001][5001][2];

inline ll f(ll prev, ll num, ll fl) {
	if (num == 0) return 1;
	if (dp[prev][num][fl] != -1) return dp[prev][num][fl];
	ll sum = 0;
	if (fl == 0) {
		for (ll i = 1; i < prev && i <= num; i++) {
			sum += f(i, num - i, 1 - fl);
			if (sum >= MOD) sum -= MOD;
		}
	}
	else {
		for (ll i = prev+1; i <= num; i++) {
			sum += f(i, num - i, 1 - fl);
			if (sum >= MOD) sum -= MOD;
		}
	}
	dp[prev][num][fl] = sum;
	return sum;
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, k;
	cin >> n >> k;
	for (ll i = 0; i < 5001; i++) {
		for (ll j = 0; j < 5001; j++) {
			dp[i][j][0] = -1;
			dp[i][j][1] = -1;
		}
	}

	if (k == n) {
		cout << 1;
		return 0;
	}

	cout << (f(k, n-k, 0) + f(k, n-k, 1))%MOD;

	return 0;
}