#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (int)(1e9) + 7
#define sz(a) (int)((a).size())

using namespace std;

struct event {
    int x, ev;
};

int n, k;
vector< vector<int> > v;

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

void start() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool cmp(event a, event b) {
    return a.x < b.x;
}

int check(vector<event>& v) {
    int cur = 0;

    for (int i = 0; i < sz(v); ++i) {
        int x, ev;
        x = v[i].x; ev = v[i].ev;

        if (ev == 1) {
            cur += 1;
            if (cur == n / 2) return 1;
        }
        else {
            cur -= 1;
        }
    }

    return false;
}

int main() {
    start();

    cin >> n >> k;
    v.resize(n);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            v[i].push_back(x);
        }
    }

    vector<int> p(n);

    for (int i = 0; i < n; ++i) p[i] = i;

    do {
        vector<event> g[k];
        for (int i = 0; i < n; i += 2) {
            for (int j = 0; j < k; ++j) {
                if (v[p[i]][j] < v[p[i + 1]][j]) {
                    g[j].push_back({v[p[i]][j], 1});
                    g[j].push_back({v[p[i + 1]][j], -1});
                }
                else {
                    g[j].push_back({v[p[i]][j], -1});
                    g[j].push_back({v[p[i + 1]][j], 1});
                }
            }
        }
        for (int i = 0; i < k; ++i) sort(g[i].begin(), g[i].end(), &cmp);

        int cur = 0;

        for (int i = 0; i < k; ++i) cur += check(g[i]);

        if (cur == k) {
            cout << "YES" << endl;
            for (int i = 0; i < n; i += 2) {
                cout << p[i] + 1 << " " << p[i + 1] + 1 << endl;
            }
            return 0;
        }
    } while (next_permutation(p.begin(), p.end()));

    cout << "NO" << endl;
}
