#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 300007;

int used[MAXN];

int p[MAXN];

int c1 = 0;
int c2 = 0;

int flag; //cycle
vector<int> cycle;
vector<int> comp;

vector<vector<int>> g(MAXN);

int col[MAXN];

int a1 = -1, a2 = -1;

void dfs(int u, int pr)
{
    comp.push_back(u);
    p[u] = pr;
    used[u] = true;
    for (auto v : g[u])
    {
        if (v != pr)
        {
            if (!used[v])
            {
                dfs(v, u);
            }
            else if (flag)
            {
                cycle.push_back(v);
                int cur = u;
                while (p[cur] != v)
                {
                    cycle.push_back(cur);
                    cur = p[cur];
                }
                cycle.push_back(cur);
                cycle.push_back(v);
                flag = false;
            }
        }
    }
}

void dfs2(int u, int c)
{
    col[u] = c;
    if (c == 0)
    {
        c1++;
    }
    else
    {
        c2++;
    }
    used[u] = true;
    for (auto v : g[u])
    {
        if ((a1 == v && a2 == u) || (a1 == u && a2 == v))
        {
            int qwerty = 123456;
        }
        else if (!used[v])
        {
            dfs2(v, c ^ 1);
        }
    }
}

int solve1(int n, vector<int> p1)
{
    int x;
    for (int i = 0; i < n; ++i)
    {
        x = p1[i];
        if (x >= 0)
        {
            g[i].push_back(x);
            g[x].push_back(i);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            c1 = 0;
            c2 = 0;
            flag = true;
            cycle = {};
            comp = {};
            dfs(i, -1);
            if (!flag)
            {
                int cnt = 0;
                for (int i = 0; i < cycle.size() - 1; ++i)
                {
                    for (auto el : comp)
                    {
                        used[el] = false;
                    }
                    c1 = 0;
                    c2 = 0;
                    int u = cycle[i + 1];
                    int v = cycle[i];
                    a1 = u;
                    a2 = v;
                    dfs2(u, 0);
                    if (col[u] != col[v])
                    {
                        cnt = max(cnt, max(c1, c2));
                    }
                    else
                    {
                        cnt = max(cnt, max(c1 - 1, c2));
                    }
                    a1 = -1;
                    a2 = -1;
                }
                ans += cnt;
            }
            else
            {
                c1 = 0;
                c2 = 0;
                for (auto el : comp)
                {
                    used[el] = false;
                }
                dfs2(i, 0);
                ans += max(c1, c2);
            }
        }
    }
    return ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> p1(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> p1[i];
        --p1[i];
    }
    cout << solve1(n, p1) << endl;
}
