#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 7;

vector<vector<int>> g(MAXN);

int c1, c2;

int used[MAXN];

int dp1[MAXN];
int dp2[MAXN];

void dfs3(int u, int pr)
{
    used[u] = true;
    if (g[u].size() == 1 && pr != -1)
    {
        dp1[u] = 0;
        dp2[u] = 1;
        return;
    }
    int cur = 0;
    int cur2 = 0;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs3(v, u);
            cur += dp1[v];
            cur2 += max(dp1[v], dp2[v]);
        }
    }
    dp2[u] = cur + 1;
    dp1[u] = cur2;
}

void dfs(int u, int c)
{
    used[u] = true;
    if (c)
    {
        ++c1;
    }
    else
    {
        ++c2;
    }
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs(v, c ^ 1);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    if (n <= 20)
    {
        for (int i = 0; i < n; ++i)
        {
            int x;
            cin >> x;
            --x;
            if (x >= 0)
            {
                g[x].push_back(i);
                g[i].push_back(x);
            }
        }
        int ans = 0;
        for (int i = 0; i < (1 << n); ++i)
        {
            int cur = 0;
            int flag = true;
            for (int u = 0; u < n; ++u)
            {
                for (auto v : g[u])
                {
                    if ((i & (1 << v)) && (i & (1 << u)))
                    {
                        flag = false;
                    }
                }
            }
            if (flag)
            {
                for (int u = 0; u < n; ++u)
                {
                    if ((i & (1 << u)))
                    {
                        ++cur;
                    }
                }
                ans = max(cur, ans);
            }
        }
        cout << ans << endl;
    }
    else
    {
        int fl = true;
        for (int i = 0; i < n; ++i)
        {
            int x;
            cin >> x;
            --x;
            if (!(x + 1 == i || i == 0))
            {
                fl = false;
            }
            if (x >= 0)
            {
                g[i].push_back(x);
                g[x].push_back(i);
            }
        }
        if (fl)
        {
            int ans = 0;
            for (int i = 0; i < n; ++i)
            {
                if (!used[i])
                {
                    c1 = 0;
                    c2 = 0;
                    dfs(i, 0);
                    ans += max(c1, c2);
                }
            }
            cout << ans << endl;
        }
        else
        {
            dfs3(0, -1);
            cout << max(dp1[0], dp2[0]) << endl;
        }
    }
}
