#include <bits/stdc++.h>
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));
vector <int> steps(1e6);
vector <vector <int> > sparse;

int ind(const vector <int>&num, int x) {
    if (upper_bound(num.begin(), num.end(), x) == num.end()) return -1;
    return num[upper_bound(num.begin(), num.end(), x) - num.begin()];
}

vector <vector <int> > build_sparse(const vector <int>&num) {
    vector <vector <int> > res;
    int n = num.size();
    vector <int> smth;
    for (int i = 0; i < n; i++) {
        smth.push_back(num[i]);
    }
    res.push_back(smth);
    for (int x = 1; x < 20; x++) {
        if ((1 << x) > n) break;
        vector <int> kek;
        for (int j = 0; j < n - (1 << x) + 1; j++) {
            kek.push_back(min(res[x - 1][j], res[x - 1][j + (1 << (x - 1))]));
        }
        res.push_back(kek);
    }
    return res;
}

int get_min(int l, int r) {
    int len = r - l + 1;
    int x = steps[len];
    return min(sparse[len][l], sparse[len][l + (1 << x)]);
}

void precalc() {
    for (int i = 0; i < steps.size(); i++) {
        int l = 0;
        int r = 23;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((1 << m) <= i) l = m;
            else r = m;
        }
        steps[i] = l;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector <pair <int, int> > num(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        num[i] = {x, i};
    }
    sort(num.begin(), num.end());
    vector <pair <int, int> > ans;
    int i = 0;
    while (i < n) {
        if (num[i + 1].first - num[i].first <= 1) {
            cout << "NO\n";
            return 0;
        }
        ans.push_back({num[i].second, num[i + 1].second});
    }
    cout << "YES\n";
    for (auto el : ans) cout << el.first << " " << el.second << "\n";
    return 0;
}
