#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

#define int long long

int sq(int a)
{
    int res = sqrt(a);
    while(res * res < a)
        ++res;
    while(res * res> a)
        --res;
    return res;
}

signed main()
{
    int k;
    cin >> k;
    if(k >= 0 && sq(k) * sq(k) == k)
    {
        cout << 0;
        return 0;
    }
    vector<int> cnt(1e6);
    vector<int> pf(1e6);
    cnt[0] = 1;
    pf[0] = 1;
    for(int i = 1; i < 1e6; ++i)
    {
        cnt[i] = cnt[i - 1] + 2;
        pf[i] = pf[i - 1] + cnt[i];
    }
    for(int n = 1; n < 1e6; ++n)
    {
        int left = 0;
        int right = 1e6;
        while(left + 1 != right)
        {
            int a = (left + right) / 2;
            if((cnt[a] + n - 1) * n > k)
            {
                right = a;
            }
            else
            {
                left = a;
            }
        }
        int q = (cnt[left] / 2) * (cnt[left] / 2) + k;
        if(sq(q) * sq(q) == q)
        {
            cout << sq(q);
            return 0;
        }
    }
    cout << "none";
}