#include <bits/stdc++.h>

using namespace std;

const int INF = (int)1e9 + 7;

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<pair<int,int>>> dp(n + 1, vector<pair<int,int>> (n + 1, make_pair(0, 0)));
    dp[k][k] = make_pair(1, 1);
    vector<vector<pair<int, int>>> dppresum(n + 1, vector<pair<int, int>>(n + 1, make_pair(0, 0)));
    for (int i = k; i <= n; ++i)
    {
        for (int j = 1; j < i; ++j)
        {
            dp[i][j].first = dppresum[i - j][j - 1].second;
            if (j != n)
                dp[i][j].second = (dppresum[i - j][n].first - 0LL - dppresum[i - j][j].first + INF) % INF;
            else
                dp[i][j].second = 0;
        }
        for (int j = 1; j <= n; ++j)
        {
            dppresum[i][j].first = (dppresum[i][j - 1].first + 0LL + dp[i][j].first) % INF;
            dppresum[i][j].second = (dppresum[i][j - 1].second + 0LL + dp[i][j].second) % INF;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i)
        ans = (ans + 0LL + dp[n][i].first + dp[n][i].second) % INF;
    cout << ans << endl;
    return 0;
}

