#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
vector<vector<int>> g;
vector<bool> used;
vector<bool> clr;
int ans = 0;
void dfs(int v, bool clrr)
{
    used[v] = true;
    if (clrr)
    {
        if (used[g[v].back()] && clr[g[v].back()])
        {
            return;
        } else if (!used[g[v].back()])
        {
            ans++;
            clr[v] = true;
            dfs(g[v].back(), false);
            return;
        }
        else
        {
            clr[v] = true;
            ans++;
            return;
        }
    } else
    {
        if (used[g[v].back()])
        {
            return;
        }
        else
        {
            dfs(g[v].back(), true);
        }
    }
}
int main()
{
    int n;
    cin >> n;
    g.resize(n + 1);
    used.resize(n + 1);
    clr.resize(n + 1);
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        if (x == -1)
        {
            clr[i + 1] = true;
            ans++;
            used[i + 1] = true;
            continue;
        }
        g[i + 1].push_back(x);
    }
    for (int i = 1; i <= n; i++)
    {
        if (!used[i])
        {
            dfs(i, true);
        }
    }
    cout << ans;
}
