#include <iostream>
#include <cmath>
#include <map>
#include <algorithm>
#include <vector>
using namespace std;

int main() {
    int n;
    cin >> n;
    int k;
    cin >> k;
    vector<int> v(n);
    map<int, vector<int>> mp;
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
        mp[v[i]].push_back(i);
    }
    sort(v.begin(), v.end());
    int i = 0;
    int j = n - 1;
    cout << "YES" << endl;
    while (i < j)
    {
        cout << mp[v[i]].back() + 1 << ' ' << mp[v[j]].back() + 1<< endl;
        mp[v[i]].pop_back();
        mp[v[j]].pop_back();
        if (mp[v[i]].size() == 0)
        {
            i++;
        }
        if (mp[v[j]].size() == 0)
        {
            j--;
        }
    }
}

