#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allv(a) a.begin(), a.end()
#define allar(a) a, a + n

#include <iostream>
#include <string>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const ll MOD = (ll)1e9 + 7;
const int inf = (int)1e9 + 7;

const int N = 3e5;

int n, a[N], cnt_black, ans;
bool used[N], in_cycle[N];
vector <int> adj_list[N], starts;

int dfs(int v, int c = 1) {
	int size_ = 1;
	used[v] = true;
	cnt_black += (c == 1);
	for (int u : adj_list[v]) {
		if (in_cycle[u]) continue;
		size_ += dfs(u, 3 - c);
	}
	return size_;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	rep(n, i) {
		scanf("%d", &a[i]);
		if (a[i] != -1) {
			--a[i];
			adj_list[a[i]].push_back(i);
		}
		else
			starts.push_back(i);
	}
	for (int elem : starts) {
		cnt_black = 0;
		int cur_size = dfs(elem);
		ans += max(cnt_black, cur_size - cnt_black);
	}
	rep(n, i) {
		if (used[i]) continue;
		vector <int> cycle;
		vector <pii> means;
		int cur = i;
		while (!used[cur]) {
			used[cur] = true;
			cur = a[cur];
		}
		cycle.push_back(cur);
		in_cycle[cur] = true;
		cur = a[cur];
		while (cur != cycle.front()) {
			cycle.push_back(cur);
			in_cycle[cur] = true;
			cur = a[cur];
		}
		for (int elem : cycle) {
			cnt_black = 0;
			int cur_size = dfs(elem);
			means.push_back(mp(cnt_black, cur_size - cnt_black));
		}
		vector <pii> dp1(cycle.size()), dp2(cycle.size());
		dp1[cycle.size() - 1].first = means.back().first;
		dp1[cycle.size() - 1].second = -inf;
		dp2[cycle.size() - 1].second = means.back().second;
		dp2[cycle.size() - 1].first = -inf;
		per(cycle.size() - 1, i) {
			dp1[i].first = dp1[i + 1].second + means[i].first;
			dp1[i].second = max(dp1[i + 1].first, dp1[i + 1].second) + means[i].second;
			dp2[i].first = dp2[i + 1].second + means[i].first;
			dp2[i].second = max(dp2[i + 1].first, dp2[i + 1].second) + means[i].second;
		}
		ans += max(max(dp2[0].first, dp2[0].second), dp1[0].second);
	}
	printf("%d", ans);
	return 0;
}