#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;
const int mod = 1e9 + 7;
const int ms = 2e7;

int get(int n)
{
    int res = 0;
    while (n)
    {
        res += n % 2;
        res %= mod;
        n /= 2;
    }
    return res;
}

int ft[ms + 1];

int ank(int n, int k)
{
    return (ft[n] / ft[n - k]);
}

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    ft[0] = 1;
    for (int i = 1; i <= ms; ++i)
    {
        ft[i] = ft[i - 1] * i;
        ft[i] %= mod;
    }
    if (m > -1)
    {
        int ans = 0;
        for (int i = 0; i <= k; ++i)
        {
            int cnt = get(i);
            int r = 1;
            for (int i = 0; i < cnt; ++i)
            {
                r *= 2;
                r %= mod;
            }
            r *= (n);
            r %= mod;
            if (r < n - 1)
            {
                continue;
            }
            ans += (ank(r, n - 1) % mod);
            ans %= mod;
        }
        cout << ans;
    }
    return 0;
}
