#include <bits/stdc++.h>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;
const int ms = 6e3;
const int mod = 1e9 + 7;

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
    dp[k][k][0] = 1;
    dp[k][k][1] = 1;
    for (int s = k + 1; s <= n; ++s)
    {
        for (int i = 1; i <= n; ++i)
        {
            if (s < i)
            {
                continue;
            }
            for (int j = 1; j < i; ++j)
            {
                dp[s][i][1] += dp[s - i][j][0];
                dp[s][i][1] %= mod;
            }
            for (int j = i + 1; j <= n; ++j)
            {
                dp[s][i][0] += dp[s - i][j][1];
                dp[s][i][0] %= mod;
            }
        }
    }
    for (int s = 0; s <= n; ++s)
    {
        for (int i = 0; i <= n; ++i)
        {
            cout << "{" << dp[s][i][0] << ", " << dp[s][i][1] << "} ";
        }
        cout << "\n";
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i)
    {
        ans += (dp[n][i][0] + dp[n][i][1]) % mod;
        ans %= mod;
    }
    cout << ans;
    return 0;
}

