#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) a.begin(), a.end()
#define rall(v) a.rbegin(), a.rend()

const int INF = 1e18, MOD = 1e9 + 7;
const ld EPS = 1e-7;

int n, m, k;
vector <int> max_len;

void solve() {
	vector <vector <int> > dp(k + 1, vector <int>(n + 1, 0)), new_dp;
	for (int i = 0; i <= k; ++i) {
		dp[i][1] = 1; 
	}
	for (int i = 1; i < n; ++i) {
		new_dp.clear(); new_dp.resize(k + 1, vector <int>(n + 1, 0));
		for (int j = 0; j <= k; ++j) {
			for (int len = 1; len <= min(max_len[i], n); ++len) {
				for (int t = 0; t <= k; ++t) {
					if ((t & j) == t) {
						if (len > 1) {
							if (j == t) {
								new_dp[j][len] += dp[t][len - 1];
							}
						} else {
							if (j != t) {
								for (int q = 0; q <= n; ++q) {
									new_dp[j][len] += dp[t][q];
								}
							}
						}
						//new_dp[j][len] += dp[t][len - 1];
						new_dp[j][len] %= MOD;
					}
				}
			}
		}
		dp = new_dp;
	}
	int ans = 0;
	for (int i = 0; i <= k; ++i) {
		for (int j = 0; j <= n; ++j) {
			ans += dp[i][j];
			ans %= MOD;
		}
	}
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> k;
	max_len.resize(n, INF);
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		max_len[r] = min(max_len[r], r - l);
	}
	solve();
	return 0;
}