#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) a.begin(), a.end()
#define rall(v) a.rbegin(), a.rend()

const int INF = 1e18;
const ld EPS = 1e-7;

vector <vector <int> > g;
vector <vector <int> > dp;
vector <bool> used;

void dfs(int v) {
	used[v] = true;
	int sum1 = 0, max_d = -INF;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to);
			sum1 += dp[to][1];
			max_d = max(max_d, dp[to][0] - dp[to][1]);
		}
	}
	if (max_d == -INF) {
		dp[v][0] = 0;
		dp[v][1] = 1;
	} else {
		dp[v][0] = sum1;
		dp[v][1] = 1 + sum1 + max_d;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a != -1) {
			g[a - 1].push_back(i);
			g[i].push_back(a - 1);
		}
	}
	used.resize(n, false);
	dp.resize(n, vector <int>(2, 0));
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
			ans += dp[i][1];
		}
	}
	/*for (int i = 0; i < n; ++i) {
		cout << dp[i][0] << " " << dp[i][1] << endl;
	}*/
	cout << ans << endl;
	return 0;
}