#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const ld EPS = 1e-7;

int n;
vector <vector <int> > g;
vector <bool> take, used;


void dfs(int v, bool f) {
	used[v] = true;
	for (int to : g[v]) {
		if (take[to]) {
			f = false;
			break;
		}
	}
	take[v] = f;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to, !f);
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a != -1) {
			g[a - 1].push_back(i);
			g[i].push_back(a - 1);
		}
	}
	vector <pair <int, int> > sv;
	for (int i = 0; i < n; ++i) {
		sv.push_back({sz(g[i]), i});
	}
	sort(all(sv));
	take.resize(n, false);
	used.resize(n, false);
	for (auto it : sv) {
		int v = it.second;
		if (!used[v]) {
			dfs(v, true);
		}
	}
	cout << count(all(take), true) << endl;
	return 0;
}