#include <iostream>
#include <vector>
#include <cmath>
#include <climits>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double lld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll k;
    ull x, n, s;
    long double sq;
    cin >> k;
    if (k < 0) {
        n = 0;
    } else {
        n = sqrt((lld)k);
        if (n * n < k)
            ++n;
    }
    ll end_ = 2*1e9;
    if (end_ - n > 1e8)
        end_ = n + 1e8;
    for (int p = 1; p < 1e8 && n < 3*1e9; ++p, ++n) {
        ull tmp = (n * n - (ull)k);
        s = trunc(sqrt((lld)tmp));

        if (s*s == tmp) {
            cout << n << endl;
            return 0;
        }
    }
    cout << "none\n";
    return 0;
}
