#include <iostream>
#include <vector>
#include <cmath>
#include <climits>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double lld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll k;
    ull x, n, s, tmp;
    long double sq;
    cin >> k;
    if (k < 0) {
        n = 0;
    } else {
        n = sqrt((lld)k);
        if (n * n < k)
            ++n;
    }
    cout << fixed;
    cout.precision(10);
    ll end_ = 2*1e9;
    if (end_ - n > 1e8)
        end_ = n + 1e8;
    for (int p = 1; p < 1e8; ++p, ++n) {
        if (n > 2*1e6)
            break;
        sq = sqrt((lld)(n * n - (ull)k));
        if (sq == trunc(sq)) {
            cout << n << endl;
            //cout << sq*sq + k << "\n" << n *n << endl;
            return 0;
        }
    }
    cout << "none\n";
    return 0;
}
