#include <iostream>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

typedef long long ll;
set<int> q;
vector<int> ask, st, ans;
int n, m;

void down(int from) {
    //cout << "<><><><>\n";
    int x = st[0];
    //cout << "goes down: " << x << endl;
    q.clear();
    for (int i = from; i < m && ask[i] != x; ++i) {
        q.insert(ask[i]);
    }
    int pos = n - 1;
    while (pos > 0 && q.find(st[pos]) == q.end())
        --pos;
    //cout << "to pos: " << pos + 1 << endl;
    for (int i = 0; i < pos; ++i)
        swap(st[i], st[i + 1]);
    ans.push_back(pos + 1);
    //cout << "<><><><>\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    ask.resize(m);
    st.resize(n);
    for (int i = 0; i < m; ++i)
        cin >> ask[i];
    for (int i = 0; i < n; ++i)
        cin >> st[i];

    bool u1 = (n == m), u2 = (n == m);
    if (n == m) {
        for (int i = 0; i < n; ++i)
            if (st[i] != ask[i])
                u1 = false;
        for (int i = 0; i < n; ++i)
            if (st[i] != ask[n - i - 1])
                u2 = false;
    }

    if (u1) {
        cout << n << endl;
        for (int i = 0; i < n; ++i)
            cout << n << " ";
        return 0;
    }
    if (u2) {
        cout << 2*n - 1 << endl;
        int t = n;
        for (int i = 1; i < n; ++i)
            cout << t-- << " ";
        for (int i = 0; i < n; ++i)
            cout << n << " ";
        return 0;
    }
    if (n < 3000 && m < 3000) {
        for (int i = 0; i < m; ++i) {
            while (st[0] != ask[i])
                down(i);
            down(i + 1);
        }
        cout << ans.size() << endl;
        for (int i = 0, end_ = (int)ans.size(); i < end_; ++i)
            cout << ans[i] << " ";
        return 0;
    }
    for (int i = 0; i < m; ++i) {
        while (st[0] != ask[i])
            down[i];
        ans.push_back(n);
        int tmp = st[0];
        st.erase(st.begin());
        st.push_back(tmp);
    }
    cout << ans.size() << endl;
        for (int i = 0, end_ = (int)ans.size(); i < end_; ++i)
            cout << ans[i] << " ";
    return 0;
}



/*

4 5
4 1 2 4 4
4 3 2 1


*/
