#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

struct graph {
	ll n;
	vector<vll> adj, radj;
	graph() {}
	graph(ll n_) {
		n = n_;
		adj.resize(n);
		radj.resize(n);
	}
	void add(ll v, ll u) {
		adj[v].pb(u);
		radj[u].pb(v);
	}
};

ll n;
vll a;
graph g;
vll dp, par;
vll used;

void dfs(ll v) {
	used[v] = 1;
	dp[v] = 1;
	for (ll u : g.radj[v]) {
		if (used[u]) {
			continue;
		}
		dfs(u);
		if (maxeq(dp[v], dp[u] + 1)) {
			par[v] = u;
		}
	}
}

inline void solve() {
	dp.assign(n, 0);
	par.assign(n, -1);
	used.assign(n, 0);
	dfs(0);
	used.assign(n, 0);
	ll ans = 0;
	for (ll v = 0; v < n; v++) {
		if (used[v]) {
			continue;
		}
		ans += (dp[v] + 1) / 2;
		ll u = v;
		while (u != -1) {
			used[u] = 1;
			u = par[u];
		}
	}
	cout << ans << endl;
}

inline void read() {
	cin >> n;
	a.resize(n);
	g = graph(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		--a[i];
		if (a[i] != -2) {
			g.add(i, a[i]);
		}
	}
}
