#define ll long long
#define forrange(i, a, b) for (int i = a; i < b; ++i)
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <iterator>
#include <cmath>

using namespace std;

const ll MD = 1000000000 + 7;


ll count(ll ind, vector<int> &bin, ll n)
{
	ll p1, p2, ind2;
	if (ind == 0)
	{
		return 1 + n * bin[0];
	}
	
	if (bin[ind] == 1)
	{
		p1 = 1;
		for (ll i = 0; i < ind; ++i)
		{
			p1 *= (n + 1);
			p1 %= MD;
		}
		return (count(ind - 1, bin, n)*p1) % MD;
	}

	return (count(ind - 1, bin, n));
}

int main()
{
	ll res = 1;
	ll n, m, k;
	cin >> n >> m >> k;

	if (k == 0)
	{
		cout << 1;
		return 0;
	}


	ll temp = k;
	vector<int> bin_k;
	while (temp > 0)
	{
		bin_k.push_back(temp % 2);
		temp /= 2;
	}

	cout << count(bin_k.size() - 1, bin_k, n)%MD;


	return 0;
}