#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
#pragma GCC optimize "-O3"


using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;

	vector<int> A(m);
	vector<int> B(n);

	vector<int> cnt(n);
	vector<int> dep(n);
	vector<int> cdep(n);
	vector<vector<int>> arr(n, {-2});

	for (int i = 0; i < m; i++)
	{
		cin >> A[i];
		A[i]--;
		arr[A[i]].pb(i);
	}

	for (int i = 0; i < n; i++)
	{
		cin >> B[i];
		B[i]--;
		dep[B[i]] = i;
		cdep[B[i]] = i;
	}

	for (int i = 0; i < n; i++)
	{
		arr[i].pb(-1);
	}

	/*set<pair<int, int>> que;

	for (int i = 0; i < n; i++)
	{
		if (arr[i][0] != -1)
		{
			que.insert({ arr[i][0], i });
		}
	}
*/
	if (n == m)
	{
		bool good = 1;

		for (int i = 0; i < n; i++)
		{
			if (A[i] != B[n - i - 1])
			{
				good = 0;
			}
		}

		if (good)
		{
			cout << 2 * n - 1;
			for (int i = n; i > 1; i--)
				cout << i << " ";
			
			for (int i = n; i > 0; i--)
				cout << n << " ";
			cout << endl;
			
			return 0;
		}
	}
	


	int maxdep = -1;

	vector<bool> used(n, 0);

	vector<int> ans;
	for (int i = 0; i < m; i++)
	{
		int cur = A[i];

		if (used[cur] == 0)
		{
			cnt[cur]++;
			used[cur] = 1;
			int tmp = maxdep;
			// cerr << cdep[cur] << endl;
			maxdep = max(maxdep, cdep[cur]);

			for (int ci = tmp + 1; ci < cdep[cur]; ci++)
			{
				int c = B[ci];

				// cerr << c << endl;
				used[c] = 1;

				/*for (int x : arr[c])
					cerr << x << " ";
				cerr << endl;*/

				if (arr[c][cnt[c] + 1] == -1)
				{
					ans.pb(n - 1);
					//cerr << " OK E" << endl;
					continue;
				}

				// cerr << 1 << endl;
				
				set<int> que;
				int maxnew = maxdep;
				
				for (int j = i + 1; j < arr[c][cnt[c] + 1]; j++)
				{
					if (used[A[j]] == 0)
					{
						maxnew = max(maxnew, cdep[A[j]]);
					}
					que.insert(A[j]);
				}

				// cerr << 2 << endl;
				ans.pb((int)que.size() + 1 + max(maxnew - maxdep, 0));

				cnt[c]++;
				//cerr << " OK" << endl;
			}

		}

		if (arr[cur][cnt[cur] + 1] == -1)
		{
			ans.pb(n - 1);
			continue;
		}

		set<int> que;
		int maxnew = maxdep;
		for (int j = i + 1; j < arr[cur][cnt[cur] + 1]; j++)
		{
			if (used[A[j]] == 0)
			{
				maxnew = max(maxnew, cdep[A[j]]);
			}
			else
				que.insert(A[j]);
		}

		//cerr << "!!! SZ:" << (int)que.size() << " Maxnew:" << maxnew << " Maxdep:" << maxdep << endl;

		ans.pb(que.size() + max(maxnew - maxdep, 0) );
		cnt[cur]++;
	}

	cout << ans.size() << endl;

	for (int i : ans)
		cout << i + 1 << " ";
	cout << endl;

	system("pause");
	return 0;
}