#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 3e5 + 228;
int n, m, sz, a[mx], b[mx], used[mx], rpos[mx], pos[mx];
vector<int> c;

int get_diff(int l, int r) {
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	int ans = 0;
	for (int i = l; i <= r; ++i) {
		if (used[c[i]] == 0) {
			used[c[i]] = 1;
			ans++;
		}
	}
	return ans;
}

int main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		b[i]--;
	}
	int ptr = 0;
	for (int i = 0; i < m; ++i) {
		if (used[a[i]]) {
			c.push_back(a[i]);
		}
		else {
			while (!used[a[i]]) {
				c.push_back(b[ptr]);
				used[b[ptr++]] = 1;
			}
		}
	}

	sz = c.size();

	fill(pos, pos + n, sz);
	for (int i = sz - 1; i >= 0; --i) {
		rpos[i] = pos[c[i]];
		pos[c[i]] = i;
	}

	//output(all(c));
	cout << c.size() << endl;
	for (int i = 0; i < c.size(); ++i) {
		cout << get_diff(i + 1, rpos[i] - 1) + 1 << " ";
	}
	cout << endl;
}
