#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const ld pi = 3.1415926;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
//#define int ll

template<typename T> void uin(T & a, T b) { if (b < a) a = b; }
template<typename T> void uax(T & a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

vector<pair<int, int>> bad[300];

vector<int> f(300001);
void upd(int r, int add) {
	for (; r < 300001; r = (r | (r + 1)))
		f[r] += add;
}
int sum(int r) {
	int ans = 0;
	for (; r >= 0; r = (r & (r + 1)) - 1)
		ans += f[r];
	return ans;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n), pos(n);
	vector<int> fir(n, inf);
	forn(i, m) {
		cin >> a[i];
		a[i]--;
		uin(fir[a[i]], i);
	}
	forn(i, n) {
		cin >> b[i];
		b[i]--;
		pos[b[i]] = i;
	}
	vector<int> mx(m + 1, -1);
	forn(i, m) mx[i + 1] = max(mx[i], pos[a[i]]);
	forn(i, n) {
		int t = fir[i];
		uin(t, m);
		int l = 0, r = t + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (mx[mid] > pos[i]) r = mid;
			else l = mid;
		}
		if (r <= t) bad[r - 1].push_back({ pos[i], i });
	}
	forn(i, m) sort(all(bad[i]));
	vector<int> allr[300];
	forn(i, m) {
		forn(j, bad[i].size()) allr[bad[i][j].y].push_back(i);
		allr[a[i]].push_back(i);
	}
	forn(i, n) {
		sort(all(allr[i]));
		allr[i].push_back(m);
		reverse(all(allr[i]));
	}
	vector<int> ans;
	forn(i, n) upd(allr[i].back(), 1);
	forn(i, m) {
		forn(j, bad[i].size()) {
			upd(allr[bad[i][j].y].back(), -1);
			allr[bad[i][j].y].pop_back();
			upd(allr[bad[i][j].y].back(), 1);
			ans.push_back(sum(allr[bad[i][j].y].back() - 1));
		}
		upd(allr[a[i]].back(), -1);
		allr[a[i]].pop_back();
		upd(allr[a[i]].back(), 1);
		ans.push_back(sum(allr[a[i]].back() - 1));
	}
	cout << (int)ans.size() << el;
	forn(i, ans.size()) cout << ans[i] + 1 << ' ';
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}