#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const ld pi = 3.1415926;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
//#define int ll

template<typename T> void uin(T & a, T b) { if (b < a) a = b; }
template<typename T> void uax(T & a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	ll k;
	cin >> n >> m >> k;
	vector<pair<int, int>> a1(m), a;
	forn(i, m) {
		cin >> a1[i].x >> a1[i].y;
		a1[i].x--; a1[i].y--;
	}
	sort(all(a1));
	reverse(all(a1));
	int r = inf;
	forn(i, m) {
		if (a1[i].y >= r) continue;
		a.push_back(a1[i]);
		uin(r, a1[i].y);
	}
	reverse(all(a));
	m = (int)a.size();
	forn(i, m) a[i].y--;
	vector<int> dp[64], t[64];
	forn(i, 64) dp[i].resize(m + 1), t[i].resize(m + 1);
	dp[0][0] = 1;
	int c[64][64];
	forn(i, 64) c[i][0] = c[i][i] = 1;
	firn(i, 64)
		firn(j, i)
		c[i][j] = (c[i - 1][j] + c[i - 1][j - 1]) % mod;
	forn(i, m) {
		int l = -1, r = i;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (a[mid].y >= a[i].x) r = mid;
			else l = mid;
		}
		firn(j, 64) {
			dp[j][i + 1] = t[j][i] - t[j][r] + mod;
			dp[j][i + 1] %= mod;
			int tmp1 = a[r].y - a[r].x + 1;
			if (r > 0 && a[r - 1].y >= a[r].x) tmp1 = a[r].y - a[r - 1].y;
			int st1 = tmp1;
			int tmp = tmp1 - (a[r].y - a[i].x + 1);
			int st = tmp;
			firn(l, j + 1) {
				dp[j][i + 1] = (dp[j][i + 1] * 1ll  + (st1 - st) * 1ll * c[j][l] % mod * 1ll * dp[j - l][r]) % mod;
				st = st * 1ll * tmp % mod;
				st1 = st1 * 1ll * tmp1 % mod;
			}
			t[j][i + 1] = t[j][i];
			if (i < m - 1) {
				tmp = a[i + 1].y - a[i].y;
				st = tmp;
				firn(l, j) {
					t[j][i + 1] = (t[j][i + 1] * 1ll + dp[j - l][i + 1] * 1ll * st % mod * 1ll * c[j][l]) % mod;
					st = st * 1ll * tmp % mod;
				}
			}
		}
	}
	ll dl = (m > 0 ? a[0].y - a[0].x + 1 : 0);
	firn(i, m) {
		dl += a[i].y - max(a[i].x - 1, a[i - 1].y);
	}
	dl = n - dl;
	vector<int> ans(64);
	forn(i, 64) {
		int st = 1;
		forn(j, i + 1) {
			ans[i] = (ans[i] * 1ll + st * 1ll * c[i][j] % mod * 1ll * dp[i - j][m]) % mod;
			st = st * 1ll * dl % mod;
		}
	}
	bitset<64> aa(k);
	int sum = 0, an = 0;
	for (int i = 63; i >= 0; --i) {
		if (!aa[i]) continue;
		forn(j, i + 1)
			an = (an * 1ll + ans[sum + j] * 1ll * c[i][j] % mod) % mod;
		sum++;
	}
	an = (an + ans[sum]) % mod;
	cout << an;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}