#include <bits/stdc++.h>

using namespace std;

const long long M = 1000000007;

int main()
{
    ios_base::sync_with_stdio(false);
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<long long> > dp(n, vector<long long>(k + 1, 1));
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j <= k; j++)
        {
            dp[i][j] = 0;
            for (int s = 0; s <= k; s++)
            {
                dp[i][j] += (dp[i - 1][s] * ((s & j) == s));
                dp[i][j] %= M;
            }
        }
    }

    long long ans = 0;
    for (auto i : dp[n - 1])
    {
        ans += i;
        ans %= M;
    }
    cout << ans;
}
