#include <iostream>
using namespace std;
const int N = 5001;
const int mod = 1e9 + 7;

static int dpu[N][N], dpd[N][N], pdpu[N][N+1], pdpd[N][N+1];

int main()
{
    int n, k;
    cin >> n >> k;
    dpu[k][k] = dpd[k][k] = 1;
    for (int i = 0; i <= N; ++i)
        pdpu[k][i] = pdpd[k][i] = i > k;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    for (int i = k + 1; i <= n; ++i)
    {
        for (int j = 0; j < i; ++j)
            dpu[i][j] = pdpd[i-j][j], dpd[i][j] = (pdpu[i-j][N] - pdpu[i-j][j+1] + mod) % mod;
        for (int j = 0; j < N; ++j)
            pdpu[i][j+1] = (pdpu[i][j] + dpu[i][j]) % mod, pdpd[i][j+1] = (pdpd[i][j] + dpd[i][j]) % mod;
    }
    int ans = 0;
    for (int i = 0; i < N; ++i)
        ans = ((ans + dpu[n][i]) % mod + dpd[n][i]) % mod;
    cout << ans;
    return 0;
}
