#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector <vector <int> > data(n, vector <int>(k));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < k; j++)
            cin >> data[i][j];
    if (k == 1) {
        for (int i = 0; i < n; i++)
            data[i].push_back(i + 1);
        sort(data.begin(), data.end());
        cout << "YES\n";
        for (int i = 0; i < n / 2; i++)
            cout << data[i][1] << " " << data[n - i - 1][1] << "\n";
        return 0;
    }
    vector <int> mask(n);
    for (int i = 0; i < n; i++)
        mask[i] = i;
    do {
        int ok = 0;
        for (int i = 0; i < n; i++)
            if ((mask[mask[i]] == i) && (mask[i] != i)) ok++;
        if (ok != n) continue;
        set <pair <int, int> > p;
        for (int i = 0; i < n; i++) {
            p.insert(make_pair(min(i, mask[i]), max(i, mask[i])));
        }
        ok = 0;
        for (int i = 0; i < k; i++) {
            int L = -INF, R = INF;
            for (auto cur : p) {
                int l = min(data[cur.first][i], data[cur.second][i]);
                int r = max(data[cur.first][i], data[cur.second][i]);
                if (L < l) L = l;
                if (R > r) R = r;
            }
            if (L <= R) ok++;
        }
        if (ok != k) continue;
        cout << "YES\n";
        for (auto cur : p) {
            cout << cur.first + 1 << " " << cur.second + 1 << "\n";
        }
        return 0;
    } while (next_permutation(mask.begin(), mask.end()));
    cout << "NO";
    return 0;
}
