//#include "pch.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll INF = 1000LL * 1000LL * 1000LL;

bool if_square(ll a)
{
    if (a < 0) return false;
    ll temp = sqrt(a);
    return (temp * temp == a);
}

bool q(const vector<ll> &a, const vector<ll> &b)
{
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] != b[i])
        {
            return false;
        }
    }
    return true;
}

bool iq(const vector<ll> &a, const vector<ll> &b)
{
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] != b[b.size() - i - 1])
        {
            return false;
        }
    }
    return true;
}

int find(const vector<ll> &arr, ll key)
{
    for (ll i = arr.size() - 1LL; i >= 0LL; i--)
    {
        if (arr[i] == key)
        {
            return i;
        }
    }
    return -1;
}

bool check(ll a)
{
    if (a % 2LL == 0LL) return false;
    for (ll i = 3LL; i * i <= a; i += 2LL)
    {
        if (a % i == 0LL)
        {
            return false;
        }
    }
    return true;
}

int main()
{
    /*
    for (ll k = 0; k < 1000; k++)
    {
        cout << k << " ";
        bool qweert = false;
        if (k % 2 == 0 && k % 4 != 0)
        {
            cout << "none1" << endl; continue;
        }
        for (ll i = 0LL; i < (ll)10e6; i++)
        {
            ll temp = i * i + k;
            if (temp >= 0)
            {
                ll temp1 = (ll)sqrt(temp);
                if (temp1 * temp1 == temp)
                {
                    qweert = true;
                    cout << temp1 << endl;
                    break;
                }
            }
        }
        if(!qweert)
            cout << "none" << endl;
    }
	return 0;
    */
    ll k;
    cin >> k;
    if (k % 2 == 0 && k % 4 != 0)
    {
        cout << "none" << endl; return 0;
    }
    if (k >= 0)
    {
        for (ll i = (sqrt(k) * sqrt(k) == k ? sqrt(k) : sqrt(k) + 1);; i++)
        {
            if (if_square(i * i - k))
            {
                cout << i << endl;
                break;
            }
        }
    }
    else
    {
        for (ll i = 1;; i++)
        {
            if (if_square(i * i + k))
            {
                cout << (ll)sqrt(i * i + k) << endl;
                break;
            }
        }
    }
    return 0;
}

/*
ll k;
    cin >> k;
    if (k % 2 == 0)
    {
        if (k == 0)
        {
            cout << 0 << endl; return 0;
        }
        if (k > 0)
        {
            for (ll i = 0LL; i < (ll)10e6; i++)
            {
                ll temp = i * i + k;
                if (temp >= 0)
                {
                    ll temp1 = (ll)sqrt(temp);
                    if (temp1 * temp1 == temp)
                    {
                        cout << temp1 << endl;
                        return 0;
                    }
                }
            }
            cout << "none" << endl;
            return 0;
        }
        else
        {

            if (k % 4LL == 0LL)
            {
                ll temp = sqrt(-k);
                if (temp * temp != -k)
                {
                    temp++;
                }
                if (if_square(temp * temp + k))
                {
                    cout << (ll)sqrt(temp * temp + k) << endl;
                    return 0;
                }
                k /= -4LL; k--;
                cout << k << endl;
            }
            else
            {
                cout << "none" << endl;
            }
            return 0;
            /*
            if (k % 4LL != 0LL)
            {
                cout << "none" << endl;
                return 0;
            }
            for (ll i = 0LL; i < (ll)10e6; i++)
            {
                ll temp = i * i + k;
                if (temp >= 0)
                {
                    ll temp1 = (ll)sqrt(temp);
                    if (temp1 * temp1 == temp)
                    {
                        cout << temp1 << endl;
                        return 0;
                    }
                }
            }
            cout << "none" << endl;
            return 0;
            
        }
    }
    else
    {
    if (k < 0)
    {
        ll temp = sqrt(-k);
        if (!if_square(-k))
        {
            temp++;
        }
        if (if_square(temp * temp + k))
        {
            cout << (ll)sqrt(temp * temp + k) << endl;
            return 0;
        }
        k *= -1;
        k = (k + 1) / 2;
        k--;
        cout << k << endl;
        return 0;
        /*
        for (ll i = 0LL; i < (ll)10e6; i++)
        {
            ll temp = i * i + k;
            if (temp >= 0)
            {
                ll temp1 = (ll)sqrt(temp);
                if (temp1 * temp1 == temp)
                {
                    cout << temp1 << endl;
                    return 0;
                }
            }
        }
        return 0;
        
    }
    if (k > 0)
    {
        ll temp = sqrt(k);
        if (temp * temp != k)
        {
            temp++;
        }
        if (if_square(temp * temp - k) && k <= temp * temp - k)
        {
            cout << (ll)sqrt(temp * temp - k) << endl;
            return 0;
        }
        k = (k + 1) / 2;
        cout << k << endl;
        return 0;
        /*
        for (ll i = 0LL; i < (ll)10e6; i++)
        {
            ll temp = i * i + k;
            if (temp >= 0)
            {
                ll temp1 = (ll)sqrt(temp);
                if (temp1 * temp1 == temp)
                {
                    cout << temp1 << endl;
                    return 0;
                }
            }
        }
        
        return 0;
    }
    }
*/

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
