//#include "pch.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll INF = 1000LL * 1000LL * 1000LL;

bool if_square(ll a)
{
    if (a < 0) return false;
    ll temp = sqrt(a);
    return (temp * temp == a);
}

bool q(const vector<ll> &a, const vector<ll> &b)
{
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] != b[i])
        {
            return false;
        }
    }
    return true;
}
bool iq(const vector<ll> &a, const vector<ll> &b)
{
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] != b[b.size() - i - 1])
        {
            return false;
        }
    }
    return true;
}

int main()
{
    ll n, m;
    cin >> n >> m;
    vector<ll> zapros(m);
    for (ll &x : zapros) { cin >> x; }
    vector<ll> arr(n);
    for (ll &x : arr) { cin >> x; }
    if (n == m)
    {
        if (q(arr, zapros))
        {
            cout << n << endl;
            for (int i = 0; i < n; i++)
            {
                cout << n << " ";
            }
            cout << endl;
        }
        else if (iq(arr, zapros))
        {
            cout << 2LL * n - 1 << endl;
            for (int i = 0; i < n - 1; i++)
            {
                cout << n - i << " ";
            }
            for (int i = 0; i < n; i++)
            {
                cout << n << " ";
            }
            cout << endl;
        }
    }
	return 0;
}

/*
ll k;
    cin >> k;
    if (k % 2 == 0)
    {
        if (k == 0)
        {
            cout << 0 << endl; return 0;
        }
        if (k > 0)
        {
            for (ll i = 0LL; i < (ll)10e6; i++)
            {
                ll temp = i * i + k;
                if (temp >= 0)
                {
                    ll temp1 = (ll)sqrt(temp);
                    if (temp1 * temp1 == temp)
                    {
                        cout << temp1 << endl;
                        return 0;
                    }
                }
            }
            cout << "none" << endl;
            return 0;
        }
        else
        {

            if (k % 4LL == 0LL)
            {
                ll temp = sqrt(-k);
                if (temp * temp != -k)
                {
                    temp++;
                }
                if (if_square(temp * temp + k))
                {
                    cout << (ll)sqrt(temp * temp + k) << endl;
                    return 0;
                }
                k /= -4LL; k--;
                cout << k << endl;
            }
            else
            {
                cout << "none" << endl;
            }
            return 0;
            /*
            if (k % 4LL != 0LL)
            {
                cout << "none" << endl;
                return 0;
            }
            for (ll i = 0LL; i < (ll)10e6; i++)
            {
                ll temp = i * i + k;
                if (temp >= 0)
                {
                    ll temp1 = (ll)sqrt(temp);
                    if (temp1 * temp1 == temp)
                    {
                        cout << temp1 << endl;
                        return 0;
                    }
                }
            }
            cout << "none" << endl;
            return 0;
            
        }
    }
    else
    {
    if (k < 0)
    {
        ll temp = sqrt(-k);
        if (!if_square(-k))
        {
            temp++;
        }
        if (if_square(temp * temp + k))
        {
            cout << (ll)sqrt(temp * temp + k) << endl;
            return 0;
        }
        k *= -1;
        k = (k + 1) / 2;
        k--;
        cout << k << endl;
        return 0;
        /*
        for (ll i = 0LL; i < (ll)10e6; i++)
        {
            ll temp = i * i + k;
            if (temp >= 0)
            {
                ll temp1 = (ll)sqrt(temp);
                if (temp1 * temp1 == temp)
                {
                    cout << temp1 << endl;
                    return 0;
                }
            }
        }
        return 0;
        
    }
    if (k > 0)
    {
        ll temp = sqrt(k);
        if (temp * temp != k)
        {
            temp++;
        }
        if (if_square(temp * temp - k) && k <= temp * temp - k)
        {
            cout << (ll)sqrt(temp * temp - k) << endl;
            return 0;
        }
        k = (k + 1) / 2;
        cout << k << endl;
        return 0;
        /*
        for (ll i = 0LL; i < (ll)10e6; i++)
        {
            ll temp = i * i + k;
            if (temp >= 0)
            {
                ll temp1 = (ll)sqrt(temp);
                if (temp1 * temp1 == temp)
                {
                    cout << temp1 << endl;
                    return 0;
                }
            }
        }
        
        return 0;
    }
    }
*/

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
