#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector<int> last(n);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		last[r] = l;
	}

	vector<vector<int> > dp(n, vector<int>(k + 1));
	for (int i = 0; i <= k; i++) {
		dp[0][i] = 1;
	}

	const int MOD = 1e9 + 7;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j <= k; j++) {
			for (int mask = 0; mask <= k; mask++) {
				if ((j & mask) == j) {
					dp[i][mask] += dp[i - 1][j];
					dp[i][mask] %= MOD;
				}
			}
		}
	}

	int ans = 0;
	for (int i = 0; i <= k; i++) {
		ans += dp[n - 1][i];
		ans %= MOD;
	}
	cout << ans;
}