#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

vector<int> used;

pair<int, int> d(int v);
vector<vector<int>> P;

int main() {
	int n;
	cin >> n;
	P.resize(n + 1);
	used.resize(n + 1, 0);
	for (int i = 1; i < n + 1; i++) {
		int j;
		cin >> j;
		if (j != -1) {
			P[i].push_back(j);
			P[j].push_back(i);
		}
	}
	int cnt = 0;
	for (int i = 1; i < n + 1; i++) {
		int q = 0;
		if (P[i].size() == 0) {
			q = 1;
		}
		else if (!used[i]) {
			pair<int,int> ans = d(i);
			q = max(ans.first, ans.second);
		}
		cnt += q;
	}
	cout << cnt;
	system("Pause");
}

pair<int,int> d(int v) {
	int ans1 = 1;
	int ans2 = 0;
	used[v] = 1;
	for (auto e : P[v]) {
		if (!used[e]) {
			ans1 += d(e).second;
			ans2 += max(d(e).first, d(e).second);
		}
	}
	return { ans1, ans2 };
}