#include <bits/stdc++.h>
using namespace std;
#define int long long
//#define HOME
const int N = 1e6 + 7;
int w[N], per[N];
map <int, int> to[N];
bool type[N];
vector <int> del[N];
int quer[N];

int pr[N];
vector <int> ev;
int tree[N << 2];

void upd(int v, int tl, int tr, int p, int x) {
    if (tl == tr) {
        tree[v] = x;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (p <= tm) upd(v * 2 + 1, tl, tm, p, x);
    else upd(v * 2 + 2, tm + 1, tr, p, x);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

int get(int v, int tl, int tr, int l, int r) {
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl + tr) >> 1;
    return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm + 1, tr, l, r);
}

void add(int x) {
    upd(0, 0, N, ev.size(), 1);
    ev.push_back(x);
    if (pr[x] != -1) {
        upd(0, 0, N, pr[x], 0);
    }
    pr[x] = (int)ev.size() - 1;
}

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) cin >> w[i];
    for (int i = 0; i < n; ++i) cin >> per[i];
    for (int i = 1; i <= n; ++i) pr[i] = -1;
    int ans = 0;
    int ptr = 0;
    for (int i = 0; i < m; ++i) {
        int x = w[i];
        if (pr[x] == -1) {
            while (1) {
                int nx = per[ptr];
                del[i].push_back(nx);
                quer[nx] = i;
                add(nx);
                ++ans;
                ++ptr;
                if (nx == x) break;
            }
        }
        else {
            del[i].push_back(x);
            type[i] = 1;
            to[quer[x]][x] = get(0, 0, N, pr[x] + 1, N) + 1;
            add(x);
            quer[x] = i;
            ++ans;
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < m; ++i) {
        for (auto x : del[i]) {
            if (to[i].find(x) != to[i].end()) {
                cout << to[i][x] << ' ';
            }
            else {
                cout << n << ' ';
            }
        }
    }
    cout << '\n';
}
