#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


int ppcnt(int x) {
    int res = 0;

    while (x) {
        res += x % 2;

        x >>= 1;
    }

    return res;
}


int log(int x) {
    int i;
    for (i = 0; (1LL << i) <= x; ++i);

    return i - 1;
}


const int M = (int)1e9 + 7;


int n, m;
vector<pair<int, int>> qs;


int solve(int bits) {
    vector<int> c(n);

    int answ = 0;

    while (true) {
        bool b = true;
        for (auto &p : qs) {
            if (c[p.first] == c[p.second]) {
                b = false;

                break;
            }
        }

        answ += b;

        int i = n - 1;
        for (; i >= 0 && c[i] == bits; --i);

        if (i < 0) {
            return answ;
        }

        int cur = ++c[i];
        for (++i; i < n; ++i) {
            c[i] = cur;
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int k;

    cin >> n >> m >> k;

    qs.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> qs[i].first >> qs[i].second;

        --qs[i].first;
        --qs[i].second;
    }

    cout << (solve(ppcnt(k)) + solve(log(k))) % M;

    return 0;
}