#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
int prov(vector<long long>& A, vector<vector<long long> >& G, long long n)
{
    for (int i = 0; i < n; i++)
    {
        if (A[i] == 1)
        {
            for (int j = 0; j < G[i].size(); j++)
            {
                if (A[G[i][j]] == 1)
                {
                    return 1;
                }
            }
        }
    }
    return 0;
}
vector<long long> per(long long a, long long n)
{
    vector<long long> P;
    while (a > 0)
    {
        P.push_back(a % 2);
        a = a / 2;
    }
    while (P.size() != n)
    {
        P.push_back(0);
    }
    return P;
}
pair<long long, long long> dfs(long long i, vector<vector<long long> >& G, vector<long long>& visited)
{
    visited[i] = 1;
    pair<long long, long long> a;
    a.first = 1;
    a.second = 0;
    for (int j = 0; j < G[i].size(); j++)
    {
        if (visited[G[i][j]] == 0)
        {
            pair<long long, long long> b = dfs(G[i][j], G, visited);
            a.first += b.second;
            a.second += b.first;
        }
    }
    return a;
}

int main()
{
    long long n;
    cin >> n;
    vector<vector<long long> > G(n);
    long long lol;
    for (int i = 0; i < n; i++)
    {
        cin >> lol;
        if (lol > 0)
        {
            G[i].push_back(lol - 1);
            G[lol - 1].push_back(i);
        }
    }
    if (n <= 20)
    {
        long long ans = 1;
        for (long long i = 0; i < pow(2, n); i++)
        {
            vector<long long> P = per(i, n);
            if (prov(P, G, n) == 0)
            {
                long long sum = 0;
                for (int i = 0; i < n; i++)
                {
                    sum += P[i];
                }
                ans = max(ans, sum);
            }
        }
        cout << ans;
    }
    else
    {
        vector<long long> visited(n, 0);
        long long ans = 0;
        for (int i = n - 1; i >= 0; i--)
        {
            if (visited[i] == 0)
            {
                ans++;
                for (int j = 0; j < G[i].size(); j++)
                {
                    visited[G[i][j]] = 1;
                }
            }
        }
        cout << ans;
    }
}
