#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <vector <char>> vec;
vector <bool> used;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
	cin >> k;
	ll cur = 0;
	while (k < 1e16) {
		k = k + cur;
		ll l = 0, r = k + 1;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (mid * mid <= k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (l * l == k) {
			cout << l << '\n';
			return 0;
		}
		if (cur) cur += 2;
		else ++cur;
	}
	cout << "none";
	return 0;
/*	if (k < 0) k *= -1;
	if (k % 2) {
		cout << k / 2;
	}
	else {
		ll l = 0, r = k + 1;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (mid * mid <= k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (l * l == k) {
			cout << k;
		}
		else {
			cout << "none";
		}
	}*/
    return 0;
}