#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;
const long long mod = 1e9 + 7;

using namespace std;

long long n, m, k;
vector <int> vec;
vector <vector <int>> rvec;
vector <int> used;
vector <bool> tused;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
ll cursum, ans = 0;

void f(ll last = -1, ll before_last = -1) {
	if (cursum == n) {
		ans++;
		if (ans == mod) {
			ans = 0;
		}
		return;
	}
	if (last == -1) {
		for (int i = 1; i <= n - k; ++i) {
			if (i != k) {
				cursum += i;
				f(i, k);
				cursum -= i;
			}
		}
	}
	else if (last > before_last) {
		for (int i = 1; i <= min(last - 1, n - cursum); ++i) {
			cursum += i;
			f(i, last);
			cursum -= i;
		}
	}
	else {
		for (int i = last + 1; i <= n - cursum; ++i) {
			cursum += i;
			f(i, last);
			cursum -= i;
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> k;
	cursum = k;
	f();
	cout << ans;
	return 0;
}