#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll INF = 1e9 + 228;

struct Task {

    ll ans;
    ll n, k;

    void run(istream &cin, ostream &cout) {
        fast_io();
        cin >> n >> k;
        ans = 0;
        vector<ll> dp(n + 1);
        dp[0] = 1;
        dp[k] = 1;
        for (int i = 1; i <= n; i++) {
            if (i < k) {
                for (int j = 0; j < i; j++) {
                        dp[i] += dp[j];
                }
            } else {
                for (int j = k; j < i; j++) {
                        dp[i] += dp[j - k];
                }
            }
        }
        cout << dp[n];
    }
};

signed main() {
    Task task;
    task.run(cin, cout);
    return 0;
}
