#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll INF = 1e9 + 228;

struct Task {
    int n;
    int ans;
    vector<int> a;

    void brt(string s, int n) {
        if (n > 0) {
            brt(s + '0', n - 1);
            brt(s + '1', n - 1);
        } else {
            n = s.size();
            int cans = 0;
            for (int i = 0; i < n; i++) {
                if (s[i] == '1' && a[i] == -2) cans++;
                else if (s[i] == '1' && s[a[i]] == '0') cans++;
                else if (s[i] == '1') return;
            }
            ans = max(cans, ans);
        }
    }

    vector<char> usd;
    vector<vector<int>> g;

    pair<int, int> dfs(int v, bool cl) {
        usd[v] = 1;
        pair<int ,int> ans;
        if (cl) {
            ans.first++;
        } else {
            ans.second++;
        }
        for (auto u : g[v]) {
            if (!usd[u]) {
                auto pr = dfs(u, !cl);
                ans.first += pr.first;
                ans.second += pr.second;
            }
        }
        return ans;
    }

    void run(istream &cin, ostream &cout) {
        fast_io();
        cin >> n;
        a.resize(n);
        g.resize(n);
        usd.resize(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            g[i].push_back(a[i]);
            g[a[i]].push_back(i);
        }
        if (n <= 20) {
            ans = 0;
            brt("", n);
            cout << ans;
        } else {
            ll ans = 0;
            for (int i = 0; i < n; i++) {
                if (!usd[i]) {
                    auto pr = dfs(i, 0);
                    ans += max(pr.first, pr.second);
                }
            }
            cout << ans;
        }
    }
};

signed main() {
    Task task;
    task.run(cin, cout);
    return 0;
}
