#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll INF = 1e9 + 228;

struct Task {
    int n;
    int ans;
    vector<int> a;

    void brt(string s, int n) {
        if (n > 0) {
            brt(s + '0', n - 1);
            brt(s + '1', n - 1);
        } else {
            n = s.size();
            int cans = 0;
            for (int i = 0; i < n; i++) {
                if (s[i] == '1' && a[i] == -2) cans++;
                else if (s[i] == '1' && s[a[i]] == '0') cans++;
                else if (s[i] == '1') return;
            }
            if (cans == 5) {
                cout << s;
            }
            ans = max(cans, ans);
        }
    }

    vector<char> usd;
    vector<vector<int>> g;
    vector<vector<int>> org;
    vector<vector<int>> dp;

    void dfs(int v) {
        usd[v] = 1;
        dp[v][1] = 1;
        for (auto u : g[v]) {
            if (!usd[u]) {
                dfs(u);
                dp[v][0] += max(dp[u][0], dp[u][1]);
                dp[v][1] += dp[u][0];
            }
        }
    }

    void run(istream &cin, ostream &cout) {
        fast_io();
        cin >> n;
        a.resize(n);
        g.resize(n);
        usd.resize(n);
        org.resize(n);
        dp.resize(n, vector<int>(2));
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            if (a[i] != -2) {
                g[i].push_back(a[i]);
                g[a[i]].push_back(i);
                org[i].push_back(a[i]);
            }
        }
        if (n <= 20) {
            ans = 0;
            brt("", n);
            cout << ans;
        } else {
            ll tans = 0;
            for (int i = 0; i < n; i++) {
                if (!usd[i]) {
                    dfs(i);
                    tans += max(dp[i][0], dp[i][1]);
                }
            }
            cout << tans;
        }
    }
};

signed main() {
    Task task;
    task.run(cin, cout);
    return 0;
}
