#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

int main(){


    long long int mod = 1e9 + 7;
    int n, k;
    cin >> n >> k;

    vector < vector < vector <long long int> > > dp(n + 1, vector < vector <long long int>> (n + 1, vector <long long int> (2)));



    for (int i = k; i <= n; i++){
        dp[k][i][0] = dp[k][i][1] = 1;
    }

    for (int j = k + 1; j <= n; j++){

        for (int i = 1; i <= n; i++){
            if (i < j){

                dp[j][i][0] = (dp[j - i][i - 1][1] + dp[j][i - 1][0]) % mod;//
                dp[j][i][1] = (dp[j - i][n][0] - dp[j - i][i][0] + dp[j][i - 1][1]) % mod;//dp[j - i][n][1] - dp[j - i][i][1], dp[j - i][i - 1][0]

            }else{

                dp[j][i][0] = dp[j][i - 1][0];
                dp[j][i][1] = dp[j][i - 1][1];

            }
        }

    }
    if (k != n)
        cout << (dp[n][n][0] + dp[n][n][1]) % mod;
    else
        cout << 1;

    /*cout << '\n';

    for (int i = 0; i <= n; i++){

        for (int j = 0; j <= n; j++){

            cout << dp[i][j][0] << ", " << dp[i][j][1] << "   ";

        }

        cout << '\n';

    }*/

    return 0;
}
