#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

#define int long long

signed main()
{
    const int a = 1e9 + 7;
    int n, m;
    cin >> n >> m;
    vector<vector<int>> U(n + 2, vector<int> (n + 2));
    vector<vector<int>> D(n + 2, vector<int> (n + 2));
    for (int i = 1; i <= n; ++i)
    {
        U[i][i] = 1;
        D[i][i] = 1;
    }
    int p1 = 1;
    int p2;
    for (int s = 2; s <= n; ++s)
    {
        p2 = 0;
        for (int k = 1; k <= s; ++k)
        {
            D[s][k] = (D[s - 1][k - 1] + U[s - k][k - 1]) % a;
            p2 = (p2 + D[s][k]) % a;
        }
        U[s][1] = p1 - D[s - 1][1];
        p1 = p2;
        for (int k = 2; k <= s; ++k)
        {
            U[s][k] = U[s - 1][k - 1] - D[s - k][k];
        }
    }
    if (n > m)
        cout << (D[n][m] + U[n][m]) % a << endl;
    else
        cout << 1 << endl;
    return 0;
}

