#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

template<class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template<class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

ll jump (ll a, ll b) {
    if (a == b)
        return 0;
    return (b - a - 1) / 2 + 1;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    ll a, b, c;
    cin >> a >> b >> c;
    ll cs = b / c - a / c;
    ll fa = a + c - a % c, fb = b - b % c;
    //cout << fa << ' ' << fb << '\n';
    ll ans = jump(a, fa - 1) + jump(fb + 1, b) + max(cs - 1, 0) * jump(1, c - 1) + cs;
    cout << ans << '\n';
}
