#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

template<class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template<class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, k;
    cin >> n >> k;
    const ll MOD = 1e9 + 7;
    vector<vector<ll>> a(n + 1, vector<ll>(n + 1, 0)), b(n + 1, vector<ll>(n + 1, 0));
    a[1][1] = 1;
    b[1][1] = 1;
    for (int i = 2; i <= n; ++i) {
        a[i][i] = 1;
        for (int t = 2; t < i; ++t)
            a[i][t] = (b[i - t][t - 1] + a[i - 1][t - 1]) % MOD;
        b[i][i] = 1;
        b[i][1] = 0;
        for (int t = 2; t <= n; ++t)
            b[i][1] = (b[i][1] + a[i - 1][t]) % MOD;
        for (int t = 2; t < i; ++t)
            b[i][t] = (b[i - 1][t - 1] - a[i - t][t]) % MOD;
    }
    cout << (b[n][k] + a[n][k] - (int)(n == k) + MOD) % MOD << '\n';
}
