#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define all(c) c.begin(), c.end()

ll mod = 1e9 + 7;

vector<vector<vector<ll>>> m;

ll rec(ll sum, ll v, bool f) {
	//cout << v << " " << sum << endl;
	if (v > sum) {
		return 0;
	}
	if (v == sum) {
		return 1;
	}
	if (m[sum][v][f] != -1) {
		return m[sum][v][f];
	}
	ll ans = 0;
	if (f == 0) {
		for (int i = 1; i < v; i++) {
			if (m[sum - v][i][1] == -1) {
				m[sum - v][i][1] = rec(sum - v, i, 1);
			}
			ans += m[sum - v][i][1];
			ans %= mod;
		}
	}
	else {
		for (int i = v + 1; i + v <= sum; i++) {
			if (m[sum - v][i][0] == -1) {
				m[sum - v][i][0] = rec(sum - v, i, 0);
			}
			ans += m[sum - v][i][0];
			ans %= mod;
		}
	}
	return ans;
}
int main() {
	ll sum, v;
	cin >> sum >> v;
	m.resize(sum + 1, vector<vector<ll>>(sum + 1, vector<ll>(2, -1)));
	ll ans = 0;
	if (v == sum) {
		cout << 1;
		return 0;
	}
	for (int i = 1; i < v; i++) {
		ans += rec(sum - v, i, 1);
		ans %= mod;
	}
	for (int i = v + 1; i + v <= sum; i++) {
		ans += rec(sum - v, i, 0);
		ans %= mod;
	}
	cout << (ans + mod) % mod;
	//system("pause");
	return 0;
}