#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
#define all(c) c.begin(), c.end()

vector<set<int>> ans;
vector<pii> q;
set<int> pos;

bool eend = false;

void dfs(int v) {
	/*for (pii i : q) {
		cout << i.first << " " << i.second << endl;
	}
	cout << endl;*/
	if (eend) {
		return;
	}
	pos.erase(v);
	for (int u : ans[v]) {
		if (pos.count(u)) {
			q.push_back({ v, u });
			pos.erase(u);
			if (pos.empty()) {
				cout << "YES\n";
				for (pii a : q) {
					cout << a.first + 1 << " " << a.second + 1 << endl;
				}
				eend = true;
				return;
			}
			dfs(*pos.begin());
			q.pop_back();
			pos.insert(u);
		}
	}
	pos.insert(v);
}

int main() {
	int n, k;
	cin >> n >> k;
	if (k == 1) {
		vector<pii> v(n);
		for (int i = 0; i < n; i++) {
			cin >> v[i].first;
			v[i].second = i;
		}
		sort(all(v));
		cout << "YES\n";
		for (int i = 0; i < n / 2; i++) {
			cout << v[i].second + 1 << " " << v[n - i - 1].second + 1 << endl;
		}
	}
	else {
		vector<vector<pii>> v(k, vector<pii>(n));
		ans.resize(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				ans[i].insert(j);
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < k; j++) {
				cin >> v[j][i].first;
				v[j][i].second = i;
			}
		}
		
		for (int i = 0; i < k; i++) {
			sort(all(v[i]));
			for (int j = 0; j < n / 2; j++) {
				for (int k = 0; k < n / 2; k++) {
					if (v[i][j].first != v[i][k].first) {
						ans[v[i][j].second].erase(v[i][k].second);
						ans[v[i][k].second].erase(v[i][j].second);
					}
					if (v[i][j + n / 2].first != v[i][k + n / 2].first) {
						ans[v[i][j + n / 2].second].erase(v[i][k + n / 2].second);
						ans[v[i][k + n / 2].second].erase(v[i][j + n / 2].second);
					}
				}
			}
		}

		for (int i = 0; i < n; i++) {
			pos.insert(i);
		}
		dfs(0);
		if (!eend) {
			cout << "NO";
		}
	}
	//system("pause");
	return 0;
}

/*
6 2 8 6 1 5 6 3 3 1 4 7 7 2 
*/