#include <bits/stdc++.h>
using namespace std;

#ifdef _LOCAL_SRC
#define debug(...) fprintf (stderr, __VA_ARGS__)
#else
#define debug(...)
#endif
#define db(var) debug (#var " = %d\n", var);

typedef long long i64;
typedef unsigned long long u64;
typedef vector <vector <int>> g_t;

int main () {
	int n;
	cin >> n;
	g_t g (n);
	vector <set <int>> tg (n);
	for (int i = 0; i < n; ++i) {
		int b;
		cin >> b;
		if (b == -1)
			continue;
		b--;
		tg[b].insert (i);
		tg[i].insert (b);
	}
	for (int i = 0; i < n; ++i)
		g[i] = vector (tg[i].begin (), tg[i].end ());

	vector <int> col (n, -1);
	function<int(int,int)> dfs1 = [&] (int v, int p_b) {
		if (col[v] >= 0)
			return 0;
		db (v + 1);
		db (p_b);

		int this_col = !p_b;
		this_col = (g[v].size () > 2 ? 0 : this_col);

		for (size_t i = 0; i < g[v].size (); ++i) {
			if (col[g[v][i]] == 1)
				this_col = 0;
		}
		col[v] = this_col;
		int ret = (this_col ? 1 : 0);
		for (size_t i = 0; i < g[v].size (); ++i) {
			ret += dfs1 (g[v][i], this_col);
		}

		db (v + 1);
		db (ret);
		return ret;
	};

	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (col[i] == -1)
			cnt += dfs1 (i, 0);
	}

	cout << cnt << endl;

	return 0;
}