#include <bits/stdc++.h>
using namespace std;

#ifdef _LOCAL_SRC
#define debug(...) fprintf (stderr, __VA_ARGS__)
#else
#define debug(...)
#endif
#define db(var) debug (#var " \x1b[36m=\x1b[0m %d\n", var);

typedef long long i64;
typedef unsigned long long u64;
typedef vector <vector <int>> g_t;

int main () {
	int n;
	cin >> n;
	g_t g (n);
	vector <set <int>> tg (n);
	for (int i = 0; i < n; ++i) {
		int b;
		cin >> b;
		if (b == -1)
			continue;
		b--;
		tg[b].insert (i);
		tg[i].insert (b);
	}
	for (int i = 0; i < n; ++i)
		g[i] = vector (tg[i].begin (), tg[i].end ());

	vector <int> col (n, -1);
	function<int(int,int)> dfs1 = [&] (int v, int p_b) {
		if (col[v] >= 0)
			return 0;
		debug (" > %d pb=%d\n", v + 1, p_b);

		int this_col = !p_b;
		if (g[v].size () > 2)
			this_col = 0;

		db (this_col);	
		bool no_2 = true;
		bool border = false;
		for (size_t i = 0; i < g[v].size (); ++i) {
			if (col[g[v][i]] == 1)
				border = true;
			else if (g[g[v][i]].size () < 3)
				no_2 = false;
		}

		if (border)
			this_col = 0;
		else if (no_2 && g[v].size () > 2)
			this_col = 1;

		col[v] = this_col;
		int ret = (this_col ? 1 : 0);
		for (size_t i = 0; i < g[v].size (); ++i) {
			ret += dfs1 (g[v][i], this_col);
		}

		debug ("< %d ret=%d\n", v + 1, ret);
		return ret;
	};

	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (col[i] == -1)
			cnt += dfs1 (i, 0);
	}

	cout << cnt << endl;

	return 0;
}