#include <bits/stdc++.h>
using namespace std;

#ifdef _LOCAL_SRC
#define debug(...) fprintf (stderr, __VA_ARGS__)
#else
#define debug(...)
#endif
#define db(var) debug (#var " \x1b[36m=\x1b[0m %d\n", var);

typedef long long i64;
typedef unsigned long long u64;
typedef vector <vector <int>> g_t;

int main () {
	int n;
	cin >> n;
	g_t g (n);
	vector <set <int>> tg (n);
	for (int i = 0; i < n; ++i) {
		int b;
		cin >> b;
		if (b == -1)
			continue;
		b--;
		tg[b].insert (i);
		tg[i].insert (b);
	}
	for (int i = 0; i < n; ++i)
		g[i] = vector (tg[i].begin (), tg[i].end ());

	vector <int> col (n, -1);
	multimap <int, int> frnd;
	for (int i = 0; i < n; ++i)
		frnd.emplace (g[i].size (), i);

	auto up1 = [&] (int v) {
		int b = 0;
		for (auto i: g[v])
			if (col[i] == 1) ++b;
		
		if (b == 0)
			col[v] = 1;
		else
			col[v] = 0;
		debug ("! %d %d\n", v + 1, col[v]);
	};

	for (auto &p: frnd) {
		if (p.first == 0)
			col[p.second] = 1;
		else {
			up1 (p.second);
		}
	}

	cout << count (col.begin (), col.end (), 1) << endl;

	return 0;
}