
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int maxn = 300 * 1000 + 228;

vector<int> g[maxn];
bool used[maxn], cycled[maxn], bip = 1;
int dp[maxn][2];

void DFSDP(int v, int par = -1) {
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (int to : g[v]) {
		if (to != par && !cycled[to]) {
			DFSDP(to, v);
			dp[v][0] += max(dp[to][0], dp[to][1]);
			dp[v][1] += dp[to][0];
		}
	}
}

vector<int> cycle;
int color[maxn], p[maxn];

void do_cycle(int v, int to) {
	while (v != to) {
		cycle.push_back(v);
		v = p[v];
	}
	cycle.push_back(to);
}

void dfs(int v, int par = -1) {
	used[v] = 1;
	color[v] = 1;
	p[v] = par;
	for (int to : g[v]) {
		if (color[to] == 1 && to != par) {
			do_cycle(v, to);
		}
		if (color[to] == 0) {
			dfs(to, v);
		}
	}
	color[v] = 2;
}

int d[maxn][2];

map< pair<int, int>, bool> was;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector< pair<int, int> > heh;
	for (int i = 1; i <= n; ++i) {
		int ai;
		cin >> ai;
		int u = i, v = ai;
		if (u > v) swap(u, v);
		if (ai != -1 && !was[{u, v}]) {
			was[{u, v}] = 1;
			heh.push_back({i, ai});
			g[i].push_back(ai);
			g[ai].push_back(i);
		}
	}
	int res = 0;
	for (int s = 1; s <= n; ++s) {
		if (!used[s]) {
			cycle.clear();
			dfs(s);
			if (cycle.empty()) {
				DFSDP(s);
				res += max(dp[s][0], dp[s][1]);
				
			} else {
				
				int cur = 0;
				for (int v : cycle) {
					cycled[v] = 1;
				}
				for (int v : cycle) {
					DFSDP(v);
				}
				int sz = (int)cycle.size();
				for (int i = 0; i < sz; ++i) {
					d[i][0] = d[i][1] = 0;
				}	
				d[0][0] = d[0][1] = dp[cycle[0]][0];
				for (int i = 1; i < sz; ++i) {
					d[i][0] = max(d[i - 1][0] + dp[cycle[i]][0], d[i - 1][1] + dp[cycle[i]][0]);
					d[i][1] = dp[cycle[i]][1] + d[i - 1][0];
				}
				cur = max(d[sz - 1][0], d[sz - 1][1]);
				d[0][0] = dp[cycle[0]][0];
				d[0][1] = dp[cycle[0]][1];
				for (int i = 1; i < sz; ++i) {
					d[i][0] = max(d[i - 1][0] + dp[cycle[i]][0], d[i - 1][1] + dp[cycle[i]][0]);
					d[i][1] = dp[cycle[i]][1] + d[i - 1][0];
				}
				uax(cur, d[sz - 1][0]);
				res += cur;
			}
		}
	}
	cout << res << '\n';
	return 0;
}