#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int maxn = 200 * 1000 + 228, INF = 1e9 + 228;

int n, k;
int A[maxn][7];

bool dead[maxn];

int L[7], R[7], LL[7], RR[7];

void gen(int i, vector< pair<int, int> > res) {
	if (i == n / 2) {
		cout << "YES\n";
		for (auto P : res) {
			cout << P.first << " " << P.second << "\n";
		}
		exit(0);
	}
	for (int a = 1; a <= n; ++a) {
		if (!dead[a]) {
			for (int b = a + 1; b <= n; ++b) {
				if (!dead[b]) {
					vector<int> LL, RR;
					for (int t = 0; t < k; ++t) {
						LL.push_back(L[t]);
						RR.push_back(R[t]);
					}
					dead[a] = dead[b] = 1;
					res.push_back({a, b});
					bool okedoke = 1;
					for (int t = 0; t < k; ++t) {
						uax(L[t], min(A[a][t], A[b][t]));
						uin(R[t], max(A[a][t], A[b][t]));
						if (L[t] > R[t]) {
							okedoke = 0;
							break;
						}
					}
					if (okedoke) {
						gen(i + 1, res);
					}
					res.pop_back();
					dead[a] = dead[b] = 0;
					for (int t = 0; t < k; ++t) {
						L[t] = LL[t];
						R[t] = RR[t];
					}
				}
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> A[i][j];
		}
	}
	if (k == 1) {
		vector< pair<int, int> > v;
		for (int i = 1; i <= n; ++i) {
			v.push_back({A[i][0], i});
		}
		sort(v.begin(), v.end());
		cout << "YES\n";
		for (int i = 0; i < n / 2; ++i) {
			cout << v[i].second << " " << v[n - i - 1].second << '\n';
		}
		return 0;
	}
	if (n <= 10) {
		for (int i = 0; i < k; ++i) {
			L[i] = -INF;
			R[i] = INF;
		}
		vector< pair<int, int> > heh;
		gen(0, heh);
		cout << "NO\n";
	} else {
		vector< pair<int, int> > v;
		for (int i = 1; i <= n; ++i) {
			v.push_back({A[i][0], i});
		}
		sort(v.begin(), v.end());
		vector< pair<int, int> > vl, vr;
		for (int i = 0; i < n / 2; ++i) {
			vl.push_back({A[v[i].second][1], v[i].second});
		}
		for (int i = n / 2; i < n; ++i) {
			vr.push_back({A[v[i].second][1], v[i].second});
		}
		sort(vl.begin(), vl.end());
		sort(vr.rbegin(), vr.rend());
		vector< pair<int, int> > pairs;
		for (int i = 0; i < n / 2; ++i) {
			pairs.push_back({vl[i].second, vr[i].second});
		}
		bool okedoke = 1;
		for (int t = 0; t < k; ++t) {
			int ll = -INF, rr = INF;
			for (auto p : pairs) {
				uax(ll, min(A[p.first][1], A[p.second][1]));
				uin(rr, max(A[p.first][1], A[p.second][1]));
				if(ll > rr) break;
			}
			if (ll > rr) {
				okedoke = 0;
				break;
			}
		}
		if (okedoke) {
			cout << "YES\n";
			for (auto P : pairs) {
				cout << P.first << " " << P.second << '\n';
			}
		} else {
			cout << "NO\n";
		}
	}
	return 0;
}
