#include <bits/stdc++.h>

using namespace std;

int n;
vector < vector < int > > g;
vector < int > used;
int ns;
vector < int > dist;
vector < int > cnt;

void rebuild() {
    ns = 1;
    while (ns < n) {
        ns *= 2;
    }
}

void dfs(int v) {
    used[v] = 1;
    int ans = ns + 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u);
        }
        ans = min(ans, dist[u] + 1);
    }
    if (ans == ns + 1) {
        ans = 1;
    }
    dist[v] = ans;
    cnt[ans - 1]++;
}

int maxx() {
    int ans = 0;
    for (int i = 0; i < n; i += 2) {
        ans += cnt[i];
    }
    return ans;
}

int main() {
    int a, ans = 0;
    cin >> n;
    if (n <= 20) {
        vector < int > v(n);
        for (int i = 0; i < n; ++i) {
            cin >> v[i];
            v[i]--;
        }
        for (int i = 0; i < pow(2, n); ++i) {
            bool f = true;
            for (int j = 0; j < n; ++j) {
                if (v[j] == -2) {
                    continue;
                }
                if ((((i >> j) & 1) & ((i >> v[j]) & 1))) {
                    f = false;
                    break;
                }
            }
            if (f) {
                ans = max(ans, __builtin_popcount(i));
            }
        }
        cout << ans << "\n";
        return 0;
    }
    if (n == 1) {
        cout << 1 << "\n";
        return 0;
    }
    g.resize(n);
    used.resize(n, 0);
    rebuild();
    dist.resize(ns + 1);
    cnt.resize(ns + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a;
        if (a == -1) {
            continue;
        }
        g[a - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    cout << maxx() << "\n";
}
